
Create Table L_DOCLIST (N_BASE   CHAR(20),
			N_DOC    CHAR(40),
			W_LS     INTEGER,
			W_LC     INTEGER,
			W_RS     INTEGER,
			W_RC     INTEGER,
			W_BORD   INTEGER,
			W_SHAD   INTEGER,
			W_TYPE   CHAR,
			C_BASE   CHAR(20),
			CIRCUIT  CHAR(20),
			LEN      INTEGER,
			N_TABL   CHAR(37)
)
MaxIsn 100 PCTFILL 80 MaxRow 2;
Create index N_BASE on L_DOCLIST;
Create index W_TYPE on L_DOCLIST;
Create index CIRCUIT on L_DOCLIST;

!!

Create Table L_STRINGS (  N_BASE   CHAR(20),
			  S_POS    INTEGER,
			  FIELD    CHAR(220)
			)
MaxIsn 1000 PCTFILL 80 MaxRow 2;
Create index N_BASE on L_STRINGS;

!!

Create Table L_FIELDS (   N_BASE  CHAR(20),
			  S_POS   INTEGER,
			  C_POS   INTEGER,
			  NAME    CHAR(15),
			  FORMAT  CHAR(220),
			  TYPE    CHAR(1),
			  W_LEN   INTEGER,
			  LEN     INTEGER,
			  C_BASE  CHAR(20),
			  C_FIELD CHAR(15),
			  C_TYPE  CHAR(1),
			  IS_KEY  BYTE,
			  "INITIAL" CHAR(220),
			  VALIDATE CHAR(220),
			  NOPRINT BYTE,
			  "BEFORE" CHAR(220),
			  TITLE CHAR(30),
			  SIGNIF BYTE,
			  "PRIORITY" SMALLINT,
			  IS_INDEX BYTE,
			  VISIBLE CHAR(220),
			  NODATABASE CHAR(1),
			  INPFORMAT CHAR(220)
			  )
MaxIsn 100 PCTFILL 80 MaxRow 2;
Create index N_BASE on L_FIELDS;
Create index TYPE on L_FIELDS;
Create index C_TYPE on L_FIELDS;
Create index NAME on L_FIELDS;
Create index IS_KEY on L_FIELDS;

!!

Create Table L_BROWSES (  N_BROW  CHAR(15),
			  N_FIEL  CHAR(15),
			  TYPE    CHAR(1),
			  LEN     INTEGER,
			  TEXT    CHAR(30),
			  FORMAT  CHAR(220),
			  C_BASE  CHAR(20),
			  C_FIELD CHAR(15),
			  C_TYPE  CHAR(1),
			  "INITIAL" CHAR(220),
			  VALIDATE CHAR(220),
			  VISIBLE CHAR(220),
			  NODATABASE CHAR(1),
			  "BEFORE" CHAR(220),
			  W_LEN INTEGER,
			  INPFORMAT CHAR(220)
			  )
MaxIsn 100 PCTFILL 80 MaxRow 2;
Create index N_BROW on L_BROWSES;

!!

create table l_refers (
	   n_base char(20),
	   n_field char(15),
	   c_base char(20),
	   c_field char(15),
	   c_table char(37),
	   c_attr char(18)
) MaxIsn 100 PCTFILL 80 MaxRow 2;
Create index N_BASE on l_Refers;
Create index N_FIELD on l_Refers;
Create index C_BASE on l_Refers;
Create index C_FIELD on l_Refers;

!!

create table l_cond (
	   "ROW" integer
);

!!

create table l_users (
       username char(20),
       privileg char(1),
       menuname char(20),
       bootexec char(220)
) MaxIsn 10 PCTFILL 80 MaxRow 2;
create index username on l_users;

!!

create table l_filters (
   n_base  char(20),
   n_field char(15),
   patt    char(50),
   mask    smallint,
   eq      char(25),
   neq     char(25),
   gt      char(25),
   lt      char(25),
   issort  byte
) MaxIsn 100 PCTFILL 80 MaxRow 2;
create index n_base on l_filters;
create index n_field on l_filters;

!!

create table l_menues (
   ordn smallint autoinc,
   username char(20),
   menuid integer,
   item char(40),
   id integer,
   act integer,
   docname char(20)
) MaxIsn 100 PCTFILL 80 MaxRow 2;
create index username on l_menues;

!!

create table l_rezerv (
     name char(40)
) MaxIsn 100 PCTFILL 80 MaxRow 25;
create index name on l_rezerv;
insert into l_rezerv values('ROW');
insert into l_rezerv values('SELECT');
insert into l_rezerv values('FROM');
insert into l_rezerv values('WHERE');
insert into l_rezerv values('MAX');
insert into l_rezerv values('MIN');
insert into l_rezerv values('COUNT');
insert into l_rezerv values('ABS');
insert into l_rezerv values('IN');
insert into l_rezerv values('SET');
insert into l_rezerv values('VALUES');
insert into l_rezerv values('GROUP');
insert into l_rezerv values('NUMBER');
insert into l_rezerv values('CREATE');
insert into l_rezerv values('TABLE');
insert into l_rezerv values('VIEW');
insert into l_rezerv values('DROP');
insert into l_rezerv values('INSERT');
insert into l_rezerv values('UPDATE');
insert into l_rezerv values('DELETE');
insert into l_rezerv values('BY');
insert into l_rezerv values('HAVING');
insert into l_rezerv values('ALTER');
insert into l_rezerv values('ADD');
insert into l_rezerv values('GRANT');
insert into l_rezerv values('KEY');
insert into l_rezerv values('INTEGER');
insert into l_rezerv values('NUMERIC');
insert into l_rezerv values('DATE');
insert into l_rezerv values('CHAR');
insert into l_rezerv values('BLOB');
insert into l_rezerv values('SMALLINT');
insert into l_rezerv values('REAL');

create table l_scripts (
   scod integer autoinc,
   smemo char(25)
) MaxIsn 50 PCTFILL 80 MaxRow 2;
create index scod on l_scripts;
create index smemo on l_scripts;

create table l_uscrpt (
   username char(20),
   scod integer
) MaxIsn 100 PCTFILL 80 MaxRow 2;
create index scod on l_uscrpt;
create index username on l_uscrpt;

Create Table L_CIRCUIT (CIRCUIT CHAR(20) );
Create public synonym circuit FOR l_circuit;
Create index CIRCUIT on CIRCUIT;

Insert into CIRCUIT values('References');

Insert into L_DOCLIST values('CIRCUIT','Document classes',2,41,6,78,3,0,'D','','References',10000,'CIRCUIT');
Insert into L_DOCLIST values('CIRCUIT_','Classes declarator',2,41,6,78,3,0,'E','CIRCUIT','References',10000,'');

Insert into L_FIELDS values('CIRCUIT',1,1,'CIRCUIT','','C',19,20,'','','','1',
			   '','','0','','Class name','1',0,'0','','0','*******************');
Insert into L_STRINGS values('CIRCUIT',0,' Class name');

Insert into L_DOCLIST values('GLOBVARS','Globvars',2,41,6,78,3,0,'D','','References',10000,'GLOBVARS');
Insert into L_DOCLIST values('GLOBVARS_','Globvars declarator',2,41,6,78,3,0,'E','GLOBVARS','References',10000,'GLOBVARS_');

create role lakunadev;
create role lakunaall;

grant select on L_DOCLIST to lakunaall;
grant select on L_FIELDS to lakunaall;
grant select on L_STRINGS to lakunaall;
grant select on L_BROWSES to lakunaall;
grant select on L_REFERS to lakunaall;
grant select,insert,delete,update on L_FILTERS to lakunaall;
grant select on L_USERS to lakunaall, lakunadev;
grant select on L_MENUES to lakunaall;
grant select,insert,delete on L_COND to lakunaall;
grant select on L_REZERV to lakunaall;
grant select on L_CIRCUIT to lakunaall;
grant select on L_SCRIPTS to lakunaall;
grant select on L_USCRPT to lakunaall;

grant all on L_DOCLIST to lakunadev;
grant all on L_FIELDS to lakunadev;
grant all on L_STRINGS to lakunadev;
grant all on L_BROWSES to lakunadev;
grant all on L_REFERS to lakunadev;
grant all on L_FILTERS to lakunadev;
grant all on L_MENUES to lakunadev;
grant all on L_COND to lakunadev;
grant all on L_REZERV to lakunadev;
grant all on L_CIRCUIT to lakunadev;
grant all on L_SCRIPTS to lakunadev;
grant all on L_USCRPT to lakunadev;

create public synonym WIN_DOCS for L_DOCLIST;
create public synonym DOCUM_G for L_FIELDS;
create public synonym DOCUM_S for L_STRINGS;
create public synonym DOCUM_B for L_BROWSES;
create public synonym DOCUM_R for L_REFERS;
create public synonym DOCUM_F for L_FILTERS;
create public synonym USERLIST for L_USERS;
create public synonym LMENU for L_MENUES;
create public synonym DOCUM_C for L_COND;
create public synonym REZERV for L_REZERV;
create public synonym LSCRIPTS for L_SCRIPTS;
create public synonym USCRIPTS for L_USCRPT;

create table L_EVENTS
(
  EV_NAME CHAR(32),
  PRIORITY INT,
  PARAMS VARCHAR(128),
  DT DATE
);

grant all on L_EVENTS to public;
create public synonym LEVENTS for L_EVENTS;
