 /***************************************************************************
 *          Apache Cayenne interface for RDBMS Linter source code           *
 *        This is unpublished proprietary source code of RELEX, Inc.        *
 *     The copyright notice does not evidence any actual or intended        *
 *                  publication of such source code.                        *
 *                                                                          *
 *                 Copyright (c) 2003-2014 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE:
 ----------------------------------------------------------------------------
 REVISION HISTORY:
 30.10.14 -- Galina Ermakova (Corrected LOB's comparison)
*/
package org.apache.cayenne.dba.linter;

import java.sql.Types;

import org.apache.cayenne.CayenneRuntimeException;
import org.apache.cayenne.access.trans.QueryAssembler;
import org.apache.cayenne.access.trans.TrimmingQualifierTranslator;
import org.apache.cayenne.dba.TypesMapping;
import org.apache.cayenne.exp.Expression;
import org.apache.cayenne.map.DbAttribute;

public class LinterQualifierTranslator extends TrimmingQualifierTranslator {

    public LinterQualifierTranslator() {
        super();
    }

    public LinterQualifierTranslator(
        QueryAssembler queryAssembler,
        String trimFunction) {
        super(queryAssembler, trimFunction);
    }

    protected void processColumn(StringBuffer buf, DbAttribute dbAttr)      /* 30.10.14 */
    {
        int jdbcType = dbAttr.getType();
        if (jdbcType == Types.CLOB || jdbcType == Types.LONGVARCHAR)
        {
            int len = dbAttr.getMaxLength();
            // length is required for VARCHAR
            if (len <= 0)
               len = 254;
            buf.append("GETBLOBSTR(");
            super.processColumn(buf, dbAttr);
            buf.append(",1,").append(len).append(") ");
        }
//        else if (jdbcType == Types.BLOB || jdbcType == Types.LONGVARBINARY)
//        {
//        }
        else
        {
          super.processColumn(buf, dbAttr);
        }
    }
}
