 /***************************************************************************
 *          Apache Cayenne interface for RDBMS Linter source code           *
 *        This is unpublished proprietary source code of RELEX, Inc.        *
 *     The copyright notice does not evidence any actual or intended        *
 *                  publication of such source code.                        *
 *                                                                          *
 *                 Copyright (c) 2003-2014 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE:
 ----------------------------------------------------------------------------
 REVISION HISTORY:
*/
package org.apache.cayenne.dba.linter;

import java.sql.PreparedStatement;
import java.sql.Types;

import org.apache.cayenne.access.types.CharType;

/**
 * Oracle specific CHAR type handling. 
 * 
 * If connection property "fixedString" is true, then
 * 'a' equal 'a ' in a CHAR(4) while parameter binding in PreparedStatement.
 * 
 * @since 3.1
 */
public class LinterCharType extends CharType {

    public LinterCharType() {
        super(true, true);
    }

    @Override
    public void setJdbcObject(
            PreparedStatement st,
            Object val,
            int pos,
            int type,
            int precision) throws Exception {
/*        if (type == Types.CLOB) {
            st.setString(pos, (String) val);
        }
        else {*/
            // use exactly this method to solve CAY-1470
            // setting connection property "fixedString" to true doesn't help
            // with .setString(parameterIndex, x)
            // nether with .setObject(parameterIndex, x, targetSqlType)
            st.setObject(pos, val);
/*        }*/
    }
}
