/***************************************************************************
 *                           RELEX, Inc. DBMS Linter                        *
 *  This is unpublished propietary source code of RELEX, Inc.               *
 *  The copyright notice does not evidence any actual or intended           *
 *  publication of such source code.                                        *
 *                                                                          *
 *                 Copyright (c) 1990-2012 RELEX, Inc.                      *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: adding one L_DECIMAL with other L_DECIMAL
 ----------------------------------------------------------------------------
 14.10.91 
 20.07.97 -- Ermakov (Copyright) 
 16.03.98 -- DV (Set zero status)
 28.04.98 -- Peshkoff (Register optimization)
 08.06.12 -- Glukhov (datatypes)
*/

#include <stdlib.h>                    
#include "decimals.h"


void DLLAPI  ADDDECIMAL(const L_DECIMAL D1,
                        const L_DECIMAL D2,
                              L_DECIMAL D)      /* D1+D2 -> D */
/**************************************/
{ register DECSTATUS  S1, S2;			/* 28.04.98 */
  register L_SWORD    J, C, IS;			/* 28.04.98 */
  register L_CHAR const *P;			/* 28.04.98 */

  S1 = GETDECSTATUS(D1);
  S2 = GETDECSTATUS(D2);
  if (((S1 == DECNEGATIV) || (S1 == DECPOSITIV)) &&
      ((S2 == DECNEGATIV) || (S2 == DECPOSITIV)))
    {
     IS = 0;
     if (S1 == S2)
       for (J = 0; ++J < DECLNG; )    
         {
          C = D1[J] + D2[J] + IS;
          IS = (C >= DECLIMIT);
          if (IS) C -= DECLIMIT;
          D[J] = (L_CHAR)C;             
         }
     else /* IF S1<>S2 THEN */
       {
        for (J = DECLNG; --J;)      
          if (D1[J] != D2[J]) {     
            if (D1[J] < D2[J]) {   
              P=D1; D1=D2; D2=P; /* &D1<->&D2 */
              S1=S2;
            }      
            break;
          }
        if (J == 0)             /* 16.03.98 */
          S1 = DECZERO;
        for (J = 0; ++J < DECLNG;)   
          {
           C = D1[J] - D2[J] - IS;
           IS = (C < 0);
           if (IS) C += DECLIMIT;
           D[J] = (L_CHAR)C;              
          }
       }
     if (IS)
       if (S1 == DECPOSITIV) S1 = DECPOSOVER;
       else                  S1 = DECNEGOVER;
     SETDECSTATUS(S1,D);
    }
  else if (((S1 == DECNEGOVER) && (S2 == DECPOSOVER)) ||
           ((S1 == DECPOSOVER) && (S2 == DECNEGOVER)) ||
            (S1 == DECERROR)   || (S2 == DECERROR))
    SETDECSTATUS(DECERROR,D);
  else if ((S1 == DECZERO) || (S2 == DECNEGOVER) || (S2 == DECPOSOVER))
    COPYDEC(D2,D);
  else
    COPYDEC(D1,D);

} /* end ADDDECIMAL */

