/***************************************************************************
 *                           RELEX, Inc. DBMS Linter                        *
 *  This is unpublished propietary source code of RELEX, Inc.               *
 *  The copyright notice does not evidence any actual or intended           *
 *  publication of such source code.                                        *
 *                                                                          *
 *                 Copyright (c) 1990-2012 RELEX, Inc.                      *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: compare two L_DECIMAL values
 ----------------------------------------------------------------------------
 14.10.91 
 20.07.97 -- Ermakov (Copyright) 
 13.09.99 -- DV (Return error code if invalid operand)
 13.01.04 -- AV (Rewritten without subtraction)
 08.06.12 -- Glukhov (datatypes)
*/

#include <stdlib.h>                  
#include "decimals.h"


L_SWORD DLLAPI CMPDECIMAL(const L_DECIMAL D1,
                          const L_DECIMAL D2) /* D1=D2 ? */
/**************************************/
{ 
  register DECSTATUS  S1, S2;
  int i;

  S1 = GETDECSTATUS(D1);
  S2 = GETDECSTATUS(D2);

  if (((S1 == DECPOSITIV) || (S1 == DECNEGATIV)) &&
      ((S2 == DECPOSITIV) || (S2 == DECNEGATIV)))
    if ( S1 == S2 )
    {
      for ( i = DECLNG-1; i > 0; i-- )
      {
        if ( D1[i] == D2[i] ) 
          continue;
        if ( D1[i] < D2[i] )
          if ( S1 == DECPOSITIV )
            return -1;
          else
            return  1;
        else
          if ( S1 == DECPOSITIV )
            return  1;
          else
            return -1;
      }
      return 0; 
    }
    else
      if ( S1 == DECPOSITIV )
        return  1;
      else
        return -1; 

  if ( S1 == DECERROR || S2 == DECERROR ) 
    return DECERROR;

  if ( S1 == DECZERO ) 
  {
    if ( S2 == DECZERO )
      return 0;
    if ( S2 == DECPOSITIV || S2 == DECPOSOVER ) 
      return -1; 
    return 1;
  }  

  if ( S2 == DECZERO ) 
  {
    if ( S1 == DECPOSITIV || S1 == DECPOSOVER ) 
      return 1; 
    return -1;
  }  

  if ( S1 == DECNEGOVER )
    if ( S2 == DECNEGOVER ) 
      return 0;
    else 
      return -1;

  if ( S1 == DECPOSOVER )
    if ( S2 == DECPOSOVER ) 
      return 0;
    else 
      return 1;
    
  return 0;

} /* end CMPDECIMAL */

