/***************************************************************************
 *                           RELEX, Inc. DBMS Linter                        *
 *  This is unpublished propietary source code of RELEX, Inc.               *
 *  The copyright notice does not evidence any actual or intended           *
 *  publication of such source code.                                        *
 *                                                                          *
 *                 Copyright (c) 1990-2012 RELEX, Inc.                      *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: device one L_DECIMAL on other L_DECIMAL
 ----------------------------------------------------------------------------
 14.10.91 
 06.07.95 -- DV (Corrected error)
 15.07.96 -- DV (Corrected the analogous error)
 20.07.97 -- Ermakov (Copyright) 
 28.04.98 -- Peshkoff (Register optimization)
 16.01.06 -- KOV (Correction for TT#12635)
 02.02.06 -- DV (Last update corrected)
 08.06.12 -- Glukhov (datatypes)
 19.06.14 -- Galizin (Decimal round correction)
*/

#include <stdlib.h>                      
#include "decimals.h"


#define DECLNG1 DECLNG + DECFRACTLNG

void  DLLAPI DIVDECIMAL(const L_DECIMAL D1,
                        const L_DECIMAL D2,
                              L_DECIMAL D)  /* D1/D2 -> D */
/**************************************/
{ DECSTATUS        S1, S2, S;
  register L_SWORD P1, P2, P, J;			/* 28.04.98 */
  L_SWORD          PP1, PP2, C, Q, N, B, ISNEG, IS;
  L_SWORD          F1[DECLNG1 + 1], F2[DECLNG1 + 1]; 

  S1 = GETDECSTATUS(D1);
  S2 = GETDECSTATUS(D2);
  if ( (S1 <= DECPOSITIV) &&          
      ((S2 == DECNEGATIV) || (S2 == DECPOSITIV)) )
  {
    SETDECSTATUS(DECZERO,D);
    if (S1 != DECZERO)
    {
      ISNEG = (S1 != S2);

      for (J = 0; J <= DECLNG1; J++)   
      { 
        F2[J] = 0; 
        F1[J] = 0; 
      }
      for (J = 0; ++J < DECLNG;)
      { 
        F1[J + DECFRACTLNG] = D1[J]; 
        F2[J] = D2[J];  
      }

      for(P1 = DECLNG1; /*(P1 > 0) &&*/ (F1[--P1] == 0););  
      for(P2 = DECLNG1; /*(P2 > 0) &&*/ (F2[--P2] == 0);); 

      Q = DECLIMIT / (F2[P2] + 1);  /* Q <= (DECLIMIT DIV 2) ! */

      for (C = 0, J = 0; ++J <= P2;)       
      {
        C += F2[J] * Q;
        F2[J] = (C % DECLIMIT);
        C /= DECLIMIT;
      }
        
      for(  J = 0; ++J <= P1;)     
      {
        C += F1[J] * Q;
        F1[J] = (C % DECLIMIT);
        C /= DECLIMIT;
      }
      F1[J] = C;

      B = F2[P2];

      for(IS=L_TTRUE, P = P1 - P2;; P--, P1--)                /* 16.01.06 */
      {
        N = F1[P1+1] * DECLIMIT + F1[P1];             
        Q = N / B;
        for (;;)                                      /* 06.07.95 */
        {
          N = F1[P1+1] * DECLIMIT + F1[P1];         
          N = (N - B*Q) * DECLIMIT;
          for(PP2 = P2, PP1 = P1; --PP2;)   
          {
            if (--PP1) 
              N += F1[PP1];            
            if (N -= F2[PP2] * Q) 
            {
              /* 15.07.96 */
              if (N <= -Q || N >= Q) 
                break;
              else
                N *= DECLIMIT;
              /* 15.07.96 */
            }
          }
          if (N>=0) 
            break;
          else 
            Q--;
        }
        if (Q )     
        {
          if ( P < 0 )                                     /* 16.01.06 ... */
          {
            if ( Q > 50 )
            {
              L_SWORD J;                                  /* 02.02.06 ... */
              for (J = P+2; J < DECLNG; J++)               /* 19.06.14 */
              {
                D[J]++;
                if (D[J] != DECLIMIT)
                  break;
                else
                 D[J] = 0;
              }                                            /* ... 02.02.06 */
            }
          }
          else                                             /* ... 16.01.06 */
          {
            if (P >= DECLNG-1) 
            { 
              IS=L_TFALSE; 
              break; 
            }
            D[P+1] = (L_CHAR)Q;                         
            for (C=PP2=0; ++PP2 <= P2;)             
            {
              N = F2[PP2] * Q + C;
              C = N / DECLIMIT;
              N %= DECLIMIT;
              PP1 = PP2 + P;                       
              N = F1[PP1] - N;
              if (N < 0) 
              {
                N += DECLIMIT;
                C++;
              }
              F1[PP1] = N;
            }
          }
        }
        if ( P < 0 )                                       /* 16.01.06 */
          break;
      }
      if (IS)
        if (ISNEG) 
          S = DECNEGATIV;
        else       
          S = DECPOSITIV;
      else
      if (ISNEG) 
        S = DECNEGOVER;
      else       
        S = DECPOSOVER;
      SETDECSTATUS(S,D);
    }
  }
  else
    SETDECSTATUS(DECERROR,D);
} /* end DIVDECIMAL */

