/***************************************************************************
 *                           RELEX, Inc. DBMS Linter                        *
 *  This is unpublished propietary source code of RELEX, Inc.               *
 *  The copyright notice does not evidence any actual or intended           *
 *  publication of such source code.                                        *
 *                                                                          *
 *                 Copyright (c) 1990-2012 RELEX, Inc.                      *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: convert from string to L_DECIMAL
 ----------------------------------------------------------------------------
   14.10.91 -- first release
   19.01.95 -- DV
   20.07.97 -- Ermakov (Copyright)
   08.06.12 -- Glukhov (datatypes)
*/

#include <stdlib.h>                  
#include <string.h>
#include "decimals.h"



L_SWORD DLLAPI STRTODEC(L_CHAR   *STR,        /* STR->D */
                        L_DECIMAL D)
/*************************************/
{ DECSTATUS  S;
  L_SWORD    ISNEG, ISDIG, ISVAL, ISMUL, ISOVR;
  L_SWORD    L, B, P, J, K, C;

  SETDECSTATUS(DECZERO,D);
  L = (L_SWORD) strlen(STR);
  while ((L > 0) && (STR[L-1] == ' ')) L--;
  B = 0; while ((B < L) && (STR[B] == ' ')) B++;
  P = B; while ((P < L) && (STR[P] != '.')) P++;
  ISNEG    =   ((B < L) && (STR[B] == '-'));
  if (ISNEG || ((B < L) && (STR[B] == '+'))) B++;
  ISDIG = ISVAL = ISMUL = ISOVR = L_TFALSE;
  S = DECZERO;
  for(K = DECLNG - DECFRACTLNG - 1, J = P;(S==DECZERO) && (--J >= B);)
    {
     C = (L_SWORD)(STR[J]) - (L_SWORD)('0');
     if ((C < 0) || (C > 9)) S = DECERROR;
     else
       {
        ISDIG = L_TTRUE; if (C) ISVAL = L_TTRUE;
        if (ISMUL) C *= DECBASE;
        if (K > 0) D[DECLNG-K] += (L_CHAR)C;
        else if (C) ISOVR = L_TTRUE;
       }
     if (ISMUL) K--;
     ISMUL = !ISMUL;
    }
  ISMUL = L_TFALSE;
  for(K = DECLNG - DECFRACTLNG, J = P;(S==DECZERO) && (++J < L);)
    {
     C = (L_SWORD)(STR[J]) - (L_SWORD)('0');
     if ((C < 0) || (C > 9)) S = DECERROR;
     else
       {
	ISDIG = L_TTRUE; if (C) ISVAL = L_TTRUE;
	if (!ISMUL) C *= DECBASE;
	if (K < DECLNG) D[DECLNG-K] += (L_CHAR)C;
        else if (C) ISOVR = L_TTRUE;
       }
     if (ISMUL) K++;
     ISMUL = !ISMUL;
    }
  if (S == DECZERO)
    if (!ISDIG) S = DECERROR;
    else
      if (ISOVR)
	if (ISNEG) S = DECNEGOVER;
	else S = DECPOSOVER;
      else
	if (ISVAL)
	  if (ISNEG) S = DECNEGATIV;
	  else S = DECPOSITIV;
  SETDECSTATUS(S,D);
  return OKDECSTATUS(D);
} /* end STRTODEC */

