/***************************************************************************
 *                           RELEX, Inc. DBMS Linter                        *
 *  This is unpublished propietary source code of RELEX, Inc.               *
 *  The copyright notice does not evidence any actual or intended           *
 *  publication of such source code.                                        *
 *                                                                          *
 *                 Copyright (c) 1990-2012 RELEX, Inc.                      *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: multiple two L_DECIMAL values
 ----------------------------------------------------------------------------
   14.10.91 -- first release
   20.07.97 -- Ermakov (Copyright)
   08.06.12 -- Glukhov (datatypes)
*/
#include <stdlib.h>                   
#include "decimals.h"


void  DLLAPI MULDECIMAL(const L_DECIMAL D1,
                        const L_DECIMAL D2,
                              L_DECIMAL D)        /* D1*D2 -> D */
/**************************************/
{ DECSTATUS  S1, S2, S;
  L_SWORD    J1, J2, J, C1, C, CC, ISNEG, IS;
  L_SWORD    F[DECFRACTLNG];

  S1 = GETDECSTATUS(D1);
  S2 = GETDECSTATUS(D2);
  if ((S1 == DECERROR) || (S2 == DECERROR))
    S = DECERROR;
  else if ((S1 == DECZERO) || (S2 == DECZERO))
    S = DECZERO;
  else
    {
     ISNEG = ((S1 == DECNEGATIV) || (S1 == DECNEGOVER)) !=
	     ((S2 == DECNEGATIV) || (S2 == DECNEGOVER));
     IS =    ((S1 == DECNEGATIV) || (S1 == DECPOSITIV)) &&
	     ((S2 == DECNEGATIV) || (S2 == DECPOSITIV));
     if (IS)
       {
	SETDECSTATUS(DECZERO,D);
	for (J = 0; J < DECFRACTLNG;) F[J++] = 0;
	for (J1= DECLNG;  (--J1) && IS;)
	  { C1 = D1[DECLNG-J1];	
	   if (C1)            
	     {
              CC = 0;
	      for (J2= DECLNG; (--J2) && IS;)
		{ C = C1 * D2[DECLNG-J2] + CC;  
		 if (C)               
                   {
		    J = J1 + J2 - (DECLNG - DECFRACTLNG - 1);
		    IS = (J > 0);       
		    if (IS)           
                      if (J >= DECLNG)
                        {
                         J -= DECLNG;
                         C += F[J];
                         F[J] = (C % DECLIMIT);
                        }
                      else
                        {
			 C += D[DECLNG-J];                  
			 D[DECLNG-J] = (L_CHAR)(C % DECLIMIT); 
			}
		    CC = (C / DECLIMIT);
		   }
		}
              IS = IS && (CC == 0);
             }
          }
       }
     if (IS)
       if (ISNEG) S = DECNEGATIV;
       else       S = DECPOSITIV;
     else
       if (ISNEG) S = DECNEGOVER;
       else       S = DECPOSOVER;
    }
  SETDECSTATUS(S,D);

} /* end MULDECIMAL */

