/***************************************************************************
 *                           RELEX, Inc. DBMS Linter                        *
 *  This is unpublished propietary source code of RELEX, Inc.               *
 *  The copyright notice does not evidence any actual or intended           *
 *  publication of such source code.                                        *
 *                                                                          *
 *                 Copyright (c) 1990-2012 RELEX, Inc.                      *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: get L_DECIMAL value status and return to user
 ----------------------------------------------------------------------------
   14.10.91 -- first release
   20.07.97 -- Ermakov (Copyright)
   25.12.02 -- DV (Optimization, cosmetic)
   17.02.03 -- DV (Optimization bug fixed - TT#7505)
   08.06.12 -- Glukhov (datatypes)
*/
#include <stdlib.h>

#include "decimals.h"

DECSTATUS  DLLAPI GETDECSTATUS(const L_DECIMAL D)
/***************************************/
{ 
  register DECSTATUS S;
  register L_SWORD ISZERO = L_TTRUE;
  register const L_BYTE *P = (L_BYTE *) &D[DECLNG-1];
 
  for (; P > (L_BYTE *) &D[0]; P--)                        /* 17.02.03 */
  {
    if (!*P)
      continue;
    if (*P >= DECLIMIT)
      return DECERROR;
    if (ISZERO)
      ISZERO = L_TFALSE;
  }

  S = (DECSTATUS) D[0];

  if (S == DECPOSITIV || S == DECNEGATIV)
    return ISZERO ? DECZERO : S;
  if (S == DECZERO)
    return !ISZERO ? DECERROR : S;
  if (S == DECNEGOVER || S == DECPOSOVER)
    return S;
  return DECERROR;
} /* end GETDECSTATUS */
