 /***************************************************************************
 *           RELEX, Inc. Linter Kernel source code                          *
 *  This is unpublished proprietary source code of RELEX, Inc.              *
 *  The copyright notice does not evidence any actual or intended           *
 *  publication of such source code.                                        *
 *                                                                          *
 *                  Copyright (c) 1990-2014 RELEX Inc.                      *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR: 
 ----------------------------------------------------------------------------
 PURPOSE: Intlib sources
 ----------------------------------------------------------------------------
 REVISION HISTORY:
 ---------------------------------------------------------------------------
   05.07.98  --  Ermakov - (ConvertType argument from long to L_LONG)
   23.10.98  --  RAV     - (inter_getParamName() )
   15.04.99  --  Kolbeshkin (Tree Query structures)
   01.06.00  --  Pasec (codepage, ConvertData, ConvertAnswer)
   29.08.00  --  Pasec (encoding)
   31.10.00  --  Ermakov (added DT_DEFAULT and inter_isselect)
   10.11.00  --  DV (added inter_GetBlobColNum)
   29.11.01  --  KOV (CHARSET in parameters)
   12.02.03  --  Pasec (inter_get_paradr)
   15.08.03  --  Pasechnik (inter_GetProcType)
   21.10.03  --  Galizin (VxWorks and precompiled queue in stored procedures )
   16.10.05  --  Ermakov (Corrected for 64bit arch - L from consts removed)
   08.06.12  --  Glukhov (datatypes)
*/


#ifndef _CQUERY_H_
#define _CQUERY_H_

#ifndef PREPARE_INCLUDE
#define PREPARE_INCLUDE

#define e_Alternative 0x00004000                        /* 24.12.95 */

#if defined(VXWORKS) && defined(LINTER_KERNEL)             /* 21.10.03 ... */
#define FillBufferSize KERNELFillBufferSize
#define inter_bind_name_cs KERNELinter_bind_name_cs
#define inter_bind_num_cs KERNELinter_bind_num_cs
#define ConvertAnswer  KERNELConvertAnswer
#define ConvertData KERNELConvertData
#define ConvertParameter KERNELConvertParameter
#define inter_DescribeParam KERNEL_DescribeParam
#define inter_ExtDescParam KERNEL_ExtDescParam
#define inter_GetBlobColNum KERNEL_GetBlobColNum
#define inter_GetParamCount KERNEL_GetParamCount
#define inter_GetParamName KERNEL_GetParamName
#define inter_GetParamNumber KERNEL_GetParamNumber
#define inter_GetProcType KERNEL_GetProcType
#define inter_SetEncoding KERNEL_SetEncoding
#define inter_bind_name KERNEL_bind_name
#define inter_bind_num KERNEL_bind_num
#define inter_check_bind KERNEL_check_bind
#define inter_column_number KERNEL_column_number
#define inter_fill_parameters KERNEL_fill_parameters
#define inter_get_blobnum KERNEL_get_blobnum
#define inter_get_description KERNEL_get_description
#define inter_get_paradr KERNEL_get_paradr
#define inter_isselect KERNEL_isselect
#endif /* VXWORKS && LINTER_KERNEL */                      /* ... 21.10.03 */

#ifdef __cplusplus                                         /* 11.02.14 */
 extern "C" {
#endif

extern int ConvertParameter(char *adr1, L_BYTE typ1, L_WORD len1,
                            char *adr2, L_BYTE typ2, L_WORD len2,L_LONG * RealLen,
                            L_BYTE islike, L_LONG CodePage);
extern int ConvertAnswer(char *adr1, L_BYTE typ1, L_WORD len1, L_BYTE Prec, L_BYTE Scale,
                         char *adr2, L_BYTE typ2, L_WORD len2,L_LONG * RealLen,
                         L_LONG CodePage);        /* 01.06.00 */
extern int ConvertData(char *adr1, L_BYTE typ1, L_WORD len1, L_BYTE Prec, L_BYTE Scale,
                     char *adr2, L_BYTE typ2, L_WORD len2,L_LONG * RealLen,
                     L_BYTE islike,
                     L_BYTE fConvert, L_LONG CodePage);    /* 01.06.00 */
extern int ConvertType(char *, L_BYTE, L_WORD, L_BYTE, L_BYTE,
                       char *, L_BYTE, L_WORD, L_LONG *, L_BYTE, L_BYTE, L_LONG); /* 01.06.00 */

/* This macro means what real parameter type and lengthis default for 
this parameter */
#define DT_DEFAULT     -1                                     /* 31.10.00 */

extern void inter_bind_num( TCBL *, char *, int, int, short *, char *);
extern void inter_bind_name( TCBL *, char *, char *, int, short *, char *);

#if _VER_MAX >= 600                                     /* 29.11.01 ... */
extern void inter_bind_num_cs( TCBL *, char *, int, int, short *, char *, short);
extern void inter_bind_name_cs( TCBL *, char *, char *, int, short *, char *, short);
extern void FillBufferSize( char* Range, L_WORD RLnBufRow );
#endif                                                  /* ... 29.11.01 */

extern void inter_fill_parameters( TCBL *, char * );        /* 21.06.97 */
extern int  inter_check_bind(char *, int, char *, short *);
extern int  inter_column_number(TCBL * Cbl,char *);
extern void inter_get_description(TCBL * Cbl,char *,char *);
extern int  inter_isselect(TCBL * Cbl,char * Query_Buff);       /* 31.10.00 */
extern int  inter_get_blobnum(char *);
extern void inter_GetParamCount(char* QueryBuf, short* pParamCount);
extern void inter_DescribeParam( char*  QueryBuf,     /* Query buffer */
                                 short  ParamNumber,  /* Parameter number */
                                 short* pLength, 
                                 short* pType, 
                                 short* pPrecision,
                                 short* pScale, 
                                 short* pNullable );
extern void inter_ExtDescParam(char*  QueryBuf,     /* Query buffer */
                               short  ParamNumber,  /* Parameter number */
                               short* pLength, 
                               short* pType, 
                               short* pPrecision,
                               short* pScale, 
                               short* pNullable,
                               char*  pInp,
                               char*  pOut,
                               short* pArgNum );
extern short inter_GetParamNumber(char * PreparedQuery, char * Name, short * Counter);
extern char* inter_GetParamName(char * PreparedQuery, short Number);/*23.10.98*/

extern void inter_SetEncoding(char * QueryBuf, L_LONG Encoding); /* 29.08.00 */

extern void* inter_GetStartSet( char* QueryBuf, L_WORD nSet );
extern void* inter_GetQuery( char* QueryBuf, L_WORD nQuery );
extern void* inter_GetMainQuery( char* QueryBuf );
extern void* inter_GetOperQuery( char* QueryBuf );
extern void* inter_GetExpr( char* QueryBuf, L_WORD nExpr );
extern void* inter_GetColInfo( char* QueryBuf, L_WORD nOper );

extern L_WORD inter_GetBlobColNum( char* QueryBuf, L_WORD nPar );   /* 10.11.00 */

extern void * inter_get_paradr(TCBL *CBL, char * buffer, L_WORD parnum); /* 12.02.03 */

extern L_LONG inter_GetProcType(TCBL * Cbl, char * Query_Buf, char * Out_Buf); /* 15.08.03 */

#ifdef __cplusplus                                         /* 11.02.14 */
 }
#endif

#endif

typedef struct t_Desc                                      /* 11.06.97 */
{
  char              Owner[MAX_IDENT];                      /* 26.12.00 */
  char              Table[MAX_IDENT];
  char              Column[MAX_IDENT];
  L_WORD            Length;
  char              Type;
  char              Prec;
  char              Scale;
  char              Reserv;
#if _VER_MAX >= 600
  L_WORD            Charset;                               /* 04.04.01 */
#endif
} t_Desc;

#endif /* _CQUERY_H_ */
