 /***************************************************************************
 *           RELEX, Inc. Client source include file                         *
 *  This is unpublished propietary source code of RELEX, Inc.               *
 *  The copyright notice does not evidence any actual or intended           *
 *  publication of such source code.                                        *
 *                                                                          *
 *                 Copyright (c) 1990-2005 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 FILE:   encode.h
 ----------------------------------------------------------------------------
 AUTHOR: Konstatin Mjasoedov
 ----------------------------------------------------------------------------
 PURPOSE: to define functions for convertion from Ansi to Oem
 ----------------------------------------------------------------------------
 REVISION HISTORY:
 ----------------------------------------------------------------------------

  13.08.96 -- creation date
  26.01.99 -- Fedorov A. (to upper/lower)
  16.05.00 -- ReAn -- Win1251charTo866
  01.12.00 -- ReAn - moving arrays to .h
  04.04.01 -- DV (6.0)
  22.06.2001 -- Vitaliy (to correct C++ building)
  23.09.05 -- FLY (Move some functions from strin.c)
  20.10.11 -- KOV (Koi2Ansi & Ansi2Koi for 5.9: CONVERT function)
  16.11.12 -- Glukhov,Ermakov (Remove extra code, datatypes)
*/

#ifndef __ENCODE_H
#define __ENCODE_H

#ifdef  __cplusplus /* 22.06.2001 */
extern "C" {
#endif

extern unsigned char to_up_alt[256]; /* 01.12.00.. */
extern unsigned char to_low_alt[256];
extern unsigned char DosToKoi[];
extern unsigned char KoiToDos[];
extern unsigned char cToDOS[];
extern unsigned char cToWIN[];

/* 26.11.96 -- Maxim K. */
#define win2alt(c)   ( (unsigned char)(c) >= 0x80 ? \
                     cToDOS[ (unsigned char)(c) - 0x80 ] : (unsigned char)(c) )
#define alt2win(c)   ( (unsigned char)(c) >= 0x80 ? \
                     cToWIN[ (unsigned char)(c) - 0x80 ] : (unsigned char)(c) )
#define koi2alt(c)   ( (unsigned char)(c) >= 0x80 ? \
                     KoiToDos[ (unsigned char)(c) - 0x80 ] : (unsigned char)(c) )
#define alt2koi(c)   ( (unsigned char)(c) >= 0x80 ? \
                     DosToKoi[ (unsigned char)(c) - 0x80 ] : (unsigned char)(c) ) /* ..01.12.00 */

char *Oem2Ansi(const char *s, char *d, unsigned short len);
char *Ansi2Oem(const char *s, char *d, unsigned short len);
char *Koi2Oem (const char *s, char *d, unsigned short len);
char *Oem2Koi (const char *s, char *d, unsigned short len);
char *Koi2Ansi(const char *s, char *d, unsigned short len);
char *Ansi2Koi(const char *s, char *d, unsigned short len);

            /* 26.01.99 ... */
char*  str_to_upper_alt(char* src, char* dst, unsigned short len);
char*  str_to_lower_alt(char* src, char* dst, unsigned short len);
char*  str_to_upper_koi(char* src, char* dst, unsigned short len);
char*  str_to_lower_koi(char* src, char* dst, unsigned short len);
char*  str_to_upper_win(char* src, char* dst, unsigned short len);
char*  str_to_lower_win(char* src, char* dst, unsigned short len);

            /* ... 26.01.99 */
char Win1251charTo866(char Ch); /* 16.05.00 */

/* 23.09.05 ... */
#if !defined (LITE_KERNEL) || _VER_MAX < 600
#define ToUp(c)     (char)to_up_alt[(unsigned char)(c)]
#define ToLow(c)    (char)to_low_alt[(unsigned char)(c)]
#define Izalpha(c)  (to_up_alt[(unsigned char)(c)] != to_low_alt[(unsigned char)(c)] \
                     && (unsigned char)(c) < 0xf2)
#else
/* Get upper-case latin or russian letter in 866 codepage */
char ToUp(char c);
/* Get lower-case latin or russian letter in 866 codepage */
char ToLow(char c);
/* Checks for latin or russian letter in 866 codepage */
int  Izalpha(char c);
#endif
/* ... 23.09.05 */
#ifdef __cplusplus /* 22.06.2001 */
}
#endif

#endif

