/****************************************************************************
 *           RELEX, Inc. RDBMS Linter hot reserve source code               *
 *  This is unpublished propietary source code of RELEX, Inc.               *
 *  The copyright notice does not evidence any actual or intended           *
 *  publication of such source code.                                        *
 *                                                                          *
 *                  Copyright (c) 1990-2005 RELEX Inc.                      *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ----------------------------------------------------------------------------
 PURPOSE: application interface for hot  reserve control
 
 @author Dmitry Prohorov
 ----------------------------------------------------------------------------
 REVISION HISTORY:
   02.08.08 -- Prohorov ( first edition )
   16.04.14 -- Galizin (allocation error)
 ****************************************************************************/

#ifndef HRESAPI
#define HRESAPI
int HresApi(char *CmdCode, char *UsrPassw, char *HostAddr, int Port, void *AddBuff, char **ContextPtr, int *ContextLen, int TimeoutSec);
char  *GetHresApiErrorMsg(int Error);

#define HRESAPI_OPENSOCKET_ERR      -1
#define HRESAPI_BIND_ERR            -2
#define HRESAPI_FCNTL_ERR           -3
#define HRESAPI_SENDTO_ERR          -4
#define HRESAPI_CRC_ERR             -5
#define HRESAPI_TIMEOUT_ERR         -6
#define HRESAPI_NETWORK_ERR         -7
#define HRESAPI_UNEXPECTPACKET_ERR  -8
#define HRESAPI_PACKETLEN_ERR       -9
#define HRESAPI_CSUM_ERR            -10
#define HRESAPI_FRAGMENTNUM_ERR     -11
#define HRESAPI_UNEXPECTANSWER_ERR  -12
#define HRESAPI_HOSTADDR_ERR        -13
#define HRESAPI_FRAGMENTLEN_ERR     -14
#define HRESAPI_FRAGMENTOFFS_ERR    -15
#define HRESAPI_MD5_ERR             -16
#define HRESAPI_COMMAND_ERR         -17
#define HRESAPI_ALLOC_ERR           -18                     /* 16.04.16 */
#endif
