 /***************************************************************************
 *                        RELEX, Inc. DBMS Linter                           *
 *  This is unpublished proprietary source code of RELEX, Inc.              *
 *  The copyright notice does not evidence any actual or intended           *
 *  publication of such source code.                                        *
 *                                                                          *
 *                  Copyright (c) 1990-2012 RELEX Inc.                      *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR: Peshkoff
 ----------------------------------------------------------------------------
 PURPOSE: interchange module header file
 ----------------------------------------------------------------------------
 REVISION HISTORY:

 30.03.98 -- Kent (BYTE -> CHAR for TCBL fields)
 15.04.98 -- Kent (new "dlldefs.h")
 17.06.98 -- DV (for LOLTP)
 29.06.98 -- Kent (SAVE_POINT struct)
 01.07.98 -- Kent (BOOLEAN type for inter_wait_...)
 03.07.98 -- Kent, KAA (Some bugs corrected)
 08.07.98 -- Kent (Defines)
 17.07.98 -- Kent (GETA_OUT corrected)
 21.07.98 -- Kent (Structs & defines)
 27.07.98 -- Kent (Yet another defines)
 01.10.98 -- Kent (New PrzExe flag for TRAN)
 19.11.98 -- Kent (Remove/Raname obsolete names)
 01.03.99 -- Kent (Remove last 2 bytes from P_TYPE for ver. 4.4)
 30.04.99 -- Pasec (new datatypes)
 26.05.99 -- Maxim (add quant counter command)
 11.06.99 -- Maxim -- get cursor list command
 11.06.99 -- Maxim -- events get/set command
 15.06.99 -- Maxim -- cansel cursors command (for hot reserve)
 25.08.99 -- Kononyhin (some defines for SETO)
 05.11.99 -- Kononyhin (crMode - new command for SETO)
 24.01.00 -- Kent,DV (Encodings corrected)
 01.06.00 -- Pasec (NCHAR)
 02.06.00 -- AVE,DV (Blob description for 5.8)
 05.06.00 -- DV (Field name corrected)
 13.07.00 -- Pasec (EXTFILE)
 08.09.00 -- Ermakov, DV (FREL_OUT & FATR_OUT sizes corrected)
 12.09.00 -- Kent (DIRA_OUT, DIRK_OUT sizes corrected)
 18.12.00 -- Ermakov (VXWORKS and Others system )
 26.12.00 -- Ermakov (IDENT's)
 04.04.01 -- DV (6.0)
 11.04.01 -- Kent (Add num of sorting proccess to DB_DESC)
 26.04.01 -- DV (6.0)
 04.07.01 -- DV (DESC information about kernel/client byte order difference)
 22.10.01 -- Kent (Inter Control Requests added)
 25.10.01 -- Pasec (SIZEOF_ERRS_DESCR added)
 01.11.01 -- Ermakov (Corrected header)
 03.11.01 -- Kent (Describe codepage as struct)
 26.12.01 -- Kent (Add new inter_control request)
 19.03.02 -- Galizin ( Demo licence flags )
 24.06.02 -- Kent (Reread env. request for inter_control)
 03.07.02 -- RAW (MVCC related definitions: isoation levels)
 26.09.02 -- DV (Add MaxRecSize to DESC command output)
 26.09.02 -- Goncharov (Correcting code page names for english locale)
 30.09.02 -- Goncharov - locale check added
 28.10.02 -- Ermakov (Added Q_USE_UTF8)
 15.11.02 -- KOV (Changes for ADO)
 12.02.03 -- Pasec (OPEN_DESC)
 12.03.03 -- KOV (Added extension for OPEN command, PT#2556)
 19.08.03 -- RAW (Changed code for read uncommitted mode)
 16.12.03 -- Galizin ( Prevent build without _VER_MAX )
 23.12.03 -- Ermakov (For MIDL compatible)
 18.10.04 -- KOV (Added two flags: OPENDESC_PASS_EXTERNAL - password defined by another user, must be changed;
                                   OPENDESC_PASSLIFEEND - life of password expired, password must be changed )
 20.07.05 -- FLY (Lost keyword #error)
 21.12.05 -- Ermakov (Added new states)
 03.01.06 -- Ermakov (Correct OPENDESC structure)
 22.06.06 -- Pasechnik (see below)
 22.08.06 -- Pasechnik (ODBC_NUM_TYPE)
 25.10.06 -- Ermakov (recommended blob size constant)
 01.11.06 -- Ermakov (Added L_EXTFILENAMESIZE && EXTFILE_DESC)
 08.09.08 -- KOV (Added some exceptions)
 15.09.08 -- KOV (Added some flags)
 07.10.09 -- KOV,Galizin (Possibility of big buffer for exchange)
 05.04.10 -- KOV (Added flag for LARGE_EXCHANGE into DBDESC,OPENDESC structures)
 01.08.10 -- Ganin (Added charset macros for Linter 6 charset names)
 04.02.11 -- DV  (Correct custom exception numbering)
 15.12.11 -- Ganin (parenthesis for macro definition of Q_866)
 10.05.12 -- Galizin (Set stack size)
 31.06.12 -- Glukhov N.A. (Correct datatypes)
 08.06.12 -- Glukhov (datatypes)
 03.10.12 -- Galizin (Packet attribute for some compilers)
 29.05.13 -- Plotnikov (Android)
 10.12.13 -- Reshetnyak (fields for sql chache in DB_DESC)
*/

#ifndef __INTER_H__
#define __INTER_H__

#include "lincodes.h"
#include "typedef.h"
#include "dlldefs.h"
#include "intlib2.h"

#if !defined(_VER_MAX)                                      /* 16.12.03 */
#ifndef __midl                                              /* 23.12.03 */
# error _VER_MAX is not defined!!!                          /* 20.07.05 */
#endif
#endif

#if _VER_MAX >= 590
#define MAX_ID_LEN   66                                  /* 26.12.00 */
#else
#define MAX_ID_LEN   18                                  /* 27.07.98 */
#endif
#define MAX_NODE_LEN 8                                   /* 27.07.98 */

/* File's type */
#define FT_INDEX    0                                    /* 08.07.98 ... */
#define FT_DATA     1
#define FT_SYSWBV   2
#define FT_SYSWRK   3
#define FT_SYSSRT   4
#define FT_SYSLOG   5
#define FT_BLOB     7

/* 
 * 22.06.06 
 * min and max numder of data type identifier
 */
#define DT_MIN_TYPE_ID   1
#define DT_MAX_TYPE_ID   16                                   /* 22.08.06 */

/* Datatypes */
/* Attention! Comments see below. */
#define DT_CHAR     1
#define DT_INTEGER  2
#define DT_REAL     3
#define DT_DATE     4
#define DT_DECIMAL  5
#define DT_BYTE     6
#define DT_BLOB     7
#define DT_VARCHAR  8                                       /* 30.04.99 ...*/
#define DT_VARBYTE  9
#define DT_BOOL     10                                      /*... 30.04.99 */
#define DT_NCHAR    11                                      /* 01.06.00 */
#define DT_NVARCHAR 12                                      /* 01.06.00 */
#define DT_EXTFILE  13                                      /* 13.07.00 */

/*
 * 22.06.06
 * These type identifiers are used for internal data convertion routines 
 * by high-level API and ODBC driver. It used for data conversion
 * from/to LINTER timestamp type and ODBC date, time and timestamp data types.
 *
 * Attention!
 * If new DT_XXXXXX types added, these identifiers must be changed 
 * or new identifier must have greater id.
 * According to these changes, corresponding API routines 
 * and DT_MAX_TYPE_ID must be changed.
 *
 * Otherwise some functionality will break!
 */
#define ODBC_DAT_TYP  13   /* date */
#define ODBC_TIM_TYP  14   /* time */
#define ODBC_DTM_TYP  15   /* timestamp */
#define ODBC_NUM_TYP  16   /* numeric */                      /* 22.08.06 */


/* States for queue's items (exclude channels) */
#define QIS_FREE  0
#define QIS_BUSY  1

/* States for channels */
#define CHS_FREE   0
#define CHS_IDLE   1
#define CHS_BUSY   2
#define CHS_EVENT  3
#define CHS_WAIT   4
#define CHS_CLEAR  5
#define CHS_DEBUG  6
#define CHS_PAUSE  7                                            /* 21.12.05 */
#define CHS_USED   8                                            /* 21.12.05 */


/* Operation systems */
#define OS_UNKNOWN  0
#define OS_UNIX     1
#define OS_UNIXWARE 2
#define OS_USIX     3
#define OS_FREEBSD  4
#define OS_LINUX    5
#define OS_UNIXSCO  6
#define OS_SINIX    7
#define OS_MSVS     8
#define OS_MSVT     9
#define OS_MSDOS    10
#define OS_WIN3XX   11
#define OS_WIN95    12
#define OS_WINNT    13
#define OS_OS9      14
#define OS_OS9000   15
#define OS_VAXVMS   16
#define OS_NETWARE  17
#define OS_IBMOS2   18
#define OS_QNX      19                                   /* ... 08.07.98 */
#define OS_DIGITAL  20
#define OS_SUNSPARC 21
#define OS_SUNI386  22
#define OS_AIX      23
#define OS_SGI      24
#define OS_VXWORKS  25                                   /* 18.12.00 */
#define OS_WINCE    26                                   /* 29.05.13 */
#define OS_ANDROID  27                                   /* 29.05.13 */

/* NOTE! Please uncomment next section for backward comp. */
/*
#define coder    CodErr
#define isn      Isn
#define przexe   PrzExe
#define syserr   SysErr
#define comand   Command
#define priority Prior
#define node     Node
#define lnbufkor LnBufKor
#define nameuser UserName
*/
/*
#define Isn      RowId
#define KolKor   RowCount
#define LnBufKor LnBufRow

#define CODERR   CodErr
#define ISN      RowId
#define KOLKOR   RowCount
#define NMRKAN   NumChan
#define LNBUFKOR LnBufRow
*/
/* Some defines for SETO */
#define crName       0   /* Set cursor name */                /* 25.08.99 ...*/
#define crPrior      1   /* Set cursor priority */
#define crQueryPrior 2   /* Set query priority */
#define crCancel     3   /* Cancel current query */
#define crPause      4   /* Pause current query */
#define crContinue   5   /* Continue current query */         /*... 25.08.99 */
#define crMode       6   /* set channel mode */               /* 05.11.99 */

struct FREL_IN
  {
  L_LONG       Owner;
  L_CHAR       TblName[MAX_ID_LEN];                     /* 26.12.00 */
  };
typedef struct FREL_IN FREL_IN;

struct FREL_OUT
  {
  L_LONG       Table;
  L_LONG       Owner;
  L_CHAR       TblName[MAX_ID_LEN];                      /* 26.12.00 */
#if _VER_MAX >= 600                                  /* 26.04.01 */
  L_BYTE       Desc[288];
#elif _VER_MAX >= 570                                /* 08.09.00 */
  L_BYTE       Desc[284];
#elif _VER_MAX >= 500                                /* 03.07.98 */
  L_BYTE       Desc[244];
#else
  L_BYTE       Desc[162];
#endif
  };
typedef struct FREL_OUT FREL_OUT;

struct FATR_IN
  {
  L_LONG       Table;
  L_CHAR       ColName[MAX_ID_LEN];                     /* 26.12.00 */
  };
typedef struct FATR_IN FATR_IN;

struct FATR_OUT
  {
  L_LONG       Table;
  L_WORD       Column;
  L_CHAR       ColName[MAX_ID_LEN];                     /* 26.12.00 */
#if _VER_MAX >= 570                                  /* 08.09.00 */
  L_BYTE       Desc[104];
#elif _VER_MAX >= 500                                /* 03.07.98 */
  L_BYTE       Desc[96];
#else
  L_BYTE       Desc[64];
#endif
  };
typedef struct FATR_OUT FATR_OUT;

struct DIRR_OUT
  {
  L_LONG       Owner;
  L_CHAR       TblName[MAX_ID_LEN];                     /* 26.12.00 */
  L_WORD       UpdFlag;
  };
typedef struct DIRR_OUT DIRR_OUT;

struct DIRA_OUT
  {
  L_LONG       Owner;
  L_CHAR       TblName[MAX_ID_LEN];                     /* 26.12.00 */
  L_CHAR       ColName[MAX_ID_LEN];
  L_BYTE       UpdFlag;                                    /* 12.09.00 */
  L_BYTE       Reserve[3];                                 /* 12.09.00 */
  };
typedef struct DIRA_OUT DIRA_OUT;

struct DIRF_OUT
  {
  L_LONG       Owner;
  L_CHAR       TblName[MAX_ID_LEN];                             /* 26.12.00 */
  L_BYTE       Type;
  L_BYTE       Extent;
  L_LONG       State;
  };
typedef struct DIRF_OUT DIRF_OUT;

struct DIRK_OUT
  {
  L_LONG       User;
  L_LONG       Task;
  L_BYTE       State;
  L_BYTE       Process;                                    /* 12.09.00 */
  L_BYTE       Reserve[2];                                 /* 12.09.00 */
  };
typedef struct DIRK_OUT DIRK_OUT;

struct FCUR_OUT              /* 03.07.98 */
  {
  L_WORD       Channel;
  L_BYTE       Updatable;
  L_BYTE       Process;
  L_LONG       AnsCnt;
  };
typedef struct FCUR_OUT FCUR_OUT;

#if !defined(PACKED_ATTR)                                   /* 03.10.12 ... */
#define PACKED_ATTR
#endif
struct PACKED_ATTR GETA_OUT                                 /* ... 03.10.12 */
  {
  L_CHAR       User[MAX_ID_LEN];                                /* 26.12.00 */
  L_CHAR       Table[MAX_ID_LEN];
  L_CHAR       Column[MAX_ID_LEN];                              /* 26.12.00 */
#if _VER_MAX >= 500
  L_WORD       Length;
  L_BYTE       Type;                                     /* 17.07.98 */
#else
  L_BYTE       Type;                                     /* 17.07.98 */
  L_BYTE       Length;
#endif
  L_BYTE       Precision;
  L_BYTE       Scale;
#if _VER_MAX >= 500
  L_BYTE       Reserve;
#endif
#if _VER_MAX >= 600
  L_WORD       CharSet;                                 /* 26.04.01 */
#endif
  };
typedef struct GETA_OUT GETA_OUT;

struct DB_DESC
  {
  L_LONG       VerMajor;
  L_LONG       VerMinor;
  L_LONG       VerBuild;
  L_LONG       SortPoolSize;
  L_LONG       KernelPoolSize;
  L_LONG       FileQueueSize;
  L_LONG       UserQueueSize;
  L_LONG       TableQueueSize;
  L_LONG       ColumnQueueSize;
  L_LONG       ChannelQueueSize;
  L_LONG       SnapTimeout;
  L_LONG       KillTimeout;
  L_WORD       NumOfSort;                                  /* 11.04.01 */
  L_BYTE       Flags;                                      /* 04.07.01 ... */
#define KERNEL_INVBYTEORD 0x01
#define KERNEL_DEMOLIC    0x02                             /* 19.03.02 */
#define KERNEL_DEMOLICEXP 0x04                             /* 19.03.02 */
#define KERNEL_ENG_LOCALE 0x08                             /* 30.09.02 */
#define KERNEL_STANDARD_MODE  0x10                         /* 15.09.08 ... */
#define KERNEL_GEOPREFIX_MODE 0x20
#define KERNEL_READONLY_MODE  0x40                         /* ... 15.09.08 */
#define KERNEL_QUANT_TIME     0x80                         /* 05.04.10 ... */
  L_BYTE       Flags2;                                     /* ... 04.07.01 */
#define  KERNEL2_LARGE_EXCHANGE 0x01                       /* ... 05.04.10 */
  L_LONG       LReserv2;
  L_WORD       SQLUsrCacheSize;                            /* 10.12.13 ... */
  L_WORD       SQLTabCacheSize;
  L_WORD       SQLColCacheSize;
  L_WORD       SQLPrcCacheSize;
  L_WORD       SQLChsCacheSize;                            /* ... 10.12.13 */
  L_WORD       MaxRecSize;                              /* 26.09.02 */
  L_CHAR       BaseName[18];
  L_CHAR       SysLog;
  L_CHAR       Sync;
  L_CHAR       Log;
  L_CHAR       Os;
  L_WORD       CharSet;                                 /* 26.04.01 */
  };
typedef struct DB_DESC DB_DESC;

#define OPENDESC_CSET_CHANGED  0x01                         /* 12.03.03 */
#define OPENDESC_PASS_EXTERNAL 0x02                         /* 18.10.04 */
#define OPENDESC_PASSLIFEEND   0x04                         /* 18.10.04 */
typedef struct
{
  L_LONG VerMajor;
  L_LONG VerMinor;
  L_LONG VerBuild;
  L_BYTE Flags;
  L_BYTE DBFlags;  /* Same as Flags in DBDESC */            /* 03.02.06 */
  L_WORD MaxRecSize;
  L_CHAR BaseName[18];
  L_CHAR SysLog;
  L_CHAR Sync;
  L_CHAR Log;
  L_CHAR Os;
  L_WORD DefCharSet;
  L_WORD UseCharSet;
  L_BYTE DBFlags2;                                         /* 05.04.10 */
  L_BYTE Reserved;                                         /* 12.03.03 */
  L_CHAR UseCharSetName[MAX_ID_LEN];                       /* 12.03.03 */
 } OPEN_DESC;                                              /* 12.02.03 */

/* Procedure translation error description */
struct ERRS_DESCR
  {
  L_LONG  CodErr;
  L_LONG  Row;
  L_LONG  Position;
  L_CHAR  ArgType;
  };
typedef struct ERRS_DESCR ERRS_DESCR;

/* sizeof struct ERRS_DESCR */                             /* 25.10.01 ... */
/*
  ATTENTION! ATTENTION!
  If ERRS_DESRC is being modified then SIZEOF_ERRS_DESCR must be corrected
  as well.
*/
#define SIZEOF_ERRS_DESCR 13                               /* ... 25.10.01 */

/* Values of the ArgType field */
#define PROC_ERR_NOARG          0   /* error message hasn't got parameters      */
#define PROC_ERR_ARGSHORT       1   /* error message has short number parameter */
#define PROC_ERR_ARGSTRING      2   /* error message has a string parameter     */

/* Standard exceptions */
#define EXC_NONE        0
#define EXC_DIVZERO    -2
#define EXC_UNDEFPROC  -3
#define EXC_BADPARAM   -4
#define EXC_BADINDEX   -5
#define EXC_BADRETVAL  -6
#define EXC_NULLDATA   -7
#define EXC_NOMEM      -8
#define EXC_BADCURSOR  -9
#define EXC_CURNOTOPEN -10
#define EXC_BADCODE    -11
#define EXC_TRIGQUERY  -12
#define EXC_APPENDNOTSTARTED     -14                       /* 08.09.08 ... */
#define EXC_QUERYWHENAPPEND      -15
#define EXC_APPENDACTIVE         -16
#define EXC_APPLICATIONERROR     -17 /* error raised by raise_error function */
#define EXC_INVTRSTATE           -18 /* invalid transaction state */ /* ... 08.09.08 */
#define EXC_CUSTOM     -100                                /* 04.02.11 */

/* Parameter type */
struct P_TYPE
  {
  L_WORD length;  /* length               */
  L_BYTE ntyp;    /* code                 */
  L_BYTE prcs;    /* precision of number  */
  L_BYTE scale;   /* scale of number      */
  L_BYTE reserv;  /* reserved - 05.07.95  */
#if _VER_MAX >= 600
  L_WORD charset;                                         /* 04.04.01 */
#endif
  };
typedef struct P_TYPE P_TYPE;

/* Returned value/Output parameter information */
struct ARGPROC_OUT
  {
  L_BYTE Flags;           /* Argument flags -- mask of bits, see below */
  L_BYTE Reserv;
#if _VER_MAX >= 550
  L_WORD Expr;            /* Expression id -- used for internal purposes */
#endif
  L_WORD Value;           /* Value offset   */
  P_TYPE Type;          /* Argument type  */
#if _VER_MAX >= 550
  L_WORD Reserv2;
#endif
  };
typedef struct ARGPROC_OUT ARGPROC_OUT;

#define PARM_FLAG_ISNULL        2  /* parameter value is NULL */
#define PARM_FLAG_ISCURSOR      4  /* parameter is cursor     */
#define PARM_FLAG_NAMESENT      8  /* the name of parameter is sent in asciid format */

/* Cursor representation structure */
struct CR_INFO
  {
  L_WORD  NumChan;                                       /* 19.11.98 ... */
  L_WORD  LnBufRow;
  L_LONG  RowId;
  L_LONG  RowCount;
  L_LONG  CodErr;                                        /* ... 19.11.98 */
  };
typedef struct CR_INFO CR_INFO;

struct BLOB_ATR
  {
  L_LONG   Size;
  L_LONG   Adr_First_Pag;
  L_LONG   Adr_Last_Pag;
  L_BYTE   NmrFil;
#if _VER_MAX >= 580                                     /* 02.06.00 ... */
  L_BYTE   Pad[1];
  L_BYTE   Index_Time[6];      /* Really LDATETIME (datetime.h) */
  L_LONG   TypeObj;                                    /* 05.06.00 */
#else
  L_BYTE   TypeObj;                                    /* 05.06.00 */
#endif                                                  /* ... 02.06.00 */
  };
typedef struct BLOB_ATR BLOB_ATR;
#define OPTIMUM_PORTION_SIZE 4048                       /* 25.10.06 */

/* */
#define L_EXTFILENAMESIZE 512                                /* 01.11.06 ... */
struct EXTFILE_DESC
{
  L_LONG    FilterId;
  L_BYTE    IndexTime[6];                   /* Really LDATETIME (datetime.h) */
  L_CHAR    FileName[L_EXTFILENAMESIZE];
};                                                           /* ... 01.11.06 */
typedef struct EXTFILE_DESC EXTFILE_DESC;

#define NPCBL TCBL     *
#define LPCBL TCBL FAR *

#ifdef __cplusplus
 extern "C" {
#endif

L_LONG  DLLAPI inter(TCBL *, void *, void *, void *, HPVOID);
L_BOOL  DLLAPI inter_wait_single(TCBL *, L_LONG );
L_BOOL  DLLAPI inter_control(TCBL *, int, void *, int); /* 01.11.01 22.10.01 */

#ifdef LARGE_EXCHANGE                                      /* 07.10.09 ... */
#define MAX_CLIENT_BUFSIZE   65535
#else
#define MAX_CLIENT_BUFSIZE   8192
#endif                                                     /* ...  07.10.09 */

/* 26.05.99... */
#define QUANT_PAUSE     1
#define QUANT_CONTINUE  2
#define QUANT_WHILE     3
#define QUANT_SET       4
#define CANSEL_CURSORS  5                               /* 15.06.99 */
#define GET_EVENT       6                               /* 11.06.99 */
#define SET_EVENT       7                               /* 11.06.99 */
/* ...26.05.99 */

#ifdef __cplusplus
 }
#endif

#endif

/* -- End inter.h ----------------------------------------------------------- */

