 /***************************************************************************
 *                        RELEX, Inc. DBMS Linter                           *
 *  This is unpublished proprietary source code of RELEX, Inc.              *
 *  The copyright notice does not evidence any actual or intended           *
 *  publication of such source code.                                        *
 *                                                                          *
 *                  Copyright (c) 1990-2012 RELEX Inc.                      *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR: Peshkoff
 ----------------------------------------------------------------------------
 PURPOSE: interchange module header file
 ----------------------------------------------------------------------------
 REVISION HISTORY:

  01.07.93 -- Alex
  06.02.95 -- Kent
  30.06.95 -- DV
  01.11.95 -- Peshkoff
  13.01.96 -- Kent
  12.02.97 -- Peshkoff
  31.07.97 -- Kent
  14.12.97 -- Ermakov ( Alpha )
  05.01.98 -- Ermakov ( MSV... )
  12.03.98 -- Kent
  18.03.98 -- Kent (Old ver. compat.)
  30.03.98 -- Kent (BYTE -> CHAR for TCBL fields)
  15.04.98 -- Ermakov (OS9000 err. )
  16.04.98 -- Peshkoff (QNX)
  15.04.98 -- Kent (new "dlldefs.h")
  17.06.98 -- DV (for OLTP)
  29.06.98 -- Kent (SAVE_POINT struct)
  01.07.98 -- Kent (New user's AST proc.)
  05.07.98 -- Ermakov (DIGITAL_UNIX)
  01.10.98 -- Kent (New PrzExe flag for TRAN)
  12.11.98 -- Kent (New UNIX IPC)
  03.12.98 -- Kent
  22.12.98 -- Kent (UninitLinterClient prototype)
  13.02.99 -- Ermakov (For SUN)
  13.02.99 -- Kent (HANDLE instead void * - it's more right)
  16.03.99 -- E.Exarevsky (add OS_AIX, OS_SGI)
  22.03.99 -- Kent (Add thread's handle to ASTMSG)
  07.04.99 -- E.Exarevsky (No sem_id in TASTMSG ifdef NO_SEMAPHORES)
  26.05.99 -- Maxim (add quant counter command)
  11.06.99 -- Maxim -- get cursor list command
  11.06.99 -- Maxim -- events get/set command
  15.06.99 -- Maxim -- cansel cursors command (for hot reserve)
  29.07.99 -- Kent (Correct type for field `reserve' in `SDESC')
  21.12.99 -- Kent (New macro for msg max. length)
  24.01.00 -- Kent,DV (Encodings corrected)
  25.01.00 -- Kent (Add modes bits)
  20.03.00 -- Kent (For asynch. replication)
  26.12.00 -- Ermakov      (IDENT's)
  11.01.01 -- VxWorks
  07.04.01 -- Ermakov      ( Correct for VX )
  22.10.01 -- Kent (Inter Control Requests added)
  03.11.01 -- Kent (Describe codepage as struct)
  26.12.01 -- Kent (Add new inter_control request)
  08.04.02 -- Kent (Windows CE)
  21.05.02 -- Galizin ( QNX include file TT#5298 )
  24.06.02 -- Kent (Reread env. request for inter_control)
  03.07.02 -- RAW (MVCC related definitions: isoation levels)
  22.08.02 -- Galizin      (Pthread version PT#568)
  28.08.02 -- Galizin      (Pthread version PT#568)
  26.09.02 -- DV  (Savepoint name have standard length)
  26.09.02 -- Goncharov    (Correcting code page names for english locale)
  15.11.02 -- KOV (Changes for ADO)
  08.01.03 -- Kononyhin (different exchanges for WIN32)
  19.08.03 -- RAW (Changed code for read uncommitted mode) 
  07.06.04 -- Ermakov ( Added wceclib.h - For CE )
  08.12.04 -- Galizin ( OS2000 real multythread version)
  16.10.05 -- Ermakov ( Corrected for 64bit arch. mtyp_t replaced by IPC_TYP )
  28.11.05 -- Pasechnik (support 6.x codepage definitions for 5.x)
  13.02.07 -- Ermakov (Remove OS2 support )
  07.04.08 -- Ermakov (Avoid cond incompatible for linux)
  19.06.09 -- Ermakov,KOV (Correction for TT#18884)
  07.10.09 -- KOV,Galizin (Possibility of big buffer for exchange)
  19.10.09 -- Galizin(Large exchange compatible)
  14.12.09 -- Galizin ( QNX native exchange)
  22.01.10 -- Egorov (Modified for RTOS)
  01.08.10 -- Ganin (Added compatibility charset macros for _ENGLATIN1)
  10.05.12 -- Galizin (Setting intlib stack size by variable)
  08.06.12 -- Glukhov (datatypes)
  30.07.12 - Galizin(OpenVMS)
  06.09.12 -- Pashentsev (Corrected stack size for 64 bit architecture)
  16.11.12 -- Glukhov,Ermakov (Remove extra code, datatypes)
  29.05.13 -- Plotnikov (Android)
  12.04.13 -- Plotnikov (iOS. Threads)
  07.04.14 -- Plotnikov, Galizin (Some glibc versions problem. Guard area inside the thread stack.
              Increase thread stack size for UNIX 64bit arch. TT24420)
  24.08.14 -- Galizin (Kerberos authentication)
*/

#ifndef __INTLIB_H__
#define __INTLIB_H__

#if defined(INTER_NLM) || defined(UNIX) || defined(OS9000) || defined(VMS) || defined(QNXNATIVE) /* 14.12.09 */
#if defined(UNIX) && !defined(SOCKETS)
#include <sys/msg.h>
#define IPC_TYP key_t
#else
#define IPC_TYP L_LONG
#endif
#endif                                                 /* ... 14.12.97 */

#if defined(QNX) && !defined(QNXNATIVE)                      /* 14.12.09 */
# include <mqueue.h>
#endif

#ifdef RTOS32                                                /* 15.02.07 */
# include <rtk32.h>
#endif
#if defined(LIN_PTHREAD) || defined(OS2000) || defined(IOS)  /* 12.04.13 08.12.04 28.08.02 */
#define PTHREAD_INTLIB
#endif

#if defined(PTHREAD_INTLIB)                                  /* 22.08.02 */
# include <pthread.h>
typedef union                                                /* 07.04.08 ... */
{
  pthread_cond_t  Cond;
  char            Pad[48];
} L_pthread_cond_t;
#endif                                                       /* ... 07.04.08 */

#include "lincodes.h"
#include "typedef.h"
#include "dlldefs.h"                                       /* 15.04.98 */

/* -- Common Defines -------------------------------------------------------- */
#include "intlib2.h"

#define TIMEOUT      5
#define VAL_NULL     1

#if defined(UNIX) || defined(QNX)
#  define KEYLIN 20561
#  define KEYNET 20562
#endif

#ifdef INTER_MSWINDOWS
#  define KEYLIN "Linter"
#  define KEYNET "LinDbc"
#define WM_LINTER_CALL 0x004A
typedef struct
  {
  L_LONG  dwData;
  L_LONG  cbData;
  void   *lpData;
  } DATASTRUCT;
#endif

#ifdef  OS9000
#define SIGCHECKSHUT 24560
#define BASESIG      24561
#define KEYLIN       "LINTER"
#define KEYNET       "LINTER_NET"
#define TIMECHECK(t) ((t << 8) | 0x80000000)
#ifdef OS9
#define ADRDAT(a) ((int *)((char *)(a) + ((Mh_exec)a)->_mexec))
#else
#define ADRDAT(a) ((int *)((char *)(a) + (a)->m_exec))
#endif
typedef struct t_PIPEMSG
  {
  int  pid;
  int  timefork;
  int  addr;
  int  sigcod;
  } PIPEMSG;
#endif

#ifdef VMS
struct t_DSK
  {
  int   ss;
  char *adr;
  } DSK;
#endif

#ifdef WIN32
#  define LIN_MBX TEXT("LINTER_MBX")
#  define NET_MBX TEXT("NET_MBX")
#else
#  define LIN_MBX "LINTER_MBX"
#  define NET_MBX "NET_MBX"
#endif

/* -- Tail Message ---------------------------------------------------------- */

#define OS_UNKNOWN  0
#define OS_UNIX     1
#define OS_UNIXWARE 2
#define OS_USIX     3
#define OS_FREEBSD  4
#define OS_LINUX    5
#define OS_UNIXSCO  6
#define OS_SINIX    7
#define OS_MSVS     8                                     /* 05.01.98 */
#define OS_MSVT     9                                     /* 05.01.98 */
#define OS_MSDOS    10
#define OS_WIN3XX   11
#define OS_WIN95    12
#define OS_WINNT    13
#define OS_OS9      14
#define OS_OS9000   15
#define OS_VAXVMS   16
#define OS_NETWARE  17
#define OS_IBMOS2   18
#define OS_QNX      19                                     /* 16.04.98 */
#define OS_DIGITAL  20                                     /* 13.02.99 */
#define OS_SUNSPARC 21                                     /* 13.02.99 */
#define OS_SUNI386  22
#define OS_AIX      23                                     /* 16.03.99 */
#define OS_SGI      24                                     /* 16.03.99 */
#define OS_VXWORKS  25                                     /* 11.01.01 */
#define OS_WINCE    26                                     /* 08.04.02 */
#define OS_ANDROID  27                                     /* 29.05.13 */
#define OS_IOS      28                                     /* 12.04.13 */

#define PROT_UNKNOWN  0
#define PROT_IPX      1
#define PROT_SPX      2
#define PROT_TCPIP    3
#define PROT_NETBIOS  4
#define PROT_DECNET   5
#define PROT_NPIPE    6

typedef struct TAILMSG
  {
  L_LONG ClientRealPid;
  L_LONG ClientSocket;
  L_LONG ServerSocket;
  L_WORD AstInd;
  L_WORD UsrDef;
  L_BYTE NetAddr[20];
  L_LONG ServerDesc;
  L_LONG lReserv;
  L_WORD wReserv;
  L_BYTE Net;
  L_BYTE Os;
  } TAILMSG;

#define LENTAIL sizeof(TAILMSG)


/* -- Linter Message -------------------------------------------------------- */

#if defined(VMS) || defined(OS9000) || defined(UNIX)
#  define TNAMELEN (sizeof(L_LONG) + sizeof(IPC_TYP))      /* 18.03.98 */
#else
#  define TNAMELEN sizeof(L_LONG)
#endif

#ifdef LARGE_EXCHANGE                                      /* 07.10.09 ... */
#define MAXMSG (0x10000 - 8 - 4)
#else
#define MAXMSG (8192 - 4)                                  /* 21.12.99 */
#endif                                                     /* ...  07.10.09 */
#define LENBUF (MAXMSG - LENCBL - TNAMELEN)                /* 21.12.99 */
#define MAXBUF (LENBUF - LENTAIL - 6 - 8)

#if defined(RTOS32) || defined(UNIX) || defined(QNX) || defined(VXWORKS) || defined(PTHREAD_INTLIB)
#define ReadMsgFromServer_THREAD_STACK_SIZE 1024*1024      /* 24.08.14 */
#define CheckServer_THREAD_STACK_SIZE (32*1024)                  /* 13.05.07 */
#else
#define ReadMsgFromServer_THREAD_STACK_SIZE (0L)
#define CheckServer_THREAD_STACK_SIZE (0L)
#endif

/* 08.01.03 ...*/
#ifdef WIN32
#ifdef RTOS32
  DWORD *dwSerBuff;                                              /* 26.04.07 */
  DWORD *dwClientBuff;                                           /* 29.04.07 */
#endif
typedef struct OutProcessInfo_tag
{
  DWORD		dwProcessId;
#ifdef RTOS32
  DWORD *dwSerBuff;                                              /* 09.04.07 */
#endif
} OutProcessInfo, *POutProcessInfo;

#ifdef RTOS32
# include "init.h"
#endif

typedef struct ExchangeOut_tag
{
/* exchange objects for shared memory exchange */
  HANDLE	hEventLinterReady;    /* queue is unlocked by linter */
  HANDLE	hEventLinterAdd;      /* message added to the linter queue */
  HANDLE	hFileMapLinter;       /* linter queue: file-mapped object */
  LPVOID	lpvMapViewLinter;     /* linter queue: view of mapped-file */
/* exchange objects for mailslot exchange */
  HANDLE	hMailslotLinter;
/* output process info */
  OutProcessInfo	ProcessInfo;
/* thread for checking server */
  HANDLE	hServer;   /* server handle(linter or agent) opened by OpenProcess */
} ExchangeOut, *PExchangeOut;

typedef struct ExchangeIn_tag
{
/* exchange objects for shared memory exchange */
  HANDLE	hEventClientReady;    /* queue is unlocked by client */
  HANDLE	hEventClientAdd;      /* message added to the client queue */
  HANDLE	hFileMapClient;       /* client queue: file-mapped object */
  LPVOID	lpvMapViewClient;     /* client queue: view of mapped-file */
/* exchange objects for mailslot exchange */
  HANDLE	hMailslotClient;
/* thread for checking servers */
  HANDLE	hChkThrd;
  HANDLE	hEventSyncChkThrd;
} ExchangeIn, *PExchangeIn;

typedef enum KernelType_tag
{
  remote_ker = 0,
  local_ker = 1
} KernelType;

typedef enum ExchangeType_tag
{
  undefined_exch = 0,
  memory_exch,
  slot_exch
} ExchangeType;
#endif
/*... 08.01.03 */

typedef struct TMSG
  {
#if defined(VMS) || defined(UNIX) || defined(OS9000) || defined(QNXNATIVE) /* 14.12.09 */
  IPC_TYP    Msg_Type;
#endif
  L_LONG     TaskName;
  TCBL  CBL;
  union
    {
    L_BYTE Byte[LENBUF];
    L_WORD Word[LENBUF/2];
    } Buf;
#ifdef WIN32
  L_LONG     ExtraLen;                                     /* 19.06.09 */
#endif
  } TMSG;

#define LENMSG sizeof(TMSG)
#ifndef LNGMSG
#define LNGMSG LENMSG                                /* 18.03.98 */
#endif

/* -- Message Descriptor ---------------------------------------------------- */

typedef struct
  {
  TCBL   *CBL;
  void   *Range;
  void   *Korteg;
  L_WORD  NmrCom;
  L_BYTE  Actual;
  L_WORD  AstIndex;                                          /* 22.08.02 */
#if defined(KRB_AUTH)                                     /* 24.08.14 ... */
  void   *KrbData;
#endif                                                    /* ... 24.08.14 */
#ifdef INTER_MSWINDOWS
  HANDLE  hTid;                                           /* 22.03.99 */
  DWORD   dwTid;                                          /* 12.03.98 */
/* 08.01.03 ...*/
  PExchangeOut  *ppOutput;
  HANDLE  *hAsyncEvent;   /* exchange between threads - intlib */
/*... 08.01.03 */
#endif
#if defined(PTHREAD_INTLIB)                                /* 22.08.02 ... */
  L_BYTE     WaitFlag;
  pthread_mutex_t  Mutex;
  L_pthread_cond_t LCond;                                       /* 07.04.08 */
#endif                                                      /* ... 22.08.02 */
#if defined(UNIX) || defined (QNX) || defined(VXWORKS)     /* 16.04.98 */ /* 11.01.01 */
  int   Server;         /* 12.02.97 */
  int   Status;         /* 12.02.97 */
#ifdef UNIX
  int    *msg_id;         /* 31.07.97 */
#else
#if !defined(QNXNATIVE)                                     /* 14.12.09 */
  mqd_t  *msg_id;         /* 07.04.01 */
#endif
#endif
#if !defined(SOCKETS) && !defined(NO_SEMAPHORES)           /* 07.04.99 */
  int  *sem_id;         /* 31.07.97 */
#endif
#endif
#ifdef OS9000
  TMSG *ShMem;
  int   Server;
#endif
#if defined(VMS)
  L_WORD Mailbox;                                           /* 30.07.12 */
#endif
  USR_PROC UsrProc;
  } TASTMSG;

#if defined(UNIX) && defined(SOCKETS)                    /* 12.11.98 */
typedef struct
  {
  IPC_TYP Reserve;                                        /* 29.07.99 */
  int     TaskName;
  TCBL cbl;
  char pad[8];
  } SDESC;
#endif

/* 26.05.99... */ 
#define QUANT_PAUSE     1
#define QUANT_CONTINUE  2
#define QUANT_WHILE     3
#define QUANT_SET       4
#define CANSEL_CURSORS  5                               /* 15.06.99 */ 
#define GET_EVENT       6                               /* 11.06.99 */
#define SET_EVENT       7                               /* 11.06.99 */
/* ...26.05.99 */ 

#ifdef __cplusplus
 extern "C" {
#endif

#ifdef WINCE                                                 /* 07.06.04 ... */
#  ifdef DLLAPI
#    undef DLLAPI
#    define DLLAPI __stdcall
#  endif
#endif                                                       /* ... 07.06.04 */

L_LONG DLLAPI inter(TCBL *, void *, void *, void *, HPVOID);
L_BOOL DLLAPI inter_wait_single(TCBL *, L_LONG);       /* 01.07.98 */
void          UninitLinterClient(void);                 /* 22.12.98 */
#if !defined(KRB_AUTH)                                                    /* 24.08.14 ... */
static
#endif
 void SendMsgToServerByAst(TMSG *SndMsg, TASTMSG *AstMsg, L_BOOL bAsync); /* ... 24.08.14 */
#ifdef __cplusplus
 }
#endif

#endif

/* -- End of file IntLib.H -------------------------------------------------- */


