/***************************************************************************
 *           RELEX, Inc. Linter Kernel source code                          *
 *  This is unpublished proprietary source code of RELEX, Inc.              *
 *  The copyright notice does not evidence any actual or intended           *
 *  publication of such source code.                                        *
 *                                                                          *
 *                Copyright (c) 1990-2014 RELEX Inc.                        *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR: public
 ----------------------------------------------------------------------------
 PURPOSE: error codes definition
 ----------------------------------------------------------------------------
 REVISION HISTORY:

  10.11.92 -- Nikolaewa (ROWID reusing)
  18.11.92 -- Alex
  21.12.92 -- Usik
  11.01.93 -- Alex
  18.02.93 -- Peshkoff
  25.05.93 -- Peshkoff (V40)
  26.05.93 -- Peshkoff (V40)
  28.05.93 -- Alex  (BLOB)
  30.05.93 -- Peshkoff
  25.06.93 -- Alex
  29.06.93 -- Alex
  03.07.93 -- Peshkoff (V40)
  14.08.93 -- Alex
  23.09.94 -- Peshkoff
  07.12.94 -- Peshkoff
  09.12.94 -- DV (DATE)
  15.12.94 -- Alex
  27.03.95 -- Peshkoff
  28.03.95 -- Borisenkov
  16.05.95 -- Alex
  19.05.95 -- Peshkoff
  30.06.95 -- DV (translation errors)
  25.07.95 -- Nikolaewa ( for s_DRTBL )
  16.08.95 -- Alex
  09.11.95 -- Peshkoff
  16.11.95 -- Nikolaewa ( error address )
  02.12.95 -- Mark (Errors of Top Move)
  15.12.95 -- Mark (Error - Out of Data File)
  08.02.96 -- DV (DCL rewriting)
  07.05.96 -- DV (cursors)
  15.06.96 -- Peshkoff
  18.06.96 -- Peshkoff
  24.06.96 -- Peshkoff
  02.09.96 -- Peshkoff
  08.10.96 -- DV (Duplicate cursor name)
  18.10.96 -- Maxim ( Old channel and cpoint. )
  16.10.96 -- Kent ( ChannelKilled )
  28.11.96 -- Peshkoff (DeadLock)
  12.02.97 -- Ermakov (ERRNMRKAN == 1069)
  25.02.97 -- DV (Procedures)
  06.03.97 -- DV (Security groups and levels)
  07.03.97 -- Ermakov ( Mandatory access )
  19.03.97 -- Peshkoff (Audit)
  22.03.97 -- Kent
  08.04.97 -- DV (cursor bugs)
  23.04.97 -- DV (Work file)
  13.05.97 -- MarkS (Delete not Found)
  05.06.97 -- Niki ( for blob journal )
  10.06.97 -- Kent (Compress/Decompress errors)
  23.06.97 -- DV (Replication rules)
  03.07.97 -- Ermakov ( Tsp )
  07.07.97 -- Pasec ( 11111 )
  11.07.97 -- Niki ( Replication )
  08.08.97 -- DV (JOINs)
  21.08.97 -- DV (Hierarchical queries)
  27.08.97 -- Niki ( transaction reference )
  28.08.97 -- DV (Triggers)
  18.09.97 -- Kent (Devices)
  30.09.97 -- DV (Triggers)
  17.10.97 -- Maxim ( LOG_FILE_NOT_EXIST )
  27.10.97 -- AVE (Proc_Dead)
  17.11.97 -- Disabled using primary key if not FLAGLOG
  04.12.97 -- AVE ( Proc_Too_Large )
  22.12.97 -- AVE ( Proc_Inv_Version )
  23.01.98 -- Maxim V. Kositsin -- Read Only channel errors
  25.02.98 -- MarkS (For Test Err after Sort)
  26.02.98 -- Kononyhin (BIGSRTROW)
  04.04.98 -- DV (Page to be moved is locked)
  27.05.98 -- DV (Check integrity page overflow)
  20.06.98 -- Maxim -- LHB errors
  06.07.98 -- DV (Converter bitmap)
  19.07.98 -- Ermakov (Reference_Already_exist)
  22.07.98 -- Kent (Call from AST handler for call-interface)
  31.08.98 -- Ermakov (prevent cascade update infinite loop)
  15.09.98 -- Kononyhin (join errors.h and error.h from kernel 44 and 51
                         NOCOMAND -> NOCOMMAND)
  31.08.98 -- DV (RENAME TABLE & RENAME COLUMN)
  01.09.98 -- DV (DROP DEFAULT)
  23.09.98 -- DV (Do not drop PRIMARY KEY | UNIQUE if references exist)
  18.11.98 -- Kent (Can't extend column)
  01.12.98 -- Kent (Some SQL errors)
  01.12.98 -- Maxim -- if log address corrupt
  08.12.98 -- Maxim -- for lot of columns
  07.12.98 -- DV (Multicolumn keys - for future use)
  10.12.98 -- DV (CHECK clause)
  11.01.99 -- DV (different errors for REVOKE)
  18.02.99 -- DV (New SQL errors)
  17.02.99 -- Niki ( Hot_Reserve: log address overflow )
  19.02.99 -- Maxim ( Hot_Reserve: query has been made)
  07.05.99 -- DV (New SQL errors)
  12.05.99 -- DV (NOKEYQUE)
  24.05.99 -- DV (NOSUCHKEY)
  25.05.99 -- DV (KEYALREX)
  02.06.99 -- Niki ( BIG_BUFFER replacing )
  11.06.99 -- Maxim -- Hot reserve event reload error
  14.06.99 -- DV (AUTOROWID attribute)
  26.07.99 -- Kononyhin (ERRFALSEOPER)
  25.08.99 -- Kononyhin (some new errors)
  07.09.99 -- Maxim -- test control point time
  13.09.99 -- DV (Invalid DECIMAL format)
  30.09.99 -- Maxim -- last session block
  01.10.99 -- Kent (Answer too long (> LNBLOCK * 2))
  04.10.99 -- DV (No current answer for IN by indexes;
                  invalid ESC-sequence in LIKE argument)
  08.10.99 -- DV (New SQL error codes)
  12.10.99 -- DV (Channel memory processing)
  22.10.99 -- DV (Implicitly generated objects and empty names)
  18.12.99 -- AVE (dropped/altered procedure is bieng executed and tsp busy errors)
  23.12.99 -- DV (UNIQUE existence)
  15.01.00 -- Ermakov (PHRASE_INDEX)
  25.01.00 -- DV (New SQL error)
  01.02.00 -- DV (Internal buffer overflow)
  01.02.00 -- Ermakov (EINVDATAPAGE)
  20.04.00 -- DV (Tables for phrase search)
  02.05.00 -- DV (Check ROWID to be inserted to BV)
  26.05.00 -- DV (Pattern syntax error)
  29.05.00 -- DV (New SQL errors, COLNOTBLOB)
  02.06.00 -- DV (New SQL errors)
  10.08.00 -- DV (ALTER COLUMN SIZE disabled for table with composite indexes)
  20.10.00 -- DV (New SQL error, SET WORKSPACE LIMIT)
  10.11.00 -- MarkS (a New Error for Overflow of Tree's Level)
  15.11.00 -- DV (Bad integrity description)
  28.11.00 -- Ermakov (some corrections for Rowid)
  28.11.00 -- BOLT  -- Add error message: LHB_ERR_TABLEFORTRIGNOTEXIST and other...
  06.12.00 -- Niki ( optimization: RID )
  06.01.01 -- Ermakov (Index_Is_Named)
  18.01.01 -- DV (Temporary index processing internel error)
  03.02.01 -- Ermakov (Error code for phrase_search moved from phrapi.h)
  20.03.01 -- DV (Cascade DROP)
  04.04.01 -- DV (Character sets)
  12.04.01 -- MarkS (for Long RID)
  19.04.01 -- DV (SEQUENCES)
  08.05.01 -- DV (New BV for all versions)
  14.05.01 -- DV (Unknown sequence)
  31.05.01 -- AVE ( SP/Triggers Stubs )
  23.06.01 -- DV (Bad CHECK)
  10.07.01 -- DV (Check if query is obsolete)
  09.08.01 -- KOV (buffer for autoinc columns overflow)
  14.09.01 -- DV, KOV (CHARSET, TRANSLATE)
  19.09.01 -- KOV (CHARSET)
  09.10.01 -- KOV (CHARSET)
  20.10.01 -- Niki ( loggl: long records )
  23.10.01 -- DV  (Character set related statements - continued)
  26.10.01 -- KOV (CHARSET)
  29.10.01 -- KOV (CHARSET)
  30.10.01 -- KOV (TRIGGER in Foreign keys)
  30.10.01 -- Niki (File type error)
  31.10.01 -- KOV (DBCSALRSET - 149 removed)
  02.11.01 -- KOV (CHARSET)
  09.11.01 -- KOV (translation is not used for mbcs/usc2)
  13.11.01 -- KOV (invalid symbol(s) in string for CharSet)
  05.12.01 -- DV  (Decrement record size limit error)
  07.12.01 -- KOV (added 2 errors)
  26.12.01 -- KOV (added 2 errors)
  21.01.02 -- KOV (added 3 errors)
  28.01.02 -- KOV (added 2GB error)
  11.02.02 -- Ermakov (INVKERCONF - invalid kernel configuration for database)
  01.03.02 -- KOV (added 1 error: password length less minimum)
  21.03.02 -- MarkS (a New Error of the Tree Subsystem)
  01.04.02 -- KOV (added 1 error: invalid type of charset)
  16.04.02 -- BOLT (Errors for LHB: when storing and restoring servers or replication rules)
  08.05.02 -- KOV (Added error PT#407)
  31.05.02 -- KOV (Added error for using of MBCS codepages PT#737)
  31.05.02 -- BOLT (Add errors for in-kernel backup PT#685)
  07.06.02 -- KOV (Added 4 errors for PT#409)
  10.06.02 -- KOV (Added error for TT#4438)
  18.06.02 -- KOV (Added error for TT#5518)
  03.07.02 -- RAW (MVCC related error codes)
  12.07.02 -- BOLT (Add some errors for in-kernel backup PT#685)
  30.07.02 -- Galizin ( Undef NORMAL macro for remove compiler warning PT#1046 )
  07.08.02 -- BOLT (Add error for in-kernel backup PT#685)
  11.09.02 -- KOV (WEIBUF removed)
  18.09.02 -- Niki ( repeatable restoration )
  20.09.02 -- Niki ( repeatable rollback )
  02.10.02 -- KOV (Added error for modify first index file)
  11.10.02 -- KOV (do not create phrase index on system table)
  21.10.02 -- KOV (Priorities and calculations for replication rules PT#1598)
  06.11.02 -- Niki ( 570<= v.< 610: mark deleted blob-rowid in converter )
  13.11.02 -- KOV  (Multi-thread)
  11.12.02 -- DV   (Error in sorting arguments)
  16.12.02 -- Galizin ( Network error codes PT#2005)
  04.01.03 -- KOV  (Added errors for case: $$$CSALIAS not exists and desc not found)
  13.01.03 -- KOV  (Added queue for aliases PT#2104: error if memory overflow)
  12.02.03 -- Kononyhin (PT#2291: ERRUNKNTYPE - unknown type of file)
  07.03.03 -- KOV  (Error code Set_Is_Expty#75 removed, TT#7698)
  12.03.03 -- DV   (Error code of bit for bitmap page cleared)
  13.03.03 -- KOV  (Bug fixed: do not 'set database names' if indexes on system tables exist, TT#7789)
  20.03.03 -- KOV  (Added error: deleting blob file if table without blob columns, TT#7856)
  27.03.03 -- KOV  (Bug fixed: string buffer overflow, TT#8039)
  14.04.03 -- DV   (Multi-thread queues)
  14.04.03A - KOV  (PT#2848)
  17.04.03 -- RAW  (BT#8344. Added error code for PP initialization error)
  22.04.03 -- BOLT (PT#2870 move sort error codes from glsort.h into this file)
  05.05.03 -- KOV  (PT#2954: error for 'TRUNCATE TABLE')
  13.05.03 -- RAW  (PT#3001: added error code)
  07.06.03 -- DV   (Check length of variable length data to be sorted)
  20.06.03 -- DV   (ALTER COLUMN SIZE for SMALLINT and INTEGER)
  27.06.03 -- DV   (AUTOROWID value not within converter boundaries)
  05.08.03 -- KOV  (Added error for PT#3406)
  27.08.03 -- Niki (PT#2854: unlogged blob data)
  01.09.03 -- KOV  (Added error for PT#3504)
  02.09.03 -- KOV  (Added error for PT#3549, creating trigger for system table is disabled)
  30.09.03 -- Niki (PT#2954: cursor commit/rollback errors transfer)
  13.10.03 -- Niki (PT#2854: v.>=5.9: unlogged blob data)
  17.10.03 -- KOV  (Added error for checking of password for user 'SYSTEM', TT#10221)
  11.11.03 -- RAW  (Added error codes)
  19.11.03 -- KOV  (Added error CODE: operation in progress)
  18.12.03 -- KOV  (Added error code for PT#3992)
  25.02.04 -- Niki (PT#2767: version value included into log file head)
  07.05.04 -- Niki (PT#2854: PT#3794: additional to erased versions)
  07.06.04 -- Ermakov (moved from errors.h)
  07.07.04 -- KOV  (Added error code: id of procedure is invalid)
  02.09.04 -- KOV  (Added error code for SESSIONID, PT#4802)
  19.01.05 -- Ermakov (Added SQL errors 2271-2277)
  25.02.05 -- KOV  (implementation of global temporary tables, PT#5345)
  30.03.05 -- KOV  (RO mode)
  25.04.05 -- KOV  (Added geometric types & functions, PT#5576)
  29.04.05 -- Sach,Ermakov (Corrected code 7210 - mistake)
  20.07.05 -- FLY (ERROR_INDEXSAVESTATE, ERROR_SEARCHSYNTAX)
  30.07.05 -- Ermakov (Added new code)
  19.01.06 -- KOV (Added error code for function NANVL)
  25.01.06 -- Ermakov (Added procedure translation codes...)
  25.01.06 -- KOV (Added error code for ALTER SEQUENCE)
  09.02.06 -- KOV (Added error code: bad binarydecimal string)
  22.11.05 -- MarkS (ERR_INTER_LOCK --  for Lock Subsystem)
  04.03.06 -- MarkS (ERR_INTER_CKEY --  for Composite B-tree)
  30.03.06 -- Galizin (Large files are not supported by OS or kernel)
  22.05.06 -- KOV (Added restriction for timeout of quantum)
  20.06.06 -- DV  (Disable to create tables with too many AUTOINC columns)
  16.06.06 -- Niki (PT#2854: many pages extension loging)
  10.09.06 -- Niki (PT#2854: first log file header & null row comparison)
  09.03.07 -- KOV (Added parameter PCTFREE into TREL)
  19.03.07 -- Niki (PT#2584: logging to CRTFIL() corrected)
  27.03.07 -- Sacharov, DV (Remove ERRQUESRT)
  30.03.07 -- DV  (ORDER SIBLINGS)
  21.06.07 -- KOV (Added constructions ROLLUP,CUBE,GROUPING SETS)
  20.07.07 -- FLY (Added ERROR_DISABLE_REBUILD)
  02.08.07 -- KOV (Added IDENTITY columns)
  17.08.07 -- KOV (Added generated columns)
  24.08.07 -- DV  (TT#15406)
  30.08.07 -- KOV (Added support of authentication of user by operational system)
  20.10.07 -- Ermakov (extra codes, Added 185)
  23.10.07 -- KOV (Replaced error code 106: queue of file descriptions overflow)
  14.11.07 -- MarkS (+ERR_NOCORRECTRID  - There is no RID for Correct Index)
  11.03.08 -- KOV (Added error codes for <similar predicate>)
  26.03.08 -- DV  (ALTER PROCEDURE|TRIGGER DROP SOURCE TEXT)
  01.04.08 -- KOV (Added errors for sleeping channels + events)
  18.04.08 -- MarkS (Stack Subsystem Errors)
  04.05.08 -- DV  (UseDisabledKey)
  03.07.08 -- KOV (ERR_FOREIGN_EVENT)
  08.09.08 -- KOV (Added transactions for procedures)
  20.01.09 -- KOV (Rotary tables)
  25.03.09 -- KOV (Changes for TT#18471: don't delete procedure or trigger if them translation in progress)
  01.06.09 -- KOV (Added error code for TT#18873)
  14.01.10 -- KOV (Added 'alter table .. drop column' command)
  15.07.10 -- Galizin(New exchange codes)
  11.11.10 -- Galizin(Net exchange codes)
  30.11.10 -- KOV (ALTER DATABASE SET CHANNEL MEMORY LIMIT)
  08.02.11 -- Ermakov (Long file name)
  28.03.11 -- KOV (IF NOT EXISTS construction)
  31.05.11 -- KOV (Changes for materialized views)
  27.06.11 -- KOV (New bitmap format for old versions)
  23.08.11 -- glukhov (New phrase subsystem)
  16.02.12 -- KOV (Error code for case blob value is too long)
  24.02.12 -- Niki (Disable of next reference of row & blob transaction)
  26.03.12 -- DV  (CORRECT INDEX PAGE)
  16.11.12 -- Glukhov,Ermakov (Remove extra code, datatypes)
  12.02.13 -- DV (Remove unused codes)
  17.04.13 -- KOV (BLOB operations for MBCS (position, size - in symbols))
  08.06.13 -- DV (Comments for database objects)
  01.07.13 -- DV (Global variables)
  20.08.13 -- DV (Disable to recreate table used in SELECT)
  10.10.13 -- DV (Undefined global variable error in procedure)
  19.10.13 -- DV (Unknown variable in SQL)
  09.12.13 -- KOV (Correction for TT#24189: don't delete user if user has active channel(s))
  16.01.14 -- DV (Unknown translation code)
  02.06.14 -- KOV (LISTAGG function, PT2#84791)
  24.08.14 -- Pashentsev (Kerberos authentication errors)
  23.10.14 -- DV (Disable to change device in alter table)
  11.11.14 -- Pashentsev (Different error codes for client and kernel library loading errors)
*/

#ifndef __ERRORS_H__
#define __ERRORS_H__

#define NORMALKOD 3  /* maks. normalxnyj kod              */
#if defined(NORMAL)                                         /* 30.07.02 */
#undef NORMAL
#endif
#define NORMAL 0     /* w bagdade wse spokojno            */
#define NOKOR 1      /* takogo korteva net : next Row present */
#define EORR 2       /* konec otno{eniq : no more Rows */
#define UNKN 3       /* udalenie nesu{. korteva           */
#define ERRRID 10    /* protiwore~ie mevdu fajlom dannyh i konwer. */
#define ERRREL 11    /* otsutstwie opisanie otno{eniq w SYSREL     */
#define ERRATR 12    /* otsutstwie opisanie atr. w ATTRIBUTE       */
#define ERRPGD 13    /* nesootwetstwie % zapolneniq bloka BITMAP'u */
#define OVRDT 14     /* perepolnenie oblasti dannyh                */
#define OVRAS 15     /* perepolnenie oblasti associatora           */
#define ERRSS 16     /* protiwore~ie mevdu slowom sostoqniq i BMAP */
#define ERRLASTBT 17 /* neweren % zapolneniq stranicy */
#define ERRRELATR 19 /* protiwore~ie mevdu parametrami REL i ATR */
#define BadBitMap 20 /* Wrong BitMap.  0-bit out of Data File    *//* 15.12.95 */
#define NULFUN 73    /* kol-wo kortevej dlq f-cii rawno 0 */
#define ERRFUN 74    /* takoj f-cii w dannoj wersii net   */
#define Set_Not_Is_Value        76                      /* 27.11.93 */
#define Derived_Set_Not_Defined 77                      /* 27.11.93 */
#define Start_Set_Not_Defined   78                      /* 27.11.93 */
#define OVRRID 80    /* Maximum Rowid reached */
#define ERRRELCON     81  /* 10.11.92                                   */
#define Parity_Error  82  /* Nikolaewa */
#define ERRUPDSYSREL  83  /* Attempt of explicit correcting of system table */
#define ERRCONVSSBM   84  /* 06.07.98 */
#define ERRCONVBMP    85  /* 06.07.98 */
#define NOFIRSTASFILE 86  /* Modification of the first file of indexes is not supported */ /* 02.10.02 */
#define BMPBITCLR     87  /* Bit for bitmap page is cleared in bitmap */ /* 12.03.03 */
#define ERRCRTRIGSYSREL 88  /* Creating trigger for system table is disabled */ /* 02.09.03 */
#define OVRSLEEPCH    89  /* not enough memory for allocation of descriptions of sleeping channels */ /* 01.04.08 */
#define OVREVENTS     90  /* not enough memory for allocation of descriptions of events */ /* 01.04.08 */

#define INDEXNOTRELIS 98  /* obrabotka dannogo tipa indeksa ne
                                 podderviwaetsq qdrom */
#define NORELIS 99   /* zapros ne realizowan */
#define ERRSNAP 100  /* o{ibka pri otrabotke funkcii 'SNAP' */

/* =======> o{ibki o~eredej */

#define OVRREL  101  /* ne hwataet MEMORY dlq o~eredi REL  */
#define OVRATR  102  /* ne hwataet MEMORY dlq o~eredi ATR  */
#define OVRKAN  103  /* ne hwataet MEMORY dlq o~eredi KAN  */
#define OVRFIL  104  /* ne hwataet MEMORY dlq o~eredi FIL  */
#define OVRPAG  105  /* ne hwataet MEMORY dlq o~eredi PAG  */
#define ERROVRFIL 106  /* queue of file descriptions overflow */ /* 23.10.07 */
#define OVRPOOL 107  /* ne hwataet MEMORY dlq POOL'A       */

#define ERRQUEWBV   108  /* w o~eredi dlq fajla SYSWBV.IN1 mesto zanqto */
#define ERRQUEWRK   109  /* w o~eredi dlq fajla SYSWRK.IN1 mesto zanqto */
#define SMALLWRK    110  /* razmer rabo~ego fajla SYSWRK.IN1 nedostato~en*/
#define SMALLWBV    111  /* razmer rabo~ego fajla SYSWBV.IN1 nedostato~en*/
#define ERRQUESYSAS 112  /* w o~eredi dlq fajla SYS*.AS1   mesto zanqto */
#define ERRQUESYSDT 113  /* w o~eredi dlq fajla SYS*.DT1   mesto zanqto */

#define NOATRQUE    114  /* ELATR ne na{el atributa w SYSATR */
#define ERRTYPATR   115  /* |lement o~eredi ATR imeet neizwestnyj tip */
#define ERRDLNATR   116  /* |lement o~eredi ATR imeet dlinu wyhodq{u`
                                za dopustimye granicy dlq sootwetstw. tipa */
#define NOMEMFORBUF 117  /* net pamqti dlq ustanowki buferow kanala */
#define OVRWRKQRID  118  /* Rowid queue overflow */
#define BIGRID      119  /* Invalid ROWid. More when allowed */
#define NULLSDVIG   120  /* ELATR : sdwig atributa otnos. na~ala
                                korteva rawen nul` */
#define NORELQUE      121  /* ELREL ne na{el opisaniq otno{eniq */
#define NOMEMFORBV255 122  /* pri obrabotke indeksa ne hwataet oblasti
                                stranic */
#define NOACTBV255    123  /* obra{enie k BV255, kotoryj ne inicializirowan*/
#define OVRKORQRID    124  /* kol-wo kortevej otweta prewysilo 65535 */
#define NOKORQRID     125  /* net kortevej otweta dlq s~itywaniq */
#define ERRPGQRID     126  /* protiwore~ie w parametrah NMRFZAPPG i NMBKORS*/
#define ERRLASTQRID   127  /* neweren % zapolneniq stranicy fajla otwetow */
#define ERRSTRQRID    128  /* protiwore~iwy parametry STR */
#define RELLOCKED     129  /* otno{enie zablokirowano */
#define PAGELOCKED    131
#define PAGENOLOCKED  132
#define NOUSERQUE     133  /* ELUSER not detected the user name 18.02.93 */
#define ERRQUELOG     134  /* w o~eredi dlq fajla SYSLOG.IN1 mesto zanqto
                              03.07.93 */
#define Row_Locked    135  /* this row locked other user */ /* 30.05.93 */
#define OVRBVEC       136  /* ne hwataet MEMORY dlq o~eredi BVEC 29.06.93 */
#define Many_Column_Sorting 137                             /* 27.03.95 */
#define NoMemForSqlQueue    138                             /* 16.05.95 */
#define CantFixMemory       139 /* because page was locked */ /* 09.11.95 */
#define TooMuchLockedTables 140 /* 15.06.96 */
#define TooMuchLockedRows   141 /* 24.06.96 */
#define DeadLock            142 /* 28.11.96 */
#define MOVPAGELOCKED       143 /* 04.04.98 */
#define NOKEYQUE      144  /* ELCKEY has not found key in SYSATR */ /* 12.05.99 */
#define NOCSETQUE     145  /* ELCSET not detected the charset */ /* 14.09.01 */
#define NOTRANSLQUE   146  /* ELTRANSL not detected the translate table */ /* 14.09.01 */

#define OVRCSET       147  /* overflow MEMORY for charset */    /* 09.10.01 */
#define OVRTRANSL     148  /* overflow MEMORY for translate */  /* 09.10.01 */
#define OVRTHR        149  /* overflow MEMORY for threads */ /* 13.11.02 */
#define CSETUSED      150  /* charset used */                   /* 26.10.01 */
#define NOFILLDEFCSET 151  /* default Char Sets are not filled */ /* 29.10.01 */
#define INVCSETPROP   152  /* invalid properties of CharSet (previous CharSet with this name have another width) */ /* 02.11.01 */
#define PILOTNOTFOUND 153  /* pilot record form MBCS not found */ /* 02.11.01 */
#define TRANSLNOTUSED 154  /* translation is not used for mbcs/usc2 */ /* 09.11.01 */
#define ERRTRANSLSTR  155  /* error of string translation */           /* 09.11.01 */
#define INVALIDSYM    156 /*invalid symbol(s) in string for CharSet*/  /* 13.11.01 */
#define CANTDECSIZLIMIT 157 /* cant decrement rec size limit - wide tables exist */ /* 05.12.01 */
#define ERRUNICCMP    158 /* error of strings of unicode comparison */ /* 07.12.01 */
#define CSETEXISTS    159 /* CharSet already exists */  /* 26.12.01 */
#define TOOMANYCSET   160 /* Too many of charsets */    /* 26.12.01 */
#define BUFF2UNICSMALL 161 /* Buffer of array ToUnicode is small for current charset */ /* 21.01.02 ... */
#define BUFFUNIC2SMALL 162 /* Buffer of array UnicodeTo is small for current charset */
#define OVRMCSET       163  /* overflow MEMORY for MBCS charset */ /* ... 21.01.02 */
#define INVCSETTYPE    164  /* invalid type of charset - charset can not be default */ /* 01.04.02 */

#define ERRKOLUSER 165     /* KOLUSER is not correct */     /* 07.06.02 ... */
#define ERRKOLREL  166     /* KOLREL  is not correct */
#define ERRKOLFIL  167     /* KOLFIL  is not correct */
#define ERRKOLATR  168     /* KOLATR  is not correct */     /* ... 07.06.02 */
#define CANTCONVSTR 169    /* can't convert string without loss of the data */ /* 18.06.02 */
#define OVRALIAS    170    /* overflow MEMORY for queue of aliases */ /* 13.01.03 */
#define SYSTABINDEX 171    /* can't 'set database names': found index on system table */ /* 13.03.03 */

#define LOCKPOOLEXCEEDED 172     /* Lock pool exceeded                 */ /* 14.04.03 ... */
#define NOFREEREL        173     /* All table queue items locked       */
#define RELNOTLOCK       174       /* Try to unlock not locked relation  */
#define NOFREEATR        175     /* All column queue items locked      */
#define ATRNOTLOCK       176       /* Try to unlock not locked attribute */
#define NOPAGQUE         177       /* Cannot allocate page queue item    */
#define PAGENOTLOCK      178       /* Try to unlock not locked page      */ /* ... 14.04.03 */
#define OVRCHANMEM       179       /* overflow MEMORY for channels */       /* 14.04.03A */
#define ERRREADONLYDB    180       /* database is read only */ /* 30.03.05 */
#define ERRGEOFORMAT     181       /* invalid format of value of geometric type */ /* 25.04.05 */
#define ERR_INTER_LOCK   182       /* Internal Error of Lock Row Subsystem   *//* 22.11.05 */
#define ERRQUANTTIMEOUT  183       /* Current query hinder other queries */ /* 22.05.06 */
#define ERRSESSIONQUANT  184       /* Parameter for session should not exceed parameter for user */ /* 22.05.06 */
#define MBCSINITERROR    185       /* Error MBCS table initialization */
#define CANTDECCHANMEM   186       /* channel memory limit cannot be decreased */ /* 30.11.10 */

/* Unpack error */

#define ERRNULATR 200  /* ukazany ne wse zna~eniq atributow  */
#define ERRGRPACK 201  /* granica upakowki na~inaetsq ne s ~etnogo
                                bajta ili za granicej bloka */
#define ERRRAZD    202  /* newernyj razdelitelx w date. dolvna bytx '.' */
#define NOEXISTMON 203  /* newernyj nomer mesqca w date */
#define NOEXISTDAY 204  /* newernyj nomer dnq mesqca w date */
#define ERRCHISLO  205  /* neponqtnyj simwol w ~isle */
#define ERRCHDATA  206  /* newernyj simwol w nomer goda daty */
#define ERRKEYATR  207  /* kl`~ewyh aTributow (w SYSATR) bolx{e ~em
                                w opisanii otno{eniq (w SYSREL) */
#define SMALLDLNATR13 208  /* pri zapisi izmenennogo |lementa o~eredi REL
                                okazalosx, ~to atribut "STROKA" use~en pri
                                upakowke - ~ego ne dolvno bytx */
#define NORIDREL      209  /* pri zapisi izmenennogo |lementa o~eredi REL
                                ne najden kortev iz SYSREL, kotoryj dolven
                                bytx izmenen */
#define NORIDATR      210  /* pri zapisi izmenennogo |lementa o~eredi ATR
                                ne najden kortev iz SYSATR, kotoryj dolven
                                bytx izmenen */
#define SMALLDLNATR24 211  /* pri zapisi izmennogo |lementa o~eredi ATR
                                okazalosx, ~to atribut "STROKA" use~en pri
                                upakowke - ~ego ne dolvno bytx */
#define SMALLDLNATR33 212  /* pri zapisi izmennogo |lementa o~eredi USER
                                okazalosx, ~to atribut "RWED" use~en pri
                                upakowke - ~ego ne dolvno bytx 18.02.93 */
#define NORIDUSER     213  /* pri zapisi izmenennogo |lementa o~eredi USER
                                ne najden kortev iz SYSUSR, kotoryj dolven
                                bytx izmenen                   18.02.93 */

/* =======> o{ibki raspakowki */

#define ERRDLATR     300  /* w oblasti dannyh dlina bolx{e dliny
                                 w  opisanii atributa */
#define NOATRUNP     301  /* opisanie raspakowywaemogo atributa
                                otsutstwuet w o~eredi ATR           */
#define ERRRIDUNP    302  /*adres raspakowki ukazywaet ne na trebuemyj RID*/

#define ERRLNGKORTEG 303  /* dlina rezulxtata raspakowki bolx{e predpolaga-
                                emoj. pri~ina : o{ibka oborudowaniq ili
                                qdra subd */
#define ERRNMRFBT    304  /* newernyj perwyj bajt dlq raspakowki */
#define EINVDATAPAGE 305  /* Invalid data page detacted. Row has length
                             <= HREC_LEN */
/* =======> o{ibki inicializacii sistemy */

#define ERROPRELAS 400  /* fajl associatora SYSREL ne otkryt  */
#define ERROPRELDT 401  /* fajl obl. dannyh SYSREL ne otkryt  */
#define NONULKOR   402  /* otsutstwuet nulewoj kortev         */
#define INVKERCONF 403  /* Invalid kernel configuration for database 11.02.02
                           (insecure kernel on secure database) */
#define ERR2GB     404  /* DB contatn table(s) with size greater 2 Gb: */ /* 28.01.02 */
                        /*current system not support these table(s) */
#define ERRNEWBTMPFMT 405 /* table format is not supported by the current version of kernel *//* 27.06.11 */

/* =======> o{ibki I/O      */

#define ERRNMRPG        500  /* nomer stranicy za EOF fajla        */
#define ERROPFIL        501  /* o{ibka otkrytiq fajla              */
#define ERRFILBV        502  /* o{ibka I/O dlq fajla bit-wektorow  */
#define ERRORFAS        503  /* associator is~erpan, a fajl dannyh net */
#define ERRREADBL       504  /* o{ibka ~teniq blokow iz fajla */
#define ERRWRITEBL      505  /* o{ibka zapisi bloka w fajl    */
#define ERRCLFL         506  /* o{ibka zakrytiq fajla         */
#define ERRCRTFL        507  /* o{ibka sozdaniq fajla         */ /* 11.01.93 */
#define ERRDELFL        508  /* o{ibka udaleniq fajla         */ /* 11.01.93 */
#define ERREXTFL        509  /* o{ibka ras{ireniq fajla       */ /* 11.01.93 */
#define ERRPOSITION     510
#define ERRWBVLIMIT     511  /* 02.09.96 */
#define ERRWRKLIMIT     512  /* 02.09.96 */
#define ERRSRTLIMIT     513  /* 02.09.96 */
#define ERRORWRK        514  /* 02.04.99 */
#define ERRTYPFILE      515  /* 30.10.01 */
#define ERRUNKNTYPE     516                                 /* 12.02.03 */
#define ERRLARGEFILE    517                                 /* 30.03.06 */
#define ERRFLEXIST      518  /* File already exists */      /* 19.03.07 */
#define LONGFILENAME    519  /* Fine name for open is tool long */ /* 08.02.11 */

/* =======> o{ibki dannyh iz buferow kanala */

#define DIAPASON     600  /* newernyj priznak kl`~a */
#define NDLIN        601  /* dlina konstanty bolx{e dliny atributa */
#define ERRPRZFUN    602  /* newernyj priznak prinadlevnosti funkcii */
#define ERRTYPATRFUN 603  /* nedopustimyj tip atributa dlq f-cii */
#define ERRORFL      604  /* o{ibka zna~eniq FLAG dlq prozy */
#define KOLKEYERROR  605  /* nekorrektnoe ~islo kl`~ewyh atributow */
#define Err_Stack_Boolean_Expr 606  /* nekorrektnoe ~islo kl`~ewyh atributow */
#define Unknown_Oper_In_Boolean_Expr 607  /* nekorrektnoe ~islo kl`~ewyh atributow */

/* --------------------------------------------------------------- */
/* =======> o{ibki, swqzannye s B-TREE :     */

#define ErrOverBuf  699  /* Constants of Search are too Long. */          /* 21.03.02 */
                         /* Search Buffer is Overflow  */                 /* 21.03.02 */
#define ERR_LABEL   700  /* wysota bolx{e maksimalxnoj */
#define ERR_HARD_BL 701  /* O{ibka zapolneniq zagolowka*/
#define ERR_tela_BL 702  /* O{ibka zapolneniq tela uzla*/
#define ERRORMAP    703  /* B slowe sostoqniq BITMAP ne*/
                         /* pokazana polnaq zanqtostxj */
#define ERR_POINT   704  /* O{ibka gorizontalxn.ssylki */
                                                          /* 02.12.95 */
#define EXAERR      705  /* Page Test Error            */
#define ERRORNOTKEY 706  /* Column is not Key!         */
#define ERRNULLPNTR 707  /* Empty Pointer on Top!      */
#define ERRORTOPNUM 708  /* It is not True!            */
                                                          /* 02.12.95 */
#define ERRORWRKMAP 709                                   /* 02.04.99 */
#define ERRPAGEBOUND 710                                  /* 02.04.99 */
#define ERR_Over_Tree_Level 711                           /* 10.11.00 */
#define ERR_INTER_CKEY  712   /* Internal Error of Composite B-tree     *//* 04.03.06 */
#define ERR_VERS_CKEY   713   /* Incompatibility of Composite B-tree    *//* 04.03.06 */
#define ERR_NOCORRECTRID  714 /* There is no RID for Correct Index      *//* 14.11.07 */
#ifdef PHRASE_SEARCH                                      /* 15.01.00 */

#define PHRASEERROR     750
#define PHRASESEARCHERR 751
#define PHRASELOADERR   752
#define PHRASECREATEERR 753 /* can't create phrase index on system table */ /* 11.10.02 */
#define PHRASECANTRESIZECACHE 754 /* can't set new cache size */ /* 23.08.11 */
#endif

/* =======> Bv and Iq errors <=================== */

#define    Errovermem      800
#define    Erroverfil      801
#define    Errssbm         802
#define    Errhash         804    /* error hash          */
#define    ErrFreeBv       805    /* error free bv       */
#define    Erroveriq       806    /* Free Null Bvq       */
#define    Errfreeiq       807    /* Free Null Bvq       */
#define    Errbvnotfound   808    /* Bv not Found        */
#define    Erriqnotfound   809    /* Iq not Found        */
#define    Errovervar      810
#define    Errnotindex     811    /* 10.01.95 */
#define    Erroverflbv     812    /* 25.01.95 */
#define    ERRLONGMEM      813    /* 15.11.96 */
#define    ERRWRKMEM       814    /* 23.04.97 */
#define    NOFREEID        815    /* 23.04.97 */
#define    ILLROWIDBV      816    /* 02.05.00 */
#define    UserWSOverflow  817    /* 20.10.00 */
#define    Erroverbv       819    /* 08.05.01 */
#define    ERRWRKPAGE      820                                             /* 13.05.03 */

/* Stack Subsystem Errors */                                /* 18.04.08 ... */

#define    ErrBASE_STACK  (830)   
#define    ErrEMPTY_STACK (ErrBASE_STACK + 1) /* Delete from Empty Stack*/
#define    ErrDESC_STACK  (ErrBASE_STACK + 2) /* Stack Description Error*/
#define    ErrLOG_STACK   (ErrBASE_STACK + 3) /* Logical Error          */
#define    ErrSTACK_LVAR  (ErrBASE_STACK + 4) /* Long Variable Error    */
#define    ErrOVER_STACK  (ErrBASE_STACK + 5) /* Stack Overflow         */
#define    Err_STACK_LEN  (ErrBASE_STACK + 6) /* Wrong Stack Length     */
                                                            /* ... 18.04.08 */

/* Integrity errors */

#define    No_Value        901
#define    Index_Is_Busy   902    /* this column is the primary key or unique */
#define    Duplicate_Value 903
#define    No_Key_Index    904
#define    Foreign_Value_Not_Exists 905
#define    Child_Row_Exists         906
#define    Illegal_Integrity_Action 907
#define    No_Key_Log               908         /* 17.11.97 */
#define    Reference_Already_exist  909         /* 19.07.98 */
#define    TooComplexCascade        910         /* 31.08.98 */
#define    ForeignRefExists         911         /* 23.09.98 */
#define    Too_Many_Keys            912         /* 07.12.98 */
#define    Key_Ref_Not_Found        913         /* 07.12.98 */
#define    ERRCHECKROW              914         /* 10.12.98 */
#define    NOCHECK                  915         /* 10.12.98 */
#define    ERRLONGCHECK             916         /* 10.12.98 */
#define    Unique_already_exists    917         /* 23.12.99 */
#define    BADINTDESC               918         /* 15.11.00 */
#define    Index_Is_Named           919    /* cant apply this operation to named index */ /* 06.01.01 */
#define    TrigReturnFalse          920    /* "before trigger" return false in foreign key operation */ /* 30.10.01 */
#define    CantKeepIndex            921    /* cannot keep index with generic name after key deletion */ /* 24.08.07 */
#define    UseDisabledKey           922         /* 04.05.08 */
#define    TrigInsteadOfDelete      923    /* should not exist 'instead of delete' trigger for rotary table */ /* 20.01.09 */
#define    TrigOnRotaryTblRetFalse  924    /* trigger on rotary table returned FALSE */ /* 20.01.09 */
#define    TooManyTriggers          925    /* too many triggers */ /* 01.06.09 */

/* =======> o{ibki ob{eniq programm s subd */

#define NOCOMMAND    1000  /* neizwestnaq komanda */  /* 15.09.98 */
#define ERROPENQUE   1001  /* o{ibka otkrytiq o~eredi na VS: ustrojstwe */
#define NOVS         1002  /* o{ibka nazna~eniq na VS: */
#define ERRWRITEMSG  1003  /* o{ibka pereda~i soob{eniq subd */
#define ERRREADMSG   1004  /* o{ibka prinqtiq soob{eniq ot subd */
#define ERRRANGE     1005                          /* 15.09.98 */
#define NOENDOFRANGE 1005  /* net konca opredeleniq peremennyh */
#define ERRRETR      1006                          /* 15.09.98 */
#define NOENDOFOPER  1006  /* net konca opisaniq operatora */
#define ERRWHERE     1007                           /* 15.09.98 */
#define NOENDOFWHERE 1007  /* net konca opisaniq bloka uslowij */
#define BIGkortev    1008  /* bolx{oj kortev */
#define BIGKOR       1008                           /* 15.09.98 */
#define NOFREEKAN    1009  /* swobodnyh kanalow net */
#define NOQUEL       1010  /* o{ibka ob{eniq qdra s translqtorom */
#define QUELzanqt    1011  /* translqtor zanqt */

#define NOPRIVSHUT    1012  /* net priwilegij dlq zakrytiq kanala ili
                              w sisteme rabota`t drugie polxzowateli */
#define ERRSEQCOM     1013  /* newernaq posledowatelxnostx komand */
#define SMALLBUFKOR   1014  /* razmer bufera korteva u polxzowatelq
                                nedostato~en */
#define ERRTYPATROPER 1015  /* dlq dannogo tipa atributa arifm. operacij net*/
#define DIVNUL        1016  /* w arifm. operacii delenie na '0' */
#define UNKNOWNOPER   1017  /* neizwestnaq arifmeti~eskaq operaciq */
#define MANYVARS      1018  /* mnogoperemennyj zapros po komande 'READ'
                                ne wypolnqetsq */
#define OVRINTEGER    1019  /* rezulxtat arifm. operacii nad celymi ~islami
                                prewysil granicu dopustimyh zna~enij */
#define OVRREAL       1020  /* rezulxtat arifm. operacii nad dejstwitelxnymi
                                ~islami prewysil granicu dopustimyh zna~enij */
#define OVRVAR        1021  /* dlq mnogoperemennogo zaprosa ograni~enie :
                                ne bolee treh peremennyh */
#define ERRPASSWORD   1022  /* newernoe imq polxzowatelq */
#define OVRDECIMAL    1023  /* rezulxtat arifm. operacii nad decimal
                                ~islami prewysil granicu dopustimyh zna~enij */
#define NOSORT        1024  /* sortirowka ne aktiwna   18.11.92              */
#define Invalid_User_Name   1025 /* 25.05.93 */
#define Invalid_User_Passwd 1026 /* 26.05.93 */
#define ERRSEND       1027  /* send error              25.06.93              */
/* 14.08.93 */
#define ERRSTACKEXPR  1028
#define ERRTYPOPERAND 1029
#define ERRCONVDECDBL 1030
#define ERRCONVLNGDEC 1031
#define ERRCONVDBLDEC 1032
#define ERRCONVDECLNG 1033
#define ERRTYPEXPR    1034
#define ERRCHARLEN    1035 /* Incorrect char expression length */
#define ERRVALRANGE   1036 /* Argument value not in valid range */
#define QUERY_NOT_UPDATABLE 1037 /* 23.09.94 */
#define ERRCONVDATE   1038 /* 09.12.94 */
#define ERRAUTOINCOVR 1039 /* 28.03.95 */
#define ERRCONVCHINT  1040 /* 21.06.95 */
#define ERRCONVCHDEC  1041 /* 21.06.95 */
#define ERRCONVCHREA  1042 /* 21.06.95 */
/* 16.08.95 */
#define NoMemoryForAsyncQuery 1043
#define ChannelBusy           1044
#define ChannelClose          1045
#define KernelShutdown        1046
#define MessageTooLong        1047
#define SYS_CANCEL            1048
#if _VER_MAX >= 500                             /* 15.09.98 */
#define ChannelKilled         1049
#endif
/* 16.08.95 */

/* Translation errors */
#define INVPARNUM     1050 /* 30.06.95 */
#define INVPARTYP     1051 /* 30.06.95 */
#define NOTALLBIND    1052 /* 30.06.95 */
#define INVTRANBUF    1053 /* 30.06.95 */
#define INVPARNAME      1054            /* 04.07.95 */
#define INVPARCONV      1055            /* 03.08.95 */
#define NOTSELECTQUERY  1056            /* 22.08.95 */
#define NULLPOINTER     1057            /* 22.08.95 */
#define NOMEMORY        1058            /* 22.08.95 */

#define ERRAUTOINCUSE   1059            /* 09.01.96 */

/* Cannot close channel - have opened cursors */
#define HAVEOPENCUR     1060            /* 07.05.96 */
#define LoginDisabled   1061            /* 18.06.96 */
#define DupCurName      1062            /* 08.10.96 */
#define ERRVALRANGEBROKEN 1063          /* 05.08.03 */  /*The range of values of data is broken*/
#if _VER_MAX >= 500
#define OPERINPROGRESS  1064            /* 19.11.03 */
#else
#define ChannelKilled   1064            /* 15.09.98 */
#endif
#define ERRSYSPASS      1065  /* national character set cannot be used for the password of user 'SYSTEM' */ /* 17.10.03 */
#define ERRIDENTITYUSE  1066 /* IDENTITY attribute assignment error */ /* 02.08.07 */
#define ERRDROPSEQ      1067 /* can't delete sequence - exists reference: IDENTITY attribute */ /* 02.08.07 */
#define ERRAUTOGENUSE   1068 /* incorrect assignment of value to automatically generated attribute */ /* 17.08.07 */
#define ERRNMRKAN       1069  /* newernyj nomer kanala */   /* 12.02.97 */
#if _VER_MAX >= 500                                      /* 15.09.98 ...*/
#define MandatoryViolation 1070                             /* 07.03.97 */
#define CursorNameTooLong  1071
#define NOSUCHCUR       1072            /* 08.04.97 */
#define NOTCURTAB       1073            /* 08.04.97 */
#else
#define NOSUCHCUR       1070
#define NOTCURTAB       1071
#endif                                                    /*... 15.09.98 */
#define DeleteNotFound  1074 /* Key for Delete not Found */ /* 13.05.97 */
#define ERRCOMPRESS     1075            /* 08.06.97 */
#define ERRDECOMPRESS   1076            /* 10.06.97 */
#define NOTSP           1077            /* 03.07.97 */
#define BADPACKET       1078            /* 07.07.97 */
#define BADJOIN         1079            /* 08.08.97 */
#define BADTREE         1080            /* 21.08.97 */
#define DEVICEBUSY      1081            /* 18.09.97 */
#define INTPAGOVR       1082            /* 27.05.98 */
#define NOSUCHCPOINT    1083            /* 25.06.98 */
#define CPOINTALREXIST  1084            /* 03.07.98 */
#define CALLFROMHANDLER 1085            /* 22.07.98 */
#define ERRRENAME       1086            /* 31.08.98 */
#define NODEFVAL        1087            /* 01.09.98 */
#define RIDUSED         1088            /* 14.06.99 */
#define ERRFALSEOPER    1089            /* 26.07.99 */
#define ERRDECFORMAT    1090            /* 13.09.99 */
#define ANSWER_TOO_LONG 1091            /* 01.10.99 */
#define NOCURRANS       1092            /* 04.10.99 */
#define INVLIKEARG      1093            /* 04.10.99 */
#define ErrMemSeq       1094            /* 12.10.99 */
#if _VER_MAX >= 570                     /* 25.08.99 ...*/
#define ERRFALSEPRIOR   1095
#define ERRFALSECHSTATE 1096
#define QueryCanceled   1097
#endif                                  /*... 25.08.99 */
#define Temp_Index_Error 1098 /* Temporary index processing internal error */ /* 18.01.01 */
#define CROSSUSERREF    1099            /* 20.03.01 */
#define INVCHARSETCONV  1100            /* 04.04.01 */
#define SequenceOverflow 1101           /* 19.04.01 */
#define SequenceNotSet   1102           /* 19.04.01 */
#define TooManySequenceItems 1103       /* 19.04.01 */
#define BADCHECK        1104            /* 23.06.01 */
#define OBSQUERY        1105            /* 10.07.01 */
#define ERRAUTOBUFOVER  1106            /* 09.08.01 */
#define ERRMINPASSLEN   1107    /* password length less minimum */  /* 01.03.02 */
#define StrBufOverflow  1108    /* string buffer overflow - for scalar functions */ /* 27.03.03 */
#define NORIDCONV       1109    /* Cannot set AUTOROWID value */    /* 27.06.03 */
#define ERRMODIFYINMEM  1110 /* 18.12.03 */ /* Can't modify in-memory table in such a way */
#define ERRTOOMANYLOCKS 1111 /* 18.12.03 */ /* Too many locks (for pages, relations or attributes) */
#define ERRTBLNOTINMEM  1112 /* 18.12.03 */ /* Table is not in-memory (for operations SAVE and RESTORE) */
#define ERRINMEMREF     1113 /* 18.12.03 */ /* Foreign keys not supported for in-memory tables */
#define ERRINMEMTMPTAB  1114 /* 25.02.05 */ /* Conversion of global temporary table to in-memory table is illegal operation */
#define ERRCHTRIGGLTMP  1115 /* 25.02.05 */ /* Attempt of explicit correcting of triggers for global temporary table: table is used */
#define ERRADDFORGLTMP  1116 /* 25.02.05 */ /* Foreign reference to global temporary table is not implemented yet */
#define ERRDELGLTMP     1117 /* 25.02.05 */ /* Attempt of explicit correcting (with using 'cascade') of global temporary table: table is used */
#define ERRUPDGLOBALTMP 1118 /* 25.02.05 */ /* Attempt of explicit correcting of global temporary table: table is used */
#define ERRMANYAINC     1119 /* 20.06.06 */ /* Too many autoinc columns in a table */
#define ERRCREIDENTITY  1120 /* Incorrect description of IDENTITY attribute */ /* 02.08.07 */
#define ERRSEQBUFOVER   1121 /* SEQUENCE value buffer overflow */ /* 02.08.07 */
#define ERRMANYIDENTITY 1122 /* Too many IDENTITY columns in a table */ /* 02.08.07 */
#define ERRPAMOS        1123 /* operating system interaction error */ /* 30.08.07 ... */
#define ERRPAMNSUP      1124 /* user authentication is not supported by operating system */ /* ... 30.08.07 */
#define INVESCAPE       1125 /* invalid ESCAPE character */ /* 11.03.08 */
#define INVPATTERN      1126 /* invalid pattern in SINILAR argument */ /* 11.03.08 */
#define ERROBSVIEWFMT   1127 /* obsolete view format - need to recreate view */ /* 31.05.11 ... */
#define ERRBLOBNOTSUPP  1128 /* BLOB columns aren't supported for materialized views */
#define ERRVIEWNOPORT   1129 /* portion with table identifier isn't found in materialized view description (internal error) */ /* ... 31.05.11 */
#define ERRBLOBTOOLONG  1130 /* blob value is too long */  /* 16.02.12 */
#define PAGENOTININDEX  1131 /* page not found in index */      /* 26.03.12 */
#define CANTCORRECTPAGE 1132 /* cannot correct only one page */ /* 26.03.12 */
#define ERRCONCATLONG   1133 /* result of string concatenation is too long */ /* 02.06.14 */
#define ERR2WITHINGRP   1134 /* two different constructions WITHIN GROUP for one GROUP BY aren't supported */ /* 02.06.14 */
#define ERRCHANGEDEV    1135 /* try to change device for file in alter table */ /* 23.10.14 */

#define KRB_NOMEM            1180 /* No memory for krb data */                   /* 24.08.14 ... */
#define KRB_SERVICENAME      1181 /* Service name parsing */
#define KRB_ONLYSYNC         1182 /* Only sync OPEN for krb */
#define KRB_INIT_CONTEXT     1183 /* Init context failed */
#define KRB_SRV_ERRLOAD      1184 /* Krb shared library loading failed on the kernel side */ /* 11.11.14 */
#define KRB_SRV_IMPORT_NAME  1185 /* gss_import_name on server failed */
#define KRB_SRV_ACQUIRE_CRED 1186 /* gss_acquire_cred on server failed */
#define KRB_SRV_ACCEPT       1187 /* gss_accept_sec_context on server failed */
#define KRB_SRV_DISPLAY_NAME 1188 /* gss_display_name failed on server */
#define KRB_EXCH_ERR         1189 /* unknown exchange error */
#define KRB_SUPPORT_REQUIRED 1190 /* Client should support krb authentication */ /* ... 24.08.14 */
#define KRB_CLNT_ERRLOAD     1191 /* Krb shared library loading failed on the client side */ /* 11.11.14 */
/*============== charactersets errors  =============*/

#define NLS_TOOMANYSUBSETS 1300         /* 19.09.01 */
#define NLS_MBCSRESTART    1301 /* Linter must be restart before first using */
                                /* of added MBCS codepage *//* 31.05.02 */
/* Sorting error codes */                                 /* 22.04.03 ...*/
#define SRT_ERROPENFILE 1401    /* File open error */
#define SRT_ERRREADBL   1402      /* Read error      */
#define SRT_ERRWRITEBL  1403      /* Write error     */
#define SRT_STACKEMPTY  1404    /* Stack underflow */
#define SRT_STACKFULL   1405    /* Stack overflow  */
#define ERRWrongRID     1406    /* Invalid RowID after Sort Process*/      /* 25.02.98 */
#define BIGSRTROW       1407    /* Row for sorting larger than one page */ /* 26.02.98 */
#define ERRSRTARG       1408    /* Error sorting process arguments */      /* 11.12.02 */
#define SRT_PAGELOCKED  1409    /* Page allocation error */
#define SRT_NOCOLUMNS   1410    /* No columns for sorting */ /*... 22.04.03 */
#define SRT_BADDATALEN  1411    /* Bad length of variable length data */ /* 07.06.03 */
#define SRT_BADSIBLINFO 1412    /* Bad sibling information */ /* 30.03.07 */

/* 11.01.93 */
/* ============== o{ibki operatorow opredeleniq dannyh ================== */

#define NORIDSYSREL  1500  /* SYSREL overflow                 */
#define NORIDSYSUSR  1501  /* SYSUSR overflow                 */
#define NORIDSYSATR  1502  /* SYSATR overflow                 */
#define RELEXIST     1503  /* otno{enie uve su}estwuet                    */
#define OVRLNGKOR    1504  /* dlina korteva bolx{e razmera stranicy       */
#define SMALLASFIL   1505  /* razmer perwogo AS fajla nedostato~en        */
#define ILLEXT       1506  /* newernyj |kstent                            */
#define EXTBUSY      1507  /* |kstent zanqt                               */
#define ATREXIST     1508  /* atribut c takim imenem uve estx w otno{enii */
#define ILLSIZFIL    1509  /* nedopustimyj razmer fajla pri ras{irenii    */
#define ERRNOUSER    1510  /* net takogo polxzowatelq w SYSUSR            */
#define VIEWLONG     1511  /*                                             */
#define USEREXISTS   1512  /* This user already exists 08.02.96           */
#define CANTDROPUSER 1513  /* This user have tables and cant be dropped   */
#define NORIGHTS     1514  /* No rights to delete                         */ /* 11.01.99 */
#define NOROLE       1515  /* No role assignment to delete                */ /* 11.01.99 */
#define NOSUCHKEY    1516  /* No such key                                 */ /* 24.05.99 */
#define KEYALREX     1517  /* Attempt to create already existing key      */ /* 25.05.99 */
#define CANTPRESS    1518  /* Attempt to PRESS table with AUTOROWID       */ /* 14.06.99 */
#define ERREMPTYNAME 1519  /* Attempt to create object with an empty name            */ /* 22.10.99 */
#define ERRGENERNAME 1520  /* Attempt to explicitly create object with generic name  */ /* 22.10.99 */
#define ERRUSEGENER  1521  /* Attempt of explicit use of implicitly generated object */ /* 22.10.99 */
#define ERREXTCKEY   1522  /* ALTER COLUMN SIZE disabled for table with composite indexes */ /* 10.08.00 */
#define CANTDROPNODE 1523  /* This node have replication rules and cant be dropped */ /* 08.05.02 */
#define DESCNOTFOUND 1524  /* Description for character set not found (for delete) */ /* 04.01.03 */
#define NOBLOBFILE   1525  /* Deleting blob file (DROP BLOBFILE) if table without blob columns */ /* 20.03.03 */
#define CANTTRCTBL   1526  /* Can't truncate table */       /* 05.05.03 */
#define CANTRESIZEVAL 1527 /* Can't resize value */         /* 20.06.03 */
#define ERRWRONGPCT  1528 /* wrong parity of parameters PCTFILL and PCTFREE */ /* 09.03.07 */
#define ERRGROUPBY   1529  /* GROUP BY processing error (internal error) */ /* 21.06.07 */
#define CANTDROPCOL  1530  /* This column have dependences and can't be dropped */ /* 14.01.10 */
#define ERRDROPMATERIALIZED 1531 /* materialized view can't be dropped without cacade option (reference exists) */
#define ERRUSERHASCHAN 1532 /* user has active channels */ /* 09.12.13 */

/* 11.01.93 */
/*===================== o{ibki optimistic_cancaren ====================== */

#define ILLTRANS     1600  /* nelegalxnaq tranzakciq                      */

/* 28.05.93 */
#define NORIDBL       1700
#define NOATRBL       1701
#define NOLOCKBL      1702
#define ERRPARTBL     1703
#define ERRNMRBT      1704
#define ERRREFBL      1705
#define ERRSZPGBL     1706
#define ERRRIDBL      1707
#define ERRSSBL       1708 /* protiwore~ie mevdu slowom sostoqniq i BMAP */
#define OVRBL         1709 /* perepolnenie oblasti BLOB fajla            */
#define ILL_FIRST_PAG 1710
#define ILL_LAST_PAG  1711
#define ILL_CUR_PAG   1712
#define ERRBLATR      1713 /* o{ibo~noe ispolxzowanie BLOB-atr-tow w zaproce */
#define NOMEMFORBLOB  1714
#define ERRATRTYP     1715 /* Can't add Autoinc,Primary key,foreign key column */
#define ERR_RET_BLOB  1717 /* 05.06.97 for journal: error return blob value */
#define INTBUFOVR     1718 /* 01.02.00 */
#define COLNOTBLOB    1719 /* 29.05.00 */ /* Incorrect column number - not a BLOB */
/* 28.05.93 */
#define BLOBLOCK      1720 /* 27.08.03 */ /* Another channel locked this blob */
#define ILL_SHIFT_BLOB_PAG 1721 /* Illegal shift in blob page */ /* 17.04.13 */


/* 19.05.95 */
/* Events  errors */

#define INVALID_EVENT_ID    1800
#define EVENT_WAS_DESTROYED 1801
#define EVINITFAIL          1802 /* events initialization failed */ /* 01.04.08 ... */
#define EVNOBODY            1803 /* event body is not available */
#define EVENT_DISABLED      1804 /* event is disabled */   /* ... 01.04.08 */

/* 19.05.95 */



/* 11.07.97 */
/* Log -- Replication error */

#define ERRREPLICTYP  1900  /* 11.07.97 error returned type */

/* 15.09.98 ...*/
#define SQLBADCH                        2001
#define SQLNOEOCMNT                     2004
#define SQLLONGID                       2005
#define SQLLONGSTR                      2006
#define SQLLONGSY                       2007
#define SQLNOEOS                        2008
#define SQLCONVERR                      2020
#define SQLNUMBEXP                      2021
#define SQLBADNUMCH                     2022
#define SQLNUMTOOBIG                    2023
#define SQLNUMBCONV                     2024
#define SQLNUMBSYNT                     2025
#define SQLVALLOST                      2026
#define SQLBADEXP                       2030
#define SQLINCTYPE                      2031
#define SQLBDATE                        2032
#define SQLBADGEOTYPE                   2033                /* 25.04.05 */
#define SQLHEAP                         2040

#define SQLHASH                         2041

#define SQLSYNTAX                       2050
#define SQLNOSTAT                       2051
#define SQLIDEXP                        2052
#define SQLNFNC                         2060
#define SQLOFTBL                        2061
#define SQLOATBL                        2062
#define SQLOPTBL                        2063
#define SQLOGTBL                        2064
#define SQLOGRP                         2065
#define SQLLEXPR                        2066
#define SQLOSTACK                       2067
#define SQLILLOP                        2068
#define SQLFNCSYNT                      2069
#define SQLEXPRSYNT                     2070
#define SQLESCALEXP                     2071
#define SQLEQUEREXP                     2072
#define SQLNUMTEXP                      2073
#define SQLSQSYNT                       2074
#define SQLCOLEXP                       2075
#define SQLECOLSTR                      2076

#define SQLCSTREXP                      2077
#define SQLCHAR1EXP                     2078
#define SQLBADBINARY                    2079                /* 09.02.06 */
#define SQLVALEXP                       2080
#define SQLDSET1                        2081
#define SQLLINLST                       2082
#define SQLEBOOLEXP                     2083
#define SQLCHARTEXP                     2084
#define SQLNUMORDAT                     2085
#define SQLINVFORMAT                    2086
#define SQLBYTETEXP                     2087
#define SQLOPARTBL                      2088
#define SQLBLOBTEXP                     2089
#define SQLOKTBL                        2090
#define SQLOSGRTBL                      2091
#define SQLOSLVTBL                      2092
#define SQLBADHEX                       2093
#define SQLINVTIMESTR                   2094
#define SQLUNKPARTYP                    2096            /* 18.02.99 */
#define SQLMULTICOL                     2097            /* 18.02.99 */
#define SQLSTRTEXP                      2098            /* 25.01.00 */
#define SQLREALTEXP                     2099            /* 19.01.06 */

#define SQLSCRTAB                       2100
#define SQLBMXRID                       2101
#define SQLBMXROW                       2102
#define SQLBPFILL                       2103
#define SQLDMXRID                       2104
#define SQLDMXROW                       2105
#define SQLDPFILL                       2106
#define SQLBAFILES                      2107
#define SQLBFNDEV                       2108
#define SQLBFSIZE                       2109
#define SQLDDATF                        2110
#define SQLDINDF                        2111
#define SQLDBLBF                        2112
#define SQLDBLOBP                       2113
#define SQLBBLOBP                       2114
#define SQLDUPLEVEL                     2115
#define SQLBADLEVEL                     2116
#define SQLDUPGROUP                     2117
#define SQLBADGROUP                     2118
#define SQLDUPPASS                      2119
#define SQLAMCOL                        2121
#define SQLDUPCOL                       2122
#define SQLSCOL                         2123

#define SQLBCOLTYP                      2124
#define SQLBSCALE                       2125
#define SQLBLENPRC                      2126

#define SQLITDEF                        2127

#define SQLSDEF                         2128
#define SQLSCNULL                       2129
#define SQLNOCOL                        2130
#define SQLDBLOB                        2131

#define SQLCRTABU                       2132
#define SQLDRTABU                       2133
#define SQLISROLE                       2134
#define SQLISNOTROLE                    2135
#define SQLUSREXISTS                    2136
#define SQLTWOPRKEYS                    2137
#define SQLADDKEYAINC                   2138
#define SQLMODEEXP                      2139
#define SQLPRVSYNT                      2140

#define SQLTWODEFS                      2141
#define SQLREFTOBAD                     2142
#define SQLTOOLNGKEY                    2143
#define SQLDUPKEYCOL                    2144
#define SQLDPRIV                        2145
#define SQLPRVEXP                       2146
#define SQLBPASSW                       2147
#define SQLAMPASS                       2148
#define SQLBFILENUM                     2149
#define SQLIEXIST                       2150
#define SQLINEXIST                      2151
#define SQLDUSRNAM                      2152
#define SQLCCOLV                        2153
#define SQLCNAMSB                       2154
#define SQLCRPRCU                       2155
#define SQLDRPRCU                       2156
#define SQLDPFREE                       2158                /* 09.03.07 */
#define SQLBPFREE                       2159                /* 09.03.07 */
#define SQLOVBUFF                       2160
#define SQLEOV                          2161
#define SQLVIEWNUPD                     2162
#define SQLDISVIEW                      2163
#define SQLDISBASE                      2164
#define SQLUNKNODE                      2170
#define SQLNODEXIST                     2171
#define SQLILLROWID                     2172
#define SQLDUPEVENT                     2173
#define SQLNOEVENT                      2174
#define SQLSYNUSED                      2175
#define SQLSYNUNKN                      2176
#define SQLILLPARAM                     2177
#define SQLNOSUCHCUR                    2178
#define SQLCANTBEIND                    2179
#define SQLCANTDROPSEC                  2180
#define SQLNOLENGTH                     2181  /* 07.05.99 */
#define SQLEMPTYNAME                    2182  /* 22.10.99 */
#define SQLDEFAINC                      2183  /* 02.06.00 ... */
#define SQLBADRANGE                     2184
#define SQLAUTOREXP                     2185  /* ... 02.06.00 */
#define SQLCCANTBEIND                   2186  /* 20.11.00 */
#define SQLTRFORANU                     2187  /* 17.01.01 */
#define SQLZEROOBJID                    2188  /* 02.04.01 */
#define SQLILLBLOB                      2189  /* 09.07.01 */
#define SQLPARNODML                     2190  /* 02.10.02 */
#define SQLCREVTU                       2191  /* 01.04.08 */
#define SQLISUSER                       2192  /* 27.05.13 */
#define SQLISSCHEMA                     2193  /* 27.05.13 */

#define SQLOUSRTBL                      2200
#define SQLOSRFTBL                      2201
#define SQLUNKTAB                       2202
#define SQLUNKUSR                       2203
#define SQLUNKSREF                      2204
#define SQLAMBSET                       2205
#define SQLECORNAM                      2206
#define SQLUNKCOL                       2207
#define SQLOCRFTBL                      2208
#define SQLAMBCRF                       2209
#define SQLUNKCRF                       2210
#define SQLOSETTBL                      2211
#define SQLNOFROM                       2212
#define SQLOSCPTBL                      2213
#define SQLOCOLTBL                      2214
#define SQLINVCOL                       2215
#define SQLINVCNUM                      2216
#define SQLLSTLONG                      2217
#define SQLLSTSHRT                      2218
#define SQLUPDTREF                      2219
#define SQLNULLDIS                      2220
#define SQLINVASGN                      2221
#define SQLINCQTYP                      2222
#define SQLMIXFCOL                      2223

#define SQLINVFUNR                      2224

#define SQLUNSET                        2225
#define SQLOUTLNG                       2226
#define SQLUNKORD                       2227
#define SQLBADBASE                      2228
#define SQLUNKPRC                       2229
#define SQLUNKSGR                       2230
#define SQLUNKSLV                       2231
#define SQLDUPSGR                       2232
#define SQLDUPSLV                       2233
#define SQLUNKSTAT                      2234
#define SQLUNKDEV                       2235
#define SQLDUPSTAT                      2236
#define SQLDUPDEV                       2237
#define SQLUNKPROT                      2238
#define SQLTOOLNGADR                    2239
#define SQLTOOLNGDIR                    2240
#define SQLTOOLNGCMT                    2241
#define SQLDUPDEF                       2242
#define SQLUNKDAYNAME                   2243
#define SQLBADSTATLIM                   2244
#define SQLDUPPRC                       2245
#define SQLOARGTBL                      2246
#define SQLNOSUCHKEY                    2247
#define SQLOUFNTBL                      2248
#define SQLNORESULT                     2249
#define SQLNONDMLTR                     2250
#define SQLTWODIST                      2251
#define SQLDUPRULE                      2252
#define SQLUNKRULE                      2253
#define SQLRULENOTPRI                   2254
#define SQLBADJOIN                      2255
#define SQLBADHIER                      2256
#define SQLDUPTRG                       2257
#define SQLUNKTRG                       2258
#define SQLINVNPAR                      2259
#define SQLPAREXP                       2260
#define SQLINVRESTYPE                   2261
#define SQLINVARGSPEC                   2262
#define SQLDISDISTR                     2263
#define SQLCANTEXT                      2264                   /* 18.11.98 */
#define SQLOBSVIEW                      2265                   /* 07.05.99 */
#define SQLCPLXCHECK                    2266                   /* 07.05.99 */
#define SQLUNKKEY                       2267                   /* 07.05.99 */
#define SQLCONFMOD                      2268                   /* 08.10.99 */
#define SQLBADPRIO                      2269                   /* 08.10.99 */
#define SQLFORREFUPD                    2270                   /* 08.10.99 */
#define SQLCONFPAR                      2271 /* Conflicting parameter values */ /* 19.01.05 */
#define SQLPROTNOTDEF                   2272 /* Protocol not defined         */ /* 19.01.05 */
#define SQLADDRNOTDEF                   2273 /* Address not defined          */ /* 19.01.05 */
#define SQLUNKALIAS                     2274 /* Unknown charset alias        */ /* 19.01.05 */
#define SQLDIFPARTYP                    2275 /* Different parameter types    */ /* 19.01.05 */
#define SQLBADDISTSORT                  2276 /* Bad DISTINCT sorting         */ /* 19.01.05 */
#define SQLOHINTTBL                     2277 /* too many hints               */ /* 19.01.05 */
#define SQLOBJRECR                      2285 /* Try to recreate object using its definition */ /* 20.08.13 */

#define SQLAUDCMDEXP                    2300
#define SQLAUDPAREXP                    2301
#define SQLFILTEXIST                    2302               /* 29.05.00 ... */
#define SQLUNKFILT                      2303
#define SQLTOOLNGSTR                    2304
#define SQLBADFILTID                    2305
#define SQLFILECOLEXP                   2306               /* ... 29.05.00 */
#define SQLBADVALUE                     2307               /* 20.10.00 */
#define SQLUNKNVAR                      2310               /* 19.10.13 */
#define SQLUNKCHARSET                   2350               /* 30.07.05 */
#define SQLDUPSEQ                       2352               /* 28.03.11 */
#define SQLUNKSEQ                       2353               /* 14.05.01 */
#define SQLDUPCHARSET                   2354               /* 28.03.11 */
#define SQLUNKTRANSL                    2355               /* 16.01.14 */
#define SQLDUPTRANSL                    2356               /* 28.03.11 */
#define SQLALTSEQ                       2361               /* 25.01.06 */
#define SQLGETMSG                       2450
#define SQLSNDMSG                       2451
#define SQLMSGFORM                      2452
#define SQLIDBAD                        2480
#define SQLOFFBAD                       2481
#define SQLATT                          2482
#define SQLCVDATEA                      2483

#define SQLPRIV                         2484
#define SQLNORM                         2485
#define SQLUNIONNYI                     2490
#define SQLNULLVNYI                     2492
#define SQLNOIMPLV                      2498
#define SQLNOIMPL                       2499
#define SQLCOMPRESS                     2500
#define SQLBEGSYMEXP                    2700
#define SQLLEFTPAREXP                   2704               /* 01.12.98 ... */
#define SQLRIGHTPAREXP                  2705
#define SQLFROMEXP                      2779
#define SQLINTOEXP                      2794
#define SQLKEYEXP                       2796
#define SQLSETEXP                       2836               /* ... 01.12.98 */
#define SQLENDSYMEXP                    2999
/*... 15.09.98 */

/* 16.12.02 ... */
#define DBCS_BASERR       4000
/* Common network client & server errors */
#define ERR_OPENSOCKET    4001   /* socket open error               */
#define ERR_IOCTL         4002   /* ioctl error                     */
#define ERR_SOCKOPT       4003   /* setsockopt error                */
#define ERR_BIND          4004   /* bind error                      */
#define ERR_SELECT        4005   /* select error                    */
#define ERR_CONNECT       4006   /* connect error                   */
#define ERR_SEND          4007   /* send error                      */
#define ERR_RECV          4008   /* recv error                      */
#define ERR_CONNCLOSED    4009   /* connection closed by other side */
#define ERR_VERSION       4010  /* uncompatible versions           */
#define ERR_UNKNOWNPKT    4011  /* unknown packet type             */

/* Common network client errors */
#define ERR_UNKNOWNSERVER    4050  /* server not found in nodetab     */
#define ERR_TERMINATED       4051  /* connection terminated           */
#define ERR_TOOMANYSRV       4052  /* too many servers in nodetab     */
#define ERR_CRECHLDPROC      4053  /* create child proces failed      */
#define ERR_NODETABNOTFOUND  4054  /* file nodetab has not found      */
#define ERR_READNODETAB      4055  /* reading of the nodetab file has failed */
#define ERR_CREMBX           4056  /* creation client communication object has failed */
#define ERR_RECVTIMEOUT      4057  /* receive watch packet timeout has expired */
#define ERR_CONNTIMEOUT      4058  /* connection timeout has expired */
#define ERR_QUERYTIMEOUT     4059
#define ERR_TOOMANYCLIENTS   4060
#define ERR_LINKDOWN         4061
#define ERR_NETOVERLOAD      4062
#define ERR_INITPROTOCOL     4063  /* initialize protocol error       */
#define ERR_RESOLVE          4064  /* resolve server error            */
#define ERR_TIMEOUT          4065  /* connection timeout              */
#define ERR_PROTDISABLED     4066  /* protocol disabled               */
#define ERR_TOOMANYREQ       4067  /* too many requests from clients  */



/* MS-DOS network client errors */
#define ERR_COMPLCONNECT  4100 /* SPX only                        */
#define ERR_COMPLRECV     4101 /* SPX only                        */

/* Common network server (listener) errors */
#define ERR_NOLINTER      4150 /* LINTER kernel not found         */
#define ERR_SENDTOLINTER  4151 /* send to LINTER error            */
#define ERR_GETFROMLINTER 4152 /* get from LINTER error           */
#define ERR_TOOMANYCLNT   4153 /* too many clients                */
#define ERR_LISTEN        4154 /* listen of the scoket error */
#define ERR_ACCEPT        4155 /* accept connection error */
#define ERR_SSLAUT        4156 /* security autentification error  */
#define ERR_SSLNOSECURE   4157 /* only security connections permit */



/* network errors */
#define ERR_ALLOCMEM         4200
#define ERR_CREATEEVENT      4201
#define ERR_CREATETHREAD     4202
#define ERR_READMAILSLOT     4203
#define ERR_OPENEVENT        4204
#define ERR_GETTIMES         4205  /* GetProcessTimes error           */
#define ERR_OPENPROCESS      4206  /* OpenProcess error               */

/* network hot reserv */
#define ERR_RESLINK          4250
#define ERR_SEARCH           4251

/* Os9000 network errors */
#define ERR_PARRENTDEAD      4300
#define ERR_LINKACTIVE       4301
/* ... 16.12.02 */
/* 11.07.97 */

/* New exchange client codes */                             /* 15.07.10 ... */
#define II_LONG_MESSAGE     5900 /* The message is too long */
#define II_OPEN             5901 /* Opening channel to linter failed */
#define II_INVALID_REQUEST  5902 /* It is not answer to request. Invalid format */
#define II_NOMEM            5903 /* No memory for opening the channel */
#define II_ALREADY_INIT     5904 /* The client is already init */
#define II_INIT_FAILED      5905 /* Initialisation of the client failed */
#define II_ASYNC            5906 /* Moving the channel to async mode failed */
#define II_SEND             5907 /* Sending mesage failed */
#define II_CLOSED           5908 /* The channel was closed */
#define II_READ             5909 /* Reading message failed */

#define II_REQUEST_NEED_OPEN 5920 /* The request should be opened */
#define II_REQUEST_BUSY     5921 /* The request is already used */
#define II_INVALID_FORMAT   5922 /* Format of input message failed */
#define II_REQUEST_TIMEOUT  5923 /* Timeout for the request was expired */
#define II_REQUEST_ASYNC    5924 /* Cannot do operation. The request in async mode */
#define II_SMALL_BUFFER     5925 /* Answer buffer is too small */ /* 11.11.10 */

/* New exchange server codes */
#define SII_NOMEM           5930 /* No memory */
#define SII_ALREADY_INIT    5931 /* The server is already init */
#define SII_WRONG_MBX       5932 /* Too long MBX value */
#define SII_CREATE          5933 /* Creating queue failed */
                                                            /* ... 15.07.10 */
/* New exchange dbc codes */
#define II_DBC_CLIENT_FORMAT 5800 /* Dbc message has wrong format */ /* 11.11.10 */
#define II_DBC_NOIMPL        5801 /* Features is not implemented */  /* 11.11.10 */


/* Log -- warm restart */

#define ERRRIDKOR     6000
#define ERRADRKOR     6001
#define UNKNCOM       6003
#define ERRCHILDCHAN  6004  /* can't commit or rollback: child channel(s) is working */ /* 10.06.02 */

/* Errors of log file header check */                         /* 10.09.06... */
#define ERR_LOG_WRONG_HDR     6005  /* DB name, File size or circle or Flag value from header is error */
                                                              /* ...10.09.06 */
#define ERRLNGKOR     6010
#define NOTENDPROC    6070
#define UNKNTYP       6100
#define DELTABLE      6300  /* 25.07.95  16.11.95 */
#define ERRBLVAL      6500  /* 05.06.97 */
#define ERRTYPE       6501  /* 15.03.01 */
#define ERRLENLONGROW 6502  /* 20.10.01 */
#define END_REPEAT_ROLL  6503                                    /* 20.09.02 */
#define ERR_ORDER_ACTION 6504                                    /* 18.09.02 */
#define ERR_FILE_NUMBER  6505                                    /* 06.11.02 */
#define BM_PAGES_NOT_EQUAL   6506                                /* 16.06.06 */
/* commit/rollback of cursor */
#define ERROR_CURSOR_COMMIT  6510 /* cursor commit exist in work channel *//* 30.09.03 */
#define FIND_DELETING_ROWID  6511 /* rollback found deleting rowid *//* 30.09.03 */
#define INV_RESTRICT         6512 /* invalid restrict to warm restart *//* 25.02.04 */
#define ERASED_VERSION       6513 /* erased old version is in use */    /* 07.05.04 */

#define ERR_REF_ADDR  6600  /* 27.08.97 */

/* Log -- Optimistic_concurrent or Exclusive */

#define ERRMODE              6111  /* 27.10.94  error regim for commit/rollback */
#define INV_REJIME_TO_CP     6114 /* error regim to commit/roll to control point */
#define ERR_OPTIMS_PG        6115  /* error of optimistic page (from wbv) reading *//* 24.02.12 */
#define INV_OPTIMS_TYP       6116  /* error type inside optimistic page (from wbv)*//* 24.02.12 */
                                                                 /* 13.10.03 */
/* Log -- with Log_pool working */

#define  NOT_SAVE_BUF       6704
#define  INVALID_COMMAND    6705
#define  NOT_READ_BUF       6706
#define  END_OF_FILE        6707
#define  BAD_CRC            6708
#define  INV_FILE_SIZE      6709  /* assumed size large current size */
#define  NOT_IDENT_FIL      6710
#define  FORCED_ROLLB       6712  /* 07.11.96 */
#define  FORCED_COMMIT      6713  /* 07.11.96 */
#define  LOG_OVERFLOW       6714  /* 26.11.96 */
#define  LOG_FILE_NOT_EXIST 6715  /* 17.10.97 */
#define  INV_LOG_ADDRESS    6716  /* 01.12.98 */
#ifdef HOT_RESERVE
#define  HR_LogAddr_Overfl  6717  /* 17.02.99 */
#define  HR_HAS_BEEN_MADE   6718  /* 19.02.99 */
#define  HR_CHANNEL_BUSY    6719  /* 11.06.99 */
#endif
#define  LOG_INVTIME        6720  /* 07.09.99 */
#define  OLD_NEXT_BLOCK     6721  /* 30.09.99 */

#define  BIG_BUFFER         6799  /* 02.06.99 */

/* Phrase search && filter errors */
/* Grand count opened handles */                        /* 03.02.01 ... */
#define ERROR_ENDHANDLE 6800
/* Error in function Init IO */
#define ERROR_INITDRIVER 6801
/* Set of functions of driver not fill */
#define ERROR_SETFUNCTIONSIO 6802
/* Illegal handle of stream (not open) */
#define ERROR_ILLEGALHANDLEIO 6803
/* Error in function Info IO */
#define ERROR_IOINFO 6804
/* Error in function Open IO */
#define ERROR_OPENIO 6805
/* Too long table data for IO Open */
#define ERROR_LONGDATALEN 6806
/* Error in function GetStat IO*/
#define ERROR_STATIO 6807
/* Function Stat IO return structure illegal type */
#define ERROR_BADTYPESTAT 6808
/* Error in function Close IO */
#define ERROR_IOCLOSE    6809
/* Too long data for save in internal kernel memory */
#define ERROR_LENSAVEDATAIO 6810                          /* 20.07.07 */
/* Too short buffer for restore data from kernel */
#define ERROR_SMALLBUFFERRESTOREDATAIO 6811
/* Driver IO not support the Linter type field */
#define ERROR_NODRIVERFORTYPE 6812

/* Error in tsUpdateStart */
#define ERROR_INDEX_START 6813
/* Error get flags from index */
#define ERROR_INDEX_GETFLAGS 6814
/* Error get state from index */
#define ERROR_GETINDEXSTATE 6815
/* Error save state in index */
#define ERROR_INDEXSAVESTATE 6816                         /* 20.07.05 */
/* Error clear RID in index */
#define ERROR_DELETEINDEXRID 6817                         /* 20.07.07 */
/* Error update RID in index */
#define ERROR_UPDATEINDEX 6818
/* Error search in index */
#define ERROR_SEARCHININDEX 6819

/* Set of functions filter not fill */
#define ERROR_SETFUNCTIONSFILTER 6820
/* Error in function Init of the filter */
#define ERROR_INITFILTER 6821
/* Illegal handle (not open) of filter */
#define ERROR_ILLEGALHANDLEFILTER 6822
/* Too long length of saved data filter in kernel */
#define ERROR_LENSAVEDATAFILTER 6823                      /* 20.07.07 */
/* Too short length of buffer for restore filter data */
#define ERROR_SMALLBUFFERRESTOREDATAFILTER 6824
/* Filter not support type column */
#define ERROR_NOFILTERFORTYPE 6825
/* Error in function ScanData */
#define ERROR_SCANDATA  6826
/* Error in function GetData */
#define ERROR_GETDATA 6827
/* Error in function Open of filter */
#define ERROR_OPENFILTER 6828
/* Error in function Close of filter */
#define ERROR_CLOSEFILTER 6829
/* Filter table overflow */
#define ERROR_FILTERTABLEOVR 6830                       /* ... 03.02.01 */
/* Error parsing search request */
#define ERROR_SEARCHSYNTAX 6831                           /* 20.07.05 */
/* Error phrase index rebuild is disabled */
#define ERROR_DISABLE_REBUILD 6832                        /* 20.07.07 */
/* Error create phrase index */
#define ERROR_INDEX_CREATE 6833                           /* 20.10.07 */

/* Dictionary errors */
#define Table_Servers_Is_Absent      7000                 /* 07.12.94 */
#define Server_Description_Is_Absent 7001                 /* 15.12.94 */
#define Remote_Server_Not_Available  7002                 /* 15.12.94 */
#define Devices_Table_Is_Absent      7003                 /* 18.03.97 */
#define Stations_Table_Is_Absent     7004                 /* 18.03.97 */
#define Relation_Table_Is_Absent     7005                 /* 22.03.97 */
#define ErrSendToOLTP                7030                 /* 15.12.94 */
#define ErrReceiveFromOLTP           7031                 /* 15.12.94 */
#define ErrCreateOLTPMessage         7032                 /* 15.12.94 */
#define User_Id_Not_Found            7033                 /* 15.12.94 */
#define Proc_Table_Is_Absent         7100                 /* 25.02.97 */
#define SecGroup_Table_Is_Absent     7101                 /* 06.03.97 */
#define SecLevel_Table_Is_Absent     7102                 /* 06.03.97 */
#define SecGroup_Already_Defined     7103                 /* 06.03.97 */
#define SecLevel_Already_Defined     7104                 /* 06.03.97 */
#define SecGroup_Table_Overflow      7105                 /* 06.03.97 */
#define ReplRule_Table_Is_Absent     7106                 /* 23.06.97 */
#define Trigger_Table_Is_Absent      7107                 /* 28.08.97 */
#define Sequence_Table_Is_Absent     7108                 /* 19.04.01 */
#define Charset_Table_Is_Absent      7109                 /* 14.09.01 */
#define Translate_Table_Is_Absent    7110                 /* 14.09.01 */
#define ExtRepl_Table_Is_Absent      7111                 /* 21.10.02 */
#define CsAlias_Table_Is_Absent      7112                 /* 04.01.03 */
#define Event_Table_Is_Absent        7113                 /* 01.04.08 */
#define ObjComm_Table_Is_Absent      7114                 /* 08.06.13 */
#define GlVar_Table_Is_Absent        7115                 /* 01.07.13 */
#define Proc_Translation_Error       7200                 /* 25.04.97 */
#define Proc_Raised_Exception        7201                 /* 25.04.97 */
#define Proc_Not_Translated          7202                 /* 25.04.97 */
#define Proc_No_Memory               7203                 /* 28.04.97 */
#define Proc_Debug_Error             7204                 /* 07.05.97 */
#define Proc_Bad_Code                7205                 /* 23.05.97 */
#define Invalid_Trigger_Operation    7206                 /* 30.09.97 */
#define Proc_Dead                    7207                 /* 27.10.97 */
#define Proc_Too_Large               7208                 /* 04.12.97 */
#define Proc_Inv_Version             7209                 /* 22.12.97 */
#define PROC_SESSION_NOT_FOUND       7210                 /* 29.04.05 */ /* 02.09.04 */
#define Proc_TSP_Busy                7211                 /* 18.12.99 */
#define Proc_Is_Executed             7212                 /* 18.12.99 */
#define PROC_INVALID_ID              7213                 /* 07.07.04 */
#define Proc_No_Source_Text          7214                 /* 26.03.08 */
#define Proc_Transl_Not_Completed    7215 /*translation of procedure or trigger isn't completed*/ /* 25.03.09 */
#define SP_not_supported             7272                 /* 31.05.01 */
#define Table_Filters_Is_Absent      7400                 /* 20.04.00 */
#define Table_Extensions_Is_Absent   7401                 /* 20.04.00 */
#define Unknown_Internal_Filter      7402                 /* 20.04.00 */
#define Filter_Is_Internal           7403                 /* 20.04.00 */
#define Filter_Number_Is_Busy        7404                 /* 20.04.00 */
#define Pattern_Syntax_Error         7405  /* Not Used */ /* 20.10.07 26.05.00 */

/* Audit errors */

#define AuditAlreadyStarted          8001
#define AuditTableDoesntExists       8002
#define AuditAlreadyStopped          8003
#define AuditNotActive               8004
#define AuditDefinitionNotFound      8005

/* Read Only channel errors */ /* 23.01.98 */

#define ERRWRK_BadTreeTop     6590
#define ERRWRK_BadTopHeader   6591
#define ERRWRK_BadPointer     6592
#define ERRWRK_BadKey         6593
#define ERRWRK_EmptyTree      6594
#define ERRUPDATEROCHAN       6595
#define ERR_CHANGE_TR_MODE    6596                          /* 01.09.03 */

/* LHB errors */ /* 20.06.98 */

#ifndef LHB_ERR_INVPARAM
#define LHB_ERR_INVPARAM          6900
#define LHB_ERR_PROCESSPRESENT    6901
#define LHB_ERR_PROCESSNOTPRESENT 6902
#define LHB_ERR_INVOBJECT         6903
#define LHB_ERR_INVATTR           6904
#define LHB_ERR_FBYTENOTNULL      6905
#define LHB_ERR_NOMEMORY          6906
#define LHB_ERR_NOTSTARTED        6907
#define LHB_ERR_SYSLOGNOTIDENT    6908
#define LHB_ERR_TOOMANYCOLUMNS    6909 /* 08.12.98 */
#define LHB_ERR_TABLEFORTRIGNOTEXIST    6910    /* 28.11.00 */
#define LHB_ERR_PROCEDUREALREADYEXIST   6911    /* 28.11.00 */
#define LHB_ERR_TRIGGERALREADYEXIST     6912    /* 28.11.00 */
#define LHB_ERR_CANTADDPROCBODY         6913    /* 28.11.00 */
#define LHB_ERR_FOREIGNTRIGGER          6914    /* 28.11.00 */
#define LHB_ERR_FOREIGNPROCEDURE        6915    /* 28.11.00 */
#define LHB_ERR_CANT_READ_SERVER_INFO   6916    /* Can't read info from SERVER table */ /* 16.04.02 ...*/
#define LHB_ERR_CANT_READ_REPL_RULES    6917    /* Can't read from $$$REPL table */
#define LHB_ERR_CANT_RESTORE_SERVER     6918    /* Can't restore server object */
#define LHB_ERR_CANT_RESTORE_REPL_RULE  6919    /* Can't restore replication rule object */
#define LHB_ERR_SERVER_NOT_EXIST        6920    /*Server for replication rule doesn't exist*/ /*... 16.04.02 */
/* In-kernel backup errors */                             /* 31.05.02 ...*/
#define InKernBack_Table_Is_Absent          6931    /* $$$INKERNBACK table not present in database */
#define LHB_ERR_ACCESS_VIOLATION_LHB_FILE   6932    /* Access violation to archve file */
#define LHB_ERR_CANNOT_FIND_LHB_FILE        6933    /* Cannot find archive file*/
#define LHB_ERR_NO_MORE_HANDLES_LHB_FILE    6934    /* Maximum count of open files exeed */
#define LHB_ERR_ALREADY_EXIST_LHB_FILE      6935    /* Lhb archive file already exist */
#define LHB_ERR_CANNOT_OPEN_LHB_FILE        6936    /* Can not open archive file */
#define LHB_ERR_CANNOT_DELETE_LHB_FILE      6937    /* Can not remove archive file */
#define LHB_ERR_CANNOT_WRITE_IN_FILE        6938    /* Can not write to archive file */
#define LHB_ERR_PROCESS_STOPED_BY_USER      6939    /* Asynchronous archiving process stoped by user */
#define LHB_ERR_CANNOT_FIND_PROCESS         6940    /* Stop of process by number was asked - can't find specified process */
#define LHB_ERR_USER_IS_NOT_DBA             6941    /* User have not DBA privileges */
#define LHB_ERR_CANNOT_READ_ASYNC_STATUS    6942    /* Error reading from $$$INKERNBACK table */
#define LHB_ERR_PROCESS_ALREADY_STOPED      6943    /* Async archiving process already stoped (by user or it self) */
                                                          /*... 31.05.02 */ /* 12.07.02 ...*/
#define LHB_ERR_CANNOT_READ_FROM_FILE       6944    /* Can not read from archive file */
#define LHB_ERR_INVALID_INCREMENT_IN_ARCH   6945    /* Invalid increment data in archive file */
#define LHB_ERR_INCORRECT_FILE_NAME         6946    /* Incorrect archive file name */ /* 07.08.02 */
#define LHB_ERR_INCORRECT_DEVICE_NAME       6947    /* Incorrect device name */       /* 07.08.02 */
#define LHB_ERR_FOREIGN_EVENT               6948    /* event belong to another user */ /* 03.07.08 */
                                                          /*... 12.07.02 */
#endif

/* MVCC related errors: */                                                 /* 03.07.02 */
#if _VER_MAX >= 610

#define ERROR_ROW_CNV_STATUS           8100
#define ERROR_UNKNOWN_ISOLATION_LEVEL  8101
#define ERROR_NON_SERIAL_REQUEST       8102
#define ERROR_ROW_WAS_MODIFIED_OR_DELETED  8103
#define ERROR_CONCURRENT_TRANSACTION_MODIFIY_OR_DELETE_ROW  8104

#define ERROR_SS_ARRAY_ALREADY_ASSIGNED 8105 /* ShanShots Array was already assinged */
#define ERROR_SS_ARRAY_NOT_ASSIGNED    8106 /* ShanShots Array does not assigned    */
#define ERROR_NO_FREE_ENTRY_IN_SS_BV   8107 /* No free entry in SS bitvector */
#define ERROR_ASSERTION_FAILED         8108 /* Assertion failed              */
#define ERROR_MVCC_INVALID_PARAMETER   8109 /* Invalid paramater             */
#define ERROR_CHAIN_CORRUPTED          8110 /* chain corrupted.              */
#define ERROR_TSN_CHAIN_CORRUPTED      8111 /* Chain of TSN is corrupted.    */
#define ERROR_ILLEGAL_TR_MODE          8112 /* Illegal transaction mode      */


#define ERROR_PP_TABLE_IN_USE          8113 /* table for PP in use another channel */
#define ERROR_TABLE_ALREADY_PURGING    8114 /* table is already scheduled for PP */
#define ERROR_PP_INIT_FAIL             8115 /* PP initialization error       */ /* 17.04.03 */

#define ERROR_ACCESS_TO_DELETED_ROW    8116 /* internal error: access to deleted rowid */ /* 11.11.03 */
#define ERROR_NOT_VERSION              8117 /* try change status for not version */
#define ERROR_MVCC_PAUSED              8118

#endif /* _VER_MAX >= 610 */

#if _VER_MAX >= 500
#else
#define CursorNameTooLong         8888             /* 15.09.98 */
#endif
#define PROC_ERR_BASE             10000                   /* 15.09.98 */

#define PROC_E_NOMEM       (PROC_ERR_BASE+0)
#define PROC_E_SYNTAXERR   (PROC_ERR_BASE+1)
#define PROC_E_INCOMPTYP   (PROC_ERR_BASE+2)
#define PROC_E_REQLP       (PROC_ERR_BASE+3)
#define PROC_E_REQRP       (PROC_ERR_BASE+4)
#define PROC_E_REQLF       (PROC_ERR_BASE+5)
#define PROC_E_DIVZERO     (PROC_ERR_BASE+6)
#define PROC_E_REQDOLL     (PROC_ERR_BASE+7)
#define PROC_E_REQRC       (PROC_ERR_BASE+8)
#define PROC_E_MISSOP      (PROC_ERR_BASE+9)
#define PROC_E_BADNULLOP   (PROC_ERR_BASE+10)
#define PROC_E_REQLC       (PROC_ERR_BASE+11)
#define PROC_E_INVPAR      (PROC_ERR_BASE+12)
#define PROC_E_INVINDEX    (PROC_ERR_BASE+13)
#define PROC_E_BADNUMBER   (PROC_ERR_BASE+14)
#define PROC_E_BADVARFUNC  (PROC_ERR_BASE+15)
#define PROC_E_UNTERMSTR   (PROC_ERR_BASE+16)
#define PROC_E_INVHEXCHAR  (PROC_ERR_BASE+17)
#define PROC_E_BADDATE     (PROC_ERR_BASE+18)
#define PROC_E_ERRINEXPR   (PROC_ERR_BASE+19)
#define PROC_E_REQLOGIC    (PROC_ERR_BASE+20)
#define PROC_E_REQSTR      (PROC_ERR_BASE+21)
#define PROC_E_DIVZEROWARN (PROC_ERR_BASE+22)
#define PROC_E_UNTERMIF    (PROC_ERR_BASE+23)
#define PROC_E_BIGOPERATOR   (PROC_ERR_BASE+24)
#define PROC_E_MISSSEMICOLON (PROC_ERR_BASE+25)
#define PROC_E_NOLABEL       (PROC_ERR_BASE+26)
#define PROC_E_MISSIF        (PROC_ERR_BASE+27)
#define PROC_E_MISSWHILE     (PROC_ERR_BASE+28)
#define PROC_E_INVALDECLARE  (PROC_ERR_BASE+29)
#define PROC_E_INVALCODE     (PROC_ERR_BASE+30)
#define PROC_E_INVALEXCEPT   (PROC_ERR_BASE+31)
#define PROC_E_INVALEND      (PROC_ERR_BASE+32)
#define PROC_E_INVALDECL     (PROC_ERR_BASE+33)
#define PROC_E_INVALOP       (PROC_ERR_BASE+34)
#define PROC_E_MISSLABEL     (PROC_ERR_BASE+35)
#define PROC_E_MISSLOOP      (PROC_ERR_BASE+36)
#define PROC_E_MISSTHEN      (PROC_ERR_BASE+37)
#define PROC_E_DUPLABEL      (PROC_ERR_BASE+38)
#define PROC_E_UNDEFLABEL    (PROC_ERR_BASE+39)
#define PROC_E_MISSEXPR      (PROC_ERR_BASE+40)
#define PROC_E_DUPELSE       (PROC_ERR_BASE+41)
#define PROC_E_BADELSEIF     (PROC_ERR_BASE+42)
#define PROC_E_INVNAMEVAR    (PROC_ERR_BASE+43)
#define PROC_E_INVTYPESPEC   (PROC_ERR_BASE+44)
#define PROC_E_MANYDEFAULT   (PROC_ERR_BASE+45)
#define PROC_E_REQNUM        (PROC_ERR_BASE+46)
#define PROC_E_INVCURSORUSE  (PROC_ERR_BASE+47)
#define PROC_E_STRUCTDEF     (PROC_ERR_BASE+48)
#define PROC_E_BADFIELD      (PROC_ERR_BASE+49)
#define PROC_E_INVNAMEXCEPT  (PROC_ERR_BASE+50)
#define PROC_E_EXCEPTDEF     (PROC_ERR_BASE+51)
#define PROC_E_FOREXPECT     (PROC_ERR_BASE+52)
#define PROC_E_INVEXCEPTYPE  (PROC_ERR_BASE+53)
#define PROC_E_INVALEXCEPTHDR (PROC_ERR_BASE+54)
#define PROC_E_EXCEPTUNDEF   (PROC_ERR_BASE+55)
#define PROC_E_DUPEXCEPTHDR  (PROC_ERR_BASE+56)
#define PROC_E_NOEXCEPOTHERS (PROC_ERR_BASE+57)
#define PROC_E_INVALRESIGNAL (PROC_ERR_BASE+58)
#define PROC_E_MISSDOUBLEPOINT (PROC_ERR_BASE+59)
#define PROC_E_UNRESEXCEPT     (PROC_ERR_BASE+60)

#define PROC_E_MISSPROCHDR     (PROC_ERR_BASE+61)
#define PROC_E_BADPROCNAME     (PROC_ERR_BASE+62)
#define PROC_E_INVPARMODIF     (PROC_ERR_BASE+63)
#define PROC_E_BADTYPEOF       (PROC_ERR_BASE+64)

#define PROC_E_BADINTO         (PROC_ERR_BASE+65)
#define PROC_E_BADCURSOR       (PROC_ERR_BASE+66)
#define PROC_E_BADORIENT       (PROC_ERR_BASE+67)
#define PROC_E_REQCHARCONST    (PROC_ERR_BASE+68)
#define PROC_E_BADINTOCONTEXT  (PROC_ERR_BASE+69)
#define PROC_E_BADQUERY        (PROC_ERR_BASE+70)

#define PROC_E_MISSCASE        (PROC_ERR_BASE+71)
#define PROC_E_INVWHENCONST    (PROC_ERR_BASE+72)
#define PROC_E_INVWHENTYPE     (PROC_ERR_BASE+73)
#define PROC_E_WHENAFTEROTHERS (PROC_ERR_BASE+74)
#define PROC_E_DUPWHEN         (PROC_ERR_BASE+75)
#define PROC_E_EMPTYCASE       (PROC_ERR_BASE+76)
#define PROC_E_TYPRETMIS       (PROC_ERR_BASE+77)
#define PROC_E_TOOMANYERRORS   (PROC_ERR_BASE+78)

#define PROC_E_UNTERMWHILE    (PROC_ERR_BASE+79)
#define PROC_E_UNTERMCASE     (PROC_ERR_BASE+80)
#define PROC_E_LARGEVAR       (PROC_ERR_BASE+81)
#define PROC_E_BADTRIGTAB     (PROC_ERR_BASE+82)
#define PROC_E_TRANERROR      (PROC_ERR_BASE+83)
#define PROC_E_INVALIGNORE    (PROC_ERR_BASE+84)            /* 08.09.08 */
#define PROC_E_TR_MISMATCH    (PROC_ERR_BASE+85)            /* 08.09.08 */
#define PROC_E_UNDEFGLVAR     (PROC_ERR_BASE+86)            /* 10.10.13 */

#endif
