/****************************************************************************
 *           RELEX, Inc. Linter precompiler library source code             *
 *  This is unpublished proprietary source code of RELEX, Inc.              *
 *  The copyright notice does not evidence any actual or intended           *
 *  publication of such source code.                                        *
 *                                                                          *
 *                 Copyright (c) 1994-2011 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR: Razuwaev A.V.
 ----------------------------------------------------------------------------
 PURPOSE:
 ----------------------------------------------------------------------------
 REVISION HISTORY:
 ----------------------------------------------------------------------------
*/
/* 04.04.03 - RAW (code revision; lite client)                                */
/* 26.08.03 - RAW (PCIA_setd obtained additional parameter)                   */
/* 02.09.03 - RAW (GET DIAGNOSTICS)                                           */
/* 06.10.03 - RAW (sqlclu is now macro for external caller)                   */
/* 10.12.04 - Gluhov (added new trace procedures )                            */
/******************************************************************************/


#ifndef __INTER_PCI__
#define __INTER_PCI__

#ifdef __cplusplus
extern "C" {
#endif

#include "dlldefs.h"
#include "sqlca.h"
#include "sqlda.h"
#include "lintypes.h"

#ifdef INTER_MSWINDOWS                                       /* 10.12.04 ... */
#include <stdarg.h>
#include <winbase.h>
#endif                                                       /* ... 10.12.04 */

#ifdef PCI_STAT_LIB
#ifdef  INTER_MSWINDOWS
#  ifndef PCL
#    undef  DLLIMP
#    define DLLIMP
#  endif
#endif
#endif
/*---------------------------------Variable Types-----------------------------*/

typedef L_CHAR *_PCI_A_;
typedef L_BYTE *_PCI_B_;
typedef void   *_PCI_V_;
typedef L_SWORD _PCI_I_;
typedef L_WORD  _PCI_W_;
typedef L_LONG  _PCI_L_;
/*--------------------------------Completion Codes----------------------------*/

#define ErrPCI_NotFound        3000       /* no such records       */

/*---------------------------------Global Variables---------------------------*/
#define CtxPCI_ CtxPCI()                  /* default context         */
#define DdbPCI_ DdbPCI(CtxPCI_)           /* default database        */
                                                                   
#define ErrPCI_ ErrPCI(CtxPCI_)           /* completion code         */
#define CntPCI_ CntPCI(CtxPCI_)           /* records count           */
#define RowsPCI_ RowsPCI(CtxPCI_)         /* records count           */
#define IsnPCI_ RowIdPCI(CtxPCI_)         /* last processed record   */
#define RowIdPCI_ RowIdPCI(CtxPCI_)       /* last processed record   */
#define LenPCI_ LenPCI(CtxPCI_)           /* BLOB portion length     */
#define TxtPCI_ TxtPCI(CtxPCI_)           /* last operator text      */

#define SQLCODE  (*sqlcode(CtxPCI_))         /* sql complite code       */
#define SQLSTATE sqlstate(CtxPCI_)        /* sql string complite code*/
/*--------------------Synchronious Library Procedures-------------------------*/
#define PCI_Connect(a,b,c,d,e,f) PCIA_Connect(CtxPCI_,a,b,c,d,e,f)
#define PCI_CommRoll(a,b,c) PCIA_CommRoll(CtxPCI_, a,b,c)
#define PCI_ShutAll(a)  PCIA_ShutAll(CtxPCI_,a)
#define PCI_ExecStat(a,b,c,d) PCIA_ExecStat(CtxPCI_, a,b,c,d)
#define PCI_Prepare(a,b,c,d,e) PCIA_Prepare(CtxPCI_,a,b,c,d,e)
#define PCI_Exec(a,b,c,d,e) PCIA_Exec(CtxPCI_, a,b,c,d,e)
#define PCI_Open(a,b,c,d) PCIA_Open(CtxPCI_, a,b,c,d)
#define PCI_Fetch(a,b,c,d,e) PCIA_Fetch(CtxPCI_, a,b,c,d,e)
#define PCI_Close(a) PCIA_Close(CtxPCI_,a)
#define PCI_Describe(a,b,c) PCIA_Describe(CtxPCI_, a,b,c)
#define PCI_OpenDesc(a,b,c,d,e) PCIA_OpenDesc(CtxPCI_,a,b,c,d,e)
#define PCI_FetchDesc(a,b,c,d,e,f) PCIA_FetchDesc(CtxPCI_,a,b,c,d,e,f)
#define PCI_NewVar(a,b,c,d,e,f) PCIA_NewVar(CtxPCI_,a,b,c,d,e,f)
#define PCI_GetBlob(a,b,c,d,e) PCIA_GetBlobEx(CtxPCI_,a,b,c,d,e,-1)
#define PCI_DelBlob(a,b) PCIA_DelBlobEx(CtxPCI_,a,b,-1)
#define PCI_AddBlob(a,b,c,d) PCIA_AddBlobEx(CtxPCI_,a,b,c,d,-1)
#define PCI_GetBlobE(a,b,c,d,e,f) PCIA_GetBlobEx(CtxPCI_,a,b,c,d,e,f)
#define PCI_DelBlobE(a,b,c) PCIA_DelBlobEx(CtxPCI_,a,b,c)
#define PCI_AddBlobE(a,b,c,d,e) PCIA_AddBlobEx(CtxPCI_,a,b,c,d,e)
#define PCIA_GetBlob(ctx,a,b,c,d,e,f) PCIA_GetBlobEx(ctx,a,b,c,d,e,-1)
#define PCIA_DelBlob(ctx,a,b,c) PCIA_DelBlobEx(ctx,a,b,-1)
#define PCIA_AddBlob(ctx,a,b,c,d,e) PCIA_AddBlobEx(ctx,a,b,c,d,-1)
#define PCIA_GetBlobE(ctx,a,b,c,d,e,f) PCIA_GetBlobEx(ctx,a,b,c,d,e,f)
#define PCIA_DelBlobE(ctx,a,b,c) PCIA_DelBlobEx(ctx,a,b,c)
#define PCIA_AddBlobE(ctx,a,b,c,d,e) PCIA_AddBlobEx(ctx,a,b,c,d,e)
#define PCI_CreRoutine(a,b) PCIA_CreRoutine(CtxPCI_,a,b)
#define PCI_StoredRoutine(a,b,c,d,e,f) PCIA_StoredRoutine(CtxPCI_,a,b,c,d,e,f)
#define PCI_Dprepare(a) PCIA_Dprepare(CtxPCI_,a)
#define PCI_getd(a,b,c,d,e) PCIA_getd(CtxPCI_,a,b,c,d,e)
#define PCI_setd(a,b,c,d,e,f) PCIA_setd(CtxPCI_,a,b,c,d,e,f)               /* 26.08.03 */
#define PCI_sqlald(a,b,c) PCIA_sqlald(CtxPCI_,a,b,c) 
#define sqlald(a,b,c) PCIA_sqlald(CtxPCI_,a,b,c)
#define PCI_sqlclu(a) PCIA_sqlclu(CtxPCI_,(a))                             /* 06.10.03 */
#define sqlclu(a)     PCIA_sqlclu(CtxPCI_, (a))
#define PCI_ExecImm(a,b,c) PCIA_ExecImm(CtxPCI_,a,b,c)
#define PCI_AllocCursor(a) PCIA_AllocCursor(CtxPCI_,a)
#define PCI_DeallocCursor(a) PCIA_DeallocCursor(CtxPCI_,a)
#define Fill_Sqlca(a,m) AFill_Sqlca(CtxPCI_,a,m)
#define PCI_ExecDesc(a,b,c,d,e,f,g) PCIA_ExecDesc(CtxPCI_,a,b,c,d,e,f,g)
#define PCI_ver_compat(a,b,c,d) PCIA_ver_compat(CtxPCI_,a,b,c,d)
#define PCI_pcl_ver(a,b,c) PCIA_pcl_ver(CtxPCI_,a,b,c)
#define PCI_ser_ver(a,b,c,d) PCIA_ser_ver(CtxPCI_,a,b,c,d)
#define PCI_PresetStat(a,b,c,d,e,f,g) PCIA_PresetStat(CtxPCI_,a,b,c,d,e,f,g)
#define PCI_diagnostics(a,b,c,d,e) PCIA_diagnostics(CtxPCI_,(a),(b),(c),(d),(e)) /* 02.09.03 */

/*--------------------Asynchronious Library Procedures----------------------- */
void DLLAPI PCIA_Connect(_PCI_A_ ctx,_PCI_A_ *db_adr, _PCI_A_ uid, _PCI_A_ pwd, _PCI_A_ node,
                         _PCI_I_ caller, _PCI_I_ access);
void DLLAPI PCIA_CommRoll(_PCI_A_ ctx,_PCI_A_ *db_adr, _PCI_I_ commit, _PCI_I_ release);
void DLLAPI PCIA_ShutAll(_PCI_A_ ctx,_PCI_I_ commit);
void DLLAPI PCIA_ExecStat(_PCI_A_ ctx,_PCI_A_ db_adr, _PCI_A_ stat_adr, _PCI_I_ cnt, _PCI_I_ ingc);
void DLLAPI PCIA_Prepare(_PCI_A_ ctx,_PCI_A_ db, _PCI_W_ areasize, _PCI_A_ *stat_adr,
                         _PCI_I_ caller, _PCI_A_ stat_text);
void DLLAPI PCIA_Exec(_PCI_A_ ctx,_PCI_A_ db_adr, _PCI_W_ areasize, _PCI_I_ cnt,
                      _PCI_A_ stat_text, _PCI_I_ ingc);
void DLLAPI PCIA_Open(_PCI_A_ ctx,_PCI_A_ db_adr, _PCI_A_ stat_adr, _PCI_A_ curs_name,
                      _PCI_I_ access);
void DLLAPI PCIA_Fetch(_PCI_A_ ctx,_PCI_A_ stat_adr, _PCI_I_ cnt, _PCI_I_ point, _PCI_L_ offs, _PCI_I_ ingc);
void DLLAPI PCIA_Close(_PCI_A_ ctx,_PCI_A_ stat_adr);
void DLLAPI PCIA_Describe(_PCI_A_ ctx,_PCI_A_ stat_adr, _PCI_A_ desc_adr, _PCI_I_ select);
void DLLAPI PCIA_OpenDesc(_PCI_A_ ctx,_PCI_A_ db_adr, _PCI_A_ stat_adr, _PCI_A_ curs_name,
                          _PCI_A_ desc_adr, _PCI_I_ access);
void DLLAPI PCIA_FetchDesc(_PCI_A_ ctx,_PCI_A_ stat_adr, _PCI_A_ desc_adr, _PCI_I_ cnt,
                           _PCI_I_ point, _PCI_L_ offs, _PCI_I_ ingc);
void DLLAPI PCIA_NewVar(_PCI_A_ ctx,_PCI_A_ adr, _PCI_I_ siz, _PCI_I_ typ, _PCI_I_ dim,_PCI_I_ dir,_PCI_V_ ind);
void DLLAPI PCIA_GetBlobEx(_PCI_A_ ctx,_PCI_A_ db_adr, _PCI_A_ stat_adr, _PCI_A_ bufadr,
                         _PCI_W_ bufsize, _PCI_L_ position, _PCI_L_ bidx);
void DLLAPI PCIA_DelBlobEx(_PCI_A_ ctx,_PCI_A_ db_adr, _PCI_A_ stat_adr, _PCI_L_ bidx);
void DLLAPI PCIA_AddBlobEx(_PCI_A_ ctx,_PCI_A_ db_adr, _PCI_A_ stat_adr,
                         _PCI_A_ bufadr, _PCI_W_ bufsize, _PCI_L_ bidx);

void DLLAPI PCIA_CreRoutine(_PCI_A_ ctx, _PCI_A_ db_adr, _PCI_A_ proc_text);
void DLLAPI PCIA_StoredRoutine(_PCI_A_ ctx,_PCI_A_ db_adr,_PCI_A_ result,_PCI_A_ indicator,
                               _PCI_W_ areasize,_PCI_A_ stat_text,_PCI_I_ ingc);

_PCI_A_ DLLAPI CtxPCI(void);        /* default context          */
_PCI_L_ DLLAPI ErrPCI(_PCI_A_ ctx);  /* last error              */
_PCI_L_ DLLAPI CntPCI(_PCI_A_ ctx);  /* records count           */
_PCI_L_ DLLAPI RowIdPCI(_PCI_A_ ctx);  /* last processed record   */
_PCI_L_ DLLAPI LenPCI(_PCI_A_ ctx);  /* BLOB portion length     */
_PCI_A_ DLLAPI DdbPCI(_PCI_A_ ctx);  /* default database        */
_PCI_A_ DLLAPI TxtPCI(_PCI_A_ ctx);  /* last operator text      */
_PCI_L_ DLLAPI RowsPCI(_PCI_A_ ctx);  /* RowsCount               */
_PCI_L_* DLLAPI sqlcode(_PCI_A_ ctx); /* sql complite code       */
_PCI_A_ DLLAPI sqlstate(_PCI_A_ ctx);/* sql string complite code*/

void DLLAPI PCIA_AllocCursor(_PCI_A_ ctx,_PCI_A_*adr);
void DLLAPI PCIA_DeallocCursor(_PCI_A_ ctx,_PCI_A_*adr);

void DLLAPI PCIA_AllocCtx(_PCI_A_*adr, _PCI_I_ caller);
void DLLAPI PCIA_FreeCtx(_PCI_A_*adr);

void DLLAPI AFill_Sqlca(_PCI_A_ ctx,_PCI_A_ sqlca_adr, _PCI_I_ mode);

void DLLAPI PCIA_sqlclu (_PCI_A_ ctx, sqlda *ex_sqlda);                    /* 06.10.03 */

void DLLAPI PCIA_Dprepare(_PCI_A_ ctx, _PCI_A_*stat_adr);
void DLLAPI PCIA_getd(_PCI_A_ ctx, _PCI_A_ dsc, _PCI_L_ num, _PCI_A_ val, _PCI_L_ siz, _PCI_L_ act);
void DLLAPI PCIA_setd(_PCI_A_ ctx, _PCI_A_ dsc, _PCI_L_ num, _PCI_A_ val, _PCI_L_ val_typ, _PCI_L_ isimm, _PCI_L_ act); /* 26.08.03 */
psqlda DLLAPI PCIA_sqlald(_PCI_A_ ctx, int n, int m, int i);
void DLLAPI PCIA_ExecImm(_PCI_A_ ctx, _PCI_A_ db_adr,_PCI_L_ cnt, _PCI_A_ stat_text);
void DLLAPI PCIA_ExecDesc(_PCI_A_ ctx, _PCI_A_ db_adr,_PCI_A_ stat_adr,_PCI_A_ dsci,_PCI_A_ dsco,_PCI_I_ use,_PCI_I_ cnt, _PCI_I_ ingc);

_PCI_L_ DLLAPI PCIA_ver_compat(_PCI_A_ ctx,_PCI_L_ drvmajor,_PCI_L_ drvminor,_PCI_L_ srvmajor,_PCI_L_ srvminor);
void DLLAPI PCIA_pcl_ver(_PCI_A_ ctx,_PCI_L_*major,_PCI_L_*minor,_PCI_L_*build);
void DLLAPI PCIA_ser_ver(_PCI_A_ ctx,_PCI_A_ node,_PCI_L_*major,_PCI_L_*minor,_PCI_L_*build);

void DLLAPI PCIA_PresetStat(_PCI_A_ ctx,
                            _PCI_A_ db_adr,
                            _PCI_A_*stat_adr,
                            _PCI_B_ query_body,
                            _PCI_L_ query_size,
                            _PCI_L_ transaction_flags,
                            _PCI_L_ invar_cnt,
                            _PCI_L_ outvar_cnt);

void DLLAPI PCIA_diagnostics(_PCI_A_ ctx,
                             _PCI_L_ num,
                             _PCI_A_ val,
                             _PCI_L_ type,
                             _PCI_L_ size,
                             e_diag_item diag_item);                       /* 02.09.03 */


void DLLAPI dump_global_vars();


#ifdef TRACE_MODE                                           /* 10.12.04 ... */

#ifdef INTER_MSWINDOWS
#  define THREADID GetCurrentThreadId()
#  define PROCID GetCurrentProcessId()
#elif defined(UNIX)
#  define THREADID getpid()
#  define PROCID getpid()
#else
#  define THREADID 0
#  define PROCID 0
#endif

void trace_before( char *file, int line, char *func_name )
{
   fprintf( stderr, "\n%d ENTER %s in file %s; line %d; pid %d; tid %d \n", THREADID, func_name, file, line, PROCID, THREADID );
}

void trace_after( char *file, int line, char * func_name )
{
   fprintf( stderr, "%d LEAVE %s in file %s; line %d; pid %d; tid %d\n", THREADID, func_name, file, line, PROCID, THREADID );
}

#ifdef DUMP_GLOBAL_VARS
#  define DUMP	fprintf( stderr, "%d BEGIN DUMP\n", THREADID ); dump_global_vars(); fprintf( stderr, "%d END DUMP\n", THREADID );
#else
#  define DUMP
#endif

#define TRACE_BEFORE(a) trace_before( __FILE__, __LINE__, a );
#define TRACE_AFTER(a)  trace_after ( __FILE__, __LINE__, a );

#define PARAMS_PCIA_Connect(z,a,b,c,d,e,f)        fprintf(stderr,"%d ARGUMENTS : ctx=%p, *db_addr=%p, uid=%p, pwd=%p, node=%p, caller=%d, access=%d\n", THREADID, z,a,b,c,d,e,f);
#define PARAMS_PCIA_CommRoll(z,a,b,c)             fprintf(stderr,"%d ARGUMENTS : ctx=%p, *db_addr=%p, commit=%d, release=%d\n", THREADID,z,a,b,c);
#define PARAMS_PCIA_ShutAll(z,a)                  fprintf(stderr,"%d ARGUMENTS : ctx=%p, commit=%d\n", THREADID,z,a);
#define PARAMS_PCIA_ExecStat(z,a,b,c,d)           fprintf(stderr,"%d ARGUMENTS : ctx=%p, db_adr=%p, stat_adr=%p, cnt=%d, ingc=%d\n", THREADID,z,a,b,c,d);
#define PARAMS_PCIA_Prepare(z,a,b,c,d,e)          fprintf(stderr,"%d ARGUMENTS : ctx=%p, db_adr=%p, areasize=%d, *stat_adr=%p, caller=%d, stat_text=%p\n", THREADID,z,a,b,c,d);
#define PARAMS_PCIA_Exec(z,a,b,c,d,e)             fprintf(stderr,"%d ARGUMENTS : ctx=%p, db_adr=%p, areasize=%d, cnt=%d, stat_text=%p,ingc=%d\n", THREADID,z,a,b,c,d,e);
#define PARAMS_PCIA_Open(z,a,b,c,d)               fprintf(stderr,"%d ARGUMENTS : ctx=%p, db_adr=%p, stat_adr=%p, curs_name=%p, access=%d\n", THREADID,z,a,b,c,d);
#define PARAMS_PCIA_Fetch(z,a,b,c,d,e)            fprintf(stderr,"%d ARGUMENTS : ctx=%p, stat_adr=%p, cnt=%d, point=%d, offs=%d, ingc=%d\n", THREADID,z,a,b,c,d,e);
#define PARAMS_PCIA_Close(z,a)                    fprintf(stderr,"%d ARGUMENTS : ctx=%p, stat_adr=%p\n", THREADID,z,a);
#define PARAMS_PCIA_Describe(z,a,b,c)             fprintf(stderr,"%d ARGUMENTS : ctx=%p, stat_adr=%p, desc_adr=%p, select=%d\n", THREADID,z,a,b,c);
#define PARAMS_PCIA_OpenDesc(z,a,b,c,d,e)         fprintf(stderr,"%d ARGUMENTS : ctx=%p, db_adr=%p, stat_adr=%p, curs_name=%p, desc_adr=%p, access=%d\n", THREADID,z,a,b,c,d,e);
#define PARAMS_PCIA_FetchDesc(z,a,b,c,d,e,f)      fprintf(stderr,"%d ARGUMENTS : ctx=%p, stat_adr=%p, desc_adr=%p, cnt=%d, point=%d, offs=%d, ingc=%d\n", THREADID,z,a,b,c,d,e,f);
#define PARAMS_PCIA_NewVar(z,a,b,c,d,e,f)         fprintf(stderr,"%d ARGUMENTS : ctx=%p, adr=%p, siz=%d, typ=%d, dim=%d, dir=%d, ind=%p\n", THREADID,z,a,b,c,d,e,f);
#define PARAMS_PCIA_GetBlobEx(z,a,b,c,d,e,y)      fprintf(stderr,"%d ARGUMENTS : ctx=%p, db_adr=%p, stat_adr=%p, bufadr=%p, bufsize=%d, offs=%d, bidx=%d\n", THREADID,z,a,b,c,d,e,y);
#define PARAMS_PCIA_DelBlobEx(z,a,b,y)            fprintf(stderr,"%d ARGUMENTS : ctx=%p, db_adr=%p, stat_adr=%p, bidx=%d\n", THREADID,z,a,b,y);
#define PARAMS_PCIA_AddBlobEx(z,a,b,c,d,y)        fprintf(stderr,"%d ARGUMENTS : ctx=%p, db_adr=%p, stat_adr=%p, bufadr=%p, bufsize=%d, bidx=%d\n", THREADID,z,a,b,c,d,y);
#define PARAMS_PCIA_CreRoutine(z,a,b)             fprintf(stderr,"%d ARGUMENTS : ctx=%p, db_adr=%p, proc_text=%p\n", THREADID,z,a,b);
#define PARAMS_PCIA_StoredRoutine(z,a,b,c,d,e,f)  fprintf(stderr,"%d ARGUMENTS : ctx=%p, db_adr=%p, result=%p, indicator=%p, areasize=%d, stat_text=%p, ingc=%d\n", THREADID,z,a,b,c,d,e,f);
#define PARAMS_PCIA_Dprepare(z,a)                 fprintf(stderr,"%d ARGUMENTS : ctx=%p, *stat_adr=%p\n", THREADID,z,a);
#define PARAMS_PCIA_getd(z,a,b,c,d,e)             fprintf(stderr,"%d ARGUMENTS : ctx=%p, descr=%p, num=%d, val=%p, siz=%p, act=%p\n", THREADID,z,a,b,c,d,e);
#define PARAMS_PCIA_setd(z,a,b,c,d,e,f)           fprintf(stderr,"%d ARGUMENTS : ctx=%p, descr=%p, num=%d, val=%p, valtyp=%d, isimm=%d, act=%d\n", THREADID,z,a,b,c,d,e,f);
#define PARAMS_PCIA_sqlald(z,a,b,c)               fprintf(stderr,"%d ARGUMENTS : ctx=%p, n=%d, m=%d, i=%d\n", THREADID,z,a,b,c);
#define PARAMS_PCIA_sqlclu(z,a)                   fprintf(stderr,"%d ARGUMENTS : ctx=%p, dsc=%p\n", THREADID,z,a);
#define PARAMS_PCIA_ExecImm(z,a,b,c)              fprintf(stderr,"%d ARGUMENTS : ctx=%p, db_adr=%p, cnt=%d,stat_text=%p\n", THREADID,z,a,b,c);
#define PARAMS_PCIA_AllocCursor(z,a)              fprintf(stderr,"%d ARGUMENTS : ctx=%p, *adr=%p\n", THREADID,z,a);
#define PARAMS_PCIA_DeallocCursor(z,a)            fprintf(stderr,"%d ARGUMENTS : ctx=%p, *adr=%p\n", THREADID,z,a);
#define PARAMS_PCIA_ExecDesc(z,a,b,c,d,e,f,g)     fprintf(stderr,"%d ARGUMENTS : ctx=%p, db_adr=%p, stat_adr=%p, dsci_adr=%p, dsco_adr=%p, use=%d, cnt=%d, ingc=%d\n", THREADID,z,a,b,c,d,e,f,g);
#define PARAMS_PCIA_ver_compat(z,a,b,c,d)         fprintf(stderr,"%d ARGUMENTS : ctx= %p drvmajor=%d, drvminor=%d, srvmajor=%d, srvminor=%d\n", THREADID,z,a,b,c,d);
#define PARAMS_PCIA_pcl_ver(z,a,b,c)             
#define PARAMS_PCIA_ser_ver(z,a,b,c,d)           
#define PARAMS_PCIA_PresetStat(z,a,b,c,d,e,f,g)   fprintf(stderr,"%d ARGUMENTS : ctx=%p, db_adr=%p, stat_adr=%p, query_body=%p query_size=%d, tr_flags=%X, invar=%d, outvar=%d)\n", THREADID,z,a,b,c,d,e,f,g);
#define PARAMS_PCIA_diagnostics(z,a,b,c,d,e)     


#define PCIA_Connect(z,a,b,c,d,e,f)       TRACE_BEFORE("PCIA_Connect")       PARAMS_PCIA_Connect(z,a,b,c,d,e,f)        DUMP  PCIA_Connect(z,a,b,c,d,e,f);       TRACE_AFTER("PCIA_Connect")        PARAMS_PCIA_Connect(z,a,b,c,d,e,f)         DUMP
#define PCIA_CommRoll(z,a,b,c)            TRACE_BEFORE("PCIA_CommRoll")      PARAMS_PCIA_CommRoll(z,a,b,c)             DUMP  PCIA_CommRoll(z,a,b,c);            TRACE_AFTER("PCIA_CommRoll")       PARAMS_PCIA_CommRoll(z,a,b,c)              DUMP
#define PCIA_ShutAll(z,a)                 TRACE_BEFORE("PCIA_ShutAll")       PARAMS_PCIA_ShutAll(z,a)                  DUMP  PCIA_ShutAll(z,a);                 TRACE_AFTER("PCIA_ShutAll")        PARAMS_PCIA_ShutAll(z,a)                   DUMP
#define PCIA_ExecStat(z, a,b,c,d)         TRACE_BEFORE("PCIA_ExecStat")      PARAMS_PCIA_ExecStat(z, a,b,c,d)          DUMP  PCIA_ExecStat(z, a,b,c,d);         TRACE_AFTER("PCIA_ExecStat")       PARAMS_PCIA_ExecStat(z, a,b,c,d)           DUMP
#define PCIA_Prepare(z,a,b,c,d,e)         TRACE_BEFORE("PCIA_Prepare")       PARAMS_PCIA_Prepare(z,a,b,c,d,e)          DUMP  PCIA_Prepare(z,a,b,c,d,e);         TRACE_AFTER("PCIA_Prepare")        PARAMS_PCIA_Prepare(z,a,b,c,d,e)           DUMP
#define PCIA_Exec(z,a,b,c,d,e)            TRACE_BEFORE("PCIA_Exec")          PARAMS_PCIA_Exec(z,a,b,c,d,e)             DUMP  PCIA_Exec(z,a,b,c,d,e) ;           TRACE_AFTER("PCIA_Exec")           PARAMS_PCIA_Exec(z,a,b,c,d,e)              DUMP
#define PCIA_Open(z,a,b,c,d)              TRACE_BEFORE("PCIA_Open")          PARAMS_PCIA_Open(z,a,b,c,d)               DUMP  PCIA_Open(z,a,b,c,d);              TRACE_AFTER("PCIA_Open")           PARAMS_PCIA_Open(z,a,b,c,d)                DUMP
#define PCIA_Fetch(z,a,b,c,d,e)           TRACE_BEFORE("PCIA_Fetch")         PARAMS_PCIA_Fetch(z,a,b,c,d,e)            DUMP  PCIA_Fetch(z,a,b,c,d,e);           TRACE_AFTER("PCIA_Fetch")          PARAMS_PCIA_Fetch(z,a,b,c,d,e)             DUMP
#define PCIA_Close(z,a)                   TRACE_BEFORE("PCIA_Close")         PARAMS_PCIA_Close(z,a)                    DUMP  PCIA_Close(z,a);                   TRACE_AFTER("PCIA_Close")          PARAMS_PCIA_Close(z,a)                     DUMP
#define PCIA_Describe(z,a,b,c)            TRACE_BEFORE("PCIA_Describe")      PARAMS_PCIA_Describe(z,a,b,c)             DUMP  PCIA_Describe(z,a,b,c);            TRACE_AFTER("PCIA_Describe")       PARAMS_PCIA_Describe(z,a,b,c)              DUMP
#define PCIA_OpenDesc(z,a,b,c,d,e)        TRACE_BEFORE("PCIA_OpenDesc")      PARAMS_PCIA_OpenDesc(z,a,b,c,d,e)         DUMP  PCIA_OpenDesc(z,a,b,c,d,e);        TRACE_AFTER("PCIA_OpenDesc")       PARAMS_PCIA_OpenDesc(z,a,b,c,d,e)          DUMP
#define PCIA_FetchDesc(z,a,b,c,d,e,f)     TRACE_BEFORE("PCIA_FetchDesc")     PARAMS_PCIA_FetchDesc(z,a,b,c,d,e,f)      DUMP  PCIA_FetchDesc(z,a,b,c,d,e,f);     TRACE_AFTER("PCIA_FetchDesc")      PARAMS_PCIA_FetchDesc(z,a,b,c,d,e,f)       DUMP
#define PCIA_NewVar(z,a,b,c,d,e,f)        TRACE_BEFORE("PCIA_NewVar")        PARAMS_PCIA_NewVar(z,a,b,c,d,e,f)         DUMP  PCIA_NewVar(z,a,b,c,d,e,f);        TRACE_AFTER("PCIA_NewVar")         PARAMS_PCIA_NewVar(z,a,b,c,d,e,f)          DUMP
#define PCIA_GetBlobEx(z,a,b,c,d,e,y)     TRACE_BEFORE("PCIA_GetBlobEx")     PARAMS_PCIA_GetBlobEx(z,a,b,c,d,e,y)      DUMP  PCIA_GetBlobEx(z,a,b,c,d,e,y);     TRACE_AFTER("PCIA_GetBlobEx")      PARAMS_PCIA_GetBlobEx(z,a,b,c,d,e,y)       DUMP
#define PCIA_DelBlobEx(z,a,b,y)           TRACE_BEFORE("PCIA_DelBlobEx")     PARAMS_PCIA_DelBlobEx(z,a,b,y)            DUMP  PCIA_DelBlobEx(z,a,b,y);           TRACE_AFTER("PCIA_DelBlobEx")      PARAMS_PCIA_DelBlobEx(z,a,b,y)             DUMP
#define PCIA_AddBlobEx(z,a,b,c,d,y)       TRACE_BEFORE("PCIA_AddBlobEx")     PARAMS_PCIA_AddBlobEx(z,a,b,c,d,y)        DUMP  PCIA_AddBlobEx(z,a,b,c,d,y) ;      TRACE_AFTER("PCIA_AddBlobEx")      PARAMS_PCIA_AddBlobEx(z,a,b,c,d,y)         DUMP
#define PCIA_CreRoutine(z,a,b)            TRACE_BEFORE("PCIA_CreRoutine")    PARAMS_PCIA_CreRoutine(z,a,b)             DUMP  PCIA_CreRoutine(z,a,b);            TRACE_AFTER("PCIA_CreRoutine")     PARAMS_PCIA_CreRoutine(z,a,b)              DUMP
#define PCIA_StoredRoutine(z,a,b,c,d,e,f) TRACE_BEFORE("PCIA_StoredRoutine") PARAMS_PCIA_StoredRoutine(z,a,b,c,d,e,f)  DUMP  PCIA_StoredRoutine(z,a,b,c,d,e,f); TRACE_AFTER("PCIA_StoredRoutine")  PARAMS_PCIA_StoredRoutine(z,a,b,c,d,e,f)   DUMP
#define PCIA_Dprepare(z,a)                TRACE_BEFORE("PCIA_Dprepare")      PARAMS_PCIA_Dprepare(z,a)                 DUMP  PCIA_Dprepare(z,a);                TRACE_AFTER("PCIA_Dprepare")       PARAMS_PCIA_Dprepare(z,a)                  DUMP
#define PCIA_getd(z,a,b,c,d,e)            TRACE_BEFORE("PCIA_getd")          PARAMS_PCIA_getd(z,a,b,c,d,e)             DUMP  PCIA_getd(z,a,b,c,d,e);            TRACE_AFTER("PCIA_getd")           PARAMS_PCIA_getd(z,a,b,c,d,e)              DUMP
#define PCIA_setd(z,a,b,c,d,e,f)          TRACE_BEFORE("PCIA_setd")          PARAMS_PCIA_setd(z,a,b,c,d,e,f)           DUMP  PCIA_setd(z,a,b,c,d,e,f);          TRACE_AFTER("PCIA_setd")           PARAMS_PCIA_setd(z,a,b,c,d,e,f)            DUMP
#define PCIA_sqlald(z,a,b,c)              TRACE_BEFORE("PCIA_sqlald")        PARAMS_PCIA_sqlald(z,a,b,c)               DUMP  PCIA_sqlald(z,a,b,c);              TRACE_AFTER("PCIA_sqlald")         PARAMS_PCIA_sqlald(z,a,b,c)                DUMP
#define PCIA_sqlclu(z,a)                  TRACE_BEFORE("PCIA_sqlclu")        PARAMS_PCIA_sqlclu(z,a)                   DUMP  PCIA_sqlclu(z,a);                  TRACE_AFTER("PCIA_sqlclu")         PARAMS_PCIA_sqlclu(z,a)                    DUMP
#define PCIA_ExecImm(z,a,b,c)             TRACE_BEFORE("PCIA_ExecImm")       PARAMS_PCIA_ExecImm(z,a,b,c)              DUMP  PCIA_ExecImm(z,a,b,c);             TRACE_AFTER("PCIA_ExecImm")        PARAMS_PCIA_ExecImm(z,a,b,c)               DUMP
#define PCIA_AllocCursor(z,a)             TRACE_BEFORE("PCIA_AllocCursor")   PARAMS_PCIA_AllocCursor(z,a)              DUMP  PCIA_AllocCursor(z,a);             TRACE_AFTER("PCIA_AllocCursor")    PARAMS_PCIA_AllocCursor(z,a)               DUMP
#define PCIA_DeallocCursor(z,a)           TRACE_BEFORE("PCIA_DeallocCursor") PARAMS_PCIA_DeallocCursor(z,a)            DUMP  PCIA_DeallocCursor(z,a);           TRACE_AFTER("PCIA_DeallocCursor")  PARAMS_PCIA_DeallocCursor(z,a)             DUMP
#define PCIA_ExecDesc(z,a,b,c,d,e,f,g)    TRACE_BEFORE("PCIA_ExecDesc")      PARAMS_PCIA_ExecDesc(z,a,b,c,d,e,f,g)     DUMP  PCIA_ExecDesc(z,a,b,c,d,e,f,g);    TRACE_AFTER("PCIA_ExecDesc")       PARAMS_PCIA_ExecDesc(z,a,b,c,d,e,f,g)      DUMP
#define PCIA_ver_compat(z,a,b,c,d)        TRACE_BEFORE("PCIA_ver_compat")    PARAMS_PCIA_ver_compat(z,a,b,c,d)         DUMP  PCIA_ver_compat(z,a,b,c,d) ;       TRACE_AFTER("PCIA_ver_compat")     PARAMS_PCIA_ver_compat(z,a,b,c,d)          DUMP
#define PCIA_pcl_ver(z,a,b,c)             TRACE_BEFORE("PCIA_pcl_ver")       PARAMS_PCIA_pcl_ver(z,a,b,c)              DUMP  PCIA_pcl_ver(z,a,b,c);             TRACE_AFTER("PCIA_pcl_ver")        PARAMS_PCIA_pcl_ver(z,a,b,c)               DUMP
#define PCIA_ser_ver(z,a,b,c,d)           TRACE_BEFORE("PCIA_ser_ver")       PARAMS_PCIA_ser_ver(z,a,b,c,d)            DUMP  PCIA_ser_ver(z,a,b,c,d);           TRACE_AFTER("PCIA_ser_ver")        PARAMS_PCIA_ser_ver(z,a,b,c,d)             DUMP
#define PCIA_PresetStat(z,a,b,c,d,e,f,g)  TRACE_BEFORE("PCIA_PresetStat")    PARAMS_PCIA_PresetStat(z,a,b,c,d,e,f,g)   DUMP  PCIA_PresetStat(z,a,b,c,d,e,f,g);  TRACE_AFTER("PCIA_PresetStat")     PARAMS_PCIA_PresetStat(z,a,b,c,d,e,f,g)    DUMP
#define PCIA_diagnostics(z,a,b,c,d,e)     TRACE_BEFORE("PCIA_diagnostics")   PARAMS_PCIA_diagnostics(z,a,b,c,d,e)      DUMP  PCIA_diagnostics(z,a,b,c,d,e);     TRACE_AFTER("PCIA_diagnostics")    PARAMS_PCIA_diagnostics(z,a,b,c,d,e)       DUMP

#endif /* ifdef TRACE_MODE */                               /* ... 10.12.04 */

#ifdef __cplusplus
}
#endif

#endif /* INTER_PCI */


/******************************************************************************/
/********************************** SOURCE END ********************************/
/******************************************************************************/
