TEMPLATE  = lib
CONFIG   += qt plugin sql-plugin
QT        = core sql
HEADERS   = qsql_linter.h log.h
SOURCES   = qsql_linter.cpp plugin.cpp
OTHER_FILES += qlinter.json

DEFINES +=
PLUGIN_CLASS_NAME = QLinterDriverPlugin

win32 {
  include(..\intlib\global.def) {
    DST_USER=1
    VERMAX=_VER_MAX=$$VERSION 
  }
  else {
    DST_BUILD=1
    VERMAX=_VER_MAX=$$(VER_MAX)
    CONFIG += thread
  }

  count(DST_USER,1) {
    HEADERS += ../intlib/lnlsutf.h
    SOURCES += ../intlib/lnlsutf.c
    INCLUDEPATH += ../intlib
    thread {
      INTLIB_DIR = ../intlib/libvc32mt
    } else {
      INTLIB_DIR = ../intlib/libvc32
    }
  }
  else {
    HEADERS     += $$(SRCROOT)/$$(LIBDIR)/intlib/lnlsutf.h
    SOURCES     += $$(SRCROOT)/$$(LIBDIR)/intlib/lnlsutf.c
    INCLUDEPATH += $$(SRCROOT)/$$(LIBDIR)/intlib
    INCLUDEPATH += $$(SRCROOT)/$$(LIBDIR)/decimals
    INCLUDEPATH += $$(SRCROOT)/$$(LIBDIR)/tick
    INCLUDEPATH += $$(SRCROOT)/$$(DRVDIR)/linapi
    thread {
      INTLIB_DIR = $$(LIBDIR_MT)
      DESTDIR = $$(LIBDIR_MD)
    } else {
      INTLIB_DIR = $$(LIBDIR_ML)
      DESTDIR = $$(LIBDIR_ML)
    }    

    CONFIG(debug, debug|release) {
     D = d
    }
  }

  VERSION=
  DEFINES += INTER_MSWINDOWS WIN32 $$VERMAX
  TARGET = qsqllinter

  win32-g++ {
    LIBS += -L. -llapi325 -ldectic32
    !system( cpp -P -D$$VERMAX qtlapi.defch qtlapi.def ) {
       error(Can''t create qtlapi.def file - cpp not found or exited with error.)
    }
    system( dlltool -k --input-def qtlapi.def --dllname lapi325.dll --output-lib liblapi325.a )
    system( dlltool -k --input-def qtdectic.def --dllname dectic32.dll --output-lib libdectic32.a )
  }
  else {
    LIBS += $${INTLIB_DIR}/lapi325$${D}.lib
    LIBS += $${INTLIB_DIR}/decimals$${D}.lib
    LIBS += $${INTLIB_DIR}/tick$${D}.lib
      
    count(DST_BUILD,1) {        
       LIBS   += user32.lib advapi32.lib
    }
  }
}

unix {

#  HEADERS += ../intlib/lnlsutf.h
#  SOURCES += ../intlib/lnlsutf.c

  VV = $$[QT_VERSION]
  VV ~= s/"\\."/""
  VV ~= s/\[QT_VERSION\]/
  system(test $${VV}0 -gt 4000 >/dev/null 2>/dev/null):CONFIG += thread
  TARGET = qsqllinter
  SOVER = $$VERSION

  include(../Definition) {
    DST_USER=1
    INCLUDEPATH   += ../intlib
    INTLIB_DIR     = ../intlib
    QMAKE_CFLAGS   = $$VERSION $$SYSTEMS $$OS $$PACKING $$PROCESSOR_FLAGS
    QMAKE_CXXFLAGS = $$VERSION $$SYSTEMS $$OS $$PACKING $$PROCESSOR_FLAGS
  }
  else {
    DST_BUILD=1
    VERSION        = $$(VER_MAX)

    INCLUDEPATH += $$(SRCROOT)/$$(LIBDIR)/intlib
    INCLUDEPATH += $$(SRCROOT)/$$(LIBDIR)/decimals
    INCLUDEPATH += $$(SRCROOT)/$$(LIBDIR)/tick
    INCLUDEPATH += $$(SRCROOT)/$$(DRVDIR)/linapi

    INTLIB_DIR     = $$(LIBDIR_MD)

    QMAKE_CFLAGS   = -D_VER_MAX=$$VERSION $$SYSTEMS $$OS $$PACKING $$PROCESSOR_FLAGS
    QMAKE_CXXFLAGS = -D_VER_MAX=$$VERSION $$SYSTEMS $$OS $$PACKING $$PROCESSOR_FLAGS

    D = $$(DBG_POSTFIX)
  }

  DESTDIR = $${INTLIB_DIR}
  QMAKE_CLEAN += $(TARGET)

# QMAKE_CFLAGS   += -DENABLE_ACCESS_BLOBFILE
# QMAKE_CXXFLAGS += -DENABLE_ACCESS_BLOBFILE
# QMAKE_CFLAGS   += -DQT3_TRANSACTIONS
# QMAKE_CXXFLAGS += -DQT3_TRANSACTIONS

  thread: MT = mt

  LIBS += $${INTLIB_DIR}/linapi$${MT}$${D}.la
  VERSION = $$SOVER
}
