/****************************************************************************
 *          RELEX, Inc. Linter interface library source code                *
 *              This is public source code of RELEX, Inc.                   *
 *                                                                          *
 *       RELEX has no warranty obligations or liability for any             *
 *      usage of interface library source code which is modified.           *
 *                                                                          *
 *                 Copyright (c) 2000-2012 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR: Gluhov
 ----------------------------------------------------------------------------
 PURPOSE:
 ----------------------------------------------------------------------------
 REVISION HISTORY:
 28.11.05 -- Gluhov ( file created )     
 22.02.13 -- DV, Ermakov (QT5)
 ----------------------------------------------------------------------------*/

#include <qsqldriverplugin.h>
#include <qstringlist.h>
#include "qsql_linter.h"

class QLinterDriverPlugin : public QSqlDriverPlugin
{
#if QT_VERSION >= 0x050000
    Q_OBJECT
    Q_PLUGIN_METADATA(IID "org.qt-project.Qt.QSqlDriverFactoryInterface" FILE "qlinter.json")
#endif

public:
    QLinterDriverPlugin();

    QSqlDriver* create( const QString & );
    QStringList keys() const;
};


QLinterDriverPlugin::QLinterDriverPlugin()
    : QSqlDriverPlugin()
{
};


QSqlDriver* QLinterDriverPlugin::create( const QString &name )
{
  if ( name == "QLINTER" ) {
	  QLinterDriver* driver = new QLinterDriver();
	  return driver;
  }
  return 0;
};


QStringList QLinterDriverPlugin::keys() const
{
    QStringList l;
    l  << QString("QLINTER");
    return l;
}

#if QT_VERSION >= 0x050000
#include "plugin.moc"
#else
#if QT_VERSION < 0x040000
   Q_EXPORT_PLUGIN( QLinterDriverPlugin )
 #else
   Q_EXPORT_PLUGIN2(qsql_linter, QLinterDriverPlugin)
#endif
#endif
