 /***************************************************************************
 *                 RELEX, Ltd. Linter DBMS source code                      *
 *        This is unpublished propietary source code of RELEX, Ltd.         *
 *     The copyright notice does not evidence any actual or intended        *
 *                  publication of such source code.                        *
 *                                                                          *
 *                 Copyright (c) 1990-1999 RELEX Ltd.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Ltd.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:  Andrew V Razuwaev
 ----------------------------------------------------------------------------
 PURPOSE: LINTER RDBMS DB driver; asynchronous support procedures
 ----------------------------------------------------------------------------
 REVISION HISTORY:
  03.04.01 -- (RAW) memory leak
*/
#ifdef DBI_THREAD
/* this critical section is used for        */  
/* memory management procedure's synchronize*/

#include "lindbd.h"

#ifdef WIN32
CRITICAL_SECTION main_sec; 
#endif

void inimutex(void)
{
#ifdef WIN32
InitializeCriticalSection(&main_sec);
#endif
}

void mutex(void)
{
#ifdef WIN32
EnterCriticalSection(&main_sec);
#endif
}

void unmutex(void)
{
#ifdef WIN32
LeaveCriticalSection(&main_sec);
#endif
}

/*
 create new local critical section 
*/
CHAR*newmutex(void)
{
#ifdef WIN32
 LPCRITICAL_SECTION mt;
 mt  =MYMEM_CALLOC(sizeof(CRITICAL_SECTION), 1);			/* 03.04.01 */
 if(!mt)
  Except(ERR_NOMEM);
 InitializeCriticalSection(mt);
 return (CHAR*)mt;
#endif
}

/*
 enter local critical section 
*/
void emutex(CHAR*mt)
{
#ifdef WIN32
EnterCriticalSection((LPCRITICAL_SECTION)mt);
#endif
}

/*
 leave local critical section 
*/
void lmutex(CHAR*mt)
{
#ifdef WIN32
LeaveCriticalSection((LPCRITICAL_SECTION)mt);
#endif
}

#endif
/**************************** source end **************************************/
