 /***************************************************************************
 *                 RELEX, Inc. Linter DBI driver source code                *
 *        This is unpublished propietary source code of RELEX, Inc.         *
 *     The copyright notice does not evidence any actual or intended        *
 *                  publication of such source code.                        *
 *                                                                          *
 *                 Copyright (c) 1990-2006 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:  Andrew V Razuwaev
 ----------------------------------------------------------------------------
 PURPOSE: Perl Interface for Linter SQL Server 4.xx/5.xx
 ----------------------------------------------------------------------------
 REVISION HISTORY:

   01.01.98  --  RAV -- project started 
   03.04.01  --  RAW -- memory leak
   05.04.01  --  RAW -- multiple blobs
   25.03.03  --  RAW -- BT#7962. memory leak while SP calling.
   14.03.06  --  Gluhov -- WARNINGS
   23.06.11  --  Galizin -- Destructor for statement
*/

#ifdef __cplusplus
extern "C" {
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#if defined(UNIX) && !defined(bool)
#  define bool int
#endif

#include "DBIXS.h"

#include "linter.h"

DBISTATE_DECLARE;

#ifdef __cplusplus
}
#endif


MODULE = DBD::Linter	PACKAGE = DBD::Linter
PROTOTYPES:DISABLE
REQUIRE: 1.9402

BOOT:
    DBISTATE_INIT;
    LINDBD_init();

MODULE = DBD::Linter	PACKAGE = DBD::Linter::dr
PROTOTYPES:DISABLE
REQUIRE: 1.9402

int
_version(major,minor,build,cth=0)
 SV*major;
 SV*minor;
 SV*build;
 int cth;
CODE:
 RETVAL=LINDBD_version(cth,major,minor,build);
OUTPUT:
 RETVAL

int
_server_version(database,major,minor,build,cth=0)
 SV*database;
 SV*major;
 SV*minor;
 SV*build;
 int cth;
CODE:
 RETVAL=LINDBD_server_version(cth,database,major,minor,build);
OUTPUT:
 RETVAL

int
_ver_compat(drvmajor,drvminor,srvmajor,srvminor,cth=0)
 int drvmajor;
 int drvminor;
 int srvmajor;
 int srvminor;
 int cth;
CODE:
 RETVAL=LINDBD_ver_compat(cth,drvmajor,drvminor,srvmajor,srvminor);
OUTPUT:
 RETVAL

int 
_linter(arg1,arg2,arg3,arg4,arg5)
SV*arg1
SV*arg2
SV*arg3
SV*arg4
SV*arg5
CODE:
 RETVAL = LINDBD_linter(arg1,arg2,arg3,arg4,arg5);
OUTPUT:
 RETVAL


SV*
_allocctx()
PREINIT:
 SV*cth=0;
CODE:
 LINDBD_allocctx(&cth);
 RETVAL = cth;
OUTPUT:
 RETVAL

int 
_freectx(cth)
 SV*cth;
CODE:
 RETVAL= LINDBD_freectx(cth);
OUTPUT:
 RETVAL

int 
_disconnect_all()
CODE:
 RETVAL=LINDBD_disconnect_all();
OUTPUT:
 RETVAL

MODULE = DBD::Linter PACKAGE = DBD::Linter::db
PROTOTYPES:DISABLE
REQUIRE: 1.9402

SV*  
_connect(database,username,password,mode,cp,cth=0)
  SV* database;
  SV* username;
  SV* password;
  SV* mode;
  SV* cp;
  int cth;
PREINIT:
 SV* dbh=0;
CODE:
 LINDBD_connect(cth, database, username, password, mode, cp, &dbh);
 RETVAL=dbh;
OUTPUT:
 RETVAL

int 
_disconnect(dbh,action,cth=0)
 int dbh;
 char*action;
 int cth;
CODE:
 RETVAL= LINDBD_disconnect(cth,dbh,action);
OUTPUT:
 RETVAL


void
_cursor_open(dbh,mode,name,cth=0)
 int dbh;
 int mode;
 char*name;
 int cth;
PREINIT:
 int crn;					/* 03.04.01 */
 int ret;
PPCODE:
 ret = LINDBD_cursor_open(cth,dbh,mode,name,&crn);
 EXTEND(SP,2);
 PUSHs(sv_2mortal(newSViv(ret)));
 PUSHs(sv_2mortal(newSViv(crn)));


int 
_cursor_close(dbh,cth=0)
 int dbh;
 int cth;
CODE:
 RETVAL= LINDBD_cursor_close(cth,dbh);
OUTPUT:
 RETVAL

int 
_snap(database,cth=0)
 SV*database;
 int cth;
CODE:
 RETVAL= LINDBD_snap(cth,database);
OUTPUT:
 RETVAL

int 
_shut(database,cth=0)
 SV*database;
 int cth;
CODE:
 RETVAL=LINDBD_shut(cth,database);
OUTPUT:
 RETVAL

int 
_commit(dbh,cth=0)
 int dbh;
 int cth;
CODE:
 RETVAL=LINDBD_commit(cth,dbh);
OUTPUT:
 RETVAL

int 
_rollback(dbh,spoint,cth=0)
 int dbh;
 SV*spoint;
 int cth;
CODE:
 RETVAL=LINDBD_rollback(cth,dbh,spoint);
OUTPUT:
 RETVAL

int 
_savepoint(dbh,spoint,cth=0)
 int dbh;
 SV*spoint;
 int cth;
CODE:
 RETVAL= LINDBD_savepoint(cth,dbh,spoint);
OUTPUT:
 RETVAL

int 
_do(dbh,stat,attr,argv,cth=0)
 int dbh;
 SV*stat;
 SV*attr;
 SV*argv;
 int cth;
CODE:
 RETVAL= LINDBD_do(cth,dbh,stat,attr,argv);
OUTPUT:
 RETVAL

void
_nativesql(stat,ret)
 SV*stat;
 SV*ret;
CODE:
 LINDBD_nativesql(stat,ret);

MODULE = DBD::Linter PACKAGE = DBD::Linter::st
PROTOTYPES:DISABLE
REQUIRE: 1.9402

int
_prepare(dbh,stat,attr=0,cth=0)
 int dbh;
 SV*stat;
 SV*attr;
 int cth;
PREINIT:
 int sh=0;
CODE:
 if(LINDBD_prepare(cth,dbh,stat,attr,&sh)!=0){
  RETVAL = -1;
 }else{
  RETVAL = sh;
 }
OUTPUT:
 RETVAL

int 
_paramcnt(sh,cth=0)
 int sh;
 int cth;
CODE:
 RETVAL=LINDBD_paramcnt(cth,sh);
OUTPUT:
 RETVAL

int 
_fieldcnt(sh,cth=0)
 int sh;
 int cth;
CODE:
 RETVAL=LINDBD_fieldcnt(cth,sh);
OUTPUT:
 RETVAL

int
_freestmt(sh)
 int sh;
CODE:
 RETVAL=LINDBD_freestmt(sh);                                /* 23.06.11 */
OUTPUT:
 RETVAL

int 
_bind(sh,parnum,value,parlen,cth=0)
 int sh;
 int parnum;
 SV*value;
 SV*parlen;
 int cth;
CODE:
 RETVAL=LINDBD_bind(cth,sh,parnum,value,parlen);
OUTPUT:
 RETVAL


void 
_execute(sh,cth=0)
 int sh;
 int cth;
PREINIT:
 int ret;
 int crn;
PPCODE:
 ret = LINDBD_execute(cth,sh,&crn);			/* 03.04.01 */
 EXTEND(SP, 2);
 PUSHs(sv_2mortal(newSViv(ret)));
 PUSHs(sv_2mortal(newSViv(crn)));

void
_titles(sh,sqltypes,cth=0)
 int sh;
 SV*sqltypes;
 int cth;
PREINIT:
  int ret = 0;
  SV*tlist;
  SV*types;
PPCODE:
  if (!(ret=LINDBD_titles(cth,sh,sqltypes,&tlist,&types))){
   EXTEND(SP,3);
   PUSHs(sv_2mortal(newSViv(ret)));
   PUSHs(sv_2mortal(tlist));
   PUSHs(sv_2mortal(types));
  }else{
   EXTEND(SP,3);
   PUSHs(sv_2mortal(newSViv(ret)));
   PUSHs(&sv_undef);
   PUSHs(&sv_undef);
  }


void
_fetch(sh,dbh,dir,fst,cth=0)
 int sh;
 int dbh;
 SV* dir;
 int fst;
 int cth;
PREINIT:
 SV*cols=0;
PPCODE:
 if(!LINDBD_fetch(cth,sh,dbh,dir,fst,&cols)){
  EXTEND(SP,1);
  PUSHs(sv_2mortal(cols));
 }
 else
 {
  EXTEND(SP,1);
  PUSHs(&sv_undef);
 }

int 
_rows(sh,cth=0)
 int sh;
 int cth;
CODE:
 RETVAL=LINDBD_rows(cth,sh);
OUTPUT:
 RETVAL

int 
_finish(sh,dbh,cth=0)
 int sh;
 int dbh;
 int cth;
CODE:
 RETVAL=LINDBD_finish(cth,sh,dbh);
OUTPUT:
 RETVAL

SV*
_getblob(sh,dbh,fn,attr,cth=0)
 int sh;
 int dbh;
 SV* fn;
 SV*attr;
 int cth;
PREINIT:
 SV* blob=0;
CODE:
  LINDBD_getblob(cth,sh,dbh,fn,attr,&blob);
  RETVAL=blob;
OUTPUT:
 RETVAL

int 
_addblob(sh,dbh,fn,len,blob,cth=0)
 int sh;
 int dbh;
 SV* fn;
 SV*len;
 SV*blob;
 int cth;
CODE:
 RETVAL= LINDBD_addblob(cth,sh,dbh,fn,len,blob);
OUTPUT:
 RETVAL

int 
_delblob(sh,dbh,fn,attr,cth=0)
 int sh;
 int dbh;
 SV* fn;
 SV*attr;
 int cth;
CODE:
 RETVAL= LINDBD_delblob(cth,sh,dbh,fn,attr);
OUTPUT:
 RETVAL

int 
_proc(dbh,proc,arg,sql_types,result,isProc,field_cnt,fields,types,cth=0)
 int dbh;
 SV*proc;
 SV*arg;
 SV*sql_types;
 SV*result;
 SV*isProc;
 SV*field_cnt;
 SV*fields;
 SV*types;
 int cth;
CODE:
 if(!(RETVAL=LINDBD_proc(cth,dbh,proc,arg,sql_types,result,isProc,field_cnt,&fields,&types)))
 {if(SvIV(SvRV(isProc))!=-1){
   sv_setsv(ST(7),sv_2mortal(fields));                                     /* 25.03.03 */
   sv_setsv(ST(8),sv_2mortal(types));
  }else{
   sv_setsv(ST(7),&sv_undef);
   sv_setsv(ST(8),&sv_undef);
  }
 }else{
   sv_setsv(ST(7),&sv_undef);
   sv_setsv(ST(8),&sv_undef);
 }
OUTPUT:
 RETVAL

int
_lockrow(dbh,cth=0)
 int dbh;
 int cth;
CODE:
 RETVAL=LINDBD_lrow(cth,dbh);
OUTPUT:
 RETVAL

int 
_unlockrow(dbh,cth=0)
 int dbh;
 int cth;
CODE:
 RETVAL=LINDBD_ulrow(cth,dbh);
OUTPUT:
 RETVAL

int
_errno(cth=0)
 int cth;
PREINIT:
 int errn=0;
CODE:
 LINDBD_errno(cth,&errn);
 RETVAL=errn;
OUTPUT:
 RETVAL

SV*
_errstr(cth=0)
 int cth;
PREINIT:
 SV*errstr=0;
CODE:
 LINDBD_errstr(cth,&errstr);
 RETVAL=errstr;
OUTPUT:
 RETVAL

int  
_errstate(dbh,cth=0)
 int dbh;
 int cth;
PREINIT:
 int errn=0;
CODE:
 LINDBD_errstate(cth,dbh,&errn);
 RETVAL=errn;
OUTPUT:
 RETVAL

SV* 
_errmsg(dbh,msg,cth=0)
 int dbh;
 SV*msg;
 int cth;
CODE:
 LINDBD_errmsg(cth,dbh,msg);
 RETVAL=msg;
OUTPUT:
 RETVAL

SV*
_sqlstate(dbh,sqlstat,cth=0)
 int dbh;
 SV*sqlstat;
 int cth;
CODE:
 LINDBD_sqlstate(cth,dbh,sqlstat);
 RETVAL=sqlstat;
OUTPUT:
 RETVAL

 