 /***************************************************************************
 *           RELEX, Ltd. Client source include file                         *
 *  This is unpublished propietary source code of RELEX, Ltd.               *
 *  The copyright notice does not evidence any actual or intended           *
 *  publication of such source code.                                        *
 *                                                                          *
 *                   Copyright (c) 1999 RELEX Ltd.                          *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Ltd.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 FILE:    linter.xs
 ----------------------------------------------------------------------------
 AUTHOR:  Alexander V. Kefeli
 ----------------------------------------------------------------------------
 PURPOSE: Interface from Perl to Linter SQL Server
 ----------------------------------------------------------------------------
 REVISION HISTORY:

 **.**.** -- Kent (file creation)
 17.02.99 -- RAV  (change Linter to LinPerl)
 17.02.99 -- RAV  (insert direct inter() call)
 11.05.00 -- Kent (New function `Cleanup')
 30.10.09 -- Glukhov (BindParamArray fixed)
 24.12.09 -- Glukhov (Blobs using modified, some functions added)      
 29.12.09 -- Glukhov (GetConnectInfo added) 
 12.01.10 -- Glukhov (SetCodepage added)  
 27.01.10 -- Glukhov (GetProcOutData removed) 
 01.02.10 -- Glukhov (GetDataRow, GetDataArray, GetDataRows added)
 03.02.10 -- Glukhov (GETM added) 
 04.02.10 -- Glukhov (GetColInfo updated)
 09.09.13 -- Galizin (Excluding redefine macro warning)

 --------------------------------------------------------------------------*/


#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "linperl.h"

MODULE = LinPerl PACKAGE = LinPerl

int
OpenConnect(usr, pwd, node, flags, connect)
char *usr;
char *pwd;
char *node;
int   flags;
SV   *connect;
CODE:
  RETVAL = LINPL_OpenConnect(usr, pwd, node, flags, connect);
OUTPUT:
  RETVAL

int
CloseConnect(connect)
int connect;
CODE:
  RETVAL = LINPL_CloseConnect(connect);
OUTPUT:
  RETVAL

int
OpenCursor(connect, name, cursor)
int   connect;
char *name;
SV   *cursor;
CODE:
  RETVAL = LINPL_OpenCursor(connect, name, cursor);
OUTPUT:
  RETVAL

int
CloseCursor(cursor)
int cursor;
CODE:
  RETVAL = LINPL_CloseCursor(cursor);
OUTPUT:
  RETVAL

int
GetCursorOption(cursor, option, sv)
int  cursor;
int  option;
SV  *sv
CODE:
  RETVAL = LINPL_GetCursorOption(cursor, option, sv);
OUTPUT:
  RETVAL

int
SetCursorOption(cursor, option, sv)
int  cursor;
int  option;
SV  *sv
CODE:
  RETVAL = LINPL_SetCursorOption(cursor, option, sv);
OUTPUT:
  RETVAL
  
int
SetCodepage(sv)
SV *sv
CODE:
  RETVAL = LINPL_SetCodepage(sv);
OUTPUT:
  RETVAL

int 
ExecDirect(cursor, query)
int   cursor;
char *query;
CODE:
  RETVAL = LINPL_ExecDirect(cursor, query);
OUTPUT:
  RETVAL

int
Prepare(cursor, query)
int   cursor;
char *query;
CODE:
  RETVAL = LINPL_Prepare(cursor, query);
OUTPUT:
  RETVAL

int
BindParameter(cursor, num, sv)
int  cursor;
int  num;
SV  *sv;
CODE:
  RETVAL = LINPL_BindParameter(cursor, num, sv);
OUTPUT:
  RETVAL

int
BindParamArrayInternal(cursor, av, begin, end) 
int  cursor;
AV  *av;
int begin;
int end;
CODE:
  RETVAL = LINPL_BindParamArray(cursor, av, begin, end);
OUTPUT:
  RETVAL

int
Execute(cursor)
int cursor;
CODE:
  RETVAL = LINPL_Execute(cursor);
OUTPUT:
  RETVAL

int
Fetch(cursor, direct, pos)
int    cursor;
int    direct;
int    pos;
CODE:
  RETVAL = LINPL_Fetch(cursor, direct, pos);
OUTPUT:
  RETVAL

int
BindColumn(cursor, col, sv)
int  cursor;
int  col;
SV  *sv;
CODE:
  RETVAL = LINPL_BindColumn(cursor, col, sv);
OUTPUT:
  RETVAL

int
UnbindColumn(cursor, col)
int cursor;
int col;
CODE:
  RETVAL = LINPL_UnbindColumn(cursor, col);
OUTPUT:
  RETVAL

int
GetDataColumn(cursor, col_num, data)
int  cursor;
int  col_num;
SV *data;
CODE:
  RETVAL = LINPL_GetDataColumn(cursor, col_num, data);
OUTPUT:
  RETVAL
  
int
GetDataRow(cursor, data)
int  cursor;
AV *data;
CODE:
  RETVAL = LINPL_GetDataRow(cursor, data);
OUTPUT:
  RETVAL
  
int
GetDataArray(cursor, data)
int  cursor;
HV *data;
CODE:
  RETVAL = LINPL_GetDataArray(cursor, data);
OUTPUT:
  RETVAL
  
int
GetDataRows(cursor, data, rows)
int  cursor;
int rows;
AV *data;
CODE:
  RETVAL = LINPL_GetDataRows(cursor, data, rows);
OUTPUT:
  RETVAL
  
int
GETM(cursor, data, row)
int  cursor;
int row;
AV *data;
CODE:
  RETVAL = LINPL_GETM(cursor, data, row);
OUTPUT:
  RETVAL

int
TestNull(cursor, col, flag)
int  cursor;
int  col;
SV *flag;
CODE:
  RETVAL = LINPL_TestNull(cursor, col, flag);
OUTPUT:
  RETVAL

int
BLOBAppend(cursor, body)
int cursor;
SV *body;
CODE:
  RETVAL = LINPL_BLOBAppend(cursor, body);
OUTPUT:
  RETVAL
  
int
BLOBAppendEx(cursor, body, type)
int cursor;
SV *body;
int type;
CODE:
  RETVAL = LINPL_BLOBAppendEx(cursor, body, type);
OUTPUT:
  RETVAL

int
BLOBClear(cursor)
int cursor;
CODE:
  RETVAL = LINPL_BLOBClear(cursor);
OUTPUT:
  RETVAL

int
BLOBGetSizeInternal(cursor, size, colnum)
int cursor;
int colnum;
SV *size;
CODE:
  RETVAL = LINPL_BLOBGetSize(cursor, size, colnum);
OUTPUT:
  RETVAL
  
int
BLOBGetType(cursor, type, colnum)
int cursor;
int colnum;
SV *type;
CODE:
  RETVAL = LINPL_BLOBGetType(cursor, type, colnum);
OUTPUT:
  RETVAL


int
BLOBGetData(cursor, pos, len, data)
int cursor;
int pos;
SV *len;
SV *data;
CODE:
  RETVAL = LINPL_BLOBGetData(cursor, pos, len, data);
OUTPUT:
  RETVAL

int
BLOBAdd(cursor, body, col)
int cursor;
int col;
SV *body;
CODE:
  RETVAL = LINPL_BLOBAdd(cursor, body, col);
OUTPUT:
  RETVAL

int
BLOBAddEx(cursor, body, col, type)
int cursor;
int col;
int type;
SV *body;
CODE:
  RETVAL = LINPL_BLOBAddEx(cursor, body, col, type);
OUTPUT:
  RETVAL
    
int
BLOBFetch(cursor, pos, len, data, col)
int cursor;
int pos;
int col;
SV *len;
SV *data;
CODE:
  RETVAL = LINPL_BLOBFetch(cursor, pos, len, data, col);
OUTPUT:
  RETVAL
  
int
BLOBPurge(cursor, col)
int cursor;
int col;
CODE:
  RETVAL = LINPL_BLOBPurge(cursor, col);
OUTPUT:
  RETVAL
  
int
Commit(cursor)
int cursor;
CODE:
  RETVAL = LINPL_Commit(cursor);
OUTPUT:
  RETVAL

int
Rollback(cursor)
int cursor;
CODE:
  RETVAL = LINPL_Rollback(cursor);
OUTPUT:
  RETVAL

int
GetConnectInfo(cursor, hv) 
int  cursor;
HV  *hv;
CODE:
  RETVAL = LINPL_GetConnectInfo(cursor, hv);
OUTPUT:
  RETVAL
  
int
GetColInfo(cursor, col, data)
int  cursor;
int  col;
HV  *data;
CODE:
  RETVAL = LINPL_GetColInfo(cursor, col, data);
OUTPUT:
  RETVAL

int 
GetError(cursor, linerr, syserr)
int cursor;
SV *linerr;
SV *syserr;
CODE:
  RETVAL = LINPL_GetError(cursor, linerr, syserr);
OUTPUT:
  RETVAL

int 
GetErrorMsg(cursor, linerr, errmsg)
int cursor;
int linerr;
SV *errmsg;
CODE:
  RETVAL = LINPL_GetErrorMsg(cursor, linerr, errmsg);
OUTPUT:
  RETVAL

int
Cleanup()
CODE:
  RETVAL = LINPL_Cleanup();
OUTPUT:
  RETVAL

int
constant(name, arg)
char *name
int   arg
CODE:
  RETVAL = LINPL_constant(name, arg);
OUTPUT:
  RETVAL

int 
inter(cbl, range, retr, where, korteg)
SV *cbl;
SV *range;
SV *retr;
SV *where;
SV *korteg
CODE:
  RETVAL = LINPL_inter(cbl, range, retr, where, korteg);
OUTPUT:
  RETVAL

