<?php

if (!defined('ADODB_DIR')) die();


class ADODB_linter extends ADOConnection {
	var $dataProvider = 'native'; // ?
	var $databaseType = 'linter';		/// RDBMS currently in use, eg. odbc, mysql, mssql
	var $database = '';			/// Name of database to be used.
	var $host = ''; 			/// The hostname of the database server
	var $user = ''; 			/// The username which is used to connect to the database server.
	var $password = ''; 		/// Password for the username. For security, we no longer store it.
	var $debug = false; 		/// if set to true will output sql statements
	var $maxblobsize = 2147483648; // 2 GB	/// maximum size of blobs or large text fields (262144 = 256K)-- some db's die otherwise like foxpro
	var $fmtTimeStamp = "'Y-m-d h:i:s'"; /// used by DBTimeStamp as the default timestamp fmt.
	var $true = 'TRUE';			/// string that represents TRUE for a database
	var $false = 'FALSE';			/// string that represents FALSE for a database
	var $replaceQuote = "''"; 	/// string to use to replace quotes
	var $nameQuote = '"';//?		/// string to use to quote identifiers and names
	var $charSet=false;//? 		/// character set to use - only for interbase, postgres and oci8
	var $metaDatabasesSQL = '';//?
	var $metaTablesSQL = 'SELECT table_name, SUBSTR(table_type, 1, 1) FROM tables WHERE table_type IN (\'TABLE\', \'VIEW\')';
	var $metaColumnsSQL = 'SELECT column_name, type_name, column_size FROM COLUMNS WHERE TABLE_NAME = UPPER(\'%s\');';
	
	var $metaPrimaryKeysSQL = 'SELECT * FROM PRIMARY_KEYS WHERE TABLE_NAME = UPPER(\'%s\')';
	
	var $uniqueOrderBy = true; /// All order by columns have to be unique
	var $lastInsID = false;//?
	//--
	var $hasInsertID = false; 		/// supports autoincrement ID?
	var $hasAffectedRows = true; 	/// supports affected rows for update/delete?
	var $hasMoveFirst = false;  /// has ability to run MoveFirst(), scrolling backwards
	var $hasGenID = true; 		/// can generate sequences using GenID();
	//--?
	var $genID = 0; 			/// sequence id used by GenID();
	var $raiseErrorFn = false; 	/// error function to call
	var $isoDates = false; /// accepts dates in ISO format
	var $cacheSecs = 3600; /// cache for 1 hour

	// memcache?
	var $memCache = false; /// should we use memCache instead of caching in files
	var $memCacheHost; /// memCache host
	var $memCachePort = 11211; /// memCache port
	var $memCacheCompress = false; /// Use 'true' to store the item compressed (uses zlib)

	var $sysDate = 'SYSDATE'; /// name of function that returns the current date
	var $sysTimeStamp = "ROUND(TO_NUMBER(SYSDATE - TO_DATE('1970-01-01','YYYY-MM-DD'))/100)"; /// name of function that returns the current timestamp
	var $arrayClass = 'ADORecordSet_array';//? /// name of class used to generate array recordsets, which are pre-downloaded recordsets

	var $numCacheHits = 0;//?
	var $numCacheMisses = 0;//?
	var $pageExecuteCountRows = true;//?
	var $uniqueSort = false;//? /// indicates that all fields in order by must be unique
	var $leftOuter = '(+)='; /// operator to use for left outer join in WHERE clause
	var $rightOuter = '(+)';//? /// operator to use for right outer join in WHERE clause
	var $ansiOuter = false;//? /// whether ansi outer join syntax supported
	var $autoRollback = false;//? // autoRollback on PConnect().
	var $poorAffectedRows = false;//? // affectedRows not working or unreliable

	var $fnExecute = false;
	var $fnCacheExecute = false;
	var $blobEncodeType = false; // false=not required, 'I'=encode to integer, 'C'=encode to char
	var $rsPrefix = "ADORecordSet_";
	
	var $transOff = 0; 			/// temporarily disable transactions
	var $transCnt = 0; 			/// count of nested transactions
	
	var $fetchMode=false;
	
	var $null2null = 'null'; // in autoexecute/getinsertsql/getupdatesql, this value will be converted to a null
	 //
	
	
	// sequences
	var $_genIDSQL = 'SELECT %s.nextval';
	var $_genSeqSQL = "CREATE OR REPLACE SEQUENCE %s START WITH %s INCREMENT BY 1";
	var $_dropSeqSQL = "DROP SEQUENCE %s";
	
	//time
//	var $sysDate = "sysdate()";
//	var $sysTimeStamp = "sysdate()";
	
	var $lastResult;
	var $_errorMsg;
	var $_errorCode;
	var $_errorRow;
	var $_errorPos;
	var $mode = TM_AUTOCOMMIT;
	var $_cursorID;
	var $_cursorPool = array();
	var $_cursorPoolLimit = 64;

	
	
	function ADODB_linter()
	{
		
	}//
	
	function setMode($mode)
	{
		$this->mode = !empty($mode) ? $mode : TM_AUTOCOMMIT;
	}
	
	function _connect($argHostname, $argUsername, $argPassword, $argDatabasename)
	{
		if (!function_exists('linter_open_connect')) return null;
		$this->_connectionID = linter_open_connect($argUsername, $argPassword, $argDatabasename, $this->mode);
		if ($this->_connectionID < 0) return false;
		return true;	
	}
	
	function _pconnect($argHostname, $argUsername, $argPassword, $argDatabasename)
	{
		return $this->_connect($argHostname, $argUsername, $argPassword, $argDatabasename);
	}
	
	
	function GenId($seq, $start=1)
	{
		$seq .= "_seq";
		$sql = sprintf($this->_genIDSQL, $seq);
		$num = $this->GetOne($sql);
		if (empty($num))
		{
			return $start;
		}
		else
		{
			return $num;
		}
	}
	
	function ServerInfo()
	{
		$arr = array();
		$arr['version'] = ADOConnection::GetOne('select getbits($$$s14,65,0,7) from $$$sysrl where rowid=1;');
		$arr['description'] = 'RDBMS Linter v.'.$arr['version'];
		return $arr;
	}//
	
	function ConnectionInfo()
	{
		return linter_connect_info($this->_connectionID);
	}
	
	/**
	 * 	Return affected rows count
	*/
	function _affectedrows()
	{
		return linter_get_cursor_opt($this->_cursorID, CO_ROW_COUNT);
		   
	}//
	
	/**
	 * Return last insert row id
	*/
	function _insertid()
	{
		$this->GetOne("select last_autoinc");
	}//
	
	function BeginTrans()
	{
		if ($this->transOff) return true; 
		$this->transCnt += 1;
	   	$this->lastResult = $this->Execute('begin;');
	   	return true;
	}//
	
		
	function CommitTrans($ok=true) 
	{ 
		if ($this->transOff) return true; 
		if (!$ok) return $this->RollbackTrans();
		if ($this->transCnt) $this->transCnt -= 1;
		$this->lastResult = $this->Execute('commit;');
		return true;
	}
	function RollbackTrans()
	{
		if ($this->transOff) return true; 
		if ($this->transCnt) $this->transCnt -= 1;
		$this->lastResult = $this->Execute('rollback;');
		return true;
	}
	
	function ErrorMsg() 
	{
		$this->handle_errors();
		return $this->_errorMsg;
	}
	
	function ErrorNo() 
	{
		$this->handle_errors();
		return $this->_errorCode;
	}

	
	function SelectLimit($sql,$nrows=-1,$offset=-1, $inputarr=false,$secs2cache=0)
	{
		if ($nrows > 0) 
		{
			if (empty($offset) || $offset < 0)
			{
				$sql .= " limit " . $nrows; 
			}
			else
			{
				$sql .= " limit " . $offset . ", " . $nrows;
			}
		}
		return $this->Execute($sql, $inputarr);
	}
	
	
	function Prepare($sql)
	{
		$this->lastResult = linter_prepare($this->_cursorID, $sql);
	}
	
	function &Execute($sql, $inputarr=false)
	{
		$a = $this->_Execute($sql, $inputarr);
		if (!$a)
		{
			var_dump($a);
			var_dump($sql);
		}
		return $a;
	}
	
	function _query($sql,$inputarr)
	{
		//error_log($sql."\n\n\n", 3, 'aaa.txt');
		$this->_errorMsg = false;
		$sql = trim($sql);
		if (substr($sql, -1) != ";")
		{
			$sql .= ";";
		}
		if ($this->_cursorID > 0)
		{
			$this->_cursorPool[] = $this->_cursorID;
			if (count($this->_cursorPool) > $this->_cursorPoolLimit)
			{
				$cur = array_shift($this->_cursorPool);
				linter_close_cursor($cur);
			}
		}
		$this->_cursorID = linter_open_cursor($this->_connectionID);
		if ($this->_cursorID < 0)
		{
			die("Unable to open cursor. ".count($this->_cursorPool)." cursors already opened.");
		}
		linter_set_cursor_opt($this->_cursorID, CO_FETCH_BLOBS_AS_USUAL_DATA, 1);
		if (is_array($inputarr) && count($inputarr)) 
		{
			$this->Prepare($sql);
			$this->lastResult = linter_execute($this->_cursorID, $inputarr);
		}
		else
		{
			$this->lastResult = linter_exec_direct($this->_cursorID, $sql);
		}
		if ($this->lastResult < 0)
		{
			$this->handle_errors();
			if ($this->_errorCode > 2)
			{
				var_dump($sql);
				var_dump($this->lastResult);
				var_dump($this->_errorCode);
				print_r(debug_backtrace());
				die($this->ErrorMsg());
				return null;
			}
			else
			{
				return $this->_cursorID;
			}
		}
		else
		{
			return $this->_cursorID;
		}
	}
	
	function CreateSequence($seqname, $startID)
	{
		$seqname .= "_seq";
		$sql = sprintf($this->_genSeqSQL, $seqname, $startID);
		$this->Execute($sql);
	}
	
	function DropSequence($seqname)
	{
		$seqname .= "_seq";
		$sql = sprintf($this->_dropSeqSQL, $seqname);
		$this->Execute($sql);
	}
	
	function _close()
	{ 
		if ($this->transCnt) $this->RollbackTrans();
		$this->lastResult = linter_close_connect($this->_connectionID);
		$this->_connectionID = false;
		return $this->lastResult;
	}
	
	function handle_errors()
	{
	  	if ($this->lastResult >= 0 && $this->_connectionID >= 0)
	  	{
	    	return;
	  	}
	
	  	if ($this->_connectionID < 0)
	    {
	    	$lin_err = linter_last_error($this->_connectionID, LINTER_ERROR);
	    	$sys_err = linter_last_error($this->_connectionID, SYSTEM_ERROR);
	    	$this->_errorMsg = sprintf("Linter connect error %s, system error %s\n", $lin_err, $sys_err);
	    	$this->_errorCode = $sys_err;
	    } 
	
	  	if ($this->lastResult == LPE_LINTER_ERROR)
	    {
	    	$lin_err = linter_last_error($this->_cursorID, LINTER_ERROR);
	    	$sys_err = linter_last_error($this->_cursorID, SYSTEM_ERROR);
	    	$this->_errorMsg = linter_error_msg($this->_cursorID);
	    	$this->_errorCode = $lin_err;
	    	if ($lin_err <= 2)
	    	{                       
	      		return;
	    	}
	    	if ($lin_err >= 2000 && $lin_err < 3000) // SQL syntax errors
	      	{
	      		$this->_errorRow = $sys_err & 0xFFFF;
	      		$this->_errorPos = $sys_err >> 16;
	      		$this->_errorMsg .= sprintf("at row %d, position %d", $this->_errorRow, $this->_errorPos);
	      	}
	    	else
	    	{
	      		$this->_errorMsg .= sprintf(", system error %d", $sys_err);
	    	}
	    }
	  	else
	  	{
	    	$this->_errorMsg = sprintf("Module internal error %d\n", $this->lastResult);
	    	$this->_errorCode = -1;
	  	}
	}

	function &MetaTables($ttype = false, $showSchema = false, $mask = false) 
	{
		if ($mask) {
			$save = $this->metaTablesSQL;
			$mask = $this->qstr($mask);
			$this->metaTablesSQL .= ' AND table_name LIKE '.$mask;
		}

		$ret =& ADOConnection :: MetaTables($ttype, $showSchema);

		if ($mask) {
			$this->metaTablesSQL = $save;
		}
		return $ret;
	}//
	
	function &MetaColumns($table, $normalize=true)
	{
		$columns = ADOConnection :: MetaColumns($table, $normalize);
		
		$keys = $this->MetaPrimaryKeys($table);
		
		if (is_array($columns))
		{
			foreach ($columns as $key=>$column)
			{
				if (defined('ADODB_ASSOC_CASE') && ADODB_ASSOC_CASE == 0)
				{
					$column->name = strtolower($column->name);
					$column->type = strtolower($column->type);
					if (!is_numeric($key))
					{
						$columns[strtolower($key)] = $column;
						unset($columns[$key]);
					}
					else
					{
						$columns[$key] = $column;
					}
				}
				if (in_array($column->name, $keys))
				{
					$column->primary_key = true;
				}
			}
		}
		
		return $columns;
	}

	function MetaPrimaryKeys($table, $owner=false)
	{
		$sql = sprintf($this->metaPrimaryKeysSQL, $table, $table, $table);
		$fm = $this->fetchMode;
		$this->setFetchMode(ADODB_FETCH_ASSOC);
		$rs = $this->Execute($sql);
		$keys = array();
		if (!$rs->EOF)
		{
			$rs->MoveFirst();
			while (!$rs->EOF)
			{
				if (defined('ADODB_ASSOC_CASE') && ADODB_ASSOC_CASE == 0)
				{
					$keys[] = strtolower($rs->fields['column_name']);
				}
				else
				{
					$keys[] = $rs->fields['COLUMN_NAME'];
				}
				$rs->MoveNext();
			}
			$rs->Close();
		}
		$this->setFetchMode($fm);
		return $keys;		
	}
	
	function UpdateBlob($table,$column,$val,$where,$blobtype='BLOB')
	{
		$sql = "SELECT  $column from $table  WHERE $where";
		if ($this->Execute($sql) != false)
		{
			$this->ClearBlob(1);
			return $this->AppendBlob($val,1);	
		}
		
		$lin_err = linter_last_error($this->_cursorID, LINTER_ERROR);
	    $this->_errorMsg = linter_error_msg($this->_cursorID);
	    $this->_errorCode = $lin_err;
	    return  false;
	    	
	}
	
	function AppendBlob($blob, $colnum = '', $b_convert = false, $blobtype=0) 
	{
	  if($b_convert)
	  {
	    $blob = convert_cyr_string($blob, "w", "a");
	  }
	  
	  $blobsize = strlen($blob);
	  if(!empty($colnum)) 
	  {
	    if(!in_array("linter_blob_add", get_extension_funcs("linter"))) 
	    {
	    	$this->_errorMsg = linter_error_msg('DB_ERROR_UNSUPPORTED');
	    	$this->_errorCode = DB_ERROR_UNSUPPORTED;
	    	return  false;
	    
	    }
	    if(in_array("linter_blob_add_ex", get_extension_funcs("linter"))) 
	    {
	      $ret = @linter_blob_add_ex($this->_cursorID, $blob, $blobsize, $colnum, $blobtype);
	    } else {
	      $ret = @linter_blob_add($this->_cursorID, $blob, $blobsize, $colnum);
	    }
	    if($ret < 0)
	    {
	      	$lin_err = linter_last_error($this->_cursorID, LINTER_ERROR);
	    	$this->_errorMsg = linter_error_msg($this->_cursorID);
	    	$this->_errorCode = $lin_err;
	    	return  false;
	    }
	  } else {
	    if(in_array("linter_blob_append_ex", get_extension_funcs("linter"))) 
	    {
	      $ret = @linter_blob_append_ex($this->_cursorID, $blob, $blobsize, $blobtype);
	    } else {
	      $ret = @linter_blob_append($this->_cursorID, $blob, $blobsize);
	    }
	    if($ret < 0)
	    {
	      	$lin_err = linter_last_error($this->_cursorID, LINTER_ERROR);
	    	$this->_errorMsg = linter_error_msg($this->_cursorID);
	    	$this->_errorCode = $lin_err;
	    	return  false;
	    }
	  }
	  return 1;
	}
	
	
	function GetBlob ($colnum = '', $b_convert = false) 
	{
	  if(!empty($colnum)) 
	  {
		    if(!in_array("linter_blob_fetch", get_extension_funcs("linter")))
		    {
		    	$this->_errorMsg = linter_error_msg('DB_ERROR_UNSUPPORTED');
		    	$this->_errorCode = DB_ERROR_UNSUPPORTED;
		    	return  false;
		    }
		
		   $size = @linter_blob_get_size($this->_cursorID, $colnum);
		   if($size < 0)
		   {
		    	$lin_err = linter_last_error($this->_cursorID, LINTER_ERROR);
		    	$this->_errorMsg = linter_error_msg($this->_cursorID);
		    	$this->_errorCode = $lin_err;
		    	return  false;
		   }
		   $ret = @linter_blob_fetch($this->_cursorID, 1, $size, $colnum);
		   if($ret < 0)
		   {
		    	$lin_err = linter_last_error($this->_cursorID, LINTER_ERROR);
		    	$this->_errorMsg = linter_error_msg($this->_cursorID);
		    	$this->_errorCode = $lin_err;
		    	return  false;
		   }
		   
	  } else {
	    $size = @linter_blob_get_size($this->_cursorID);
	    if($size < 0)
	    {
	      	$lin_err = linter_last_error($this->_cursorID, LINTER_ERROR);
	    	$this->_errorMsg = linter_error_msg($this->_cursorID);
	    	$this->_errorCode = $lin_err;
	    	return  false;
	    }
	    $ret = @linter_blob_get_data($this->_cursorID, 1, $size);
	    if($ret < 0)
	    {
	      	$lin_err = linter_last_error($this->_cursorID, LINTER_ERROR);
	    	$this->_errorMsg = linter_error_msg($this->_cursorID);
	    	$this->_errorCode = $lin_err;
	    	return  false;
	    }
	  }
	  $blob = $ret;
	  if($b_convert)
	  {
	    $blob = convert_cyr_string($blob, "a", "w");
	  }
	  return($blob);
	}
	
	
	function ClearBlob($colnum = '') 
	{
	  if(!empty($colnum)) 
	  {
	    if(!in_array("linter_blob_purge", get_extension_funcs("linter")))
	    {
	      	$this->_errorMsg = linter_error_msg('DB_ERROR_UNSUPPORTED');
		  	$this->_errorCode = DB_ERROR_UNSUPPORTED;
		    return  false;
	    }
	    $ret = @linter_blob_purge($this->_cursorID, $colnum);
	    if($ret < 0)
	    {
	      $lin_err = linter_last_error($this->_cursorID, LINTER_ERROR);
	    	$this->_errorMsg = linter_error_msg($this->_cursorID);
	    	$this->_errorCode = $lin_err;
	    	return  false;
	    }
	  } else {
	    $ret = @linter_blob_clear($this->_cursorID);
	    if($ret < 0)
	    {
	    	$lin_err = linter_last_error($this->_cursorID, LINTER_ERROR);
	    	$this->_errorMsg = linter_error_msg($this->_cursorID);
	     	$this->_errorCode = $lin_err;
	    	return  false;
	    }
	  }
	  return(1);
	}//
	
	function SetCursorOpt($cursor, $option, $value) 
	{
  		$res = linter_set_cursor_opt($cursor, $option, $value);
  		if($res < 0) 
  		{
    		return false;
  		} else 
  		{
    		return true;
  		}
	}//



}


class ADORecordset_linter extends ADORecordSet
{
	var $dataProvider = "native";
	var $databaseType = "linter";
	var $fields = false; 	/// holds the current row data
	var $blobSize = 100; 	/// any varchar/char field this size or greater is treated as a blob
							/// in other words, we use a text area for editing.
	var $canSeek = true; 	/// indicates that seek is supported
	var $sql; 				/// sql text
	var $EOF = false;		/// Indicates that the current record position is after the last record in a Recordset object. 
	
	var $emptyTimeStamp = '&nbsp;'; /// what to display when $time==0
	var $emptyDate = '&nbsp;'; /// what to display when $time==0
	var $debug = false;
	var $timeCreated=0; 	/// datetime in Unix format rs created -- for cached recordsets

	var $bind = false; 		/// used by Fields() to hold array - should be private?
	var $fetchMode;			/// default fetch mode
	var $connection = false; /// the parent connection
	/*
	 *	private variables	
	 */
	var $_numOfRows = -1;	/** number of rows, or -1 */
	var $_numOfFields = -1;	/** number of fields in recordset */
	var $_queryID = -1;		/** This variable keeps the result link identifier.	*/
	var $_currentRow = -1;	/** This variable keeps the current row in the Recordset.	*/
	var $_closed = false; 	/** has recordset been closed */
	var $_inited = false; 	/** Init() should only be called once */
	var $_obj; 				/** Used by FetchObj */
	var $_names;			/** Used by FetchObj */
	
	var $_currentPage = -1;	/** Added by Iv�n Oliva to implement recordset pagination */
	var $_atFirstPage = false;	/** Added by Iv�n Oliva to implement recordset pagination */
	var $_atLastPage = false;	/** Added by Iv�n Oliva to implement recordset pagination */
	var $_lastPageNo = -1; 
	var $_maxRecordCount = 0;
	var $datetime = false;
	
	var $lastResult;

	
	
	
	function ADORecordset_linter($queryID, $mode = false)
	{
		$this->hasFetchAssoc = false;

		if ($mode === false) 
		{ 
			global $ADODB_FETCH_MODE;
			$mode = $ADODB_FETCH_MODE;
		}
		$this->fetchMode = $mode;
		return $this->ADORecordSet($queryID);
	}
	
	function _initrs()
	{
		GLOBAL $ADODB_COUNTRECS;
		
		$this->_numOfRows = ($ADODB_COUNTRECS) ? linter_get_cursor_opt($this->_queryID, CO_ROW_COUNT) : 0;
		$this->_numOfFields = linter_get_cursor_opt($this->_queryID, CO_COL_COUNT);
	}
	
	function NextRecordSet()
	{
		return false;
	}
	
	function Fields($colname)
	{
		if ($this->fetchMode != ADODB_FETCH_NUM) return $this->fields[$colname];
		if (!$this->bind) {
			$this->bind = array();
			for ($i=0; $i < $this->_numOfFields; $i++) {
				$o = $this->FetchField($i);
				$this->bind[strtoupper($o->name)] = $i;
			}
		}
		
		 return $this->fields[$this->bind[strtoupper($colname)]];
	}
	
	
	function &FetchField($fieldOffset = -1) 
	{
		if ($fieldOffset != -1) 
		{
			$fieldOffset++;
			$res = linter_get_col_prop($this->_queryID, $fieldOffset);
		}
		else if ($fieldOffset == -1) 
		{	
			$res = linter_get_col_prop($this->_queryID, 1);
		}
		if (is_object($res))		
		{
			if (defined("ADODB_ASSOC_CASE") && ADODB_ASSOC_CASE == 0)
			{
				$res->name = strtolower($res->name);
				$res->type_name = strtolower($res->type_name);
				$res->table = strtolower($res->table);
				$res->length = -1;
			}
		}
		$res->type = $res->type_name;
		if ($res->type == 'BYTE')
		{
			$res->type = 'BINARY';
		}
		elseif ($res->type == 'DATE')
		{	
			$res->type .= 'TIMESTAMP';
		}
		$res->max_length = $res->length;
		return $res;
	}

	
	function _seek($row) 
	{
		$this->_currentRow = $row;
		return linter_fetch($this->_queryID, FETCH_ABSNUM, $row);
	}
	
	function MoveFirst()
	{
		if (!$this->_seek(1))
		  $this->EOF = false;
		$this->MoveNext();
	}
	
	function MoveNext() 
	{
		if ($this->EOF) return false;
		
		$this->_currentRow++;
		
		if ($this->fetchMode & ADODB_FETCH_ASSOC) 
		{
			$this->fields = linter_fetch_array($this->_queryID);
			if ($this->fetchMode & ADODB_FETCH_NUM) 
			{
				$flds = linter_get_data_row($this->_queryID);
				if (is_array($flds))
				{
					foreach ($flds as $k=>$v)
					{
						$this->fields[$k] = $v;
					}
				}
			}
			if (is_array($this->fields))
			{
				if (ADODB_ASSOC_CASE == 0) 
				{
					foreach($this->fields as $k=>$v) 
					{
						if (!is_numeric($k))
						{
							$this->fields[strtolower($k)] = $v;
						}
					}
				} 
				else if (ADODB_ASSOC_CASE == 1) 
				{
					foreach($this->fields as $k=>$v) 
					{
						if (!is_numeric($k))
						{
							$this->fields[strtoupper($k)] = $v;
						}
					}
				}
			}
		} 
		else 
		{
			$this->fields = linter_fetch_row($this->_queryID);
		}
		if ($this->fields && is_array($this->fields) && $this->fields != LPE_LINTER_ERROR) 
		{
			return true;
		}
		$this->EOF = true;
		
		return false;
	}
	
	
	function _fetch($ignore_fields=false) 
	{
		 
		if ($this->fetchMode & ADODB_FETCH_ASSOC) 
		{
			$this->fields = linter_fetch_array($this->_queryID);
			if ($this->fetchMode & ADODB_FETCH_NUM) 
			{
				$flds = linter_get_data_row($this->_queryID);
				if (is_array($flds))
				{
					foreach ($flds as $k => $v)
					{
						$this->fields[$k] = $v;
					}
				}
			} 

			if (is_array($this->fields))
			{
				if (ADODB_ASSOC_CASE == 0) 
				{
					foreach($this->fields as $k=>$v) 
					{
						if (!is_numeric($k))
						{
							$this->fields[strtolower($k)] = $v;
						}
					}
				}
				else if (ADODB_ASSOC_CASE == 1) 
				{
					foreach($this->fields as $k=>$v) 
					{
						if (!is_numeric($k))
						{
							$this->fields[strtoupper($k)] = $v;
						}
					}
				}
			}
		} 
		else 
		{
			$this->fields = linter_fetch_row($this->_queryID);
		}
		return $this->fields;
	}
	
	function _close() 
	{
		$this->lastResult = linter_close_cursor($this->_queryID);	
		$this->_queryID = false;
	}
	
	
}