/****************************************************************************
 *                       RELEX, Inc. DBMS Linter                            *
 *             This is propietary source code of RELEX, Inc.                *
 *                                                                          *
 *                    Copyright (c) 2006 RELEX, Inc.                        *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
*/

#ifndef ZEND_DBX_LINTER_H
#define ZEND_DBX_LINTER_H

#ifndef INIT_FUNC_ARGS
#include "zend_modules.h"
#endif

#include "php.h"

int dbx_linter_connect(zval **rv, zval **host, zval **db, zval **username, zval **password, INTERNAL_FUNCTION_PARAMETERS);
  /* returns connection handle as resource on success or 0 as long on failure */
int dbx_linter_pconnect(zval **rv, zval **host, zval **db, zval **username, zval **password, INTERNAL_FUNCTION_PARAMETERS);
  /* returns persistent connection handle as resource on success or 0 as long on failure */
int dbx_linter_close(zval **rv, zval **dbx_handle, INTERNAL_FUNCTION_PARAMETERS);
  /* returns 1 as long on success or 0 as long on failure */
int dbx_linter_query(zval **rv, zval **dbx_handle, zval **db_name, zval **sql_statement, INTERNAL_FUNCTION_PARAMETERS);
  /* returns 1 as long or a result identifier as resource on success  or 0 as long on failure */
int dbx_linter_getcolumncount(zval **rv, zval **result_handle, INTERNAL_FUNCTION_PARAMETERS);
  /* returns column-count as long on success or 0 as long on failure */
int dbx_linter_getcolumnname(zval **rv, zval **result_handle, long column_index, INTERNAL_FUNCTION_PARAMETERS);
  /* returns column-name as string on success or 0 as long on failure */
int dbx_linter_getcolumntype(zval **rv, zval **result_handle, long column_index, INTERNAL_FUNCTION_PARAMETERS);
  /* returns column-type as string on success or 0 as long on failure */
int dbx_linter_getrow(zval **rv, zval **result_handle, long row_number, INTERNAL_FUNCTION_PARAMETERS);
  /* returns array[0..columncount-1] as strings on success or 0 as long on failure */
int dbx_linter_error(zval **rv, zval **dbx_handle, INTERNAL_FUNCTION_PARAMETERS);
  /* returns string */
int dbx_linter_esc(zval **rv, zval **dbx_handle, zval **string, INTERNAL_FUNCTION_PARAMETERS);
  /* returns escaped string */

#endif /* ZEND_DBX_LINTER_H */
