dnl $Id$
dnl config.m4 for extension linter

PHP_ARG_WITH(linter, for RDBMS LINTER support,
[  --with-linter=PATH   Include RDBMS LINTER support. PATH is RDBMS LINTER
                              home directory])

PHP_ARG_WITH(mt-linter, for MT version RDBMS LINTER support ,
[  --with-mt-linter     Include MT RDBMS LINTER support .], auto, auto )

PHP_ARG_WITH(pdo-linter, PDO for RDBMS LINTER support,
[  --with-pdo-linter          Include PDO RDBMS LINTER support.], no, no)


if test "$PHP_LINTER" != "no"; then
  AC_MSG_CHECKING([for LINTER])

  test "$PHP_MT_LINTER" = "auto" && {
    if test "$PHP_THREAD_SAFETY" = "yes"; then
      PHP_MT_LINTER=yes
    else
      PHP_MT_LINTER=no
    fi
  }


  test "$PHP_MT_LINTER" != "no" -a "$PHP_THREAD_SAFETY" != "yes"  && {
    AC_MSG_ERROR([The PHP is not support Zend Thead Safety. The module cannot be built in multythead mode])
  }

  dnl we should not delete linter la files
  grep liblinphpbuild Makefile.global || {
    cp Makefile.global Makefile.global_orig
    cat Makefile.global_orig|awk '/find \. -name \\\*.la/ {print "\tfind . \\( -name \\*.la -o -name \\*.a \\) ! -name liblinphpbuild\\*| xargs rm -f  " ; next} { print $0}' >Makefile.global
    }


   SEARCH_PATH="$PHP_LINTER"' '".."' '"/usr/linter"

   AC_MSG_CHECKING([for LINTER include files])
   for i in $SEARCH_PATH ; do
      AC_MSG_CHECKING([ in $i/intlib])
      if test -r $i/intlib/inter.h; then
         LINTER_DIR=$i
         AC_MSG_RESULT(found in $i)
         break
      fi
   done

  if test -z "$LINTER_DIR"; then
    AC_MSG_RESULT([not found])
    AC_MSG_ERROR([Linter include files was not found. Please check --with-linter option value])
  fi

  dnl getting linter version from Definition file
  VERMJ=`awk -F"\t*=\t*" '/^(I___VERMJ)/ { print $2 }' $LINTER_DIR/Definition`
  VERMI=`awk -F"\t*=\t*" '/^(I___VERMI)/ { print $2 }' $LINTER_DIR/Definition`
  if test -z "$VERMJ" ; then
    VERSION=`awk -F"\t*=\t*" '/^(VERSION)/ { print "-D_VER_MAX=" $3 }' $LINTER_DIR/Definition`
  else
    VERSION="-D_VER_MAX=""$VERMJ""$VERMI"0
  fi
  FLAGS=`awk -F"\t*=\t*" '/^(SYSTEMS|OS|PACKING)/ { print $2}' $LINTER_DIR/Definition`
  PTHREAD_FLAGS=`awk -F"\t*=\t*" '/^(PTHREAD_FLAGS)/ { print $2}' $LINTER_DIR/Definition`
  LIBS=`awk -F"\t*=\t*" '/^(PTHREAD_LIB)/ { print $2}' $LINTER_DIR/Definition`

  CFLAGS="$VERSION $FLAGS"
  if test "$PHP_PDO_LINTER" != "no"; then
    CFLAGS="$CFLAGS -DPDO"
  fi
  if test "$PHP_MT_LINTER" != "no"; then
    CFLAGS="$CFLAGS $PTHREAD_FLAGS -DUSE_THREADS -DPTHREADS"
  fi

  AC_MSG_CHECKING(for LINTER libraries)
  if test -r "$LINTER_DIR/php/liblinphpbuild.a" ;then
    LIB_DIR="$LINTER_DIR/php/"
  elif test -r "$LINTER_DIR/linphp/liblinphpbuild.a"; then
    LIB_DIR="$LINTER_DIR/linphp/"
  elif test -r "$EXTENSION_DIR/linter/liblinphpbuild.a"; then
    LIB_DIR="$EXTENSION_DIR/linphp/"
  else
    AC_MSG_ERROR(Could not find $LINTER_DIR/php/liblinphpbuild.a. Please check --with-linter value)
  fi

  # --with-linter -> add include path
  PHP_ADD_INCLUDE($LINTER_DIR/intlib)

  if test "$ext_shared" = "no"; then
    if test "$PHP_MT_LINTER" != "no"; then
      AC_MSG_RESULT(using "$LIB_DIR"/liblinphpbuildmt)
      PHP_ADD_LIBRARY_WITH_PATH(linphpbuildmt, $LIB_DIR, LINTER_SHARED_LIBADD)
    else
      AC_MSG_RESULT(using "$LIB_DIR"/liblinphpbuild)
      PHP_ADD_LIBRARY_WITH_PATH(linphpbuild, $LIB_DIR, LINTER_SHARED_LIBADD)
    fi
  else
    if test "$PHP_MT_LINTER" != "no"; then
      AC_MSG_RESULT(using "$LIB_DIR"/liblinphpbuildmtpic)
      PHP_ADD_LIBRARY_WITH_PATH(linphpbuildmtpic, $LIB_DIR, LINTER_SHARED_LIBADD)
    else
      AC_MSG_RESULT(using "$LIB_DIR"/liblinphpbuildpic)
      PHP_ADD_LIBRARY_WITH_PATH(linphpbuildpic, $LIB_DIR, LINTER_SHARED_LIBADD)
    fi
  fi

  if test "$PHP_PDO_LINTER" != "no"; then
    if test "$PHP_PDO" = "no"; then
      AC_MSG_ERROR([PDO is not enabled! Add --enable-pdo to your configure line.])
    fi
    PHP_NEW_EXTENSION(pdo_linter, php_linter.c linter_statement.c linter_driver.c tools.c linmutex.c pdo_linter.c, $ext_shared)
  else
    PHP_NEW_EXTENSION(linter, php_linter.c linter_statement.c linter_driver.c tools.c linmutex.c pdo_linter.c, $ext_shared)
  fi

  PHP_SUBST(LINTER_SHARED_LIBADD)
fi
