/***************************************************************************
 *           RELEX, Inc. Client source include file                         *
 *  This is unpublished proprietary source code of RELEX, Inc.              *
 *  The copyright notice does not evidence any actual or intended           *
 *  publication of such source code.                                        *
 *                                                                          *
 *                    Copyright (c) 2008 RELEX Inc.                         *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 FILE:    php_pdo_linter_int.h
 ----------------------------------------------------------------------------
 AUTHOR: Dmitrii Glukhov
 ----------------------------------------------------------------------------
 PURPOSE: PDO interface from PHP language to Linter SQL Server
 ----------------------------------------------------------------------------
 REVISION HISTORY:
 04.08.08 -- Creation
 28.11.08 -- Glukhov (remove global variables)
 17.02.09 -- Glukhov (close_sub_chans added) 
 29.08.13 -- Galizin (Building as internal php extension)
*/

#ifdef PDO

#ifndef PHP_PDO_LINTER_INT_H
#define PHP_PDO_LINTER_INT_H
#include "php_linter_int.h"                                /* 29.08.13 */

#define MAX_BLOB       4000     

extern pdo_driver_t pdo_linter_driver;

extern int _pdo_linter_error(pdo_dbh_t *dbh, pdo_stmt_t *stmt, const char *file, int line TSRMLS_DC);
#define pdo_linter_error(s) _pdo_linter_error(s, NULL, __FILE__, __LINE__ TSRMLS_CC)
#define pdo_linter_error_stmt(s) _pdo_linter_error(s->dbh, s, __FILE__, __LINE__ TSRMLS_CC)

extern struct pdo_stmt_methods linter_stmt_methods;
extern struct pdo_dbh_methods linter_dbh_methods;

extern int get_sql_state(pdo_error_type *sql_state,int linter_error_code);
extern int to_autocommit_mode(TCBL *CBL);
extern int close_sub_chans(CURSOR *csr, int is_rollback);                             /* 17.02.09 */
#endif /* PHP_PDO_LINTER_INT_H */

#endif
