 /***************************************************************************
 *           RELEX, Inc. PHP core client source file                        *
 *  This is unpublished propietary source code of RELEX, Inc.               *
 *  The copyright notice does not evidence any actual or intended           *
 *  publication of such source code.                                        *
 *                                                                          *
 *                   Copyright (c) 1996-2006 RELEX Inc.                     *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 FILE:    tools.c
 ----------------------------------------------------------------------------
 AUTHOR:  Alexander V. Kefeli
 ----------------------------------------------------------------------------
 PURPOSE: Interface from PHP language to Linter SQL Server
 ----------------------------------------------------------------------------
 REVISION HISTORY:

 **.**.** -- Kent (file creation)
 07.06.00 -- Kononyhin
 20.03.01 -- Galizin ( if define "strdup" exist skip function strdup)
 08.04.02 -- Galizin ( Move internal section from public file)
 01.02.06 -- Ermakov, Gluhov (new function LinPHP_ConnectInfo ) 
 --------------------------------------------------------------------------*/

#define __TOOLS_C__

#include <string.h>
#include "tools.h"                                          /* 08.04.02 */


# define LENTER_DEMOVEREXPR_STRING	"The license has expired."

                                                            /* 08.04.02 ... */
int PhpCheckDemoLicense(TCBL* CBL, OPEN_DESC* desc)
{
  
  if (CBL->CodErr != 0)
    return -1;
  if (desc->DBFlags & KERNEL_DEMOLICEXP)
    printf(LENTER_DEMOVEREXPR_STRING);
  return 0;
}
                                                            /* ... 08.04.02 */
char *strrtrim(char *str, char *chs)
{
  int i;

  i = strlen(str) - 1;
  while (strrchr(chs, str[i]) && i >= 0)
    str[i--] = 0;
  return (str);
}

char *strltrim(char *str, char *chs)
{
  while (strrchr(chs, str[0]) && *str)
    strcpy(str, str + 1);
  return (str);
}

#if defined(UNIX)
int strnicmp(const char *s1, const char *s2, size_t n)
{
  if (n == 0)
    return (0);
  do{
  if (tolower(*s1) != tolower(*s2))
    return ((int)tolower(*s1) - (int)tolower(*s2));
  if (*(s1++) == 0)
    break;
  s2++;
  } while (--n != 0);
  return (0);
}
#endif /* UNIX */
