 /***************************************************************************
 *                 RELEX, Inc. Linter Python driver source code             *
 *        This is unpublished propietary source code of RELEX, Inc.         *
 *     The copyright notice does not evidence any actual or intended        *
 *                  publication of such source code.                        *
 *                                                                          *
 *                 Copyright (c) 2003 RELEX Inc.                            *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR: Boris Fedorov (fbv@relex.ru)
 ----------------------------------------------------------------------------
 PURPOSE: 
 ----------------------------------------------------------------------------
 REVISION HISTORY:
*/

#ifndef CONNECTION_H
#define CONNECTION_H

typedef struct ChanLink                                      /* 28.11.08 ... */
{
  short handle;
  int   mode;
  struct ChanLink *Next;
} t_ChanLink;                                                /* ... 28.11.08 */

typedef struct
{
  PyObject_HEAD
  short handle;
  PyObject *username;
  PyObject *password;
  PyObject *database;
  PyObject *version;
  int mode;
  t_DBDesc desc;
  t_ChanLink *ChanLink;                                          /* 28.11.08 */
} t_Connection;

extern PyTypeObject g_ConnectionType;

#if PY_VERSION_HEX < 0x02060000
extern PyObject *Connection_Connect(
  PyObject *self,
  PyObject *args,
  PyObject *kwargs);
#endif

extern int Connection_IsConnected(
  t_Connection *connection);

extern int Connection_CheckForError(
  t_Connection *connection,
  int status);

#endif /* CONNECTION_H */
