 /***************************************************************************
 *                 RELEX, Inc. Linter Python driver source code             *
 *        This is unpublished proprietary source code of RELEX, Inc.        *
 *     The copyright notice does not evidence any actual or intended        *
 *                  publication of such source code.                        *
 *                                                                          *
 *                 Copyright (c) 2003-2014 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR: Boris Fedorov (fbv@relex.ru)
 ----------------------------------------------------------------------------
 PURPOSE: 
 ----------------------------------------------------------------------------
 REVISION HISTORY:
 06.10.14 -- Kononov (Fixed support for Python < 2.6)
 13.10.14 -- Kononov (Fixed behavior - if BLOB column exists then cursor will return only one row)
 14.10.14 -- Kononov (Implemented function setoutputsize() for setting up fetch size of BLOB columns or one of them)
*/

#ifndef CURSOR_H
#define CURSOR_H

typedef struct
{
  PyObject_HEAD
  t_Connection *connection;
  int mode;
  short handle;
  short handleFromSP;
  short statementHandle;
  PyObject *statement;
  PyObject *bindArrays;
  PyObject *fetchArrays;
  PyObject *blobOutputSizes;   /* 14.10.14 ... */
  int blobOutputSize;          /* ... 14.10.14 */
  int fetchArraySize;
  int arraySize;
  int rowCount;
  int fetchOffset;
  int actualRows;
  int rowNum;
  int statementType;
  int isDML;
  int blobColumns;             /* 13.10.14 */
} t_Cursor;

extern PyTypeObject g_CursorType;

int Cursor_CheckForError(t_Cursor *cur, int status);

int Cursor_IsOpen(t_Cursor *cur);

#if PY_VERSION_HEX < 0x02060000                       /* 06.10.14 ... */
  PyObject *Cursor_New(t_Connection *con, int mode);
#endif                                                /* ... 06.10.14 */

#endif /* CURSOR_H */
