 /***************************************************************************
 *                 RELEX, Inc. Linter Python driver source code             *
 *        This is unpublished propietary source code of RELEX, Inc.         *
 *     The copyright notice does not evidence any actual or intended        *
 *                  publication of such source code.                        *
 *                                                                          *
 *                 Copyright (c) 2003-2014 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR: Boris Fedorov (fbv@relex.ru)
 ----------------------------------------------------------------------------
 PURPOSE: 
 ----------------------------------------------------------------------------
 REVISION HISTORY:
 31.10.03 -- Boris Fedorov (Remove C++ style comments)
 25.12.13 -- Muratova (Python 3 support)
 06.10.14 -- Kononov (Fixed support for Python < 2.6)
 10.10.14 -- Kononov (Fixed code values for x86_64)
*/

#ifndef ERROR_H
#define ERROR_H

#define ERROR_MSG_SIZE 256

typedef struct
{
  PyObject_HEAD
  L_LONG apiCode;                                            /* 10.10.14 ... */
  L_LONG linCode;
  L_LONG sysCode;                                            /* ... 10.10.14 */
  PyObject *message;                                         /* 25.12.13 ... */
  L_LONG code;                                               /* ... 25.12.13 */ /* 10.10.14 */
} t_Error;

extern PyTypeObject g_ErrorType;

#if PY_VERSION_HEX >= 0x02060000                             /* 06.10.14 ... */
extern PyObject *Error_New(PyTypeObject*);
#else
extern t_Error *Error_New();
#endif                                                       /* ... 06.10.14 */

#endif /* ERROR_H */
