 /***************************************************************************
 *                 RELEX, Inc. Linter Python driver source code             *
 *        This is unpublished proprietary source code of RELEX, Inc.        *
 *     The copyright notice does not evidence any actual or intended        *
 *                  publication of such source code.                        *
 *                                                                          *
 *                 Copyright (c) 2003-2013 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR: Boris Fedorov (fbv@relex.ru)
 ----------------------------------------------------------------------------
 PURPOSE: 
 ----------------------------------------------------------------------------
 REVISION HISTORY:
 06.09.03 -- Boris Fedorov (Removed datetime.h dependence)
 11.08.08 -- Ermakov (g_TimestampArrayType proto added)
 22.09.08 -- Ermakov (Added date and unicode configuration)
*/

#ifndef TIMESTAMP_H
#define TIMESTAMP_H

#include <decimals.h>                                      /* 06.09.03 ... */
#include <tick.h>                                          /* ... 06.09.03 */

typedef struct
{
  PyObject_HEAD
  unsigned year;
  unsigned month;
  unsigned day;
  unsigned hour;
  unsigned minute;
  unsigned second;
  unsigned tick;
} t_Timestamp;

extern PyTypeObject g_TimestampType;
extern PyTypeObject g_TimestampArrayType;

extern PyObject *Timestamp_New(
  unsigned type,                                                 /* 22.09.08 */
  unsigned year,
  unsigned month,
  unsigned day,
  unsigned hour,
  unsigned minute,
  unsigned second,
  unsigned tick);

#endif /* TIMESTAMP_H */
