 /***************************************************************************
 *                 RELEX, Inc. Linter DBMS source code                      *
 *              This is public source code of RELEX, Inc.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                 Copyright (c) 1998-2005 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:  KWN
 ----------------------------------------------------------------------------
 PURPOSE: Linter first step !
 ----------------------------------------------------------------------------
 REVISION HISTORY:
 22.08.01 - Galizin ( For VxWorks )
 25.03.03 -- Sveta (code format)

 ----------------------------------------------------------------------------
*/
#include <stdio.h>
#include <string.h>
#include "inter.h"
#if defined(VXWORKS)
#include "vxstart.h"
#endif


#define LName     20
#define LFirstNam 15
#define LCity     15
#define LPhone     8

static void PrintErrorAndCloseChannel(TCBL * pCBL);

#if defined(VXWORKS)
MainStart(c_step, 1024 * 32, UninitLinterClient)
#else
int main()
#endif
{
  TCBL Cbl;

  static char *Query =
  "select NAME,FIRSTNAM,CITY,PHONE from PERSON where Name='CLINTON';";
  char cBufKorteg[LName + LFirstNam + LCity + LPhone];

  char cName[LName + 1];
  char cFirstNam[LFirstNam + 1];
  char cCity[LCity + 1];
  char cPhone[LPhone + 1];


  memset(&Cbl, 0, sizeof(TCBL));

  printf("Open channel ...");
  memcpy(Cbl.Command, "OPEN", 4);
  memcpy(Cbl.Node, "        ", 8);
  Cbl.PrzExe = 0;               /* Autocommit */
  inter(&Cbl, "SYSTEM/MANAGER", NULL, NULL, NULL);
  if (Cbl.CodErr)
  {
    PrintErrorAndCloseChannel(&Cbl);
    return 1;
  }
  printf("done\n");

  printf("Query execution:\n\"%s\" ... ", Query);
  memcpy(Cbl.Command, "SLCT", 4);
  Cbl.LnBufRow = 58;
  inter(&Cbl, NULL, Query, NULL, cBufKorteg);
  if (Cbl.CodErr > 2)           /* Error 2 - select 0 row */
  {
    PrintErrorAndCloseChannel(&Cbl);
    return 1;
  }
  printf("done\n");
  printf("Select %ld rows\n", Cbl.RowCount);

  printf("--------------------+---------------+---------------+--------\n");
  printf("NAME                |FIRSTNAME      |CITY           |PHONE\n");
  printf("--------------------+---------------+---------------+--------\n");

  /* Get next row. First row already into cBufKorteg after SLCT command */
  memcpy(Cbl.Command, "GETN", 4);
  while (Cbl.CodErr == 0)
  {
    memcpy(cName, cBufKorteg, LName);
    cName[LName] = 0;
    memcpy(cFirstNam, cBufKorteg + LName, LFirstNam);
    cFirstNam[LFirstNam] = 0;
    memcpy(cCity, cBufKorteg + LName + LFirstNam, LCity);
    cCity[LCity] = 0;
    memcpy(cPhone, cBufKorteg + LName + LFirstNam + LCity, LPhone);
    cPhone[LPhone] = 0;

    printf("%20s|%15s|%15s|%8s\n", cName, cFirstNam, cCity, cPhone);
    inter(&Cbl, NULL, NULL, NULL, cBufKorteg);
  }
  printf("--------------------+---------------+---------------+--------\n");

  printf("Close channel ... ");
  memcpy(Cbl.Command, "CLOS", 4);
  inter(&Cbl, NULL, NULL, NULL, NULL);
  printf("done\n");

  printf("\nEnd of Work\n");
  return 0;
}

static void PrintErrorAndCloseChannel(TCBL * pCBL)
{
  printf("\n");
  if (strncmp(pCBL->Node, "        ", MAX_NODE_LEN) != 0 && *pCBL->Node != 0)
    printf("* Linter server <%.8s>\n", pCBL->Node);
  printf("* Channel N %d\n", pCBL->NumChan);
  printf("* Command [%.4s]\n", pCBL->Command);
  printf("* Linter error: %ld\n", pCBL->CodErr);
  if (pCBL->CodErr >= 2000 && pCBL->CodErr < 3000)
    fprintf(stderr, "    Line %hd position %hd\n",
       ((L_WORD *) (&pCBL->SysErr))[0], ((L_WORD *) (&pCBL->SysErr))[1]);
  else if (pCBL->SysErr)
    printf("* System error: %ld\n", pCBL->SysErr);
  memcpy(pCBL->Command, "CLOS", 4); /* Close channel */
  inter(pCBL, NULL, NULL, NULL, NULL);
}
