
 /***************************************************************************
 *                 RELEX, Ltd. Linter DBMS source code                      *
 *              This is public source code of RELEX, Ltd.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                    Copyright (c) 1998 RELEX Ltd.                         *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Ltd.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: Demonstration Call-interface's command FATR
          in asynchronous version.
 ----------------------------------------------------------------------------
 REVISION HISTORY:
  11.08.98 --          , Creation date
  04.02.00 -- Kononyhin (CBL clearing)
  30.07.02 -- Galizin   ( Function main return int type PT#1046 )
  23.05.03 -- EVG       ( Porting to WinCE: PT #784)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "inter.h"
#include "exlib.h"


#ifndef WINCE                                             /* 23.05.03 ...*/
int    main()                                               /* 30.07.02 */
#else
int    aexfatr()
#endif                                                    /*... 23.05.03 */
  {
  TCBL    CBLconnect;
  L_CHAR    Name_Pass[] = "SYSTEM/MANAGER";
  L_CHAR    Node[] = "        ";
  L_WORD    Priority = 0;
  L_LONG  Err;
  L_LONG  PrzExe = M_EXCLUSIVE | Q_ENCODE | M_BINARY;
  L_LONG  ID;
  L_CHAR    User[] = "SYSTEM";
  L_CHAR    Table[] = "PERSON";
  L_CHAR    ColName[] = "NAME";
  FREL_IN FREL_In;
  FREL_OUT FREL_Out;
  FATR_IN FATR_In;
  FATR_OUT FATR_Out;

  memset(&CBLconnect,0,sizeof(TCBL));			/* 04.02.00 */
  Err = LinterOPEN(&CBLconnect, Name_Pass, Node, Priority, PrzExe);
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("Connect to RDBMS Linter\n");

  Err = LinterFUSR(&CBLconnect, User, &ID);
  if (Err != NORMAL)
    PrintError(&CBLconnect);

  FREL_In.Owner = ID;
  memset(FREL_In.TblName, ' ', MAX_ID_LEN);
  strncpy(FREL_In.TblName, Table, strlen(Table));

  Err = LinterFREL(&CBLconnect, &FREL_In, &FREL_Out);
  if (Err != NORMAL)
    PrintError(&CBLconnect);

  FATR_In.Table = FREL_Out.Table;
  memset(FATR_In.ColName, ' ', MAX_ID_LEN);
  strncpy(FATR_In.ColName, ColName, strlen(ColName));

  LinterASYNC_FATR(&CBLconnect, &FATR_In, &FATR_Out, WorkError);
  printf("FATR ... ");
  fflush(stdout);

  /* ... */

  inter_wait_single(&CBLconnect, -1);
  printf("OK,\n");
  printf("\tTable=%ld\n", FATR_Out.Table);
  printf("\tColumn=%ld\n", FATR_Out.Column);
  printf("\tColName=%.18s\n", FATR_Out.ColName);

  printf("End Example\n");
  
  return 0;                                                 /* 30.07.02 */
  }
