
 /***************************************************************************
 *                 RELEX, Ltd. Linter DBMS source code                      *
 *              This is public source code of RELEX, Ltd.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                    Copyright (c) 1998 RELEX Ltd.                         *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Ltd.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: Demonstration Call-interface's commands.
 ----------------------------------------------------------------------------
 REVISION HISTORY:
  11.08.98 --          , Creation date
  08.12.98 -- Kononyhin (NAME/PASS in SHUT for VER_MAX >= 500)
	23.05.03 -- EVG       ( Porting to WinCE: PT #784)
*/

/******************** CONNECTION COMMAND *********************/
L_LONG LinterOPEN(TCBL * pCBL, L_CHAR * Name_Pass, L_CHAR * Node, L_WORD Priority, L_LONG PrzExe);
L_LONG LinterOCUR(TCBL * pCBL, L_WORD NumChan, L_WORD Prior, L_LONG PrzExe);
L_LONG LinterSETO(TCBL * pCBL, L_CHAR * NameCur);
L_LONG LinterCLOS(TCBL * pCBL);
L_LONG LinterKILL(TCBL * pCBL, L_WORD NumChan);
L_LONG LinterSNAP(L_CHAR * Node);
#if _VER_MAX >= 500                                              /* 08.12.98 */
L_LONG LinterSHUT(TCBL * pCBL, L_CHAR * Name_Pass, L_CHAR * Node);
#else
L_LONG LinterSHUT(TCBL * pCBL, L_CHAR * Node);
#endif
void    LinterASYNC_OPEN(TCBL * pCBL, L_CHAR * Name_Pass, L_CHAR * Node, L_WORD Prior, L_LONG PrzExe, USR_PROC func);
void    LinterASYNC_OCUR(TCBL * pCBL, L_WORD NumChan, L_WORD Prior, L_LONG PrzExe, USR_PROC func);
void    LinterASYNC_SETO(TCBL * pCBL, L_CHAR * NameCur, USR_PROC func);
void    LinterASYNC_CLOS(TCBL * pCBL, USR_PROC func);
void    LinterASYNC_KILL(TCBL * pCBL, L_WORD NumChan, USR_PROC func);
void    LinterASYNC_SNAP(TCBL * pCBL, L_CHAR * Node, USR_PROC func);
#if _VER_MAX >= 500                                                        /* 08.12.98 */
void    LinterASYNC_SHUT(TCBL * pCBL, L_CHAR * Name_Pass, L_CHAR * Node, USR_PROC func);
#else
void    LinterASYNC_SHUT(TCBL * pCBL, L_CHAR * Node, USR_PROC func);
#endif

/******************** SYSTEM DICTIONARY COMMAND *********************/
L_LONG LinterFREL(TCBL * pCBL, FREL_IN * pIn, FREL_OUT * pOut);
L_LONG LinterFATR(TCBL * pCBL, FATR_IN * pIn, FATR_OUT * pOut);
L_LONG LinterFUSR(TCBL * pCBL, L_CHAR * User, L_LONG * pUser_ID);
L_LONG LinterDESC(TCBL * pCBL, DB_DESC * pOut);
L_LONG LinterFCUR(TCBL * pCBL, L_CHAR * NameCur, FCUR_OUT * pOut);
L_LONG LinterFNOD(TCBL * pCBL, L_CHAR * Node, L_LONG * ErrOut);
void    LinterASYNC_FUSR(TCBL * pCBL, L_CHAR * User, L_LONG * pUser_ID, USR_PROC func);
void    LinterASYNC_FREL(TCBL * pCBL, FREL_IN * pIn, FREL_OUT * pOut, USR_PROC func);
void    LinterASYNC_FATR(TCBL * pCBL, FATR_IN * pIn, FATR_OUT * pOut, USR_PROC func);
void    LinterASYNC_DESC(TCBL * pCBL, DB_DESC * pOut, USR_PROC func);
void    LinterASYNC_FCUR(TCBL * pCBL, L_CHAR * NameCur, FCUR_OUT * pOut, USR_PROC func);
void    LinterASYNC_FNOD(TCBL * pCBL, L_CHAR * Node, L_LONG * ErrOut, USR_PROC func);

/******************** SELECT COMMAND *********************/
L_LONG LinterSLCT(TCBL * pCBL, L_LONG PrzExe, L_CHAR * Statement, void *RowBuf, L_WORD RowBufLen, void *VarBuf);
void    LinterASYNC_SLCT(TCBL * pCBL, L_LONG PrzExe, L_CHAR * Statement, void *RowBuf, L_WORD RowBufLen, void *VarBuf, USR_PROC func);

/******************** ANSWERS SUBCOMMAND *********************/
L_LONG LinterAnsColNum(TCBL * pCBL, L_WORD * N);
L_LONG LinterGETA(TCBL * pCBL, L_WORD N, void *Out, L_WORD OutLen);
L_LONG LinterGETE(TCBL * pCBL, L_LONG CodErr, void *Str, L_WORD StrLen);
L_LONG LinterGETF(TCBL * pCBL, void *RowBuf, L_WORD RowBufLen, void *NullBuf);
L_LONG LinterGETP(TCBL * pCBL, void *RowBuf, L_WORD RowBufLen, void *NullBuf);
L_LONG LinterGETN(TCBL * pCBL, void *RowBuf, L_WORD RowBufLen, void *NullBuf);
L_LONG LinterGETL(TCBL * pCBL, void *RowBuf, L_WORD RowBufLen, void *NullBuf);
L_LONG LinterGETS(TCBL * pCBL, L_LONG N, void *RowBuf, L_WORD RowBufLen, void *NullBuf);
L_LONG LinterGETM(TCBL * pCBL, L_LONG Start, L_LONG N, void *RowBuf, L_WORD RowBufLen, void *NullBuf);
void    LinterASYNC_GETA(TCBL * pCBL, L_WORD N, void *Out, L_WORD OutLen, USR_PROC func);
void    LinterASYNC_AnsColNum(TCBL * pCBL, USR_PROC func);
void    LinterASYNC_GETE(TCBL * pCBL, L_LONG CodErr, void *Str, L_WORD StrLen, USR_PROC func);
void    LinterASYNC_GETF(TCBL * pCBL, void *RowBuf, L_WORD RowBufLen, void *NullBuf, USR_PROC func);
void    LinterASYNC_GETN(TCBL * pCBL, void *RowBuf, L_WORD RowBufLen, void *NullBuf, USR_PROC func);
void    LinterASYNC_GETP(TCBL * pCBL, void *RowBuf, L_WORD RowBufLen, void *NullBuf, USR_PROC func);
void    LinterASYNC_GETL(TCBL * pCBL, void *RowBuf, L_WORD RowBufLen, void *NullBuf, USR_PROC func);
void    LinterASYNC_GETS(TCBL * pCBL, L_LONG N, void *RowBuf, L_WORD RowBufLen, void *NullBuf, USR_PROC func);
void    LinterASYNC_GETM(TCBL * pCBL, L_LONG Start, L_LONG N, void *RowBuf, L_WORD RowBufLen, void *NullBuf, USR_PROC func);

/******************** NOT SELECT COMMAND *********************/
L_LONG LinterNotSelect(TCBL * pCBL, L_CHAR * Statement);
void    LinterASYNC_NotSelect(TCBL * pCBL, L_CHAR * Statement, USR_PROC func);

/******************** TRANSACTION COMMAND *********************/
L_LONG LinterCOMT(TCBL * pCBL);
L_LONG LinterRBAC(TCBL * pCBL);
L_LONG LinterLREL(TCBL * pCBL, L_CHAR * User, L_CHAR * Table);
L_LONG LinterUREL(TCBL * pCBL);
L_LONG LinterLROW(TCBL * pCBL);
L_LONG LinterUROW(TCBL * pCBL);
void    LinterASYNC_COMT(TCBL * pCBL, USR_PROC func);
void    LinterASYNC_RBAC(TCBL * pCBL, USR_PROC func);
void    LinterASYNC_LREL(TCBL * pCBL, L_CHAR * User, L_CHAR * Table, USR_PROC func);
void    LinterASYNC_UREL(TCBL * pCBL, USR_PROC func);
void    LinterASYNC_LROW(TCBL * pCBL, USR_PROC func);
void    LinterASYNC_UROW(TCBL * pCBL, USR_PROC func);

/******************** TRACING COMMAND *********************/
L_LONG LinterDIRR(TCBL * pCBL, L_LONG N, DIRR_OUT * Out);
L_LONG LinterDIRA(TCBL * pCBL, L_LONG N, DIRA_OUT * Out);
L_LONG LinterDIRF(TCBL * pCBL, L_LONG N, DIRF_OUT * Out);
L_LONG LinterDIRK(TCBL * pCBL, L_LONG N, DIRK_OUT * Out);
void    LinterASYNC_DIRR(TCBL * pCBL, L_LONG N, DIRR_OUT * Out, USR_PROC func);
void    LinterASYNC_DIRA(TCBL * pCBL, L_LONG N, DIRA_OUT * Out, USR_PROC func);
void    LinterASYNC_DIRF(TCBL * pCBL, L_LONG N, DIRF_OUT * Out, USR_PROC func);
void    LinterASYNC_DIRK(TCBL * pCBL, L_LONG N, DIRK_OUT * Out, USR_PROC func);

/******************** BLOB-VALUES COMMAND *********************/
L_LONG LinterGOBJ(TCBL * pCBL, L_LONG Position, void *Out, L_WORD OutLen);
L_LONG LinterAOBJ(TCBL * pCBL, void *Out, L_WORD OutLen);
L_LONG LinterCOBJ(TCBL * pCBL);
void    LinterASYNC_GOBJ(TCBL * pCBL, L_LONG Position, void *Out, L_WORD OutLen, USR_PROC func);
void    LinterASYNC_AOBJ(TCBL * pCBL, void *Buf, L_WORD BufLen, USR_PROC func);
void    LinterASYNC_COBJ(TCBL * pCBL, USR_PROC func);

/******************** PACK LOADING COMMAND *********************/
L_LONG LinterPUTM(TCBL * pCBL, void *RowBuf, L_WORD RowBufLen);
void    LinterASYNC_PUTM(TCBL * pCBL, void *Buf, L_WORD BufLen, USR_PROC func);

/******************** PROCEDURE FUNCTION *********************/
L_LONG LinterExec(TCBL * pCBL, L_CHAR * ExecStat, void *Buf, L_WORD LenBuf);
L_LONG LinterASYNC_Exec(TCBL * pCBL, L_CHAR * ExecStat, void *Buf, L_WORD LenBuf, USR_PROC func);

#ifdef WINCE                                      /* 23.05.03 ..*/
#	ifndef MAX_PATH
#		define MAX_PATH 260
#	endif
# define MAX_ARG 5
extern int  argc;
extern char argv[MAX_ARG][MAX_PATH];
#endif

#if _VER_MAX>500
void    WorkError(TCBL * pCBL, HPVOID Korteg, HPVOID NullInd);
#else
void    WorkError(TCBL * pCBL, HPVOID Korteg);
#endif
void    PrintError(TCBL * pCBL);                  /*... 23.05.03 */
