
 /***************************************************************************
 *                 RELEX, Ltd. Linter DBMS source code                      *
 *              This is public source code of RELEX, Ltd.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                    Copyright (c) 1998 RELEX Ltd.                         *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Ltd.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: Example function of error's processing.
 ----------------------------------------------------------------------------
 REVISION HISTORY:
  11.08.98 --          , Creation date
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "inter.h"
#include "exlib.h"

void    PrintError(TCBL * pCBL)
  {
  if (pCBL->CodErr != NORMAL)
    {
    if (strncmp(pCBL->Node, "        ", MAX_NODE_LEN) != 0 && *pCBL->Node != 0)
      printf("* Linter server <%.8s>\n", pCBL->Node);
    printf("* Channel N %d\n", pCBL->NumChan);
    printf("* Command [%.4s]\n", pCBL->Command);
    printf("* Linter error: %ld\n", pCBL->CodErr);
    if (pCBL->SysErr)
      printf("* System error: %ld\n", pCBL->SysErr);
    exit(1);
    }
  }

#if _VER_MAX>500
void    WorkError(TCBL * pCBL, HPVOID Korteg, HPVOID NullInd)
#else
void    WorkError(TCBL * pCBL, HPVOID Korteg)
#endif
  {
  if (pCBL->CodErr != NORMAL)
    {
    if (strncmp(pCBL->Node, "        ", MAX_NODE_LEN) != 0 && *pCBL->Node != 0)
      printf("* Linter server <%.8s>\n", pCBL->Node);
    printf("* Channel N %d\n", pCBL->NumChan);
    printf("* Command [%.4s]\n", pCBL->Command);
    printf("* Linter error: %ld\n", pCBL->CodErr);
    if (pCBL->SysErr)
      printf("* System error: %ld\n", pCBL->SysErr);
    exit(1);
    }
  }
