
 /***************************************************************************
 *                 RELEX, Ltd. Linter DBMS source code                      *
 *              This is public source code of RELEX, Ltd.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                    Copyright (c) 1998 RELEX Ltd.                         *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Ltd.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: Demonstration Call-interface's command DESC.
 ----------------------------------------------------------------------------
 REVISION HISTORY:
  11.08.98 --          , Creation date
  04.02.00 -- Kononyhin (CBL clearing)
  30.07.02 -- Galizin   ( Function main return int type PT#1046 )
  23.05.03 -- EVG       ( Porting to WinCE: PT #784)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "inter.h"
#include "exlib.h"

#ifndef WINCE                                             /* 23.05.03 ...*/
int    main()                                               /* 30.07.02 */
#else
int    exdesc()
#endif                                                    /*... 23.05.03 */
  {
  TCBL    CBLconnect;
  L_CHAR    Name_Pass[] = "SYSTEM/MANAGER";
  L_CHAR    Node[] = "        ";
  L_WORD    Priority = 0;
  L_LONG  PrzExe = M_EXCLUSIVE | Q_ENCODE | M_BINARY;
  L_LONG  Err;
  DB_DESC desc;

  memset(&CBLconnect,0,sizeof(TCBL));			/* 04.02.00 */
  Err = LinterOPEN(&CBLconnect, Name_Pass, Node, Priority, PrzExe);
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("Connect to RDBMS Linter\n");

  Err = LinterDESC(&CBLconnect, &desc);
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("DESC :\n");
  printf("\tVerMajor=%ld\n", desc.VerMajor);
  printf("\tVerMinor=%ld\n", desc.VerMinor);
  printf("\tVerBuild=%ld\n", desc.VerBuild);
  printf("\tSortPoolSize=%ld\n", desc.SortPoolSize);
  printf("\tKernelPoolSize=%ld\n", desc.KernelPoolSize);
  printf("\tFileQueueSize=%ld\n", desc.FileQueueSize);
  printf("\tUserQueueSize=%ld\n", desc.UserQueueSize);
  printf("\tTableQueueSize=%ld\n", desc.TableQueueSize);
  printf("\tColumnQueueSize=%ld\n", desc.ColumnQueueSize);
  printf("\tChannelQueueSize=%ld\n", desc.ChannelQueueSize);
  printf("\tSnapTimeout=%ld\n", desc.SnapTimeout);
  printf("\tKillTimeout=%ld\n", desc.KillTimeout);
  printf("\tBaseName=%.18s\n", desc.BaseName);
  printf("\tSysLog=%hd\n", desc.SysLog);
  printf("\tSync=%hd\n", desc.Sync);
  printf("\tLog=%hd\n", desc.Log);
  printf("\tOs=%ld\n", (L_LONG ) desc.Os);
  printf("\n");

  printf("End Example\n");

  return 0;                                                 /* 30.07.02 */
  }
