
 /***************************************************************************
 *                 RELEX, Ltd. Linter DBMS source code                      *
 *              This is public source code of RELEX, Ltd.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                    Copyright (c) 1998 RELEX Ltd.                         *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Ltd.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: Demonstration Call-interface's commands DIRR, DIRA, DIRF, DIRK.
 ----------------------------------------------------------------------------
 REVISION HISTORY:
  11.08.98 --          , Creation date
  04.02.00 -- Kononyhin (CBL clearing)
  30.07.02 -- Galizin   ( Function main return int type PT#1046 )
  23.05.03 -- EVG       ( Porting to WinCE: PT #784)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "inter.h"
#include "exlib.h"

#ifndef WINCE                                             /* 23.05.03 ...*/
int    main()                                               /* 30.07.02 */
#else
int    exdirx()
#endif                                                    /*... 23.05.03 */
  {
  TCBL    CBLconnect;
  L_CHAR    Name_Pass[] = "SYSTEM/MANAGER";
  L_CHAR    Node[] = "        ";
  L_WORD    Priority = 0;
  L_LONG  PrzExe = M_EXCLUSIVE | Q_ENCODE | M_BINARY;
  L_LONG  Err;
  DIRR_OUT DIRR_Out;
  DIRA_OUT DIRA_Out;
  DIRF_OUT DIRF_Out;
  DIRK_OUT DIRK_Out;

  memset(&CBLconnect,0,sizeof(TCBL));			/* 04.02.00 */
  Err = LinterOPEN(&CBLconnect, Name_Pass, Node, Priority, PrzExe);
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("Connect to RDBMS Linter\n");

  Err = LinterDIRR(&CBLconnect, 4, &DIRR_Out);
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("DIRR:\n");
  printf("\tOwner=%ld\n", DIRR_Out.Owner);
  printf("\tTblName=%.18s\n", DIRR_Out.TblName);
  printf("\tUpdFlag=%d\n\n", DIRR_Out.UpdFlag);

  Err = LinterDIRA(&CBLconnect, 13, &DIRA_Out);
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("DIRA:\n");
  printf("\tOwner=%ld\n", DIRA_Out.Owner);
  printf("\tTblName=%.18s\n", DIRA_Out.TblName);
  printf("\tColName=%.18s\n", DIRA_Out.ColName);
  printf("\tUpdFlag=%d\n\n", DIRA_Out.UpdFlag);

  Err = LinterDIRF(&CBLconnect, 1, &DIRF_Out);
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("DIRF:\n");
  printf("\tOwner=%ld\n", DIRF_Out.Owner);
  printf("\tTblName=%.18s\n", DIRF_Out.TblName);
  printf("\tType=%hd\n", DIRF_Out.Type);
  printf("\tExtent=%hd\n", DIRF_Out.Extent);
  printf("\tState=%ld\n\n", DIRF_Out.State);

  Err = LinterDIRK(&CBLconnect, 1, &DIRK_Out);
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("DIRK:\n");
  printf("\tUser=%ld\n", DIRK_Out.User);
  printf("\tTask=%ld\n", DIRK_Out.Task);
  printf("\tStatus=%hd\n", DIRK_Out.State);
  printf("\tProcess=%hd\n\n", DIRK_Out.Process);

  printf("End Example\n");

  return 0;                                                 /* 30.07.02 */
  }
