
 /***************************************************************************
 *                 RELEX, Inc. Linter DBMS source code                      *
 *              This is public source code of RELEX, Inc.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                    Copyright (c) 2006 RELEX Inc.                         *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: PURPOSE: Demonstration Call-interface's command GETA.
 ----------------------------------------------------------------------------
 REVISION HISTORY:
  11.08.98 --          , Creation date
  04.02.00 -- Kononyhin (CBL clearing)
  30.07.02 -- Galizin   ( Function main return int type PT#1046 )
  23.05.03 -- EVG       ( Porting to WinCE: PT #784)
  21.11.06 -- Kolesov   (Add header)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "inter.h"
#include "exlib.h"


#ifndef WINCE                                             /* 23.05.03 ...*/
int    main()                                               /* 30.07.02 */
#else
int    exgeta()
#endif                                                    /*... 23.05.03 */
  {
  TCBL    CBLconnect;
  L_CHAR    Name_Pass[] = "SYSTEM/MANAGER";
  L_CHAR    Node[] = "        ";
  L_WORD    Priority = 0;
  L_LONG  PrzExe = M_EXCLUSIVE | Q_ENCODE | M_BINARY;
  L_LONG  Err;
  L_CHAR    Query[] = "select NAME,FIRSTNAM,SEX from PERSON;";
  GETA_OUT *answer;
  L_WORD    NColumn;
  L_WORD    i;


  memset(&CBLconnect,0,sizeof(TCBL));			/* 04.02.00 */
  Err = LinterOPEN(&CBLconnect, Name_Pass, Node, Priority, PrzExe);
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("Connect to RDBMS Linter\n");

  Err = LinterSLCT(&CBLconnect, PrzExe, Query, NULL, L_MAXWORD, NULL);
  if (Err != NORMAL)
    PrintError(&CBLconnect);

  Err = LinterAnsColNum(&CBLconnect, &NColumn);
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("GETA (1), Answer Hold %d column\n", NColumn);

  answer = (GETA_OUT *) calloc(NColumn, sizeof(GETA_OUT));
  if (answer == NULL)
    {
    printf("Error: not memory\n");
    exit(1);
    }


  Err = LinterGETA(&CBLconnect, 0, answer, (L_WORD) (NColumn * sizeof(GETA_OUT)));
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("GETA (2):\n");
  for (i = 0; i < NColumn; i++)
    {
    printf("Answer Column %d\n", i + 1);
    printf("\tUser=%.18s\n", answer[i].User);
    printf("\tTable=%.18s\n", answer[i].Table);
    printf("\tColumn=%.18s\n", answer[i].Column);
    printf("\tLength=%d\n", answer[i].Length);
    printf("\tType=%hd\n", answer[i].Type);
    printf("\tPrecision=%hd\n", answer[i].Precision);
    printf("\tScale=%hd\n\n", answer[i].Scale);
    }
  free(answer);

  printf("End Example\n");

  return 0;                                                 /* 30.07.02 */
  }
