
 /***************************************************************************
 *                 RELEX, Ltd. Linter DBMS source code                      *
 *              This is public source code of RELEX, Ltd.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                    Copyright (c) 1998 RELEX Ltd.                         *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Ltd.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: Demonstration Call-interface's command KILL.
 ----------------------------------------------------------------------------
 REVISION HISTORY:
  11.08.98 --          , Creation date
  04.02.00 -- Kononyhin (CBL clearing)
  30.07.02 -- Galizin   ( Function main return int type PT#1046 )
  23.05.03 -- EVG       ( Porting to WinCE: PT #784)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "inter.h"
#include "exlib.h"


#ifndef WINCE                                             /* 23.05.03 ...*/
int    main()                                               /* 30.07.02 */
#else
int    exkill()
#endif                                                    /*... 23.05.03 */
  {
  TCBL    CBLconnect,
          CBL1;
  L_CHAR    Name_Pass[] = "SYSTEM/MANAGER";
  L_CHAR    Node[] = "        ";
  L_WORD    Priority = 0;
  L_LONG  PrzExe = M_EXCLUSIVE | Q_ENCODE | M_BINARY;
  L_LONG  Err;

  memset(&CBLconnect,0,sizeof(TCBL));			/* 04.02.00 */
  Err = LinterOPEN(&CBLconnect, Name_Pass, Node, Priority, PrzExe);
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("Connect to RDBMS Linter\n");

  Err = LinterOCUR(&CBL1, CBLconnect.NumChan, Priority, PrzExe);
  if (Err != NORMAL)
    PrintError(&CBL1);
  printf("Open Channel\n");

  Err = LinterKILL(&CBLconnect, CBL1.NumChan);
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("Kill Channel\n");

  printf("End Example\n");

  return 0;                                                 /* 30.07.02 */
  }
