
 /***************************************************************************
 *                 RELEX, Inc. Linter DBMS source code                      *
 *              This is public source code of RELEX, Inc.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                    Copyright (c) 2006 RELEX Inc.                         *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: Example use of NULL-values buffer.
 ----------------------------------------------------------------------------
 REVISION HISTORY:
  11.08.98 --          , Creation date
  04.02.00 -- Kononyhin (CBL clearing)
  30.07.02 -- Galizin   ( Function main return int type PT#1046 )
  23.05.03 -- EVG       ( Porting to WinCE: PT #784)
  22.11.06 -- Kolesov   (Add header)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "inter.h"
#include "exlib.h"


#ifndef WINCE                                             /* 23.05.03 ...*/
int    main()                                               /* 30.07.02 */
#else
int    exnull()
#endif                                                    /*... 23.05.03 */
  {
  struct TRowBuf
    {
    L_CHAR    Name[20];
    L_CHAR    FirstName[15];
    L_CHAR    Sex[1];
    L_LONG  PERSONID;
    };
  typedef struct TRowBuf TRowBuf;
  TCBL    CBLconnect;
  L_CHAR    Name_Pass[] = "SYSTEM/MANAGER";
  L_CHAR    Node[] = "        ";
  L_WORD    Priority = 0;
  L_LONG  PrzExe = M_EXCLUSIVE | Q_ENCODE | M_BINARY;
  L_LONG  Err;
  L_CHAR    Query[] = "select NAME,FIRSTNAM,SEX,PERSONID from PERSON where FIRSTNAM is NULL;";
  TRowBuf RowBuf;
  L_BYTE    NullBuf[1024];
  L_WORD    i,
          j;
  L_WORD    nRow;
  L_WORD    nCol;
  L_BYTE   *ptr;

  memset(&CBLconnect,0,sizeof(TCBL));			/* 04.02.00 */
  Err = LinterOPEN(&CBLconnect, Name_Pass, Node, Priority, PrzExe);
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("Connect to RDBMS Linter\n");

  Err = LinterNotSelect(&CBLconnect, "insert into PERSON(PERSONID) values(10000) ;");
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("insert into PERSON\n");

  Err = LinterSLCT(&CBLconnect, PrzExe, Query, &RowBuf, sizeof(TRowBuf), NullBuf);
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("Selected Row:\n");

  nRow = *((L_WORD *) NullBuf);
  nCol = *((L_WORD *) NullBuf + 1);
  ptr = NullBuf + 2 * sizeof(L_WORD);
  for (i = 0; i < nRow; i++)
    {
    for (j = 0; j < nCol; j++)
      {
      switch (j)
        {
        case 0:
          if (!*(ptr + i * nCol + j))
            printf("%.20s ", RowBuf.Name);
          else
            printf("Null ");
          break;
        case 1:
          if (!*(ptr + i * nCol + j))
            printf("%.15s ", RowBuf.FirstName);
          else
            printf("Null ");
          break;
        case 2:
          if (!*(ptr + i * nCol + j))
            printf("%c ", RowBuf.Sex);
          else
            printf("Null ");
          break;
        case 3:
          if (!*(ptr + i * nCol + j))
            printf("%ld ", RowBuf.PERSONID);
          else
            printf("Null ");
          break;
          }
      }
    printf("\n");
    }

  Err = LinterRBAC(&CBLconnect);
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("RollBack\n");

  printf("End Example\n");

  return 0;                                                 /* 30.07.02 */
  }
