
 /***************************************************************************
 *                 RELEX, Ltd. Linter DBMS source code                      *
 *              This is public source code of RELEX, Ltd.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                    Copyright (c) 1998 RELEX Ltd.                         *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Ltd.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: Demonstration Call-interface's command PUTM.
 ----------------------------------------------------------------------------
 REVISION HISTORY:
  11.08.98 --          , Creation date
  04.02.00 -- Kononyhin (CBL clearing)
  30.07.02 -- Galizin   ( Function main return int type PT#1046 )
  23.05.03 -- EVG       ( Porting to WinCE: PT #784)
  04.12.13 -- Galizin   ( Closing channel at end of work)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "inter.h"
#include "exlib.h"

#define MAX_ROWS 50


#ifndef WINCE                                             /* 23.05.03 ...*/
int    main()                                               /* 30.07.02 */
#else
int    exputm()
#endif                                                    /*... 23.05.03 */
  {
  TCBL    CBLconnect;
  L_CHAR    Name_Pass[] = "SYSTEM/MANAGER";
  L_CHAR    Node[] = "        ";
  L_WORD    Priority = 0;
  L_LONG  PrzExe = M_EXCLUSIVE | Q_ENCODE | M_BINARY;
  L_LONG  Err;
  L_BYTE    PackBuf[4096];
  L_WORD   *Len;
  L_LONG  i;
  L_WORD    size;

  memset(&CBLconnect,0,sizeof(TCBL));			/* 04.02.00 */
  Err = LinterOPEN(&CBLconnect, Name_Pass, Node, Priority, PrzExe);
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("Connect to RDBMS Linter\n");

  LinterNotSelect(&CBLconnect, "drop table TT;");
  LinterNotSelect(&CBLconnect, "create table TT(CC int);");


  Len = (L_WORD *) (PackBuf + 2);
  size = sizeof(L_WORD);;
  for (i = 0; i < MAX_ROWS; i++)
    {
    *Len = sizeof(L_LONG );
    memcpy(Len + 1, &i, sizeof(L_LONG ));
    Len += 1 + sizeof(L_LONG ) / sizeof(L_WORD);
    size += sizeof(L_LONG ) + sizeof(L_WORD);;
    }
  *((L_WORD *) PackBuf) = (L_WORD) i;

  if (LinterNotSelect(&CBLconnect, "START APPEND INTO TT BYTE (CC);") != NORMAL)
    PrintError(&CBLconnect);

  Err = LinterPUTM(&CBLconnect, PackBuf, size);
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("PUTM\n");

  if (LinterNotSelect(&CBLconnect, "END APPEND INTO TT;") != NORMAL)
    PrintError(&CBLconnect);

  if (LinterCOMT(&CBLconnect) != NORMAL)                    /* 04.12.13 */
    PrintError(&CBLconnect);

  if (LinterCLOS(&CBLconnect) != NORMAL)                    /* 04.12.13 */
    PrintError(&CBLconnect);

  printf("End Example\n");

  return 0;                                                 /* 30.07.02 */
  }
