
 /***************************************************************************
 *                 RELEX, Inc. Linter DBMS source code                      *
 *              This is public source code of RELEX, Inc.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                    Copyright (c) 2006 RELEX Inc.                         *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: Demonstration Call-interface's command SLCT.
 ----------------------------------------------------------------------------
 REVISION HISTORY:
  11.08.98 --          , Creation date
  04.02.00 -- Kononyhin (CBL clearing)
  30.07.02 -- Galizin   ( Function main return int type PT#1046 )
  23.05.03 -- EVG       ( Porting to WinCE: PT #784)
  22.11.06 -- Kolesov   (Add header)
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "inter.h"
#include "exlib.h"


#ifndef WINCE                                             /* 23.05.03 ...*/
int    main()                                               /* 30.07.02 */
#else
int    exslct()
#endif                                                    /*... 23.05.03 */
  {
  struct TRowBuf
    {
    L_CHAR    Name[20];
    L_CHAR    FirstName[15];
    L_CHAR    Sex;
    };
  typedef struct TRowBuf TRowBuf;
  TCBL    CBLconnect;
  L_CHAR    Name_Pass[] = "SYSTEM/MANAGER";
  L_CHAR    Node[] = "        ";
  L_WORD    Priority = 0;
  L_LONG  PrzExe = M_EXCLUSIVE | Q_ENCODE | M_BINARY;
  L_LONG  Err;
  L_CHAR    Query[] = "select NAME,FIRSTNAM,SEX from PERSON;";
  TRowBuf RowBuf;

  memset(&CBLconnect,0,sizeof(TCBL));			/* 04.02.00 */
  Err = LinterOPEN(&CBLconnect, Name_Pass, Node, Priority, PrzExe);
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("Connect to RDBMS Linter\n");

  Err = LinterSLCT(&CBLconnect, PrzExe, Query, &RowBuf, sizeof(TRowBuf), NULL);
  if (Err != NORMAL)
    PrintError(&CBLconnect);
  printf("First Selected Row:\n");
  printf("%.20s %.15s %c\n", RowBuf.Name, RowBuf.FirstName, RowBuf.Sex);

  printf("End Example\n");

  return 0;                                                 /* 30.07.02 */
  }
