#!/usr/local/bin/perl -w

# Blob processing test
print "\nBlob processing test\n";

require DBI;
import DBI;

DBI->install_driver('Linter');
%attr=('mode'=>'autocommit',
       'codepage'=>'CP_1251');


$dbh = DBI->connect('', 'SYSTEM', 'MANAGER', \%attr, 'Linter');
die "can't establish connection :".$dbh->err unless (defined $dbh);

$dbh->do('drop table blob_test;');

$dbh->do('create table blob_test(dummy int, data blob);');
die "\n do 'create table blob_test' error: ".$dbh->err if ($dbh->err != 0);

$dbh->do('insert into blob_test (dummy) values(1);');
$dbh->do('insert into blob_test (dummy) values(2);');
die "\n do 'insert into blob_test' error: ".$dbh->err if ($dbh->err != 0);

$sh=$dbh->prepare('select dummy,data from blob_test;');
die "\nprepare error : ".$dbh->err if (!defined $sh);

$rv = $sh->execute();
die "\nexecute error : ".$dbh->err if (!$rv);

$dummy = $sh->fetch();
die {"\fetch error: ", $dbh->err} if (!defined $dummy);

#now write to blob 
open F,'<blob.jpg' or die "abort: file blob.jpg not exists\n";
binmode F;
$offs=0;
$siz=1024;

M:
while(){
 $r = sysread (F, $blob, $siz);
 last M unless (defined $r && $r>0);
 $sh->func($field,$r, \$blob,'blob_write');
 $offs+=$r;
};

$field='';


open O,'>out.jpg';
binmode O;

$offs=0;
M1:
while(){
$blb= $sh->blob_read($field,$offs,1024);
last M1 unless (defined $blb);
$offs+=(length $blb);
#print "\nblb= ",length $blb;
syswrite (O, $blb, length $blb);
}
close O;

$sh->blob_copy_to_file($field, 'bbb.jpg');

$sh->func('blob_delete');

exit 0;
# end.
