 /***************************************************************************
 *                 RELEX, Ltd. Linter DBMS source code                      *
 *              This is public source code of RELEX, Ltd.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                    Copyright (c) 1998 RELEX Ltd.                         *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Ltd.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: Demonstration Linter JDBC driver work.
		  ResultSetEx usage.
          Class ResultSetEx is an extension of standard JDBC class ResultSet,
          that makes possible working with scrollable cursors.
          Attention: Non-standart! 
 ----------------------------------------------------------------------------
 REVISION HISTORY:
  23.08.1998 -- Creation date
  06.01.2000 -- encoding, className
*/

import java.sql.*;
import jdbc.LinJdbc.ResultSetEx;
import java.util.*;

public class ResultSetExDemo
extends Config
{
	public static void main (String[] args)
	{
		try 
		{
			Driver d = (Driver)Class.forName(className).newInstance();
			
			Properties props = new Properties();
		    	props.put( "user",     user );
		    	props.put( "password", password );

		    	if (encoding != null)
				props.put( "encoding", encoding );

			Connection con = DriverManager.getConnection(address, props);
			Statement stmt = con.createStatement();

			ResultSetEx results;
			
			stmt.executeUpdate("create table test1 (a int, b char(20));");
			
			//INSERT
			stmt.executeUpdate("insert into test1 values(1,'First string');");
			stmt.executeUpdate("insert into test1 values(2,'Another string');");
			stmt.executeUpdate("insert into test1 values(3,'Third string');");
			
			results = (ResultSetEx)stmt.executeQuery("select * from test1;");
			
			System.out.println("ResultSet contains "+results.getRowCount()+" rows");
			
			while ( results.next() )
			{
				// Loop through each column, getting the column
				// data and displaying
				System.out.print("| "+results.getInt(1));
				System.out.println("| "+results.getString(2)+" |");
			}
			
			System.out.println();
			System.out.println("To previous...");
			if(results.previous())
			{
				System.out.print("| "+results.getInt(1));
				System.out.println("| "+results.getString(2)+" |");
			}
			
			System.out.println("To (current+1)...");
			if(results.relative(1))
			{
				System.out.print("| "+results.getInt(1));
				System.out.println("| "+results.getString(2)+" |");
			}
			
			System.out.println("To first...");
			if(results.absolute(1))
			{
				System.out.print("| "+results.getInt(1));
				System.out.println("| "+results.getString(2)+" |");
			}
			
			results.close();

			try
			{	 
				stmt.executeUpdate("drop table test1;");
			}catch(SQLException e)
			{ 
				System.out.println("Error deleting table:"+e.getMessage());
			}

			con.close();
		} catch (Exception e)
		{
			System.out.println("Catched :"+e+" mess= "+e.getMessage() );
			e.printStackTrace(); 
			return;
		}
	} // main()
}