 /***************************************************************************
 *                 RELEX, Ltd. Linter DBMS source code                      *
 *              This is public source code of RELEX, Ltd.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                    Copyright (c) 1998 RELEX Ltd.                         *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Ltd.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: Demonstration Linter JDBC driver work.
		  Statementes & ResultSet usage.
 ----------------------------------------------------------------------------
 REVISION HISTORY:
  23.08.1998 -- Creation date
  06.01.2000 -- encoding, className
*/

import java.sql.*;
import jdbc.LinJdbc.ResultSetEx;
import java.util.*;

public class StatementDemo
extends Config
{
	public static void main (String[] args)
	{
		try 
		{
			Driver d = (Driver)Class.forName(className).newInstance();
			ResultSet results;

		        //DriverManager.setLogStream(System.out);
			
			System.out.println("Driver found. Now connecting to database ... ");       

			Properties props = new Properties();
		    	props.put( "user",     user );
		    	props.put( "password", password );

		    	if (encoding != null)
				props.put( "encoding", encoding );

			Connection con = DriverManager.getConnection(address, props);
			System.out.println(" Connection established ... ");       
			Statement stmt = con.createStatement();
			
			System.out.println(" Statement created ... ");       
			
			//DROP/CREATE TABLE
			try
			{	 
				stmt.executeUpdate("drop table test1;");
			}
			catch(SQLException e)
			{ 
				System.out.println("Error deleting table:"+e.getMessage());
			}
			stmt.executeUpdate("create table test1 (a int, b char(20));");
			
			//INSERT
			stmt.executeUpdate("insert into test1 values(1,'First string');");
			stmt.executeUpdate("insert into test1 values(2,'Another string');");
			
			results = stmt.executeQuery("select * from test1;");
			
			System.out.println(" Result set retrieved... ");       
			
			while ( results.next() )
			{
				// Loop through each column, getting the column
				// data and displaying
				System.out.print("| "+results.getInt(1));
				System.out.println("| "+results.getString(2)+" |");
			}
			results.close();
			
			try
			{	 
				stmt.executeUpdate("drop table test1;");
			}
			catch(SQLException e)
			{ 
				System.out.println("Error deleting table:"+e.getMessage());
			}
			con.close();
			
		} 
		catch (Exception e)
		{
			System.out.println("Exception catched :" + e + 
								" mess= "+e.getMessage() );
			e.printStackTrace(); 
			return;
		}
	} // main
}