 /***************************************************************************
 *                 RELEX, Ltd. Linter DBMS source code                      *
 *              This is public source code of RELEX, Ltd.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                    Copyright (c) 1998 RELEX Ltd.                         *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Ltd.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: Demonstration Linter JDBC driver work.
		  Working with stored procedures without usage CallableStatementes 
 ----------------------------------------------------------------------------
 REVISION HISTORY:
  23.08.1998 -- Creation date
  20.10.1999 -- Kononyhin (Bug fixed)
  06.01.2000 -- encoding, className
*/

import java.sql.*;
import jdbc.LinJdbc.ResultSetEx;
import java.util.*;

public class StoredProcDemo
extends Config
{
	private static Driver 		m_drv =null;
	private static Connection  	m_con =null;

	private static String  QueryD = new String("drop procedure fact1;");

	private static String  QueryC = "create procedure fact1() code end;";  /* 20.10.99 */
	
	private static String  QueryA = 
		  "alter procedure fact1(in x numeric default 1) result numeric"+
		  " for debug"+
	      " declare"+
	         " var r numeric;"+
	         " exception badparam for custom 10;"+
	      " code"+
	         " if x < 0 then"+
	            " signal badparam;"+
	         " endif"+
	         " if x <= 1 then"+
	            " r := 1;"+
	         " else"+
	            " call fact(x-1) into r;"+
	            " r := r*x;"+
	         " endif"+
	         " return r;"+
	      " exceptions"+
	         " when others then"+
	           " resignal;"+
	      " end;";



	public StoredProcDemo()
	{
	
	}

	public static void main (String[] argv)
	{	
		StoredProcDemo spDemo = new StoredProcDemo();
		try
		{
			m_drv = (Driver)Class.forName(className).newInstance();
			System.out.println(" Driver found. Now connecting to database ... ");       

			Properties props = new Properties();
		    	props.put( "user",     user );
		    	props.put( "password", password );

		    	if (encoding != null)
				props.put( "encoding", encoding );

			m_con = DriverManager.getConnection(address, props);
	
			Statement  st = m_con.createStatement();
	
			try
			{
				try
				{
					System.out.println("Drop Procedure if exists\n");
					System.out.println("Query=\n"+QueryD);
					st.executeUpdate(QueryD);
				}
				catch(Exception e)
				{ 
					// ingnore errors 
				}

  				try
				{
					System.out.println("Create Procedure\n");
					System.out.println("Query=\n"+QueryC);
					st.executeUpdate(QueryC);
				}
				catch(SQLException ex)
				{
			    	do{
				        System.out.print("Error occured: code   =");
				        System.out.println(ex.getErrorCode());
				        System.out.print("		 message= ");
			    	    System.out.println(ex.getMessage());
		  		    	ex=ex.getNextException();
					} while(ex!=null);
		  		}     
	
			    System.out.println("Alter Procedure\n");
				System.out.println("Query=\n"+QueryA);
	      		st.executeUpdate(QueryA);
	      
				System.out.println("Drop Procedure\n");
				System.out.println("Query=\n"+QueryD);
				st.executeUpdate(QueryD);
	
			}
			catch(SQLException ex)
			{  //Error handling
		    	do
				{
			        System.out.print("Error occured: code   =");
			        System.out.println(ex.getErrorCode());
			        System.out.print("message = ");
			        System.out.println(ex.getMessage());
		  			ex=ex.getNextException();
				} while(ex != null);
				m_con.close();
	  		}     
        }
		catch(Exception ex)
	 	{
			System.out.println("Error occured: "+ex.getMessage());
	 	} 		
	} // main




}