 /***************************************************************************
 *                 RELEX, Inc. Linter DBMS source code                      *
 *              This is public source code of RELEX, Inc.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                 Copyright (c) 1998-2005 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:Pavel Pasechnik, Kouyantseva Olga 
 ----------------------------------------------------------------------------
 PURPOSE: Linter API first step !
 ----------------------------------------------------------------------------
 REVISION HISTORY:
 ----------------------------------------------------------------------------

  29.09.99 -- creation date
  06.02.06 -- Maria (Cosmetic, add LINTER_CursorComplete)
*/


               	/* CHECKING COMPLETING OF OPERATION (FOR CURSOR) */

#include <stdio.h>
#include <stdlib.h>

#include "linapi.h"                               /* header file for LinAPI */

/* function for  LinAPI errors processing */
void PrintError(L_LONG  retCod,
                L_WORD  conId,
                L_WORD  curId,
                L_WORD  stmtId,
                L_CHAR * message);

int main (void)

{ 
  L_WORD  nConnID;                                   /* connection identifier */
  L_WORD  nCursID;                                   /* cursor identifier */
  L_LONG  lRet;                                      /* return code */
  L_SWORD nIsComplete;                               /* flag of termination */
  L_LONG  lApiErr;
  L_LONG  lLinErr;
  L_LONG  lSysErr;

  printf ("\n CREATING A CONNECTION \n");
  if (lRet = LINTER_Connect ("SYSTEM", 0, "MANAGER", 0, NULL, 
	                     mAutocommit, &nConnID))
    PrintError(lRet, nConnID, 0, 0, "Error Linter_Connect");
  else
    printf("\n Connection has been created successfully. \n");

  printf("\n OPENING A CURSOR \n");
  if (lRet = LINTER_OpenCursor(nConnID, &nCursID, NULL, 0, mAutocommit))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_OpenCursor");
  else
    printf("\n Cursor has been created successfully. \n");

  /* Here is the main section of sample... */

  printf("\n EXECUTE QUERY \n");
  printf(" drop table TCOMPL \n");
  LINTER_ExecuteDirect(nCursID, "drop table TCOMPL", 0, NULL, NULL);

  /* We may ignore return code for DROP table */

  printf(" create table TCOMPL(A int) \n");
  if (lRet = LINTER_ExecuteDirect(nCursID, "create table TCOMPL(A int)", 0, 
                                  NULL, NULL))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_ExecuteDirect");

  printf(" insert into TCOMPL values \n");
  if (lRet = LINTER_ExecuteDirect(nCursID, "insert into TCOMPL values(1)", 0, 
                                  NULL, NULL))
    PrintError(lRet, 0, nCursID, 0, "Error ExecuteDirect");
  else
    printf("\n Processing query has been executed successfully. \n");
                                          
  printf("\n CURSOR COMPLETE \n");
  if(lRet =LINTER_CursorComplete(nCursID, &nIsComplete, &lApiErr, 
                                 &lLinErr, &lSysErr))
    PrintError(lRet, 0, nCursID, 0, "LINTER_GetBlobLength");
  else
    if (!nIsComplete) printf("\n Not complete");
    else
      if(!lApiErr ) printf("\n Complete");
      else
        printf("\n Error: API %ld, LINTER %ld, System %ld", lApiErr,
               lLinErr, lSysErr);

  /* ...End of main section */

  printf("\n\n CLOSING CURSOR \n");
  if (lRet = LINTER_CloseCursor(nCursID))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_CloseCursor");
  else
    printf("\n Cursor has been closed successfully. \n");
		
  printf ("\n CLOSING CONNECTION \n");
  if (lRet = LINTER_CloseConnect (nConnID))
    PrintError(lRet, nConnID, 0, 0, "Error Linter_CloseConnect");
  else
    printf("\n Connection has been closed successfully. \n\n");

  return 0;
}


