 /***************************************************************************
 *                 RELEX, Inc. Linter DBMS source code                      *
 *              This is public source code of RELEX, Inc.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                 Copyright (c) 1998-2005 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:Pavel Pasechnik, Kouyantseva Olga 
 ----------------------------------------------------------------------------
 PURPOSE: Linter API first step !
 ----------------------------------------------------------------------------
 REVISION HISTORY:
 ----------------------------------------------------------------------------

  29.09.99 -- creation date
  08.02.06 -- Maria (Cosmetic, add LINTER_GetBlobType)
*/


                   	/* GETTING TYPE OF BLOB-VALUES */

#include <stdio.h>
#include <stdlib.h>

#include "linapi.h"                                /* header file for LinAPI */

/* function for  LinAPI errors processing */
void PrintError(L_LONG  retCod,
                L_WORD  conId,
                L_WORD  curId,
                L_WORD  stmtId,
                L_CHAR * message);

int main (void)

  { 
  L_WORD nConnID;                                   /* connection identifier */
  L_WORD nCursID;                                   /* cursor identifier */
  L_LONG lRet;                                      /* return code */
  L_CHAR *blob_value="aaa0p9878lhl''';./`231432a";
  L_WORD nType;                                     /* type of blob-values */

  printf ("\n CREATING A CONNECTION \n");
  if (lRet = LINTER_Connect ("SYSTEM", 0, "MANAGER", 0, NULL, 
	                     mAutocommit, &nConnID))
    PrintError(lRet, nConnID, 0, 0, "Error Linter_Connect");
  else
    printf("\n Connection has been created successfully. \n");

  printf("\n OPENING A CURSOR \n");
  if (lRet = LINTER_OpenCursor(nConnID, &nCursID, NULL, 0, mAutocommit))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_OpenCursor");
  else
    printf("\n Cursor has been created successfully. \n");

  printf("\n EXECUTE QUERY \n");
  printf(" drop table TBLOB \n");
  LINTER_ExecuteDirect(nCursID, "drop table TBLOB", 0, NULL, NULL);

  /* We may ignore return code for DROP table */

  printf(" create table TBLOB(B blob) \n");
  if (lRet = LINTER_ExecuteDirect(nCursID, "create table TBLOB(B blob)", 0, 
                                  NULL, NULL))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_ExecuteDirect");

  /* Here is the main section of sample */

  printf(" insert into TBLOB values \n");
  if (lRet = LINTER_ExecuteDirect(nCursID, "insert into TBLOB values(NULL)", 0, 
                                  NULL, NULL))
    PrintError(lRet, 0, nCursID, 0, "Error ExecuteDirect");
  else
    printf("\n Processing query has been executed successfully. \n");

  printf("\n APPENDING BLOB \n");
  if (lRet = LINTER_AppendBlob(nCursID, 0, blob_value,
                               strlen(blob_value), NULL, NULL))
    PrintError(lRet, 0, nCursID, 0, "Error AppendBlob");
  else
    printf("\n Blob-values have been appended successfully. \n");

  printf("\n GETTING TYPE OF BLOB-VALUES \n");
  if (lRet = LINTER_ExecuteDirect(nCursID, "select B from TBLOB", 0, NULL, NULL))
    PrintError(lRet, 0, nCursID, 0, "Error ExecuteDirect");

  if (lRet = LINTER_GetBlobType(nCursID, &nType))
    PrintError(lRet, 0, nCursID, 0, "Error LINTER_GetBlobType");
  else
    printf("\n Type of blob-values - %d", nType);
    printf("\n Type of blob-values has been got successfully. \n");

  /* ...End of main section */

  printf("\n CLOSING CURSOR \n");
  if (lRet = LINTER_CloseCursor(nCursID))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_CloseCursor");
  else
    printf("\n Cursor has been closed successfully. \n");
		
  printf ("\n CLOSING CONNECTION \n");
  if (lRet = LINTER_CloseConnect (nConnID))
    PrintError(lRet, nConnID, 0, 0, "Error Linter_CloseConnect");
  else
    printf("\n Connection has been closed successfully. \n\n");

  return 0;
}


