 /***************************************************************************
 *                 RELEX, Inc. Linter DBMS source code                      *
 *              This is public source code of RELEX, Inc.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                 Copyright (c) 1998-2005 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:Pavel Pasechnik, Kouyantseva Olga 
 ----------------------------------------------------------------------------
 PURPOSE: Linter API first step !
 ----------------------------------------------------------------------------
 REVISION HISTORY:
 ----------------------------------------------------------------------------

  20.09.99 -- creation date
  30.01.06 -- Maria (Cosmetic)
*/


                   /* GETTING OPTIONS OF CONNECTION */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "linapi.h"                                /* header file for LinAPI */

/* function for  LinAPI errors processing */
void PrintError(L_LONG  retCod,
                L_WORD  conId,
                L_WORD  curId,
                L_WORD  stmtId,
                L_CHAR * message);

int main (void)

{ 
  L_WORD nConnID;                                   /* connection identifier */
  L_LONG lRet;                                      /* return code */
  L_LONG PriorVal;              /* characteristics value (connection priority)*/
  L_LONG PriorValLen = sizeof(L_LONG);  /* length of characteristics(in bytes) */

  printf ("\n OPENING A CONNECTION \n");
  if (lRet = LINTER_Connect ("SYSTEM", 0, "MANAGER", 0, NULL, 
                             mAutocommit, &nConnID))
    PrintError(lRet, nConnID, 0, 0, "Error Linter_Connect");
  else
    printf("\n Connection has been created successfully. \n");

  /* Here is the main section of sample... */

  printf ("\n GETTING OPTIONS OF CONNECTION \n");
  if (lRet = LINTER_GetConnectOption(nConnID, cPriority, &PriorVal, 
                                     &PriorValLen))	 
    PrintError(lRet, nConnID, 0, 0, "Error Linter_GetConnectOptions");
  else
    printf("\n Connection priority = %d", PriorVal);
    printf("\n\n Options of cursor has been got successfully. \n");

  /* ...End of main section */

  printf ("\n CLOSING CONNECTION \n");
  if (lRet = LINTER_CloseConnect (nConnID))
    PrintError(lRet, nConnID, 0, 0, "Error Linter_CloseConnect");
  else
    printf("\n Connection has been closed successfully. \n\n");
 
  return 0;
}


 
