 /***************************************************************************
 *                 RELEX, Inc. Linter DBMS source code                      *
 *              This is public source code of RELEX, Inc.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                 Copyright (c) 1998-2005 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:Pavel Pasechnik, Kouyantseva Olga 
 ----------------------------------------------------------------------------
 PURPOSE: Linter API first step !
 ----------------------------------------------------------------------------
 REVISION HISTORY:
 ----------------------------------------------------------------------------

  29.09.99 -- creation date
  10.02.06 -- Maria (Cosmetic, add LINTER_GetObjDesc)
*/


                   	/* GETTING OBJECT DESCRIPTION */

#include <stdio.h>
#include <stdlib.h>

#include "linapi.h"                                /* header file for LinAPI */

/* function for  LinAPI errors processing */
void PrintError(L_LONG  retCod,
                L_WORD  conId,
                L_WORD  curId,
                L_WORD  stmtId,
                L_CHAR *message);


int main (void)

{ 
  L_WORD nConnID;                                   /* connection identifier */
  L_WORD nCursID;                                   /* cursor identifier */
  L_LONG lRet;                                      /* return code */
  L_CHAR Buffer[1024];                          /* object description buffer */
  L_LONG BufLen = sizeof(Buffer);                   

  printf ("\n CREATING A CONNECTION \n");
  if (lRet = LINTER_Connect ("SYSTEM", 0, "MANAGER", 0, NULL, 
	                     mAutocommit, &nConnID))
    PrintError(lRet, nConnID, 0, 0, "Error Linter_Connect");
  else
    printf("\n Connection has been created successfully. \n");

  printf("\n OPENING A CURSOR \n");
  if (lRet = LINTER_OpenCursor(nConnID, &nCursID, NULL, 0, mAutocommit))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_OpenCursor");
  else
    printf("\n Cursor has been created successfully. \n");

  printf("\n EXECUTE QUERY \n");
  printf(" drop table TCOMPL \n");
  LINTER_ExecuteDirect(nCursID, "DROP VIEW TESTVIEW;", 0, NULL, NULL);

  /* We may ignore return code for DROP table */

  printf(" create table TCOMPL(A int) \n");
  if (lRet = LINTER_ExecuteDirect(nCursID, "CREATE VIEW TESTVIEW as select $$$S11,$$$S13 from LINTER_SYSTEM_USER.$$$SYSRL;", 
                                  0, NULL, NULL))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_ExecuteDirect");

  /* Here is the main section of sample... */

  printf("\n GET OBJECT DESCRIPTION \n");
  if (lRet = LINTER_GetObjDesc(nConnID, oView, "SYSTEM.TESTVIEW", 0, 
                               (void *)Buffer, &BufLen))
    PrintError(lRet, nConnID, 0, 0, "Error LINTER_GetObjDesc");
  else
    printf("\n VIEW TESTVIEW is - %s\n Length of object - %d \n", Buffer, BufLen);
    printf("\n Description of the object has been found successfully. \n");

  /* ...End of main section */

  printf("\n\n CLOSING CURSOR \n");
  if (lRet = LINTER_CloseCursor(nCursID))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_CloseCursor");
  else
    printf("\n Cursor has been closed successfully. \n");
		
  printf ("\n CLOSING CONNECTION \n");
  if (lRet = LINTER_CloseConnect (nConnID))
    PrintError(lRet, nConnID, 0, 0, "Error Linter_CloseConnect");
  else
    printf("\n Connection has been closed successfully. \n\n");

  return 0;
}


