 /***************************************************************************
 *                 RELEX, Inc. Linter DBMS source code                      *
 *              This is public source code of RELEX, Inc.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                 Copyright (c) 1998-2005 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:Pavel Pasechnik, Kouyantseva Olga 
 ----------------------------------------------------------------------------
 PURPOSE: Linter API first step !
 ----------------------------------------------------------------------------
 REVISION HISTORY:
 ----------------------------------------------------------------------------
*/

#include <stdio.h>
#include <stdlib.h>

#include "linapi.h"                         /* header file for LinAPI */

/* function for  LinAPI errors processing */
void PrintError(L_LONG  retCod,
                L_WORD  conId,
                L_WORD  curId,
                L_WORD  stmtId,
                L_CHAR *message)
{
  L_LONG lRet;
  L_LONG apierr = 0, error = 0, syserr = 0;

  if ( retCod == LINAPI_ERROR )
  {
    /* getting errors codes for required object */
    if (lRet = LINTER_Error(conId, curId, stmtId,
                            &apierr, &error, &syserr, NULL, NULL))
      printf("diagnostic error %ld\n",lRet);
    else
    {
      printf("ApiErr = %ld, LinErr = %ld, SysErr = %ld\n%s\n",
             apierr, error, syserr, message);
      if ( (apierr == eLinterError) && error > 2000 && error < 3000)
      {
        /* getting string and position if sintax error is */
        printf("Syntax error : line %d, position %d\n",
               (short)syserr, *(short*)((char*)&syserr +2));
      }
    }
    LINTER_CloseAPI(); /* finishing LinAPI working */
    exit(1);
  }
  else
    printf("Return code = %ld\n",retCod);
}


