 /***************************************************************************
 *                 RELEX, Inc. Linter DBMS source code                      *
 *              This is public source code of RELEX, Inc.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                 Copyright (c) 1998-2005 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:Pavel Pasechnik, Kouyantseva Olga 
 ----------------------------------------------------------------------------
 PURPOSE: Linter API first step !
 ----------------------------------------------------------------------------
 REVISION HISTORY:
 ----------------------------------------------------------------------------

  29.09.99 -- creation date
  08.02.06 -- Maria (Cosmetic, add LINTER_RollBack)
*/


                   /* ROLLING BACK CHANGES ON CONNECTION */

#include <stdio.h>
#include <stdlib.h>

#include "linapi.h"                                /* header file for LinAPI */

/* function for  LinAPI errors processing */
void PrintError(L_LONG  retCod,
                L_WORD  conId,
                L_WORD  curId,
                L_WORD  stmtId,
                L_CHAR * message);

int main (void)

{ 
  L_WORD nConnID;                                   /* connection identifier */
  L_WORD nCursID;                                   /* cursor identifier */
  L_CHAR cQuery[] ="create table TDATE (D date);";
  L_LONG lRet;                                      /* return code */
  L_CHAR date[30];                                  /* date as string */

  printf ("\n CREATING A CONNECTION \n");
  if (lRet = LINTER_Connect ("SYSTEM", 0, "MANAGER", 0, NULL, 
	                     mExclusive, &nConnID))
    PrintError(lRet, nConnID, 0, 0, "Error Linter_Connect");
  else
    printf("\n Connection has been created successfully. \n");

  printf("\n OPENING A CURSOR \n");
  if (lRet = LINTER_OpenCursor(nConnID, &nCursID, NULL, 0, mExclusive))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_OpenCursor");
  else
    printf("\n Cursor has been created successfully. \n");

  printf("\n EXECUTE QUERY \n");
  printf("\n drop table TDATE\n");
  LINTER_ExecuteDirect(nCursID, "drop table TDATE;", 0, NULL, NULL);

  /* We may ignore return code for DROP table */

  printf(" creating table TDATE\n");
  if(lRet = LINTER_ExecuteDirect(nCursID, cQuery, 0, NULL, NULL))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_ExecuteDirect");

  /* Here is the main section of sample... */

  printf(" insert into TDATE values(sysdate)\n");
  if (lRet = LINTER_ExecuteDirect(nCursID, "insert into TDATE values(sysdate)", 0, NULL, NULL))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_ExecuteDirect");

  printf(" select D from TDATE \n");
  if (lRet = LINTER_ExecuteDirect(nCursID, "select D from TDATE", 0, NULL, NULL))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_ExecuteDirect");

  if (lRet = LINTER_GetData(nCursID,
                            1,
                            date,                      /* answer buffer */
                            30,                        /* length of buffer */
                            tString,                   /* type of the answer  */
                            0, 0, NULL))
    PrintError(lRet, 0, nCursID, 0, "Error GetRowBuffer");

  printf("\n DATE : %s\n", date);
  
    printf("\n Processing query has been executed successfully. \n");

  printf("\n ROLLING BACK CONNECTION \n");
  if (lRet = LINTER_RollBack(nConnID, NULL, NULL))
    PrintError(lRet, nConnID, 0, 0, "Error Linter_RollBack");
  else
    printf("\n Connection has been rolled back successfully. \n");

  printf("\n EXECUTING QUERY \n");
  printf("\n select D from TDATE\n");
  if (lRet = LINTER_ExecuteDirect(nCursID, "select D from TDATE", 0, NULL, NULL))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_ExecuteDirect");

  if (lRet = LINTER_GetData(nCursID,
                            1,
                            date,
                            30,
                            tString, 
                            0, 0, NULL))
    PrintError(lRet, 0, nCursID, 0, "Error GetRowBuffer");

  printf("\n DATE : %s\n", date);
  
  printf("\n Processing query has been executed successfully. \n");

  /* ...End of main section */

  printf("\n CLOSING CURSOR \n");
  if (lRet = LINTER_CloseCursor(nCursID))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_CloseCursor");
  else
    printf("\n Cursor has been closed successfully. \n");
		
  printf ("\n CLOSING CONNECTION \n");
  if (lRet = LINTER_CloseConnect (nConnID))
    PrintError(lRet, nConnID, 0, 0, "Error Linter_CloseConnect");
  else
    printf("\n Connection has been closed successfully. \n\n");

  return 0;
}


