 /***************************************************************************
 *                 RELEX, Inc. Linter DBMS source code                      *
 *              This is public source code of RELEX, Inc.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                 Copyright (c) 1998-2005 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:Pavel Pasechnik, Kouyantseva Olga 
 ----------------------------------------------------------------------------
 PURPOSE: Linter API first step !
 ----------------------------------------------------------------------------
 REVISION HISTORY:
 ----------------------------------------------------------------------------

  24.09.99 -- creation date
  03.02.06 -- Maria (Cosmetic)
*/


                  	/* SETTING OPTIONS OF CURSOR */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "linapi.h"                               /* header file for LinAPI */

/* function for  LinAPI errors processing */
void PrintError(L_LONG  retCod,
                L_WORD  conId,
                L_WORD  curId,
                L_WORD  stmtId,
                L_CHAR * message);

int main (void)

{ 
  L_WORD nConnID;                                   /* connection identifier */
  L_WORD nCursID;                                   /* cursor identifier */
  L_LONG lRet;                                      /* return code */
  L_CHAR CursorName[20] = "Sys";
  L_CHAR NewName [20] = "SOlVE";
  L_WORD Length = 20;
  L_CHAR OptVal[200];                               /* characteristics value */
  L_LONG OptLen = 200;                              /* length of value */


  printf ("\n OPENING A CONNECTION \n");
  if (lRet = LINTER_Connect ("SYSTEM", 0, "MANAGER", 0, NULL, 
                             mAutocommit, &nConnID))
    PrintError(lRet, nConnID, 0, 0, "Error Linter_Connect");
  else
    printf("\n Connection has been created successfully. \n");

  printf("\n OPENING A CURSOR \n");
  if (lRet = LINTER_OpenCursor(nConnID, &nCursID, CursorName, Length, 
                               mAutocommit))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_OpenCursor");
  else
    printf("\n Cursor has been created successfully. \n");

  printf("\n GETTING OPTIONS OF CURSOR \n");
  if (lRet = LINTER_GetCursorOption (nCursID, cCursorName, 1, OptVal, &OptLen))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_GetCursorOption");
  else
    printf("\n Name of cursor - %s, Length of name - %d \n", OptVal, OptLen );
    printf("\n Options of cursor has been got successfully. \n");

  /* Here is the main section of sample... */

  printf("\n SETTING OPTIONS OF CURSOR \n");
  strcpy (OptVal,NewName);
  if (lRet = LINTER_SetCursorOption(nCursID, cCursorName, OptVal, &OptLen))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_SetCursorOption");
  else
    printf("\n New name of cursor - %s", OptVal);
    printf("\n\n Options of cursor has been set successfully. \n");

  /* ...End of main section */

  printf("\n CLOSING CURSOR \n");
   if (lRet = LINTER_CloseCursor(nCursID))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_CloseCursor");
  else
    printf("\n Cursor has been closed successfully. \n");
		
  printf ("\n CLOSING CONNECTION \n");
  if (lRet = LINTER_CloseConnect (nConnID))
    PrintError(lRet, nConnID, 0, 0, "Error Linter_CloseConnect");
  else
    printf("\n Connection has been closed successfully. \n\n");

  return 0;
}
