 /***************************************************************************
 *                 RELEX, Inc. Linter DBMS source code                      *
 *              This is public source code of RELEX, Inc.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                 Copyright (c) 1998-2005 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:Pavel Pasechnic, Kouyantseva Olga
 ----------------------------------------------------------------------------
 PURPOSE: Linter API first step !
 ----------------------------------------------------------------------------
 REVISION HISTORY:
 ----------------------------------------------------------------------------

  04.10.99 -- creation date
  03.02.06 -- Maria (Cosmetic)

*/

          	           /* UNBINDING OF ANSWER */

#include <stdio.h>
#include <stdlib.h>

#include "linapi.h"                                /* header file for LinAPI */

/* function for  LinAPI errors processing */
void PrintError(L_LONG  retCod,
                L_WORD  conId,
                L_WORD  curId,
                L_WORD  stmtId,
                L_CHAR * message);

int main (void)

{ 
  L_WORD nConnID;                                   /* connection identifier */
  L_WORD nCursID;                                   /* cursor identifier */
  L_WORD nStmtID;                                   /* statement identifier */
  L_CHAR cQuery[] ="select PERSONID,NAME from PERSON where NAME='CLINTON'";
  L_LONG lRet;                                      /* return code */
  L_CHAR CursorName[20] = "Sys";
  L_WORD Lengh = 20;
  L_CHAR Ans[200];                           /* characteristics value buffer */
  typedef L_CHAR Name_Type [20];
  typedef struct {
    	         Name_Type Name;
	         L_LONG PersonID;
		 } Answ_Type; 
  Answ_Type B[20];                              /* answer buffer */
  L_CHAR N[20];                                 /* NULL-indicators buffer */
  L_LONG sum;                                   /* amount of data */
  L_LONG len = 200;                             /* buffer length in bytes */

  printf ("\n OPENING A CONNECTION \n");
  if (lRet = LINTER_Connect ("SYSTEM", 0, "MANAGER", 0, NULL, 
	                      mAutocommit, &nConnID))
    PrintError(lRet, nConnID, 0, 0, "Error Linter_Connect");
  else
    printf("\n Connection has been created successfully. \n");

  printf("\n OPENING A CURSOR \n");
  if (lRet = LINTER_OpenCursor(nConnID, &nCursID, CursorName, Lengh, mAutocommit))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_OpenCursor");
  else
    printf("\n Cursor has been created successfully. \n");

  printf("\n CREATING A STATEMENT \n");
  if (lRet = LINTER_CreateStatement(nConnID, cQuery, 0, &nStmtID))
    PrintError(lRet, 0, 0, nStmtID, "Error Linter_CreateStatement");
  else
    printf("\n Statement has been created successfully. \n");

  printf("\n EXECUTING STATEMENT \n");                                                                                               
  if (lRet = LINTER_ExecuteStatement(nCursID, nStmtID, NULL, NULL, NULL))    
    PrintError(lRet, 0, 0, nStmtID, "Error Linter_ExecuteStatement");
  else                                                                
    printf("\n Statement has been executed successfully. \n");       

  printf("\n GETTING OPTIONS OF CURSOR \n");
  if (lRet = LINTER_GetCursorOption (nCursID, cCursorName, 1, Ans, &len))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_GetCursorOption");
  else
    printf("\n Options of cursor has been getted successfully. \n");
    printf("\n Name of cursor - %s, Lengh of name - %d \n", Ans, len );

  printf("\n BINDING OF ANSWER \n");
  if (lRet = LINTER_BindAnswer(nCursID, nStmtID, 1, &B->PersonID, N, 
                               sizeof(Answ_Type), tInt, sizeof(L_LONG), 0, 0, NULL))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_BindAnswer");
  else
  {
  if (lRet = LINTER_BindAnswer(nCursID, nStmtID, 2, B->Name, N, sizeof(Answ_Type), 
                               tChar, sizeof(Name_Type), 0, 0, NULL))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_BindAnswer");
  else
    printf("\n Answer has been binded successfully. \n");}

  printf("\n FETCHING OF DATA \n");
  if (lRet = LINTER_Fetch(nCursID, toNext, 0, 1, NULL, NULL, NULL))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_Fetch");
  else
  {
    sum = 0;
  do
  {
    if (lRet = LINTER_Fetch(nCursID, toNext, 0, 1, NULL, NULL, NULL))
      break;
    else
      sum = sum + 1;
    printf("\n PersonID = %d, Name = %.20s ",B[0].PersonID, B[0].Name);		
  }
  while(lRet == 0) ;
    printf("\n\n summa = %d \n", sum);
    printf("\n Data has been fetched successfully. \n");
  }
                                 
  /* Here is the main section of sample... */

  printf("\n UNBINDING OF ANSWER \n");
  if (lRet = LINTER_UnBindAnswer(nCursID, nStmtID, 0))
    PrintError(lRet, 0, nCursID, 0, "Error Linter_UnBindAnswer");
  else
    printf("\n Unbinding of answer has been created successfully. \n");

  /* ...End of main section */

  printf("\n FREEING STATEMENT \n");
  if (lRet = LINTER_FreeStatement(nStmtID))
    PrintError(lRet, 0, 0, nStmtID, "Error Linter_FreeStatement");
  else
    printf("\n Statement has been freed successfully. \n");

  printf("\n CLOSING CURSOR \n");
  if (lRet = LINTER_CloseCursor(nCursID))
    PrintError(lRet, 0, nCursID, 0, "");
  else
    printf("\n Cursor has been closed successfully. \n");
		
  printf ("\n CLOSING CONNECTION \n");
  if (lRet = LINTER_CloseConnect (nConnID))
    PrintError(lRet, nConnID, 0, 0, "Error Linter_CloseConnect");
  else
    printf("\n Connection has been closed successfully. \n\n");
  return 0;
}


             
