 /***************************************************************************
 *                 RELEX, Inc. Linter DBMS source code                      *
 *              This is public source code of RELEX, Inc.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                 Copyright (c) 1998-2005 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR: Pavel Pasechnik
 ----------------------------------------------------------------------------
 PURPOSE: for users
 ----------------------------------------------------------------------------
 REVISION HISTORY:
 ----------------------------------------------------------------------------

  26.09.96 -- creation date
  25.03.03 -- Sveta (code format)

*/

/*
  demo1rf.c is auxiliary module for demo1.c .
  There are functions for work with files.
  They aren't constrained with LinAPI library.
*/

#include "apidemo.h"

static FILE *fp;

int OpenFiles(char *tname)
{
  char filename[256];

  sprintf(filename, "%s.lod", tname);
  if (fp = fopen(filename, "r"))
    return (tNoError);
  else
    printf("Can't open file \"%s\"\n", filename);
  return (tError);
}

void CloseFiles(void)
{
  fclose(fp);
}

int ReadParameter(char *parameter, long *len, char sep)
{
  char *pr = parameter;

  do
  {
    *pr = fgetc(fp);
  }
  while (*pr != (char) EOF && (*pr == sep || *pr == '\n' || *pr == '\r'));
  if (*pr == (char) EOF)
    return tError;
  do
  {
    *++pr = fgetc(fp);
  }
  while (*pr != EOF && *pr != sep && *pr != '\n');
  *pr = '\0';
  *len = strlen(parameter);

  return (tNoError);
}
