/****************************************************************************
 *                 RELEX, Inc. Linter DBMS source code                      *
 *              This is public source code of RELEX, Inc.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                 Copyright (c) 2000-2010 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR: Muratova
 ----------------------------------------------------------------------------
 PURPOSE: linqt sample. db info functions.
 02.08.12 -- Galizin ( connectionName is avialable from qt 4.4 )

 ----------------------------------------------------------------------------
*/
#include <iostream>

#include <qapplication.h>
#include <qsqldatabase.h>
#include <qsqlerror.h>
#include <qdatetime.h>

#include <QByteArray>
#include <QtSql>
#include <QTableView>
#include <QSqlTableModel>
#include <QSqlQuery>


using namespace std;
int main( int argc, char ** argv )
{
  QApplication a( argc, argv );

  {
    QSqlDatabase db = QSqlDatabase::addDatabase( "QLINTER", "LinConnect");  

    cout << "Set connect name... DONE\n"; 
  
    if( !db.open("SYSTEM", "MANAGER") )
    {
      cout << "Line " << __LINE__ << " : " << db.lastError().driverText().toLocal8Bit().data() << endl;
      return 1;
    }
    
#if QT_VERSION >= 0x040400                                  /* 02.08.12 */
    cout << "connectionName: " << db.connectionName().toLocal8Bit().data()<< "\n"; 
#endif
    
    db.close();    

    cout << "Close database ... DONE\n"; 
  }

  QSqlDatabase::removeDatabase("LinConnect");

  cout << "Remove database ... DONE\n"; 
  
  return 0;
}
