/****************************************************************************
 *                 RELEX, Inc. Linter DBMS source code                      *
 *              This is public source code of RELEX, Inc.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                 Copyright (c) 2000-2010 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR: Muratova
 ----------------------------------------------------------------------------
 PURPOSE: linqt sample. tables. primaryIndex. record.
 ----------------------------------------------------------------------------
*/
#include <iostream>

#include <qapplication.h>
#include <qsqldatabase.h>
#include <qsqlerror.h>
#include <qdatetime.h>

#include <QByteArray>
#include <QtSql>
#include <QTableView>
#include <QSqlTableModel>


using namespace std;
int main( int argc, char ** argv )
{
  QApplication a( argc, argv );
  
  QSqlDatabase db = QSqlDatabase::addDatabase( "QLINTER");  
  
  
  if( !db.open("SYSTEM", "MANAGER") )
  {
    cout << "Line " << __LINE__ << " : " << db.lastError().driverText().toLocal8Bit().data() << endl;
    return 1;
  }
  
  QStringList list = db.tables(QSql::Views);
  cout << "List of tables:\n " << list.join("\n").toLocal8Bit().data() << "\n";
  
  QSqlIndex ind = db.primaryIndex("PERSON");
  cout << "Primary index of table person:\n" << ind.name().toLocal8Bit().data()<< "\n";
  
  QSqlRecord rec = db.record("PERSON");
  int i;
  cout << "count " << rec.count() << "\n";
  for (i = 0; i < rec.count(); i++ )
  { 
    cout << "record " << i << ": " << rec.fieldName(i).toLocal8Bit().data()<< "\n";
  }
  
  db.close();

  cout << "Close database ... DONE\n"; 
  
  return 0;
}
