/****************************************************************************
 *                 RELEX, Inc. Linter DBMS source code                      *
 *              This is public source code of RELEX, Inc.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                 Copyright (c) 2000-2010 RELEX Inc.                       *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR: Muratova
 ----------------------------------------------------------------------------
 PURPOSE: linqt sample. db info functions.
 ----------------------------------------------------------------------------
*/
#include <iostream>

#include <qapplication.h>
#include <qsqldatabase.h>
#include <qsqlerror.h>
#include <qdatetime.h>


#include <QByteArray>
#include <QtSql>
#include <QTableView>
#include <QSqlTableModel>


using namespace std;
int main( int argc, char ** argv )
{

  QApplication a( argc, argv );

  QSqlDatabase db = QSqlDatabase::addDatabase( "QLINTER" );
  db.setUserName( "SYSTEM" );
  db.setPassword( "MANAGER" );

  cout << "User name " << db.userName().toLocal8Bit().data() << "\n";
  cout << "Password " << db.password().toLocal8Bit().data() << "\n";
  
  db.setConnectOptions("OPTIMISTIC ;CHARSET=KOI8");
  cout << "options " << db.connectOptions().toLocal8Bit().data()<< "\n";

  if( !db.open() )
  {
    cout << "Line " << __LINE__ << " : " << db.lastError().driverText().toLocal8Bit().data() << endl;
    return 1;
  }

  cout << "driver name " << db.driverName().toLocal8Bit().data()  << "\n";
  cout << "is Linter driver available " << db.isDriverAvailable("QLINTER")<< "\n";
  
  return 0;
}
