
/* 30.07.02 - Galizin - Remove compiler warning PT#1046
   25.03.03 -- Sveta (code format)
   04.05.06 -- Pasechnik (warning)

*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "oratypes.h"
#include "ociapr.h"
#include "ocidem.h"

#define ASIZE  40
#define VCHAR2 1
#define VCHAR  9
#define STRZ   5
#define   OT_INT       3
#define   OT_FLOAT     4
#define   OT_LONG      8
#define   OT_VARRAW   15

void handle_error(Lda_Def * lda, Cda_Def * cda, char *cMessageText)
{
  char cMessageBuffer[512];

  oerhms(lda, cda->rc, cMessageBuffer, (int) sizeof(cMessageBuffer));
  fprintf(stdout, "%s\n", cMessageText);
  fprintf(stdout, "%s\n", cMessageBuffer);
}

int main(void)                  /* 30.07.02 */
{
  char message[512] = "";
  Lda_Def LDA;
  Cda_Def CDA;
  int rc;
  unsigned char HDA[256];
  text *osquery = "select rowid from test";
  text *oinnum_query = "insert into test values (:1, :2)";
  text *oinname_query = "insert into test values (:par1, :par2)";
  unsigned char par1[5][20];
  unsigned char par2[5][20];
  unsigned char ans1[5][30];
  unsigned char ans2[5][30];
  char *blobbuf = NULL;
  long bloblen;
  FILE *fp;
  char a[] = "bbbbbb";
  double b = 22;

  long val1[20];
  long val2[20];
  char val3[20 * 19];
  struct
  {
    short len;
    char val[218];
  } varchar_buf[20];
  short rlen1[20];
  short rlen2[20];
  short rlen3[20];
  short rlen4[20];
  int ret;
  int i;


  if (rc = orlon(&LDA, HDA, (text *) "SYSTEM/MANAGER", (int) -1,
                 NULL /* (text *) "MANAGER" */ , (int) -1, -1))
    handle_error(&LDA, &LDA, "orlon - connecting to the database");

  if (oopen(&CDA, &LDA, (text *) NULL, -1, -1, (text *) NULL, -1))
    handle_error(&CDA, &LDA, "oopen - opening cursor");

  if (oparse(&CDA, "SELECT * from $$$SYSRL", (sb4) - 1, (sword) 0, (ub4) 2))
    handle_error(&LDA, &CDA, "oparse - parsing sql statement");
  if (oexec(&CDA))
    handle_error(&LDA, &CDA, "oexec - executing sql statement");

  if (odefin(&CDA, 1, (ub1 *) val1, sizeof(long), OT_INT,
             -1, NULL, NULL, -1, -1, rlen1, NULL))
    handle_error(&LDA, &CDA, "odefin - bind answer");
  if (odefin(&CDA, 2, (ub1 *) val2, sizeof(long), OT_INT,
             -1, NULL, NULL, -1, -1, rlen2, NULL))
    handle_error(&LDA, &CDA, "odefin - bind answer");
  if (odefin(&CDA, 3, (ub1 *) val3, 19, STRZ,
             -1, NULL, NULL, -1, -1, rlen3, NULL))
    handle_error(&LDA, &CDA, "odefin - bind answer");
  if (odefin(&CDA, 4, (ub1 *) varchar_buf, 220, OT_VARRAW,
             -1, NULL, NULL, -1, -1, rlen4, NULL))
    handle_error(&LDA, &CDA, "odefin - bind answer");

  for (i = 0; i < 1000; i++)
  {
    printf("i=%d\n", i);
    if (ret = ofen(&CDA, 20))
    {
      if (ret == 4)
      {
        if (oexec(&CDA))
          handle_error(&LDA, &CDA, "oexec - executing sql statement");
      }
      else
      {
        printf("ret code = %d\n", ret);
        handle_error(&LDA, &CDA, "ofetch");
        exit(1);
      }
    }
  }

  ologof(&LDA);
  exit(0);

  memset(&varchar_buf, 0, sizeof(varchar_buf));

  if (odefin(&CDA, 1, (ub1 *) & varchar_buf, sizeof(varchar_buf), VCHAR,
             -1, NULL, NULL, -1, -1, NULL, NULL))
  {
    handle_error(&LDA, &CDA, "odefin - bind answer");
  }
/*
 if (ret = ofetch(&CDA))
  {
   printf("ret code = %d\n",ret);
   handle_error(&LDA, &CDA,"ofetch");
  }
 else
  {
   varchar_buf.val[varchar_buf.len] = '\0';
   printf("anslen=%d date = %s\n",varchar_buf.len,varchar_buf.val);
  }
*/
  if (oparse(&CDA, "drop table test", (sb4) - 1, (sword) 0, (ub4) 2))
    handle_error(&LDA, &CDA, "oparse - parsing sql statement");
  if (oexec(&CDA))
    handle_error(&LDA, &CDA, "oparse - parsing sql statement");
  if (oparse(&CDA, "create table test (a char(20), b numeric)", (sb4) - 1, (sword) 0, (ub4) 2))
    handle_error(&LDA, &CDA, "oparse - parsing sql statement");
  if (oexec(&CDA))
    handle_error(&LDA, &CDA, "oparse - parsing sql statement");

  if (oparse(&CDA, "insert into test values ('mmm',10)",
             (sb4) - 1, (sword) 0, (ub4) 2))
    handle_error(&LDA, &CDA, "oparse - parsing sql statement 1");
  if (oexec(&CDA))
    handle_error(&LDA, &CDA, "oparse - parsing sql statement 2");

  if (oparse(&CDA, oinname_query, (sb4) - 1, (sword) 0, (ub4) 2))
    handle_error(&LDA, &CDA, "oparse - parsing sql statement 3");

  sprintf(par1[0], "aaa");
  sprintf(par1[1], "bbbbbb");
  sprintf(par1[2], "cc");
  sprintf(par1[3], "dddd");
  sprintf(par1[4], "eeeee");
  sprintf(par2[0], "111");
  sprintf(par2[1], "22");
  sprintf(par2[2], "2222");
  sprintf(par2[3], "22222");
  sprintf(par2[4], "2");

  if (obndrv(&CDA, ":par1", -1, par1[0], 20, STRZ, -1, NULL, NULL, -1, -1))
    handle_error(&LDA, &CDA, "error obndrv 1");
  if (obndrv(&CDA, ":par2", -1, par2[0], 20, STRZ, -1, NULL, NULL, -1, -1))
    handle_error(&LDA, &CDA, "error obndrv 2");

  if (oexn(&CDA, 5, 0))
    handle_error(&LDA, &CDA, "error execute");

  if (oparse(&CDA, "select * from test",
             (sb4) - 1, (sword) 0, (ub4) 2))
    handle_error(&LDA, &CDA, "oparse - parsing sql statement 1");

  if (odefin(&CDA, 1, (ub1 *) ans1, 30, STRZ,
             -1, NULL, NULL, -1, -1, NULL, NULL))
    handle_error(&LDA, &CDA, "odefin - bind answer");
  if (odefin(&CDA, 2, (ub1 *) ans2, 30, STRZ,
             -1, NULL, NULL, -1, -1, NULL, NULL))
    handle_error(&LDA, &CDA, "odefin - bind answer");

  if (oexfet(&CDA, 5, 0, 0))
    handle_error(&LDA, &CDA, "error oexfet");
  else
  {
    printf("Answers:\n");
    for (i = 0; i < 5; i++)
      printf("%d\t%s\t%s\n", i, ans1[i], ans2[i]);
  }

  /* BLOBs testing */
  bloblen = 23942;
  blobbuf = (char *) calloc(bloblen + 1, sizeof(char));
  if (!blobbuf)
  {
    printf("NoMemory\n");
    exit(1);
  }
  fp = fopen("tblob.in", "rb");
  if (!fp)
  {
    printf("file not found\n");
    exit(1);
  }
  fread(blobbuf, bloblen, 1, fp);
  fclose(fp);

  if (oparse(&CDA, "drop table blobtest", (sb4) - 1, (sword) 0, (ub4) 2))
    handle_error(&LDA, &CDA, "oparse - parsing sql statement");
  if (oexec(&CDA))
    handle_error(&LDA, &CDA, "drop table blobtest");
  if (oparse(&CDA, "create table blobtest (a char(20), b blob)", (sb4) - 1, (sword) 0, (ub4) 2))
    handle_error(&LDA, &CDA, "oparse - parsing sql statement");
  if (oexec(&CDA))
    handle_error(&LDA, &CDA, "create table blobtest");

  printf("insert BLOB\n");
  if (oparse(&CDA, "insert into blobtest values ('mmm',:blob1)", (sb4) - 1, (sword) 0, (ub4) 2))
    handle_error(&LDA, &CDA, "oparse - parsing sql statement 1");
  if (obndrv(&CDA, ":blob1", -1, blobbuf, bloblen, OT_LONG, -1, NULL, NULL, -1, -1))
    handle_error(&LDA, &CDA, "error obndrv 2");
  if (oexec(&CDA))
    handle_error(&LDA, &CDA, "insert into blobtest");

  printf("update BLOB\n");
  if (oparse(&CDA, "update blobtest  set b = :blob1", (sb4) - 1, (sword) 0, (ub4) 2))
    handle_error(&LDA, &CDA, "oparse - parsing sql statement 1");
  if (obndrv(&CDA, ":blob1", -1, blobbuf, bloblen, OT_LONG, -1, NULL, NULL, -1, -1))
    handle_error(&LDA, &CDA, "error obndrv 2");
  if (oexec(&CDA))
    handle_error(&LDA, &CDA, "update blobtest");

  printf("get BLOB\n");
  if (oparse(&CDA, "select * from blobtest",
             (sb4) - 1, (sword) 0, (ub4) 2))
    handle_error(&LDA, &CDA, "oparse - parsing sql statement 1");
  if (oexec(&CDA))
    handle_error(&LDA, &CDA, "select * from test");
  memset(blobbuf, 0, bloblen);
  fp = fopen("blob.out", "wb");
  if (oflng(&CDA, 2, blobbuf, bloblen, OT_LONG, (ub4 *) &bloblen, 0))
    handle_error(&LDA, &CDA, "oflng");
  fwrite(blobbuf, bloblen, 1, fp);
  fclose(fp);

  oclose(&CDA);
  ologof(&LDA);

  printf("Done.\n");

  return 0;                     /* 30.07.02 */
}
