
/* 30.07.02 - Galizin - Remove compiler warning PT#1046
   25.03.03 -- Sveta (code format)
   29.04.03 -- Galizin ( Return value added )
*/

#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include "oratypes.h"
#include "ociapr.h"
#include "ocidem.h"

#define ASIZE 40

void handle_error(Lda_Def * lda, Cda_Def * cda, char *cMessageText)
{
  char cMessageBuffer[512];

  oerhms(lda, cda->rc, cMessageBuffer, (int) sizeof(cMessageBuffer));
  fprintf(stdout, "%s\n", cMessageText);
  fprintf(stdout, "%s\n", cMessageBuffer);
}

int main()                      /* 30.07.02 */
{
  Lda_Def *LDA;
  Cda_Def *CDA;
  unsigned char HDA[256];
  text *UPDATEstmt = "update auto set make=:1 where make=:2 and rowid=:3";
  text *SELECTstmt = "SELECT MODEL FROM AUTO;";
  ub1 *param, *param1, *param2;
  sb2 indp = 0;
  sb4 iDbsize;
  sb2 iDbtype;
  text tSelectName[20];
  sb4 iSelectNameLength = sizeof(tSelectName);
  sb4 iDisplaySize;
  sb2 iPrecision;
  sb2 iScale;
  sb2 iNullok;
  int control = 0, i;
  short error;

  printf("START!\n");
  LDA = calloc(1, sizeof(Lda_Def) + 1);
  CDA = calloc(1, sizeof(Cda_Def) + 1);
  param = calloc(4 + 1, sizeof(ub1));
  param2 = calloc(4 + 1, sizeof(ub1));
  param1 = calloc(1, sizeof(int));
  strcpy(param, "FORD");
  strcpy(param2, "LADA");
  *param1 = 1;

  if (error = orlon(LDA, HDA, (text *) "SYSTEM/MANAGER", (int) -1,
                    (text *) "MANAGER", (int) -1, -1))
    handle_error(LDA, LDA, "orlon - connecting to the database");

  if (oopen(CDA, LDA, (text *) NULL, -1, -1, (text *) NULL, -1))
    handle_error(CDA, LDA, "oopen - opening cursor");

  if (oparse(CDA, SELECTstmt, (sb4) - 1, (sword) 0, (ub4) 2))
    handle_error(LDA, CDA, "oparse - parsing sql statement");

/* Descrybing the select list */

  for (i = 1;; i++)
  {
    iSelectNameLength = sizeof(tSelectName);
    odescr(CDA, (sword) i, &iDbsize, &iDbtype, (sb1 *) tSelectName,
           &iSelectNameLength, &iDisplaySize, &iPrecision,
           &iScale, &iNullok);
    if (CDA->rc == 1007)
      break;
    if (CDA->rc != 0)
    {
      handle_error(LDA, CDA, "odescr - describing select list");
      break;
    }
    else
      printf("Column %d, %s, has type %d, precision %d, \
     scale %d, length %d.\n", i,
             tSelectName, iDbtype, iPrecision, iScale, iDisplaySize);
    if (iNullok)
      printf("This column allows nulls.\n");
    else
      printf("This column does not allow nulls.\n");

    return 0;                   /* 30.07.02 */
  }


/*
 if (obndrv(CDA, (text *) ":sss", (sword) -1, (ub1 *) param,
     (sword) strlen(param), (sword) STRING_TYPE, (sword) -1,
      &indp, (text *) NULL,(sword) -1, (sword) -1))
  handle_error(LDA, CDA,"obndrv - bind param");
*/

  if (oparse(CDA, UPDATEstmt, (sb4) - 1, (sword) 0, (ub4) 2))
    handle_error(LDA, CDA, "oparse - parsing sql statement");

  if (obndrn(CDA, (sword) 1, (ub1 *) param2,
             (sword) strlen(param), (sword) STRING_TYPE, (sword) - 1,
             &indp, (text *) NULL, (sword) - 1, (sword) - 1))
    handle_error(LDA, CDA, "obndrn - bind param");
  if (obndrn(CDA, (sword) 2, (ub1 *) param,
             (sword) strlen(param), (sword) STRING_TYPE, (sword) - 1,
             &indp, (text *) NULL, (sword) - 1, (sword) - 1))
    handle_error(LDA, CDA, "obndrn - bind param");
  if (obndrn(CDA, (sword) 3, (ub1 *) param1,
             sizeof(int), (sword) INT_TYPE, (sword) - 1,
             &indp, (text *) NULL, (sword) - 1, (sword) - 1))
    handle_error(LDA, CDA, "obndrn - bind param");

  if (oexec(CDA))
    handle_error(LDA, CDA, "oexec - executing");


  if (oclose(CDA))
    handle_error(LDA, CDA, "oclose - closing cursor");

  if (ologof(LDA))
  {
    free(CDA);
    free(LDA);
    free(param);
    handle_error(LDA, LDA, "ologof - disconnecting from database");
    return -1;                                              /* 29.04.03 */
  }
  free(CDA);
  free(LDA);
  free(param);
  printf("FINISH!\n");
}
