 /***************************************************************************
 *                 RELEX, Ltd. Linter DBMS source code                      *
 *              This is public source code of RELEX, Ltd.                   *
 *                                                                          *
 *      You have a royalty-free right to use, modify, reproduce and         *
 *     distribute the Sample Files (and/or any modified version) in         *
 *        any way you find useful, provided that you agree that             *
 *       RELEX has no warranty obligations or liability for any             *
 *           Sample Application Files which are modified.                   *
 *                                                                          *
 *                Copyright (c) 1990 - 2001 RELEX Ltd.                      *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Ltd.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR: Maxim V. Kositsin
 ----------------------------------------------------------------------------
 PURPOSE: TPC Benchmark B
 ----------------------------------------------------------------------------
 REVISION HISTORY:
   21.09.01 - Galizin - For QNX console running
   09.10.01 -- Maxim -- add __strupr function
   30.11.01 -- Maxim -- change & -> &&
   30.11.01 -- Maxim -- correct types
   05.03.02 -- Galizin -- Change command line handle. For VxWorks
   13.03.02 -- Galizin -- Delay for Usix
   28.03.03 -- Sveta (Code format)
   13.09.03 -- Kononyhin (_RunTPCB=FALSE in init dialog)
   23.12.03 -- Svetlana (Revisions for error messages, output results, progress
                         bar...)
   20.01.04 -- Svetlana (message for console version)
   27.06.12 -- Egorov  (x64)
   19.07.12 -- Galizin (OpenVMS)
 ------------------------------------------------------------
*/

#if defined(UNIX) || defined(VXWORKS) || defined(QNX) || defined(VMS)/* 19.07.12 21.09.01 */
#define TPCB_CONSOLE
#endif

#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#ifdef WIN32
#include <windows.h>
#include <commctrl.h>
#endif
#if _MSC_VER <= 1200
# define SetClassLongPtr SetClassLong
# define GCLP_HICON GCL_HICON
#endif
/* ODBC SDK 2.x header files */
#include <sql.h>
#include <sqlext.h>

#if defined(VXWORKS)            /* 05.03.02 */
#include "vxstart.h"
#endif

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

void ODBC_TestErr1(char *s, int err, HSTMT Stm);
void ODBC_TestInfo1(char *s, int err, HSTMT Stm);
void _Mess(char *str);
long RandomNumber(unsigned long x, unsigned long y);
void DoOne(long Bid, long Tid, long Aid, long delta);
void CreateDatabase(void);
void RunTPCB(void);
void PeekAllMessage(void);
void PutSpeedBar(int Percent);
#if defined(VMS)
#define Prepare LocalTpcbPrepare                            /* 19.07.12 */
#endif
void Prepare(void);

#ifdef WIN32
#define ID_LISTBOX      110                                /* 23.12.03 */
#define ID_DATASOURCE   101
#define ID_USERNAME	102
#define ID_PASSWORD	103
#define ID_ACCOUNTS	104
#define ID_TIME         105
#define ID_EXIT         106
#define ID_FILE         195
#define IDC_PROGRESS1   1002

HBRUSH bl, wt;
HWND hwnd;
LPSTR szTitle = "ODBC";
HWND HWindow;
HANDLE hInst;
HFONT hFont;                                                  /* 23.12.03 */
BOOL FAR PASCAL DialogTPCB(HWND hDlg, unsigned mess, WORD wParam, LONG lParam);

#endif

HENV Env;                       /* environment handle */
HDBC Dbc;                       /* connect handle     */
HSTMT Stmt;                     /* statement handle   */

HSTMT StmtUA;
HSTMT StmtSA;
HSTMT StmtUT;
HSTMT StmtUB;
HSTMT StmtIH;

long diff, summa, summa1, summa2, summa3;

time_t first, second;
long worktime;
int rnd;
char DSstr[50];

#define ODBC_TestErr(str,err,stm) { int e; e = err; \
   if ( e == SQL_SUCCESS_WITH_INFO )\
          ODBC_TestInfo1(str,e,stm);\
   else if ( e != SQL_SUCCESS )\
      { ODBC_TestErr1(str,e,stm); return; } }
                                                          /* 23.12.03... */
#define ODBC_TestErr2(str,err,stm) { int e; e = err; \
   if ( e == SQL_SUCCESS_WITH_INFO )\
          ODBC_TestInfo1(str,e,stm);\
   else if ( e != SQL_SUCCESS )\
      { ODBC_TestErr1(str,e,stm); } }
                                                          /* ...23.12.03 */
char szDSN[50], szUser[50], szPassword[50]; 

long tps = 1;
long nbranches = 1;
long ntellers = 10;
long naccounts;
long nhistory;
long Abalance;
BOOL Master = TRUE;
BOOL _RunTPCB = TRUE;

BOOL mm = FALSE;
BOOL ca1 = FALSE;
BOOL ca2 = FALSE;
BOOL ca3 = FALSE;
BOOL ca4 = FALSE;
BOOL ca5 = FALSE;
BOOL ca6 = FALSE;
FILE *OutputFile = NULL;
char filename[512];

#define SWITCH_SYMBOL1 '-'
#if defined(UNIX) || defined(OS9000)
#define SWITCH_SYMBOL2 '-'
#define TPCB_CONSOLE
#else
#define SWITCH_SYMBOL2 '/'
#endif
void Delay(unsigned duration);

static char *__strlwr(char *str)
{
  char *sv = str;

  while (*str)
  {
    if (*str >= 65 && *str <= 90)
      *str += 32;
    str++;
  }                             /* while */
  return sv;
}

/*-----------------------------------------------------------
  Created:    09.10.01 12:13 by Maxim V. Kositsin
  Comments:
  -----------------------------------------------------------*/
static char *__strupr(char *str)
{
  char *sv = str;

  while (*str)
  {
    if (*str >= 97 && *str <= 122)
      *str -= 32;
    str++;
  }                             /* while */
  return sv;
}

                                                            /* 05.03.02 ... */
static char *GetParam(int Argc, char **Argv, char *Key)
{
  int i;
  int len = strlen(Key);
  int l;

  for (i = 1; i < Argc; i++)
  {
    if (*Argv[i] != '/' && *Argv[i] != '-')
      continue;
    for (l = 0; (*(Argv[i] + 1 + l) != 0) && (*(Argv[i] + 1 + l) != '='); l++)
      ;
    if (l == len)
    {
      int j;

      for (j = 0; j < len; j++)
        if (toupper(Argv[i][1 + j]) != toupper(Key[j]))
          break;
      if (j == len)
      {
        if (Argv[i][len + 1] == '=')
          return &Argv[i][len + 2];
        else
        {
          if (&Argv[i + 1][0])
            return &Argv[i + 1][0];
          else
            return &Argv[i][len + 1];
        }
      }
    }
  }
  return NULL;
}
                                                       /* ... 05.03.02 */

void usage(void)
{
  printf(
         "Usage:\n"
         "  tpcb <-ds DATASOURCE>     --- data source name\n"         
         "       <-u NAME/PASSWORD>   --- name and password\n"
         "       <-a ACCOUNTSNUM>     --- number of accounts\n"
         "       <-t TIME>            --- working time (min)\n"
         "       [-f OUTPUTFILE]      --- output file name\n"
         "       [-s|-m]              --- master/slave mode\n"
  );
  exit(0);
}

#ifdef TPCB_CONSOLE
#ifdef VXWORKS                  /* 05.03.02 */
MainStart(tpcb, 256 * 1024, UninitLinterClient)
#else
int main(int argc, char *argv[])
#endif
{
  char arg[512], *q, *param;

  _RunTPCB = FALSE;                                 /* 05.03.02 ... */
  if (param = GetParam(argc, argv, "ds"))
  {
    strncpy(szDSN, param, 50);
    szDSN[49] = 0;
  }
  else
    szDSN[0] = 0;
  strcpy(DSstr, szDSN);
  __strupr(DSstr);                                  /* 09.10.01 */


  if ((param = GetParam(argc, argv, "u")) == NULL)
    param = "SYSTEM/MANAGER";
  strncpy(arg, param, 256);
  arg[255] = 0;
  q = strchr(arg, '/');
  if (q)
  {
    *q++ = 0;
    strncpy(szPassword, q, 50);
    szPassword[49] = 0;
  }
  strncpy(szUser, arg, 50);
  szUser[49] = 0;

  if (param = GetParam(argc, argv, "a"))
    naccounts = atol(param);
  else
    naccounts = 1000;

  if (param = GetParam(argc, argv, "t"))
    worktime = atol(param) * 60;
  else
    worktime = 300;

  if (param = GetParam(argc, argv, "f"))
    strncpy(filename, param, 512);
  else
    filename[0] = 0;
  filename[511] = 0;

  if (GetParam(argc, argv, "s"))
    Master = FALSE;
  else
    Master = TRUE;
  _RunTPCB = TRUE;

  if (!GetParam(argc, argv, "s") &&
      !GetParam(argc, argv, "m"))
  {
    usage();
    return 0;
  }                                                 /* ... 05.03.02 */


  if (filename[0])
    OutputFile = fopen(filename, "wb");
  if (OutputFile)
  {
    fprintf(OutputFile, "Data source: \t%s\n", szDSN);
    fprintf(OutputFile, "Accounts:    \t%ld\n", naccounts);
  }

  RunTPCB();
  if (OutputFile)
    fclose(OutputFile);
}

#else
int PASCAL WinMain(hInstance, hPrevInstance, lpszCmdLine, nCmdShow)
                   HANDLE hInstance;
                   HANDLE hPrevInstance;
                   LPSTR lpszCmdLine;
                   int nCmdShow;
{
  hInst = hInstance;
                                                          /* 23.12.03... */
  hFont = CreateFont(8, 0, 0, 0, FW_NORMAL, 0, 0, 0, ANSI_CHARSET, OUT_DEFAULT_PRECIS,
              CLIP_DEFAULT_PRECIS, DEFAULT_QUALITY, 
              DEFAULT_PITCH|FW_DONTCARE, "MS Sans Serif"); /* ...23.12.03 */
  HWindow = DialogBox(hInstance, "DIALOG_1", NULL, DialogTPCB);
  return 0;
}
#endif

#ifndef TPCB_CONSOLE
BOOL FAR PASCAL DialogTPCB(HWND hDlg, unsigned mess, WORD wParam, LONG lParam)
{
  char str[50];
  HICON hic;

  HWindow = hDlg;
  switch (mess)
  {
    case WM_INITDIALOG:
      _RunTPCB = FALSE;                                    /* 13.09.03 */
      bl = CreateSolidBrush(RGB(0, 0, 255));
      wt = CreateSolidBrush(RGB(255, 255, 255));
      hic = LoadIcon(hInst, "ICON_1");
#if defined(WIN32)
      SetClassLongPtr(hDlg, GCLP_HICON, hic);
#else
      SetClassWord(hDlg, GCW_HICON, hic);
#endif
      SendDlgItemMessage(hDlg, 150, BM_SETCHECK, TRUE, 0);
      EnableWindow(GetDlgItem(hDlg, IDCANCEL), FALSE);
                                                                /* 23.12.03... */
      {
        char DSNbuf[200];
        int  bufLen;        
        SQLRETURN ret;

        ODBC_TestErr("SQLAllocEnv", SQLAllocEnv((HENV *) & Env), Stmt);
        ODBC_TestErr2("SQLDataSources",
                 ret = SQLDataSources(Env, SQL_FETCH_FIRST_SYSTEM, DSNbuf,
               sizeof(DSNbuf), &bufLen, NULL, 0, NULL), 0);
        while(ret == SQL_SUCCESS || ret == SQL_SUCCESS_WITH_INFO)
        {   
          SendDlgItemMessage(hDlg, ID_DATASOURCE, CB_ADDSTRING, 0, (LPARAM)DSNbuf);
          ret = SQLDataSources(Env, SQL_FETCH_NEXT, DSNbuf,
                       sizeof(DSNbuf), &bufLen, NULL, 0, NULL);         
        }/* while */
        ODBC_TestErr("SQLFreeEnv", SQLFreeEnv(Env), Stmt);
      }
                                                                    /* ...23.12.03 */
      return FALSE;
    case WM_COMMAND:
      switch (wParam)
      {
        case IDCANCEL:
          _RunTPCB = FALSE;
          return TRUE;
        case IDOK:
          GetDlgItemText(hDlg, ID_DATASOURCE, szDSN, 50);
          strcpy(DSstr, szDSN);
          __strupr(DSstr);      /* 09.10.01 */          
          GetDlgItemText(hDlg, ID_USERNAME, szUser, 50);
          GetDlgItemText(hDlg, ID_PASSWORD, szPassword, 50);
          GetDlgItemText(hDlg, ID_ACCOUNTS, str, 50);
          GetDlgItemText(hDlg, ID_FILE, filename, 50);
          if (filename[0])
            OutputFile = fopen(filename, "wb");
          naccounts = atol(str);
          if (OutputFile)
          {
            fprintf(OutputFile, "Data source: \t%s\n", szDSN);
            fprintf(OutputFile, "Accounts:    \t%ld\n", naccounts);
          }

          GetDlgItemText(hDlg, ID_TIME, str, 50);
          if (SendDlgItemMessage(hDlg, 150, BM_GETCHECK, 0, 0))
            Master = TRUE;
          else
            Master = FALSE;
          worktime = atol(str) * 60;
          if (naccounts <= 0 || worktime <= 0)
          {
            MessageBox(NULL, "Invalid parameter!", "Error", MB_OK | MB_ICONSTOP);
            return TRUE;
          }                     /* if */
          _RunTPCB = TRUE;
          RunTPCB();
          EnableWindow(GetDlgItem(HWindow, IDOK), TRUE);
          EnableWindow(GetDlgItem(HWindow, IDCANCEL), FALSE);
          EnableWindow(GetDlgItem(HWindow, ID_EXIT), TRUE);
          if (OutputFile)
            fclose(OutputFile);
          OutputFile = NULL;
          return TRUE;
        case ID_EXIT:
          if (_RunTPCB == TRUE)
            return TRUE;
          goto ex;
      }
      return TRUE;
    case WM_CLOSE:
  ex:
      DeleteObject(bl);
      DeleteObject(wt);
      DeleteObject(hFont);                                       /* 23.12.03 */
      EndDialog(hDlg, FALSE);
      PostQuitMessage(0);
      return TRUE;
    default:
      break;
  }
  return FALSE;
}
#endif

void RunTPCB(void)
{
  int j;
  char string[100];
  long nb, nt, na, delta;
  long tm, tmold = 0, tml;
  float tr = 0, trl = 0;

#ifndef TPCB_CONSOLE
  EnableWindow(GetDlgItem(HWindow, IDOK), FALSE);
  EnableWindow(GetDlgItem(HWindow, IDCANCEL), TRUE);
  EnableWindow(GetDlgItem(HWindow, ID_EXIT), FALSE);
#endif

  if (Master)
    _Mess("Master connected...");
  else
    _Mess("Slave connected...");
  ODBC_TestErr("SQLAllocEnv", SQLAllocEnv((HENV *) & Env), Stmt);
  ODBC_TestErr("SQLAllocConnect", SQLAllocConnect(Env, (HDBC *) & Dbc), Stmt);

  if (strstr(DSstr, "LINTER"))
  {
    char str[512], szConnStrOut[256];
    WORD len;
    sprintf(str, "DSN=%s;UID=%s;PWD=%s;TXN=PESSIMISTIC;", szDSN, szUser, szPassword);
    ODBC_TestErr("SQLDriverConnect",
                 SQLDriverConnect(Dbc, NULL, str, SQL_NTS, szConnStrOut, 256, &len, SQL_DRIVER_NOPROMPT), Stmt);
  }                             /* if */
  else
    ODBC_TestErr("SQLConnect", SQLConnect(Dbc, szDSN, SQL_NTS,
                            szUser, SQL_NTS, szPassword, SQL_NTS), Stmt);

  if (memcmp(DSstr, "ORACLE", 6) != 0)
    ODBC_TestErr("SQLSetConnectOption", SQLSetConnectOption(Dbc, SQL_AUTOCOMMIT, SQL_AUTOCOMMIT_OFF), Stmt);

  if (memcmp(DSstr, "ORACLE", 6) == 0)
    ODBC_TestErr("SQLSetConnectOption", SQLSetConnectOption(Dbc, SQL_AUTOCOMMIT, SQL_AUTOCOMMIT_OFF), Stmt);

  ODBC_TestErr("SQLAllocStmt", SQLAllocStmt(Dbc, (HSTMT *) & Stmt), Stmt);
  ca1 = TRUE;
  mm = TRUE;

  if (Master == TRUE)
    CreateDatabase();
  else
  {
    _Mess("Waiting for master...");
    while (SQLExecDirect(Stmt, "SELECT COUNT(*) FROM BEGIN_TPCB", SQL_NTS) !=
           SQL_SUCCESS)
      PeekAllMessage();
    _Mess("Master started.");
  }
  if (_RunTPCB == FALSE)
  {
    _Mess("Insert Break!");
    goto Done;
  }

  ODBC_TestErr("SQLTransact", SQLTransact(Env, Dbc, SQL_COMMIT), Stmt);/* 23.12.03 */
  ODBC_TestErr("SQLFreeStmt", SQLFreeStmt(Stmt, SQL_DROP), Stmt);
  ca1 = FALSE;

  ODBC_TestErr("SQLDisconnect", SQLDisconnect(Dbc), Stmt);
  ODBC_TestErr("SQLFreeConnect", SQLFreeConnect(Dbc), Stmt);
  ODBC_TestErr("SQLFreeEnv", SQLFreeEnv(Env), Stmt);

  ODBC_TestErr("SQLAllocEnv", SQLAllocEnv((HENV *) & Env), Stmt);
  ODBC_TestErr("SQLAllocConnect", SQLAllocConnect(Env, (HDBC *) & Dbc), Stmt);

  if (memcmp(DSstr, "ORACLE", 6) != 0)
    ODBC_TestErr("SQLSetConnectOption", SQLSetConnectOption(Dbc, SQL_AUTOCOMMIT, 0), Stmt);

  ODBC_TestErr("SQLConnect", SQLConnect(Dbc, szDSN, SQL_NTS,
                            szUser, SQL_NTS, szPassword, SQL_NTS), Stmt);

  if (memcmp(DSstr, "ORACLE", 6) == 0)
    ODBC_TestErr("SQLSetConnectOption", SQLSetConnectOption(Dbc, SQL_AUTOCOMMIT, 0), Stmt);

  ODBC_TestErr("SQLAllocStmt", SQLAllocStmt(Dbc, (HSTMT *) & StmtUA), StmtUA);
  ca2 = TRUE;
  ODBC_TestErr("SQLAllocStmt", SQLAllocStmt(Dbc, (HSTMT *) & StmtSA), StmtSA);
  ca3 = TRUE;
  ODBC_TestErr("SQLAllocStmt", SQLAllocStmt(Dbc, (HSTMT *) & StmtUT), StmtUT);
  ca4 = TRUE;
  ODBC_TestErr("SQLAllocStmt", SQLAllocStmt(Dbc, (HSTMT *) & StmtUB), StmtUB);
  ca5 = TRUE;
  ODBC_TestErr("SQLAllocStmt", SQLAllocStmt(Dbc, (HSTMT *) & StmtIH), StmtIH);
  ca6 = TRUE;

  Prepare();
  if (_RunTPCB == FALSE)
    goto Done;

  _Mess("Begin TPC-B");

#ifdef TPCB_CONSOLE
  _Mess("        Time                      Local speed                      Global speed");
#endif

  PutSpeedBar(0);
  first = time(NULL);
  do
  {
    for (j = 0; j < 40; j++)
    {
      nb = 0;
      nt = RandomNumber(0L, 9L);
      na = RandomNumber(0L, naccounts - 1);
      delta = RandomNumber(0L, 999999L);
      rnd = RandomNumber(0L, 999L);
      if (rnd < 500)
        delta = -delta;
      DoOne(nb, nt, na, delta);
      if (_RunTPCB == FALSE)
        break;
      tr++;
      trl++;
    }
    second = time(NULL);
    tm = (int) difftime(second, first);
    if (tm - tmold > 7)
    {
      tml = tm - tmold;
      memset(string, ' ', 100);
      sprintf(string, "        %02ld:%02ld          |              %.2f ", tm / 60, tm % 60, trl / tml);
      string[strlen(string)] = ' ';
      sprintf(string + 59, "|            %.2f ", tr / tm);
      _Mess(string);
      PutSpeedBar(tm * 100 / worktime);
      tmold = tm;
      trl = 0;
    }
  } while (tm < worktime && _RunTPCB == TRUE);  /* 30.11.01 */

  PutSpeedBar(100);
  _Mess("Processing: 100% The end - OK!");

  ODBC_TestErr("SQLAllocStmt", SQLAllocStmt(Dbc, (HSTMT *) & Stmt), Stmt);
  ca1 = TRUE;

  if (Master == TRUE)
  {
    long l1 = 0, l2 = 0, l3 = 0, Repeat = 5;
    long _summa = 0, w = 0;

    _Mess("Results:");
    SQLFreeStmt(Stmt, SQL_RESET_PARAMS);
    SQLFreeStmt(Stmt, SQL_UNBIND);
    SQLFreeStmt(Stmt, SQL_CLOSE);
    ODBC_TestErr("SQLExecDirect", SQLExecDirect(Stmt, "SELECT COUNT(*) FROM HISTORY", SQL_NTS), Stmt);
    ODBC_TestErr("SQLFetch", SQLFetch(Stmt), Stmt);
    SQLGetData(Stmt, 1, SQL_C_LONG, &nhistory, sizeof(long), 0);

    sprintf(string, "  Transactions:       %ld", nhistory);
    _Mess(string);
    sprintf(string, "  Work time:          %02ld:%02ld", tm / 60, tm % 60);
    _Mess(string);
    sprintf(string, "  Speed:              %6.3f tps", ((float) nhistory) / ((float) tm));
    _Mess(string);
begin:
    SQLFreeStmt(Stmt, SQL_CLOSE);
    ODBC_TestErr("SQLExecDirect", SQLExecDirect(Stmt,
                   "SELECT SUM(BBALANCE) FROM BRANCHES", SQL_NTS), Stmt);
    SQLBindCol(Stmt, 1, SQL_C_LONG, &summa, sizeof(long), NULL);
    ODBC_TestErr("SQLFetch", SQLFetch(Stmt), Stmt);
    SQLFreeStmt(Stmt, SQL_UNBIND);
    SQLFreeStmt(Stmt, SQL_CLOSE);
    ODBC_TestErr("SQLExecDirect", SQLExecDirect(Stmt,
                    "SELECT SUM(TBALANCE) FROM TELLERS", SQL_NTS), Stmt);
    SQLBindCol(Stmt, 1, SQL_C_LONG, &summa1, sizeof(long), NULL);
    ODBC_TestErr("SQLFetch", SQLFetch(Stmt), Stmt);
    SQLFreeStmt(Stmt, SQL_UNBIND);
    SQLFreeStmt(Stmt, SQL_CLOSE);
    ODBC_TestErr("SQLExecDirect", SQLExecDirect(Stmt,
                   "SELECT SUM(ABALANCE) FROM ACCOUNTS", SQL_NTS), Stmt);
    SQLBindCol(Stmt, 1, SQL_C_LONG, &summa2, sizeof(long), NULL);
    ODBC_TestErr("SQLFetch", SQLFetch(Stmt), Stmt);
    SQLFreeStmt(Stmt, SQL_RESET_PARAMS);
    SQLFreeStmt(Stmt, SQL_UNBIND);
    SQLFreeStmt(Stmt, SQL_CLOSE);
    ODBC_TestErr("SQLExecDirect", SQLExecDirect(Stmt,
                       "SELECT SUM(DELTA) FROM HISTORY", SQL_NTS), Stmt);
    SQLBindCol(Stmt, 1, SQL_C_LONG, &summa3, sizeof(long), NULL);
    ODBC_TestErr("SQLFetch", SQLFetch(Stmt), Stmt);
    SQLFreeStmt(Stmt, SQL_UNBIND);                     /* 23.12.03 */
    SQLFreeStmt(Stmt, SQL_CLOSE);                      /* 23.12.03 */
    if (((summa == summa1) && (summa2 == summa3)) && summa == summa2)
      sprintf(string, "  Balance:            %ld", summa);
    else
    {
      if (Repeat == 0)
      {
        sprintf(string, "  Error! B=%ld, T=%ld, A=%ld, H=%ld", summa, summa1, summa2, summa3);
      }
      else
      {
        if (w == 0)
        {
          w = 1;
          _Mess("Waiting for slave stoped...");
        }                       /* if */
        if (_summa == summa + summa1 + summa2 + summa3)
          Repeat--;
        _summa = summa + summa1 + summa2 + summa3;
        Delay(30);
        printf("*");
        fflush(stdout);
        goto begin;
      }
    }

    _Mess(string);
    _Mess("Master Done.");
#ifndef TPCB_CONSOLE
    if (OutputFile)
    {
      int i;
      char str[150];
      LRESULT nInd = SendDlgItemMessage(HWindow, ID_LISTBOX, LB_GETCOUNT, 0, str); /* 23.12.03 */ /* 30.11.01 */

      for (i = 0; i < nInd; i++)
      {
        SendDlgItemMessage(HWindow, ID_LISTBOX, LB_GETTEXT, i, (LPARAM) str);/* 23.12.03 */
        fprintf(OutputFile, "\n%s", str);
      }
    }
#endif
  }
  else
    _Mess("Slave Done.");
Done:
  /*ODBC_TestErr("SQLExecDirect", */SQLExecDirect(Stmt, "DROP TABLE BEGIN_TPCB;", SQL_NTS)/*, Stmt)*/;/* 23.12.03 */
  SQLTransact(Env, Dbc, SQL_COMMIT);
  if (mm = TRUE)
  {
    if (ca1 == TRUE)
    {
      ca1 = FALSE;
      ODBC_TestErr("SQLFreeStmt", SQLFreeStmt(Stmt, SQL_DROP), Stmt);
    }
    if (ca2 == TRUE)
    {
      ca2 = FALSE;
      ODBC_TestErr("SQLFreeStmt", SQLFreeStmt(StmtUA, SQL_DROP), StmtUA);
    }
    if (ca3 == TRUE)
    {
      ca3 = FALSE;
      ODBC_TestErr("SQLFreeStmt", SQLFreeStmt(StmtSA, SQL_DROP), StmtSA);
    }
    if (ca4 == TRUE)
    {
      ca4 = FALSE;
      ODBC_TestErr("SQLFreeStmt", SQLFreeStmt(StmtUT, SQL_DROP), StmtUT);
    }
    if (ca5 == TRUE)
    {
      ca5 = FALSE;
      ODBC_TestErr("SQLFreeStmt", SQLFreeStmt(StmtUB, SQL_DROP), StmtUB);
    }
    if (ca6 == TRUE)
    {
      ca6 = FALSE;
      ODBC_TestErr("SQLFreeStmt", SQLFreeStmt(StmtIH, SQL_DROP), StmtIH);
    }
    ODBC_TestErr("SQLDisconnect", SQLDisconnect(Dbc), Stmt);
    ODBC_TestErr("SQLFreeConnect", SQLFreeConnect(Dbc), Stmt);
    ODBC_TestErr("SQLFreeEnv", SQLFreeEnv(Env), Stmt);
    mm = FALSE;
  }                             /* if */
  _RunTPCB = FALSE;
#ifndef TPCB_CONSOLE
  EnableWindow(GetDlgItem(HWindow, IDOK), TRUE);
  EnableWindow(GetDlgItem(HWindow, IDCANCEL), FALSE);
  EnableWindow(GetDlgItem(HWindow, ID_EXIT), TRUE);
#endif
}

void CreateDatabase(void)
{
  int tmp = 0;
  long i;
  char sqlstr[200];
  char str[100];
  long dwVal1, dwVal2;

  SQLFreeStmt(Stmt, SQL_RESET_PARAMS);
  SQLFreeStmt(Stmt, SQL_UNBIND);
  SQLFreeStmt(Stmt, SQL_CLOSE);
  PutSpeedBar(0);
  SQLExecDirect(Stmt, "DROP TABLE BEGIN_TPCB", SQL_NTS);

  SQLExecDirect(Stmt, "SELECT COUNT(*) FROM ACCOUNTS", SQL_NTS);
  SQLBindCol(Stmt, 1, SQL_C_LONG, &i, sizeof(long), NULL);
  if (SQLFetch(Stmt) != SQL_SUCCESS)
    goto cont;
  if (naccounts != i)
    goto cont;

  SQLFreeStmt(Stmt, SQL_RESET_PARAMS);
  SQLFreeStmt(Stmt, SQL_UNBIND);
  SQLFreeStmt(Stmt, SQL_CLOSE);
  _Mess("Tables already exists, don't created...");
  _Mess("Delete from history...");
  PutSpeedBar(20);
  ODBC_TestErr("SQLExecDirect", SQLExecDirect(Stmt, "DELETE FROM HISTORY", SQL_NTS), Stmt);
  ODBC_TestErr("SQLTransact", SQLTransact(Env, Dbc, SQL_COMMIT), Stmt);
  _Mess("Update accounts...");

  PutSpeedBar(40);
  SQLExecDirect(Stmt, "UPDATE ACCOUNTS SET ABALANCE = 0 WHERE AID=0", SQL_NTS);
  ODBC_TestErr("SQLTransact", SQLTransact(Env, Dbc, SQL_COMMIT), Stmt);
  SQLFreeStmt(Stmt, SQL_RESET_PARAMS);
  SQLFreeStmt(Stmt, SQL_UNBIND);
  SQLFreeStmt(Stmt, SQL_CLOSE);
  ODBC_TestErr("SQLExecDirect", SQLExecDirect(Stmt,
                   "SELECT SUM(ABALANCE) FROM ACCOUNTS", SQL_NTS), Stmt);
  SQLBindCol(Stmt, 1, SQL_C_LONG, &summa2, sizeof(long), NULL);
  ODBC_TestErr("SQLFetch", SQLFetch(Stmt), Stmt);
  SQLFreeStmt(Stmt, SQL_RESET_PARAMS);
  SQLFreeStmt(Stmt, SQL_UNBIND);
  SQLFreeStmt(Stmt, SQL_CLOSE);
  sprintf(str, "UPDATE ACCOUNTS SET ABALANCE = %ld WHERE AID=0", -summa2);
  SQLExecDirect(Stmt, str, SQL_NTS);

  _Mess("Update branches...");
  PutSpeedBar(60);
  SQLExecDirect(Stmt, "UPDATE BRANCHES SET BBALANCE = 0", SQL_NTS);
  _Mess("Update tellers...");
  PutSpeedBar(80);
  SQLExecDirect(Stmt, "UPDATE TELLERS  SET TBALANCE = 0", SQL_NTS);
  ODBC_TestErr("SQLTransact", SQLTransact(Env, Dbc, SQL_COMMIT), Stmt);

  PutSpeedBar(100);
  goto EndWork;
cont:
  SQLFreeStmt(Stmt, SQL_RESET_PARAMS);
  SQLFreeStmt(Stmt, SQL_UNBIND);
  SQLFreeStmt(Stmt, SQL_CLOSE);
  _Mess("Drop old tables...");
  PutSpeedBar(10);
  SQLExecDirect(Stmt, "DROP TABLE BRANCHES", SQL_NTS);
  PutSpeedBar(25);
  SQLExecDirect(Stmt, "DROP INDEX TID ON TELLERS", SQL_NTS);
  PutSpeedBar(40);
  SQLExecDirect(Stmt, "DROP TABLE TELLERS", SQL_NTS);
  PutSpeedBar(55);
  SQLExecDirect(Stmt, "DROP INDEX AID ON ACCOUNTS", SQL_NTS);
  PutSpeedBar(70);
  SQLExecDirect(Stmt, "DROP TABLE ACCOUNTS", SQL_NTS);
  PutSpeedBar(85);
  SQLExecDirect(Stmt, "DROP TABLE HISTORY", SQL_NTS);
  PutSpeedBar(100);

  _Mess("Create table branches...");
  PutSpeedBar(0);
  SQLExecDirect(Stmt, "CREATE TABLE BRANCHES (BID INT,BBALANCE INT,FILLER CHAR(92))", SQL_NTS);
  _Mess("Create table tellers...");
  PutSpeedBar(20);
  SQLExecDirect(Stmt, "CREATE TABLE TELLERS (TID INT,BID INT,TBALANCE INT,FILLER CHAR(88))", SQL_NTS);
  _Mess("Create table accounts...");
  PutSpeedBar(40);
  if (memcmp(DSstr, "LINTER", 6) == 0)
    SQLExecDirect(Stmt, "CREATE TABLE ACCOUNTS (AID INT,BID INT, ABALANCE INT,FILLER CHAR(88)) MAXISN 100000 MAXROW 2", SQL_NTS);
  else
    SQLExecDirect(Stmt, "CREATE TABLE ACCOUNTS (AID INT,BID INT, ABALANCE INT,FILLER CHAR(88))", SQL_NTS);
  _Mess("Create table history...");
  PutSpeedBar(60);
  SQLExecDirect(Stmt, "CREATE TABLE HISTORY (TID INT,BID INT,AID INT,DELTA INT,tim CHAR(24),FILLER CHAR(10)) ", SQL_NTS);
  SQLTransact(Env, Dbc, SQL_COMMIT);
  PutSpeedBar(100);
  _Mess("Insert new values into tables...");
  PutSpeedBar(0);
  for (i = 0; i < nbranches * tps; i++)
  {
    sprintf(sqlstr, "INSERT INTO BRANCHES(BID,BBALANCE) VALUES (%ld,0)", i);
    SQLExecDirect(Stmt, sqlstr, SQL_NTS);
    PutSpeedBar(((i + 1) * 100) / (nbranches * tps));
  }
  PutSpeedBar(0);
  for (i = 0; i < ntellers * tps; i++)
  {
    sprintf(sqlstr, "INSERT INTO TELLERS(TID,BID,TBALANCE) VALUES (%ld,%ld,0)", i, i / ntellers);
    SQLExecDirect(Stmt, sqlstr, SQL_NTS);
    PutSpeedBar(((i + 1) * 100) / (ntellers * tps));
  }
  _Mess("Insert into accounts...");

  SQLFreeStmt(Stmt, SQL_RESET_PARAMS);
  SQLFreeStmt(Stmt, SQL_UNBIND);
  SQLFreeStmt(Stmt, SQL_CLOSE);
  if (memcmp(DSstr, "ORACLE", 6) != 0)
  {
    ODBC_TestErr("SQLPrepare", SQLPrepare(Stmt, "INSERT INTO ACCOUNTS(AID,BID,ABALANCE) VALUES (?,?,0)", SQL_NTS), Stmt);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(Stmt, 1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &dwVal1,
                                               sizeof(dwVal1), 0), Stmt);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(Stmt, 2, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &dwVal2,
                                               sizeof(dwVal2), 0), Stmt);
  }
  PutSpeedBar(0);
  for (i = 0; i < naccounts * tps; i++)
  {
    if (memcmp(DSstr, "ORACLE", 6) == 0)
    {
      sprintf(sqlstr, "INSERT INTO ACCOUNTS(AID,BID,ABALANCE) VALUES (%ld,%ld,0)", i, i / naccounts);
      SQLExecDirect(Stmt, sqlstr, SQL_NTS);
    }
    else
    {
      dwVal1 = i;
      dwVal2 = i / naccounts;
      ODBC_TestErr("SQLExecute", SQLExecute(Stmt), Stmt);
    }
    if (!((i + 1) % 100))
    {
      ODBC_TestErr("SQLTransact", SQLTransact(Env, Dbc, SQL_COMMIT), Stmt);
      PutSpeedBar(((i + 1) * 100) / (naccounts * tps));
#ifndef TPCB_CONSOLE
      PeekAllMessage();
#endif
      if (_RunTPCB == FALSE)
        return;
    }
  }

  SQLFreeStmt(Stmt, SQL_RESET_PARAMS);
  SQLFreeStmt(Stmt, SQL_UNBIND);
  SQLFreeStmt(Stmt, SQL_CLOSE);

  SQLTransact(Env, Dbc, SQL_COMMIT);

  _Mess("Create index TID...");
  ODBC_TestErr("SQLExecDirect", SQLExecDirect(Stmt, "CREATE INDEX TID ON TELLERS (TID)", SQL_NTS), Stmt);
  _Mess("Create index AID...");
  ODBC_TestErr("SQLExecDirect", SQLExecDirect(Stmt, "CREATE INDEX AID ON ACCOUNTS (AID)", SQL_NTS), Stmt);
EndWork:
  SQLTransact(Env, Dbc, SQL_COMMIT);
  SQLExecDirect(Stmt, "CREATE TABLE BEGIN_TPCB (BEG INT)", SQL_NTS);

  SQLTransact(Env, Dbc, SQL_COMMIT);
  return;
}

char timS[30];

long _Bid;
long _Aid;
long _Tid;
long _delta;

void Prepare(void)
{

  _Mess("Prepare...");

  if (memcmp(DSstr, "ORACLE", 6) == 0)
  {
    ODBC_TestErr("SQLPrepare", SQLPrepare(StmtUA, "UPDATE ACCOUNTS SET ABALANCE = ABALANCE+? WHERE AID=?", SQL_NTS), StmtUA);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtUA, 1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_FLOAT, 0, 0, &_delta, sizeof(_delta), 0), StmtUA);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtUA, 2, SQL_PARAM_INPUT, SQL_C_LONG, SQL_FLOAT, 0, 0, &_Aid, sizeof(_Aid), 0), StmtUA);

    ODBC_TestErr("SQLPrepare", SQLPrepare(StmtSA, "SELECT ABALANCE FROM ACCOUNTS WHERE AID=?", SQL_NTS), StmtSA);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtSA, 1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_FLOAT, 0, 0, &_Aid, sizeof(_Aid), 0), StmtSA);
    ODBC_TestErr("SQLBindCol", SQLBindCol(StmtSA, 1, SQL_C_LONG, &Abalance, sizeof(long), NULL), StmtSA);

    ODBC_TestErr("SQLPrepare", SQLPrepare(StmtUT, "UPDATE TELLERS SET TBALANCE = TBALANCE+?  WHERE TID=?", SQL_NTS), StmtUT);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtUT, 1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_FLOAT, 0, 0, &_delta, sizeof(_delta), 0), StmtUT);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtUT, 2, SQL_PARAM_INPUT, SQL_C_LONG, SQL_FLOAT, 0, 0, &_Tid, sizeof(_Tid), 0), StmtUT);

    ODBC_TestErr("SQLPrepare", SQLPrepare(StmtUB, "UPDATE BRANCHES SET BBALANCE = BBALANCE+?  WHERE BID=?", SQL_NTS), StmtUB);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtUB, 1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_FLOAT, 0, 0, &_delta, sizeof(_delta), 0), StmtUB);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtUB, 2, SQL_PARAM_INPUT, SQL_C_LONG, SQL_FLOAT, 0, 0, &_Bid, sizeof(_Bid), 0), StmtUB);

    ODBC_TestErr("SQLPrepare", SQLPrepare(StmtIH, "INSERT INTO HISTORY (TID,BID,AID,DELTA,TIM) VALUES (?,?,?,?,?)", SQL_NTS), StmtIH);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtIH, 1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_FLOAT, 0, 0, &_Tid, sizeof(long), 0), StmtIH);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtIH, 2, SQL_PARAM_INPUT, SQL_C_LONG, SQL_FLOAT, 0, 0, &_Bid, sizeof(long), 0), StmtIH);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtIH, 3, SQL_PARAM_INPUT, SQL_C_LONG, SQL_FLOAT, 0, 0, &_Aid, sizeof(long), 0), StmtIH);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtIH, 4, SQL_PARAM_INPUT, SQL_C_LONG, SQL_FLOAT, 0, 0, &_delta, sizeof(long), 0), StmtIH);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtIH, 5, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 0, 0, timS, 24, 0), StmtIH);
  }
  else
  {
    ODBC_TestErr("SQLPrepare", SQLPrepare(StmtUA, "UPDATE ACCOUNTS SET ABALANCE = ABALANCE+? WHERE AID=?", SQL_NTS), StmtUA);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtUA, 1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &_delta, sizeof(_delta), 0), StmtUA);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtUA, 2, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &_Aid, sizeof(_Aid), 0), StmtUA);

    ODBC_TestErr("SQLPrepare", SQLPrepare(StmtSA, "SELECT ABALANCE FROM ACCOUNTS WHERE AID=?", SQL_NTS), StmtSA);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtSA, 1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &_Aid, sizeof(_Aid), 0), StmtSA);
    ODBC_TestErr("SQLBindCol", SQLBindCol(StmtSA, 1, SQL_C_LONG, &Abalance, sizeof(long), NULL), StmtSA);

    ODBC_TestErr("SQLPrepare", SQLPrepare(StmtUT, "UPDATE TELLERS SET TBALANCE = TBALANCE+?  WHERE TID=?", SQL_NTS), StmtUT);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtUT, 1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &_delta, sizeof(_delta), 0), StmtUT);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtUT, 2, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &_Tid, sizeof(_Tid), 0), StmtUT);

    ODBC_TestErr("SQLPrepare", SQLPrepare(StmtUB, "UPDATE BRANCHES SET BBALANCE = BBALANCE+?  WHERE BID=?", SQL_NTS), StmtUB);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtUB, 1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &_delta, sizeof(_delta), 0), StmtUB);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtUB, 2, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &_Bid, sizeof(_Bid), 0), StmtUB);

    ODBC_TestErr("SQLPrepare", SQLPrepare(StmtIH, "INSERT INTO HISTORY (TID,BID,AID,DELTA,TIM) VALUES (?,?,?,?,?)", SQL_NTS), StmtIH);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtIH, 1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &_Tid, sizeof(long), 0), StmtIH);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtIH, 2, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &_Bid, sizeof(long), 0), StmtIH);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtIH, 3, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &_Aid, sizeof(long), 0), StmtIH);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtIH, 4, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &_delta, sizeof(long), 0), StmtIH);
    ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtIH, 5, SQL_PARAM_INPUT, SQL_C_CHAR, SQL_CHAR, 24, 0, timS, 24, 0), StmtIH);
  }
}

void DoOne(long Bid, long Tid, long Aid, long delta)
{
  time_t time_of_day;
  char *p;

  _Bid = Bid;
  _Aid = Aid;
  _Tid = Tid;
  _delta = delta;

  ODBC_TestErr("SQLExecute", SQLExecute(StmtUA), StmtUA);

  ODBC_TestErr("SQLFreeStmt", SQLFreeStmt(StmtSA, SQL_CLOSE), StmtSA);
  ODBC_TestErr("SQLBindParameter", SQLBindParameter(StmtSA, 1, SQL_PARAM_INPUT, SQL_C_LONG, SQL_INTEGER, 0, 0, &_Aid, sizeof(_Aid), 0), StmtSA);
  ODBC_TestErr("SQLExecute", SQLExecute(StmtSA), StmtSA);
  ODBC_TestErr("SQLFetch", SQLFetch(StmtSA), StmtSA);

  ODBC_TestErr("SQLExecute", SQLExecute(StmtUT), StmtUT);
  ODBC_TestErr("SQLExecute", SQLExecute(StmtUB), StmtUB);

  time_of_day = time(NULL);
  p = ctime(&time_of_day);
  strncpy(timS, p, sizeof(timS));
  if ((p = strchr(timS, '\n')) != NULL)
    *p = 0;

  ODBC_TestErr("SQLExecute", SQLExecute(StmtIH), StmtIH);

  ODBC_TestErr("SQLTransact", SQLTransact(Env, Dbc, SQL_COMMIT), Stmt);

#ifndef TPCB_CONSOLE
  PeekAllMessage();
#endif

}

long RandomNumber(unsigned long x, unsigned long y)
{
  unsigned long r;

  r = (unsigned long) rand();
  r *= (unsigned long) rand();
  return (r % (y - x + 1) + x);
}

void _Mess(char *str)
{
#ifndef TPCB_CONSOLE
#define LST_BOX_SIZE  100                                         /* 23.12.03... */
  char   *pstr = str;
  char    sbuf[LST_BOX_SIZE];
  LRESULT nInd;
  int     i,
          begin;
  SIZE sz;
  RECT rc;
  HWND wlb = GetDlgItem(HWindow, ID_LISTBOX); 
  HDC hDC = GetDC(wlb);

  GetClientRect(wlb, &rc); 
  SelectObject(hDC, hFont);
  memset(sbuf, 0, sizeof(sbuf));

  begin = 0;
  while(*pstr)
  {   
    for(i = begin; i < LST_BOX_SIZE - 1 && *pstr; i ++, pstr ++)
    {
      sbuf[i] = *pstr;
      GetTextExtentPoint32(hDC, sbuf, i + 1, &sz);
      if(sz.cx >= rc.right)
        break; 
    } /* for */
    nInd = SendDlgItemMessage(HWindow, ID_LISTBOX, LB_ADDSTRING, 0, sbuf);  
    memset(sbuf, 0, sizeof(sbuf));
    sbuf[0]=' ';
    sbuf[1]=' ';
    begin = 2;
  } /* while */  
  SendDlgItemMessage(HWindow, ID_LISTBOX, LB_SETCURSEL, nInd, 0);     /* ...23.12.03 */
#else
   printf("%s\n", str);
  if (OutputFile)
    fprintf(OutputFile, "%s\n", str);
  fflush(OutputFile);
  fflush(stdout);
#endif
}

int DiagMess(char *s, int err)  /* 23.12.03... */
{
  SQLCHAR      Sqlstate[20];
  SQLINTEGER   NativeError;
  SQLCHAR      MessageText[200];
  SQLSMALLINT  TextLength = 0;
  char str[200];

  SQLGetDiagRec(
     SQL_HANDLE_DBC,
     Dbc,
     1,
     Sqlstate,
     &NativeError,
     MessageText,
     200,
     &TextLength);
  if(TextLength)
  {
    sprintf(str, "%s: State = %s; Code = %d %s", s, 
                      Sqlstate, NativeError, MessageText);
    if(err != SQL_SUCCESS && err != SQL_SUCCESS_WITH_INFO)
#ifndef TPCB_CONSOLE                                             /* 20.01.04... */
      MessageBox(NULL, str, "ODBC Error", MB_OK | MB_ICONSTOP);
#else
    {
      printf("ODBC Error: %s", str);
      if (OutputFile)
        fprintf(OutputFile, "ODBC Error: %s", str);
    } /* if */
#endif                                                           /* ...20.01.04 */
    _Mess(str);
    return 1;
  }/*if*/ 
  return 0;
}                                                  /* ...23.12.03 */

void ODBC_TestErr1(char *s, int err, HSTMT Stm)
{
  char str1[200];
  char str[200];
  char state[50];                                      /* 23.12.03... */
  long coderr = 0;
  SQLSMALLINT len = 0;

  state[0] = 0;
  if(err == SQL_SUCCESS) 
    return;
  SQLError(Env, Dbc, Stm, state, &coderr, str, 200, &len);
  str1[0] = 0;
  if (coderr == 0 && !len)
  {    
    if(!DiagMess(s, err))  
      sprintf(str1, "%s return: %d", s, err);
  }/*if*/
  else
    sprintf(str1, "%s: State = %s; Code = %ld\n%s", s, state, coderr, str);
  if(strlen(str1))
  {
#ifndef TPCB_CONSOLE
    MessageBox(NULL, str1, "ODBC Error", MB_OK | MB_ICONSTOP);
#else
    printf("ODBC Error: %s", str1);
    if (OutputFile)
      fprintf(OutputFile, "ODBC Error: %s", str1);
#endif
  } /*if*/                                                          /* ...23.12.03 */

  _RunTPCB = FALSE;
  if (mm == TRUE)
  {
    if (ca1 == TRUE)
    {
      ca1 = FALSE;
      SQLFreeStmt(Stmt, SQL_DROP);
    }
    if (ca2 == TRUE)
    {
      ca2 = FALSE;
      SQLFreeStmt(StmtUA, SQL_DROP);
    }
    if (ca3 == TRUE)
    {
      ca3 = FALSE;
      SQLFreeStmt(StmtSA, SQL_DROP);
    }
    if (ca4 == TRUE)
    {
      ca4 = FALSE;
      SQLFreeStmt(StmtUT, SQL_DROP);
    }
    if (ca5 == TRUE)
    {
      ca5 = FALSE;
      SQLFreeStmt(StmtUB, SQL_DROP);
    }
    if (ca6 == TRUE)
    {
      ca6 = FALSE;
      SQLFreeStmt(StmtIH, SQL_DROP);
    }
    SQLDisconnect(Dbc);
    SQLFreeConnect(Dbc);
    SQLFreeEnv(Env);
    mm = FALSE;
  }                             /* if */
}

void ODBC_TestInfo1(char *s, int err, HSTMT Stm)
{
  char str1[200];
  char str[200];
  long coderr = 0;
  SQLSMALLINT len;

  SQLError(Env, Dbc, Stm, str1, &coderr, str, 200, &len);
                                                              /* 23.12.03... */
  if(len)
  {
    sprintf(str1, "%s: Warning! Code = %ld %s", s, coderr, str); 
    _Mess(str1);
  }/*if*/
  else if(!DiagMess(s, err))
        _Mess("%s: Unknown warning!");
                                                                /* ...23.12.03 */
}

void Delay(unsigned duration)
{
#  ifdef OS9000
  tsleep(duration * 2);
#  elif (defined(SINIX)) || defined(USIX) /* 13.03.02 */
  sleep(duration);
#  elif (defined(VXWORKS)) && !defined(OS2000)  /* 05.03.02 */
  taskDelay(duration * 55);
#  elif (defined(UNIX) || defined(QNX))
#if defined(DIGITAL_UNIX) || defined(BSD)
  usleep(duration * 1000 * 10);
#else
#if (defined(LINUX)  || defined(SUN))
  usleep(duration * 2);
#else
#if defined(AIX) || defined(HPUX) /* 04.04.01 */
  napms(duration * 55);
#else
  nap(duration * 2);
#endif
#endif
#endif
#  elif (defined(VMS))
  float Len = duration / 100;

  LIB$WAIT(&Len);
#  elif (defined(MSDOS))
  delay(duration * 100);        /* 25.09.00 */
#  elif (defined(NETWARE))
  delay(duration);
#  elif (defined(WIN32))
  Sleep(duration * 100);
#  elif (defined(INTER_OS2))
  DosSleep(duration * 50);
#else
# error "NO OS Specified"
#endif
}

void PeekAllMessage(void)
{
#ifndef TPCB_CONSOLE
  MSG msg;

  while (PeekMessage(&msg, (HWND) 0, 0, 0, PM_REMOVE))
  {
    TranslateMessage(&msg);
    DispatchMessage(&msg);
  }
#else
  Delay(1);
#endif
}

void PutSpeedBar(int Percent)
{
#ifndef TPCB_CONSOLE
  HWND hWndScaleBar;
  RECT rc, rc1;
  HDC hDC;
  static int first = 1;

  if (Percent > 100)
    Percent = 100;

  if (first)
  {
    first = 0;
    SendMessage(GetDlgItem(HWindow, IDC_PROGRESS1), PBM_SETRANGE, 0, MAKELPARAM(0, 100));/* 23.12.03 */
  }
  SendMessage(GetDlgItem(HWindow, IDC_PROGRESS1), PBM_SETPOS, Percent, 0);

  hWndScaleBar = GetDlgItem(HWindow, 120);
  GetClientRect(hWndScaleBar, &rc);

  rc.right -= 3;
  rc.left += 3;
  rc.top += 3;
  rc.bottom -= 3;
  hDC = GetDC(hWndScaleBar);

  rc1 = rc;
  rc.right = rc.left + ((rc.right - rc.left) * Percent) / 100;
  rc1.left = rc.right;
  FillRect(hDC, &rc1, wt);
  FillRect(hDC, &rc, bl);
  ReleaseDC(hWndScaleBar, hDC);
#else
  printf("%3d%%\b\b\b\b", Percent);
  fflush(stdout);
#endif
}
