use LinPerl;

open(IN, "blob.pl") || die "Can't open input file: $!";

$err = LinPerl::OpenConnect("SYSTEM", "MANAGER", "", 0, $c);
$err && LinterError($c);

$err = LinPerl::ExecDirect($c, "drop table BLTEST;");
$err = LinPerl::ExecDirect($c, "create table BLTEST (I int, B blob);");
$err && LinterError($c);

$err = LinPerl::ExecDirect($c, "insert into BLTEST (I) values (1);");
$err && LinterError($c);
print "Appending BLOB ";
while (<IN>)
  {
  $err = LinPerl::BLOBAppend($c, $_);
  $err && LinterError($c);
  print ".";
  }
print "\n";

$err = LinPerl::ExecDirect($c, "select * from BLTEST;");
$err && LinterError($c);

$err = LinPerl::BLOBGetSize($c, $size);
$err && LinterError($c);
printf "BLOB size is %d\n", $size;

$err = LinPerl::BLOBGetData($c, 1, $size, $blob);
$err && LinterError($c);
printf $blob;

$err = LinPerl::CloseConnect($c);
$err && LinterError($c);

exit();

sub LinterError
{
 my $linerr, $syserr, $errmsg;

 LinPerl::GetError($c, $linerr, $syserr);
 LinPerl::GetErrorMsg($c, $linerr, $errmsg);
 printf "\n";
 printf "Internal error: %d\n", $err;
 printf "Linter error  : %d - \'%s\'\n", $linerr, $errmsg;
 printf "System error  : %d\n", $syserr;
 printf "\n";
 exit();
}

