use LinPerl;

$err = LinPerl::OpenConnect("SYSTEM", "MANAGER", "", CP_866, $connect);
$err && LinterError($connect);

$err = LinPerl::OpenCursor($connect, "", $cursor);
$err && LinterError($cursor);

$query = "select cast ROWID as NUMERIC, MAKE, MODEL, PERSONID from AUTO where PERSONID <= ?;";
$err = LinPerl::Prepare($cursor, $query);
$err && LinterError($cursor);

$err = LinPerl::BindParameter($cursor, 1, $param);
$err && LinterError($cursor);

$param = 10;

$err = LinPerl::Execute($cursor);
$err && LinterError($cursor);

LinPerl::GetCursorOption($cursor, CO_COLCOUNT, $cols);
LinPerl::GetCursorOption($cursor, CO_ROWCOUNT, $rows);
printf "Rows %d, Cols %d\n\n", $rows, $cols;

while ($err == 0)
   {
   $err = LinPerl::GetDataColumn($cursor, 1, $rowid);
   $err = LinPerl::GetDataColumn($cursor, 2, $make);
   $err = LinPerl::GetDataColumn($cursor, 3, $model);
   $err = LinPerl::GetDataColumn($cursor, 4, $personid);
   printf "%4.f | %s | %s | %d\n", $rowid, $make, $model, $personid;
   $err = LinPerl::Fetch($cursor, FETCH_NEXT, 0);
   }
$err > 2 && LinterError($cursor);

$err = LinPerl::CloseConnect($connect);
$err && LinterError($cursor);

exit();

sub LinterError($cursor)
{
 my $linerr, $syserr, $errmsg;

 LinPerl::GetError($cursor, $linerr, $syserr);
 LinPerl::GetErrorMsg($cursor, $linerr, $errmsg);
 printf "\n";
 printf "Linter error %d - \'%s\'\n", $linerr, $errmsg;
 printf "System error %d\n", $syserr;
 if ($linerr >= 2000 && $linerr < 3000)
   {
   LinPerl::GetCursorOption($cursor, CO_ERRROW, $row);
   LinPerl::GetCursorOption($cursor, CO_ERRPOS, $col);
   printf "Error position %d %d\n", $row, $col;
   }
 exit();
}

