use LinPerl;

$err = LinPerl::OpenConnect("SYSTEM", "MANAGER", "", CP_866, $connect);
$err && LinterError($connect);

$err = LinPerl::OpenCursor($connect, "", $cursor);
$err && LinterError($cursor);

$query = "drop table TEST;";
LinPerl::ExecDirect($cursor, $query);
$query = "create table TEST (I int, S smallint, R real, D double,\
                             N numeric, T date, C char(10));";
LinPerl::ExecDirect($cursor, $query);
$err && LinterError($cursor);

$query = "insert into TEST values (1, 2, 3.4, 5.6, 7.8, '13.09.71', 'Kent');";
LinPerl::ExecDirect($cursor, $query);
$err && LinterError($cursor);

$query = "select * from TEST where I=? and S=? and R=? and D=? and N=? and T=? and C=?;";
$err = LinPerl::Prepare($cursor, $query);
$err && LinterError($cursor);

$int    = 1;
$short  = 2;
$real   = 3.4;
$double = 5.6;
$dec    = 7.8;
$date   = "13.09.1971";
$char   = "Kent";

$err = LinPerl::BindParameter($cursor, 1, $int);
$err && LinterError($cursor);

$err = LinPerl::BindParameter($cursor, 2, $short);
$err && LinterError($cursor);

$err = LinPerl::BindParameter($cursor, 3, $real);
$err && LinterError($cursor);

$err = LinPerl::BindParameter($cursor, 4, $double);
$err && LinterError($cursor);

$err = LinPerl::BindParameter($cursor, 5, $dec);
$err && LinterError($cursor);

$err = LinPerl::BindParameter($cursor, 6, $date);
$err && LinterError($cursor);

$err = LinPerl::BindParameter($cursor, 7, $char);
$err && LinterError($cursor);

$err = LinPerl::Execute($cursor);
$err && LinterError($cursor);

LinPerl::GetCursorOption($cursor, CO_COLCOUNT, $cols);
LinPerl::GetCursorOption($cursor, CO_ROWCOUNT, $rows);
printf "Rows %d, Cols %d\n\n", $rows, $cols;

$err = LinPerl::BindColumn($cursor, 6, $ts);
$err && LinterError($cursor);
$err = LinPerl::BindColumn($cursor, 7, $name);
$err && LinterError($cursor);

$err = LinPerl::SetCursorOption($cursor, CO_DTFORMAT, "DD.MM.YYYY");
$err && LinterError($cursor);

$err = LinPerl::Fetch($cursor, FETCH_ABSNUM, 1);
$err && LinterError($cursor);
printf("Name = %s, date = %s\n", $char, $ts);

$err = LinPerl::CloseConnect($connect);
$err && LinterError($cursor);

exit();

sub LinterError($cursor)
{
 my $linerr, $syserr, $errmsg;

 LinPerl::GetError($cursor, $linerr, $syserr);
 LinPerl::GetErrorMsg($cursor, $linerr, $errmsg);
 printf "\n";
 printf "Linter error %d - \'%s\'\n", $linerr, $errmsg;
 printf "System error %d\n", $syserr;
 if ($linerr >= 2000 && $linerr < 3000)
   {
   LinPerl::GetCursorOption($cursor, CO_ERRROW, $row);
   LinPerl::GetCursorOption($cursor, CO_ERRPOS, $col);
   printf "Error position %d %d\n", $row, $col;
   }
 exit();
}

