<?php
  require("library.php");
  require("err_h.php");

  printf("Demo 1: direct query, linter_get_data_row and linter_get_data_array examples<br><br>");

  $con = Linter_Open_Connect("SYSTEM", "MANAGER", "", TM_AUTOCOMMIT);
  Errors_Handler($con, 0);
  printf("Successfuly connected (id = %d)<br><br>", $con);

  $query = "select personid, make, model from auto where personid <= 5;";
  printf("Query: `%s'<br>", $query);
  $err = Linter_Exec_Direct($con, $query);
  Errors_Handler($con, $err);
  printf("Successfuly executed<br>");
  
  $cols = Linter_Get_Cursor_Opt($con, CO_COL_COUNT);
  
  printf("<br>Using linter_get_data_row<br>");
  do {
    $data = Linter_Get_Data_Row($con);
    if (is_array($data)) {
      foreach ( $data as $key => $value)
        printf(" data[$key] = $value; ");
      printf("<br>");
    }
    $err = Linter_Fetch($con, FETCH_NEXT);
  } while($err == LPE_SUCCESS);

  $err = Linter_Fetch($con, FETCH_FIRST);
  Errors_Handler($con, $err);

  printf("<br>Using linter_get_data_array<br>");
  do {
    $data = Linter_Get_Data_Array($con);
    if (is_array($data)) {
      foreach ( $data as $key => $value)
        printf(" data[$key] = $value; ");
      printf("<br>");
    }
    $err = Linter_Fetch($con, FETCH_NEXT);
  } while($err == LPE_SUCCESS);
  
  Errors_Handler($con, $err);

  $err = Linter_Close_Connect($con);
  Errors_Handler($con, $err);
  printf("<br>Successfuly disconnected<br>");

?>

