<?php

  require("library.php");
  require("err_h.php");

  printf("Demo 2: prepared query, linter_fetch_row and linter_fetch_array examples\n\n");

  $con = Linter_Open_Connect("SYSTEM", "MANAGER", "", TM_AUTOCOMMIT);
  Errors_Handler($con, 0);
  printf("Successfuly connected (id = %d)\n\n", $con);

  $query = "select personid, make, model from auto where make like ? and personid < ?;";
  printf("Query: `%s'\n", $query);
  $err = Linter_Prepare($con, $query);
  Errors_Handler($con, $err);
  $params[0] = "FER%";
  $params[1] = 100;
  printf("Parameters: 1st = \"%s\", 2nd = %d\n", $params[0], $params[1]);
  $err = Linter_Execute($con, $params);
  Errors_Handler($con, $err);

  printf("\nUsing linter_fetch_row()\n");
  while ( is_array( $data = Linter_Fetch_Row($con) ) )
  {
    foreach ($data as $key => $value)
      printf("data[%s]=%s; ", $key, $value);
    printf("\n");
  };              

  $err = Linter_Fetch($con, FETCH_FIRST);
  Errors_Handler($con, $err);

  printf("\nUsing linter_fetch_array()\n");
  while ( is_array( $data = Linter_Fetch_Array($con) ) )
  {
    foreach ($data as $key => $value)
      printf("data[%s]=%s; ", $key, $value);
    printf("\n");
  };              

  Errors_Handler($con, $err);
  
  $err = Linter_Close_Connect($con);
  Errors_Handler($con, $err);

  printf("\nSuccessfuly disconnected\n");

?>

