<?php

  require("library.php");
  require("err_h.php");

  printf("Demo 4: work with cursors: linter_open_cursor, linter_get_cursor_opt and linter_set_cursor_opt example\n\n");

  $con = Linter_Open_Connect("SYSTEM", "MANAGER", "", TM_AUTOCOMMIT);
  Errors_Handler($con, 0);
  printf("Successfuly connected (id = %d)\n\n", $con);

  printf("Open cursor...\n");
  $csr = Linter_Open_Cursor($con);
  Errors_Handler($csr, $err);

  printf("Create table...\n");
  $err = Linter_Exec_Direct($csr, "drop table PHP_TEST;");
  $err = Linter_Exec_Direct($csr, "create table PHP_TEST(I int, D DATE);");
  Errors_Handler($csr, $err);

  printf("Insert data...\n");
  $err = Linter_Exec_Direct($csr, "insert into PHP_TEST values (1, '13.09.1970');");
  $err = Linter_Exec_Direct($csr, "insert into PHP_TEST values (2, '04.04.1946');");
  $err = Linter_Exec_Direct($csr, "insert into PHP_TEST values (3, '18.11.1975');");
  Errors_Handler($csr, $err);

  printf("Make cursor as select...\n");
  $err = Linter_Exec_Direct($csr, "select * from PHP_TEST;");
  Errors_Handler($csr, $err);

  printf("Set date format 'DD.MM.YYYY' and select data\n");
  $err = Linter_Set_Cursor_Opt($csr, CO_DT_FORMAT, "DD.MM.YYYY");
  Errors_Handler($csr, $err);
  $data = Linter_Get_Data_Row($csr);
  if (is_array($data))
    printf("Result: %s\n", $data[1]);
  else
    Errors_Handler($csr, $data);
  printf("Set date format 'MM/DD/YYYY' and select data\n");
  $err = Linter_Set_Cursor_Opt($csr, CO_DT_FORMAT, "DD/MM/YYYY");
  Errors_Handler($csr, $err);
  $data = Linter_Get_Data_Row($csr);
  if (is_array($data))
    printf("Result: %s\n", $data[1]);
  else
    Errors_Handler($csr, $data);

  printf("Set cursor name `TEST'...\n");
  $err = Linter_Set_Cursor_Opt($csr, CO_NAME, "TEST");
  Errors_Handler($csr, $err);

  $query = "update PHP_TEST set D = '13.01.1971' where current of TEST;";
  printf("Execute query...\n", $query);
  printf("%s\n", $query);
  $err = Linter_Exec_Direct($csr, $query);
  Errors_Handler($csr, $err);

  printf("Drop table...\n");
  $err = Linter_Exec_Direct($csr, "drop table PHP_TEST;");
  Errors_Handler($csr, $err);

  $err = Linter_Close_Connect($con);
  Errors_Handler($con, $err);

  printf("\nSuccessfuly disconnected\n");

?>

