<?php
  require("library.php");
  require("err_h.php");

  define("BLOB_VALUE_1", "Blob value");
  define("BLOB_VALUE_2", "Another blob value");

  printf("Demo 5: work with BLOB\n\n");

  $con = Linter_Open_Connect("SYSTEM", "MANAGER", "", TM_AUTOCOMMIT);
  Errors_Handler($con, 0);
  printf("Successfuly connected (id = %d)\n\n", $con);

  $err = Linter_Exec_Direct($con, "drop table test;");
  $err = Linter_Exec_Direct($con, "create table test(b1 blob, b2 blob, i int);");
  Errors_Handler($con, $err);
  $err = Linter_Exec_Direct($con, "insert into test(b2, b1, i) values (NULL, NULL, 1);");
  Errors_Handler($con, $err);
  //set value of first blob column in the table test, wich is b1
  $err = Linter_Blob_Append($con, BLOB_VALUE_1, strlen(BLOB_VALUE_1));
  Errors_Handler($con, $err);
  //now set value of b2 column, wich column number in last statement is 1  
  $err = Linter_Blob_Add($con, BLOB_VALUE_2, strlen(BLOB_VALUE_2), 1);
  Errors_Handler($con, $err);

  $err = Linter_Close_Connect($con);
  Errors_Handler($con, $err);
  
  $con = Linter_Open_Connect("SYSTEM", "MANAGER", "", TM_AUTOCOMMIT);
  Errors_Handler($con, 0);

  $err = Linter_Exec_Direct($con, "select i, b1, b2 from test;");
  Errors_Handler($con, $err);

  $size = Linter_Blob_Get_Size($con);
  Errors_Handler($con, $size);
  printf("b1 size is %d\n", $size);

  printf("b1 data: ");
  $blobdata = Linter_Blob_Get_Data($con, 1, $size);
  Errors_Handler($con, $blobdata);

  printf("\"%s\"\n\n", $blobdata);
  $size = Linter_Blob_Get_Size($con, 3);
  Errors_Handler($con, $size);
  printf("b2 size is %d\n", $size);

  printf("b2 data: ");
  $blobdata = Linter_Blob_Fetch($con, 1, $size, 3);
  Errors_Handler($con, $blobdata);
  printf("\"%s\"\n\n", $blobdata);

  printf("Result of Linter_Get_Data_Array function:\n");
  $res = Linter_Get_Data_Array($con);
  Errors_Handler($con, $res);
  print_r($res);

  printf("\nResult of Linter_Get_Data_Array function with CO_FETCH_BLOBS_AS_USUAL_DATA option enabled:\n");
  Linter_Set_Cursor_Opt($con, CO_FETCH_BLOBS_AS_USUAL_DATA, true);
  $res = Linter_Get_Data_Array($con);
  Errors_Handler($con, $res);
  print_r($res);
  
  $err = Linter_Exec_Direct($con, "drop table test;");
  $err = Linter_Close_Connect($con);
  Errors_Handler($con, $err);

  printf("\nSuccessfuly disconnected\n");

?>

