<?php
  require("library.php");
  require("err_h.php");

  printf("Demo 6: obtaining results after executing procedure\n\n");
 
  $con = Linter_Open_Connect("SYSTEM", "MANAGER", "", TM_AUTOCOMMIT);
  Errors_Handler($con, 0);
  printf("Successfuly connected (id = %d)\n", $con);

  $Query = "drop table test_table;";
  printf("\nQuery: `%s'\n", $Query);
  $err = Linter_Exec_Direct($con, $Query);
/*  Errors_Handler($con, $err); */

  $table_types  = " int_value int, char_value char(10), varchar_value varchar(20), real_value real, bigint_value bigint";
  $table_values = " 4, 'qwerty', 'test', 12.97, 12212 ";
                                                                                                  
  $Query = "create table test_table (" . $table_types . ");";
  printf("\nQuery: `%s'\n", $Query);
  $err = Linter_Exec_Direct($con, $Query);
  Errors_Handler($con, $err);
  printf("Successfuly executed\n");

  $Query = 'create or replace
  			procedure test_proc1()
  			result
  				cursor(' . $table_types . ')
            declare
            	var c typeof(result);
            code
            	open c for direct "select * from test_table;";
            	return c;
            end;';                       
  printf("\nQuery: `%s'\n", $Query);
  $err = Linter_Exec_Direct($con, $Query);
  Errors_Handler($con, $err);
  printf("Successfuly executed\n");

  $Query = 'create or replace
  			procedure test_proc2()
  			result
  				date
            declare
            	var c typeof(result);
            code
            	return sysdate();
            end;';                       
  printf("\nQuery: `%s'\n", $Query);
  $err = Linter_Exec_Direct($con, $Query);
  Errors_Handler($con, $err);
  printf("Successfuly executed\n");
                                
  $Query = "insert into test_table values (" . $table_values . ");";
  printf("\nQuery: `%s'\n", $Query);
  $err = Linter_Exec_Direct($con, $Query);
  Errors_Handler($con, $err);
  printf("Successfuly executed\n");
 
  printf("\nExecuting procedure which return cursor\n");
  $Query = "execute test_proc1();";
  printf("Query: `%s'\n", $Query);
  $err = Linter_Exec_Direct($con, $Query);
  Errors_Handler($con, $err);
  printf("Successfuly executed\n");

  $data1 = Linter_Get_Data_Row($con);
  $data = Linter_Get_Data_Array($data1[0]);
  
  foreach ( $data as $key => $value)
    printf(" data[$key] = $value\n");

  printf("\nExecuting procedure which return value\n");
  $Query = "execute test_proc2();";
  printf("Query: `%s'\n", $Query);
  $err = Linter_Exec_Direct($con, $Query);
  Errors_Handler($con, $err);
  printf("Successfuly executed\n");

  $data = Linter_Get_Data_Row($con);
  foreach ( $data as $key => $value)
    printf(" data[$key] = $value\n");

  $err = Linter_Close_Connect($con);
  Errors_Handler($con, $err);
  printf("\nSuccessfuly disconnected\n");

?>
