<?php
  require("library.php");
  require("err_h.php");

  if ( !extension_loaded('mbstring') )  
    if ( !dl("php_mbstring.dll") )
      die("Unable to load library which works with multibyte strings ...");
                  
  printf("Demo 7: work with nchar strings and linter_set_codepage example\n\n");

  $err = linter_set_codepage( "CP1251" );
  if ( $err == LPE_SUCCESS )
      printf("Codepage set sucsessfully\n");
  else
      printf("Error while setting codepage...\n");
  
  $con = Linter_Open_Connect("SYSTEM", "MANAGER", "", TM_AUTOCOMMIT);
  Errors_Handler($con, 0);
  printf("\nSuccessfuly connected (id = %d)\n", $con);

  $query = "drop table test_table;";
  printf("\nQuery: `%s'\n", $query);
  $err = Linter_Exec_Direct($con, $query);
/*  Errors_Handler($con, $err); */
                                                                                                  
  $query = "create table test_table ( nchar_value nchar(20), nvarchar_value nchar varying(30) ) ;";
  printf("\nQuery: `%s'\n", $query);
  $err = Linter_Exec_Direct($con, $query);
  Errors_Handler($con, $err);
  printf("Successfuly executed\n");
                                
  $query = "insert into test_table values ( cast 'ਢ' as nchar(20), cast '' as nchar varying(30) );";
  printf("\nQuery: `%s'\n", $query);
  $err = Linter_Exec_Direct($con, $query);
  Errors_Handler($con, $err);
  printf("Successfuly executed\n");

  $query = "select * from test_table;";
  printf("\nQuery: `%s'\n", $query);
  $err = Linter_Exec_Direct($con, $query);
  Errors_Handler($con, $err);
  printf("Successfuly executed\n");

  $data = Linter_Get_Data_Array($con);
  Errors_Handler($con, $err);
  foreach ( $data as $key => $value)
  {
    printf(" data[$key] = $value\n");
    $value = mb_convert_encoding($value, "CP1251", "UCS-2LE");    
    printf(" converted to CP1251 value = $value\n");
  };

  $err = Linter_Close_Connect($con);
  Errors_Handler($con, $err);
  printf("\nSuccessfuly disconnected\n");

?>
