<?php
  require("library.php");
  require("err_h.php");

  printf("Demo 8: work with null values and linter_fetch example<br><br>");

  $con = Linter_Open_Connect("SYSTEM", "MANAGER", "", TM_AUTOCOMMIT);
  Errors_Handler($con, 0);
  printf("Successfuly connected (id = %d)<br><br>", $con);

  $query = "drop table test_table;";
  printf("Query: `%s'<br>", $query);
  $err = Linter_Exec_Direct($con, $query);
/*  Errors_Handler($con, $err); */
                                                                                                  
  $query = "create table test_table ( id int autoinc, int_value int default null, varchar_value varchar(20) default null ) ;";
  printf("<br>Query: `%s'<br>", $query);
  $err = Linter_Exec_Direct($con, $query);
  Errors_Handler($con, $err);
  printf("Successfuly executed<br>");

  printf("<br>Inserting data...<br>");
  $err = Linter_Exec_Direct($con, "insert into test_table( int_value ) values ( 10 ) ;");
  Errors_Handler($csr, $err);
  $err = Linter_Exec_Direct($con, "insert into test_table( varchar_value ) values ( 'string 2' ) ;");
  Errors_Handler($csr, $err);
  $err = Linter_Exec_Direct($con, "insert into test_table( int_value, varchar_value ) values ( 20 , 'string 3') ;");
  Errors_Handler($csr, $err);
  printf("Successfuly executed<br>");

  $query = "select * from test_table;";
  printf("<br>Query: `%s'<br>", $query);
  $err = Linter_Exec_Direct($con, $query);
  Errors_Handler($con, $err);
  printf("Successfuly executed<br>");

  $cols = Linter_Get_Cursor_Opt($con, CO_COL_COUNT);
  while ( is_array( $data = Linter_Fetch_Row($con, true) ) )
  {
    for ( $i = 0; $i < ($cols*2); $i = $i + 2 )
    {
      //column index
      $col = $i / 2;      
      // checking null flag
      if ( $data[$i+1] )
        printf("data[%s] is NULL; ", $col);
      else
        printf("data[%s] = %s; ", $col, $data[$i]);
    };
    printf("<br>");
  };              

  $rows = Linter_Get_Cursor_Opt($con, CO_ROW_COUNT);
  printf("<br>Number of rows in current cursor: %s<br>", $rows);

  $err = Linter_Fetch($con, FETCH_LAST);
  $cur = Linter_Get_Cursor_Opt($con, CO_CUR_ROW);
  printf("After Linter_Fetch(con, FETCH_LAST) current column is: %s<br>", $cur);
  $data = Linter_Get_Data_Row( $con );
  printf("data[%s] = %s;<br>", 0, $data[0]);

  $err = Linter_Fetch($con, FETCH_FIRST);
  $cur = Linter_Get_Cursor_Opt($con, CO_CUR_ROW);
  printf("After Linter_Fetch(con, FETCH_FISRST) current column is: %s<br>", $cur);
  $data = Linter_Get_Data_Row( $con );
  printf("data[%s] = %s;<br>", 0, $data[0]);

  $err = Linter_Fetch($con, FETCH_ABSNUM, 2);
  $cur = Linter_Get_Cursor_Opt($con, CO_CUR_ROW);
  printf("After Linter_Fetch(con, FETCH_ABSNUM, 2) current column is: %s<br>", $cur);
  $data = Linter_Get_Data_Row( $con );
  printf("data[%s] = %s;<br>", 0, $data[0]);

  $err = Linter_Fetch($con, FETCH_PREV);
  $cur = Linter_Get_Cursor_Opt($con, CO_CUR_ROW);
  printf("After Linter_Fetch(con, FETCH_PREV) current column is: %s<br>", $cur);
  $data = Linter_Get_Data_Row( $con );
  printf("data[%s] = %s;<br>", 0, $data[0]);

  $err = Linter_Fetch($con, FETCH_NEXT);
  $cur = Linter_Get_Cursor_Opt($con, CO_CUR_ROW);
  printf("After Linter_Fetch(con, FETCH_NEXT) current column is: %s<br>", $cur);
  $data = Linter_Get_Data_Row( $con );
  printf("data[%s] = %s;<br>", 0, $data[0]);

  $err = Linter_Close_Connect($con);
  Errors_Handler($con, $err);
  printf("<br>");

  printf("Successfuly disconnected<br>");

?>

