<?php
  require("library.php");
  require("err_h.php");

  printf("Demo 9: work with decimals<br><br>");

  printf("If config variable linter.decimal_as_double is set to On, decimals are returned as double, otherwise as string<br><br>");

  $a = get_cfg_var("linter.decimal_as_double");
  printf("linter.decimal_as_double %s<br><br>", $a ? "= " . $a : "is not set");

  $con = Linter_Open_Connect("SYSTEM", "MANAGER", "", TM_AUTOCOMMIT);
  Errors_Handler($con, 0);
  printf("Successfuly connected (id = %d)<br><br>", $con);

  $query = "drop table test_table;";
  printf("Query: `%s'<br>", $query);
  $err = Linter_Exec_Direct($con, $query);
/*  Errors_Handler($con, $err); */
                                                                                                  
  $query = "create table test_table ( id int autoinc, d decimal, int_value int default 12 ) ;";
  printf("<br>Query: `%s'<br>", $query);
  $err = Linter_Exec_Direct($con, $query);
  Errors_Handler($con, $err);
  printf("Successfuly executed<br>");

  printf("<br>Inserting data...<br>");
  $err = Linter_Exec_Direct($con, "insert into test_table( d ) values ( 10.012345 ) ;");
  Errors_Handler($csr, $err);
  $err = Linter_Exec_Direct($con, "insert into test_table( d ) values ( 12345678901234567890.0123456789 ) ;");
  Errors_Handler($csr, $err);
  $err = Linter_Exec_Direct($con, "insert into test_table( d ) values ( -.01289 ) ;");
  Errors_Handler($csr, $err);
  printf("Successfuly executed<br>");

  $query = "select * from test_table;";
  printf("<br>Query: `%s'<br>", $query);
  $err = Linter_Exec_Direct($con, $query);
  Errors_Handler($con, $err);
  printf("Successfuly executed<br>");
  while ( is_array( $data = Linter_Fetch_Row($con) ) )
     foreach ($data as $key => $value)
        printf("data[%s] is %s, is_numeric() = %s, gettype() = %s<br>", $key, $value, is_numeric($value) ? "TRUE": "FALSE", gettype($value) );

  $err = Linter_Close_Connect($con);
  Errors_Handler($con, $err);
  printf("<br>");

  printf("Successfuly disconnected<br>");

?>

