<?php

#
# Linter SQL Server and Linter PHP module errors handler
# Parameters: $con - connetction or cursor id;
#             $err - value was returned by any Linter_* routine.
#
function Errors_Handler($con, $err)
{
  if ($err >= 0 && $con >= 0)
    return;

  if ($con < 0)
    {
    $lin_err = Linter_Last_Error(LINTER_ERROR);
    $sys_err = Linter_Last_Error(SYSTEM_ERROR);
    printf("Linter connect error %s, system error %s\n", $lin_err, $sys_err);
    die;
    } 

  if ($err == LPE_LINTER_ERROR)
    {
    $lin_err = Linter_Last_Error($con, LINTER_ERROR);
    $sys_err = Linter_Last_Error($con, SYSTEM_ERROR);
    $err_msg = Linter_Error_Msg($con);
    if ($lin_err <= 2)                       // no more rows
      return;
    printf("Linter error %d (%s) ", $lin_err, $err_msg);
    if ($lin_err >= 2000 && $lin_err < 3000) // SQL syntax errors
      {
      $row = $sys_err & 0xFFFF;
      $pos = $sys_err >> 16;
      printf("at row %d, position %d", $row, $pos);
      }
    else
      printf(", system error %d", $sys_err);
    printf("\n");
    }
  else
    printf("Module internal error %d\n", $err);
  Linter_Close_Connect($con);
  die;
}

?>

