procedure blobtest(in ii int default 1111111; in si smallint default 222;
                   in rr real default 1.23; in nn numeric default 3.1415;
                   in dd date default 10.11.1997; in ll bool default true;
                   in cc char(20) default "string"; in n int default 10)
declare
    var s cursor(i int, b blob);
    var i,j int default 1;
    var sm smallint;
    var b byte(100);
    var c char(1000);
    exception addbloberr for custom 1;
    exception readbloberr for custom 2;
    exception clearbloberr for custom 3;
code
    execute direct "drop table tblob;";
    execute direct "create table tblob(i int, b blob);";

    // add blobs
    while i <= n loop
       execute direct "insert into tblob(i) values("+itoa(i)+");";
       j:=0;
       while j < i*3 loop
         b[j] := i*10 + j;
         j := j+1;
       endloop
       if add_blob(b, i*3) <> 0 then
          signal addbloberr;
       endif
       i := i+1;
    endloop

    call init_results();
    // replace blob in row 2 with special sequence of values
    execute direct "select b from tblob where i = 2;";
    seek_blob(3);
    sm = itoa(read_blob_smallint());
    if clear_blob() <> 0 then
       signal clearbloberr;
    endif
    add_blob(ii);
    add_blob(si);
    add_blob(rr);
    add_blob(nn);
    add_blob(dd);
    add_blob(ll);
    add_blob(cc);

    call ins_result("Seek result: "+ itoa(sm));

    // read blobs
    open s for direct "select * from tblob;";
    while not outofcursor(s) loop
       call ins_result(itoa(s.i)+". Blob of size "+itoa(blob_size(s.b))+":");
       if s.i = 2 then
          call ins_result(
            itoa(read_blob_int(s)) + "," +
            itoa(read_blob_smallint(s)) + "," +
            ntoa(read_blob_real(s),10,2) + "," +
            ntoa(read_blob_numeric(s),10,5) + "," +
            dtoa(read_blob_date(s)) + "," +
            (eif[read_blob_bool(s)] "true," ELSE "false,") +
            read_blob_char(s));
       else
          n := read_blob(s, b, 100);
          if errcode(s) <> 0 then
            signal readbloberr;
          endif
          c := "";
          j := 0;
          while j < n loop
             c := c + itoa(b[j]) + " ";
             j := j+1;
          endloop
          call ins_result(c);
       endif
       fetch s;
    endloop
exceptions
when others then
    resignal;
end   
