; BLOB function sample 

; List all procedures with text containing words beginning with 'creat'
; and a count of such words for each procedure

select $$$NAME, $$$ID, CountBLOB($$$BODY, 'creat%') 
from $$$PROC 
where $$$NAME <> '' 
order by $$$ID;

; List all procedures with text containing words beginning with 'err'
; Show the first and the last offset of such word for each procedure

select $$$NAME, $$$ID, 
       FindBLOB($$$BODY, 'err%', 1) as FirstOffset, 
       FindBLOB($$$BODY, 'err%', CountBLOB($$$BODY, 'err%')) as LastOffset
from $$$PROC 
where $$$NAME <> '' and CountBLOB($$$BODY, 'err%') > 0 
order by $$$ID;

; This query would be correct if $$$BODY contained RTF
;
; select $$$ID, FindRTF($$$BODY, 'err%', CountBLOB($$$BODY, 'err%')) 
; from $$$PROC 
; where $$$NAME <> '' and CountBLOB($$$BODY, 'err%') > 0  
; order by $$$ID;

; List all procedures with text containing words beginning with 'erro'
; Show the first and the last such word for each procedure (32 chars)

select 
  $$$NAME, $$$ID,
  cast (GetBLOB ($$$BODY, FindBLOB($$$BODY, 'err%', 1), 32) as char) as FirstWord, 
  cast (GetBLOB ($$$BODY ,FindBLOB($$$BODY ,'err%', CountBLOB($$$BODY, 'err%')), 32) 
    as char) as LastWord 
from $$$PROC 
where $$$NAME <> '' and CountBLOB($$$BODY, 'err%') > 0;

; List all procedures, show text length for each procedure

select $$$NAME, $$$ID, LenBLOB($$$BODY) 
from $$$PROC 
where $$$NAME <> '' 
order by $$$ID;
