;  Select records example
;
;

select sysdate;
select log(2.5, 10);
select 'RDBMS LINTER SQL SERVER ',' 6.0 version';
select ?(char(10)); 

;-----------  FROM     -

select count(*) from AUTO A, AUTO B where A.PERSONID = B.PERSONID;
select * from (select * from PERSON P, AUTO A where P.PERSONID = A.PERSONID) 
  as PA, (select * from PERSON P, FINANCE F where P.PERSONID = F.PERSONID) as PF;

;-----------  WHERE    -

select B.NAME, A.MODEL from AUTO A, PERSON B 
  where A.PERSONID = B.PERSONID and exists
    (select * from FINANCE C where C.PERSONID = A.PERSONID and CRDITLIM = 100);

select NAME||' '|| FIRSTNAM from PERSON where exists
  (select * from AUTO where PERSON.PERSONID = AUTO.PERSONID and COLOR = 'BLACK');

;-----------  GROUP BY -

select MAKE from AUTO where COLOR='BLACK' group by MAKE;

select NAME, MAKE, max(CYLNDERS) from AUTO, PERSON 
  where AUTO.PERSONID = PERSON.PERSONID group by NAME, MAKE;

select YEAR + 1900, MODEL from AUTO group by YEAR, MODEL;

select round(avg( distinct (CYLNDERS + length(MAKE))),0), 
  count(distinct (CYLNDERS + length(MAKE))) from AUTO group by COLOR;

;-----------  HAVING    -

select distinct MAKE from AUTO group by MAKE having 
  max(YEAR) > (select min(AUTO.YEAR) from AUTO, PERSON 
    where PERSON.PERSONID = AUTO.PERSONID and length(AUTO.MAKE) = length(PERSON.NAME));

select distinct MAKE, count(*) from AUTO group by MAKE 
  having count(*) > (select count (distinct NAME) from PERSON);

select MAKE from AUTO group by MAKE having 
  max(YEAR + 1900) < (select to_number(to_char(sysdate,'yyyy')));

select MAKE, CYLNDERS, COLOR from AUTO where 
  COLOR in ('BLACK','WHITE','GREEN') group by MAKE, CYLNDERS, COLOR having max(CYLNDERS) > 6;

select MAKE, YEAR + 1900 from AUTO group by MAKE, YEAR + 1900
  having max(YEAR + 1900) between 1969 and 1972;

;-----------  ORDER BY  -

select * from AUTO order by MODEL;
select distinct MODEL, MAKE from AUTO order by MODEL desc;
select distinct MODEL, MAKE, CYLNDERS from AUTO order by MODEL asc, CYLNDERS desc;

select distinct MODEL, MAKE, to_char(WEIGHT)||' kg.' "Weight of the car", YEAR + 1900 as 
  "Output year" from AUTO where ROWID = 1 order by MODEL, 3, 4 ;

drop   table SELECT_TAB;
create table SELECT_TAB ( C1 varchar(10), C2 varchar(10));
insert into SELECT_TAB values ('23456', 'abcd');
insert into SELECT_TAB values ('13456', 'bacd');
insert into SELECT_TAB values ('32456', 'cdba');
insert into SELECT_TAB values ('13456', 'abcd');
select * from SELECT_TAB;
select * from SELECT_TAB order by 1;
select * from SELECT_TAB order by 1, 2;

;-----------  SUBQUERY  -

select * from PERSON as P where exists 
  (select * from AUTO where PERSONID = P.PERSONID);	

select * from PERSON where SALARY = (select max( SALARY) from PERSON);

select count(*) from AUTO where (MAKE, YEAR) in ( select 'FORD', 70);

;-----------  FOR UPDATE -

select * from AUTO where COLOR = 'BLACK' for update;

;-----------  FOR BROWSE -

select * from AUTO where MAKE = 'FORD' for browse;

;-----------  FETCH FIRST -

select ROWID, MAKE, COLOR from AUTO fetch first 2;
select ROWID, MAKE, COLOR from AUTO where ROWID > 2 fetch first 3 ;







