# PATH to your shell

proc getLenChar {type len} {
    switch $type {
	1 {return $len}
	2 { if {$len==2} { return 5 } else { return 10 } }
	3 { if {$len==4} { return 12 } else { return 19 } }
	4 {return 25}
	5 {return 32}
	6 {return $len}
	7 {return 1}
	8 {return $len}
	9 {return $len}
	10 {return 1} }
    }

 set conn [linter_error [linter_connect system/manager]]
 puts "open connect N $conn"

 set curs [linter_error [linter_opencursor $conn]]
 puts "open cursor N $curs"
 
 linter_error [linter_execdir $curs "delete from tcl_test"]
 puts "delete from tcl_test" 
 set stmt [linter_error [linter_createstmt $conn "insert into tcl_test values (?,?)"]]
 puts "prepare query \"insert into tcl_test values (?,?)\" stmt N $stmt"

 linter_error [linter_bindpar $curs $stmt 1 par1]
 linter_error [linter_bindpar $curs $stmt 2 par2]
 set par1 "first parameter"
 set par2 "second parameter"
 linter_error [linter_execstmt $curs $stmt]
 puts "succes: insert into tcl_test values ('$par1','$par2')"
 linter_error [linter_freestmt $stmt]
 
 set curs2 [linter_error [linter_opencursor $conn]]
 puts "open cursor N $curs2"
 linter_error [linter_execdir $curs2 "select * from tcl_test;"]
 puts "succes: \"select * from tcl_test\""
 puts "list answer:"
 puts [eval linter_error [linter_getrow $curs2]]
 puts "\n"
 
 set stmt [linter_error [linter_createstmt $conn "insert into tcl_test values (?,?)"]]
 puts "create new stmt N $stmt \"insert into tcl_test values (?,?)\""
 linter_error [linter_bindpar $curs $stmt 1 par1]
 linter_error [linter_bindpar $curs $stmt 2 par2]
 set par1 "first (test 2)"
 set par2 "second (test 2)"
 linter_error [linter_execstmt $curs $stmt]
 puts "succes: execute statment N $stmt"
 
 
 linter_error [linter_execdir $curs2 "select * from tcl_test"]
 puts "succes:\"select * from tcl_test\""

 #get answer description 
 set countColumn [linter_error [linter_cursopt $curs2 cColumnCount]]
 for {set i 1} {$i <= $countColumn} {incr i} {
    set answDescr [linter_error [linter_cursopt $curs2 cAnswerDesc $i]]
    set columnName($i) [lindex $answDescr 2]
    set columnLen($i) [getLenChar [lindex $answDescr 3] [lindex $answDescr 4]]
    }

 puts "output all data"
 #output header
 puts -nonewline [format %-17s "Columns:"]
 for {set i 1} {$i <= $countColumn} {incr i} {
	puts -nonewline [format "%-$columnLen($i)s" "$columnName($i)"] }
 puts ""

 #output data
 for {set i 1} {[linter_fetch $curs2 toAbsNumber $i] >= 0} {incr i} {
     puts -nonewline [format "%-17s" "answer $i:"]
     for {set j 1} {$j <= $countColumn} {incr j} {
	puts -nonewline [format "%-$columnLen($j)s" [linter_error [linter_getdata $curs2 $j tString]]]}
     puts "" }

linter_error [linter_freeall]

puts "Done."

