/***************************************************************************
 *                           RELEX, Inc. DBMS Linter                        *
 *  This is unpublished propietary source code of RELEX, Inc.               *
 *  The copyright notice does not evidence any actual or intended           *
 *  publication of such source code.                                        *
 *                                                                          *
 *                 Copyright (c) 1990-2012 RELEX, Inc.                      *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: Ariphmetic operations whis DATE values
 ----------------------------------------------------------------------------
 14.10.91 
 22.12.92 -- AVO
 20.07.97 -- Ermakov (Copyright) 
 20.05.98 -- DV (DAY > DAY_MON bug fixed)
 14.09.99 -- Ermakov (For OS9000)
 05.10.99 -- Ermakov (For QNX)
 18.12.00 -- VxWorks
 01.09.10 -- DV (Interval time operations)
 19.07.12 -- Galizin (OpenVMS)
 11.04.13 -- Ermakov (remove extra code)
*/

#ifdef __MSDOS__
#include <ctype.h>
#include "decimals.h"
#include "tick.h"           /* 19.05.92 */
#define _DATE_
#endif

#ifdef INTER_OS2
#include <ctype.h>
#include "tick.h"
#define _DATE_
#endif

#ifdef __INTER_DLL__
#ifndef INTER_MSWINDOWS
#define INTER_MSWINDOWS
#endif
#endif
#ifdef INTER_MSWINDOWS
#include <ctype.h>
#include "tick.h"
#define _DATE_
#endif

#if defined(UNIX) || defined(QNX) || defined(VXWORKS) || defined(VMS)   /* 19.07.12 05.10.99 */ /* 18.12.00 */
#include <ctype.h>
#include "decimals.h"
#include "tick.h"           /* 19.05.92 */
#define _DATE_
#endif

/* 14.09.99 ... */
#ifdef OS9000
#include <sys/ctypes>
#include "decimals.h"
#include "tick.h"
#define _DATE_
#endif
/* ... 14.09.99 */

#ifndef _DATE_
ERROR: UNDEF SYSTEM
#endif
  static L_SWORD DAY_MON[2][1+MAXMON] =			/* 20.05.98 */
   {
    {0,31,28,31,30,31,30,31,31,30,31,30,31}
   ,{0,31,29,31,30,31,30,31,31,30,31,30,31}
   };

int todate(
          int   d,
          int   m,
          int   y,
          L_LONG  *dt);                                   /* 01.09.10 */

void  DLLAPI  ADDDATE(const L_DECIMAL D1,
                      const L_DECIMAL D2,
                            L_DECIMAL D3)
/************************************/
{
  ADDDECIMAL(D1,D2,D3);
} /* end ADDDATE */


void  DLLAPI  SUBDATE(const L_DECIMAL D1,
                      const L_DECIMAL D2,
                            L_DECIMAL D3)
/*********************************/
{
  SUBDECIMAL(D1,D2,D3);
} /* end SUBDATE */

L_SWORD  DLLAPI  CMPDATE(const L_DECIMAL D1, const L_DECIMAL D2)
/*********************************/
{ L_SWORD D3;
  D3=CMPDECIMAL(D1,D2);
  return D3;
} /* end CMPDATE */

void  DLLAPI ADDMONTHSTODATE(const L_DECIMAL D1,
                             const L_DECIMAL D2,
                                   L_DECIMAL D3)
/************************************/
{
  L_LONG L11, L12, L21, L22;
  L_SWORD DAY1, DAY2, MON1, MON2, MON, YEAR1, YEAR2, YEAR, IS;	/* 20.05.98 */

  TICKTODATE(D1, &L11, &L12);
  TICKTODATE(D2, &L21, &L22);
  DATEDAYNUMBER(L11,&DAY1,&MON1,&YEAR1);
  DATEDAYNUMBER(L21,&DAY2,&MON2,&YEAR2);
  if (MON2 || YEAR2)                                    /* 01.09.10 */
    YEAR2--;
  MON = MON1 + MON2;
  YEAR = YEAR1 + YEAR2;
  if (MON > 12) 
  {
    YEAR++;
    MON -= 12;  
  }
  /* 20.05.98 */
  IS = BIGYEAR((L_SWORD)YEAR);
  if (DAY1 > DAY_MON[IS][MON]) 
    DAY1 = DAY_MON[IS][MON];
  /* 20.05.98 */
  L11 = DAYNUMBERDATE(DAY1,MON,YEAR);
  DATETOTICK(L11, L12, D3);
} /* end ADDMONTHSTODATE */

void  DLLAPI SUBMONTHSFROMDATE(const L_DECIMAL D1,
                               const L_DECIMAL D2,
                                     L_DECIMAL D3)
/************************************/
{
  L_LONG L11, L12, L21, L22;
  L_SWORD DAY1, DAY2, MON1, MON2, MON, YEAR1, YEAR2, YEAR, IS; /* 20.05.98 */

  TICKTODATE(D1, &L11, &L12);
  TICKTODATE(D2, &L21, &L22);
  DATEDAYNUMBER(L11,&DAY1,&MON1,&YEAR1);
  DATEDAYNUMBER(L21,&DAY2,&MON2,&YEAR2);
  if (MON2 || YEAR2)                                    /* 01.09.10 */
    YEAR2--;
  MON = MON1 - MON2;
  YEAR = YEAR1 - YEAR2;
  if (MON <= 0) 
  {
    YEAR--;
    MON += 12;  
  }
  /* 20.05.98 */
  IS = BIGYEAR((L_SWORD)YEAR);
  if (DAY1 > DAY_MON[IS][MON]) 
    DAY1 = DAY_MON[IS][MON];
  /* 20.05.98 */
  L11 = DAYNUMBERDATE(DAY1,MON,YEAR);
  DATETOTICK(L11, L12, D3);
} /* end SUBMONTHSFROMDATE */

void  DLLAPI MULMONTHS(L_DECIMAL D1,                       /* 01.09.10 ... */
                       L_DECIMAL D2,
                       L_DECIMAL D3)
/************************************/
{
  L_LONG L1, L2;
  L_SWORD DAY, MON, YEAR;

  TICKTODATE(D1, &L1, &L2);
  if (L1)
    L1++;
  DATEDAYNUMBER(L1,&DAY,&MON,&YEAR);
  if (L1)
  {
    DAY = 0;
    YEAR--;
    MON--;    	
  }
  L1 = MON+YEAR*12;
  LongToDec(L1, D1);
  MULDECIMAL(D1,D2,D3);
  DecToLong(D3, &L1, 0);
  YEAR = (L_SWORD) (L1 / 12);
  MON = (L_SWORD) (L1 - YEAR * 12);
  if (YEAR || MON)
  {
    DAY = 1;
    YEAR++;
    MON++;
  }
  todate(DAY,MON,YEAR,&L1);
  if (YEAR || MON)
    L1--;
  DATETOTICK(L1, L2, D3);
} /* end MULMONTHS */

void  DLLAPI DIVMONTHS1(L_DECIMAL D1,
                        L_DECIMAL D2,
                        L_DECIMAL D3)
/************************************/
{
  L_LONG L1, L2;
  L_SWORD DAY, MON, YEAR;

  TICKTODATE(D1, &L1, &L2);
  if (L1)
    L1++;
  DATEDAYNUMBER(L1,&DAY,&MON,&YEAR);
  if (L1)
  {
    DAY = 0;
    YEAR--;    	
    MON--;
  }
  L1 = MON+YEAR*12;
  LongToDec(L1, D1);
  DIVDECIMAL(D1,D2,D3);
  DecToLong(D3, &L1, 0);
  YEAR = (L_SWORD) (L1 / 12);
  MON = (L_SWORD) (L1 - YEAR * 12);
  if (YEAR || MON)
  {
    DAY = 1;
    YEAR++;
    MON++;
  }
  todate(DAY,MON,YEAR,&L1);
  if (YEAR || MON)
    L1--;
  DATETOTICK(L1, L2, D3);
} /* end DIVMONTHS1 */

void  DLLAPI DIVMONTHS2(L_DECIMAL       D1,
                        L_DECIMAL       D2,
                        L_DECIMAL       D3)
/************************************/
{
  L_LONG L1, L2;
  L_SWORD DAY, MON, YEAR;

  TICKTODATE(D1, &L1, &L2);
  if (L1)
    L1++;
  DATEDAYNUMBER(L1,&DAY,&MON,&YEAR);
  if (L1)
  {
    DAY = 0;
    YEAR--;    	
    MON--;
  }
  L1 = MON+YEAR*12;
  LongToDec(L1, D1);
  TICKTODATE(D2, &L1, &L2);
  if (L1)
    L1++;
  DATEDAYNUMBER(L1,&DAY,&MON,&YEAR);
  if (L1)
  {
    DAY = 0;
    YEAR--;    	
    MON--;
  }
  L1 = MON+YEAR*12;
  LongToDec(L1, D2);
  DIVDECIMAL(D1,D2,D3);
} /* end DIVMONTHS2 */                                  

DECSTATUS DLLAPI GETTICKSTATUS(const L_DECIMAL DD)
{
  L_BOOL bInterval = L_TFALSE;
  L_DECIMAL D;

  COPYDEC(DD, D);

  if (D[15] == 1)
  {
    bInterval = L_TTRUE;
    D[15] = 0;
  }
  return GETDECSTATUS(D);
}                                                       /* ... 01.09.10 */
