/***************************************************************************
 *                       RELEX, Inc. DBMS Linter                            *
 *  This is unpublished propietary source code of RELEX, Inc.               *
 *  The copyright notice does not evidence any actual or intended           *
 *  publication of such source code.                                        *
 *                                                                          *
 *                 Copyright (c) 1990-2012 RELEX, Inc.                      *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: get DATE value componets (Year...)
 ----------------------------------------------------------------------------
 14.10.91 
 22.12.92 -- AVO
 20.07.97 -- Ermakov (Copyright) 
 06.05.98 -- DV (400, 800, ... years)
 14.09.99 -- Ermakov (For OS9000)
 05.10.99 -- Ermakov (For QNX)
 18.12.00 -- VxWorks
 02.05.03 -- DV (Optimization)
 17.02.06 -- DV (Interval time)
 01.09.10 -- DV (Interval time operations)
 19.07.12 -- Galizin (OpenVMS)
*/

#ifdef __MSDOS__
#include <ctype.h>
#include "decimals.h"
#include "tick.h"           /* 19.05.92 */
#define _DATE_
#endif

#ifdef INTER_OS2
#include <ctype.h>
#include "tick.h"
#define _DATE_
#endif

#ifdef __INTER_DLL__
#ifndef INTER_MSWINDOWS
#define INTER_MSWINDOWS
#endif
#endif
#ifdef INTER_MSWINDOWS
#include <ctype.h>
#include "tick.h"
#define _DATE_
#endif

#if defined(UNIX) || defined(QNX) || defined(VXWORKS) || defined(VMS) /* 19.07.12 05.10.99 */ /* 18.12.00 */
#include <ctype.h>
#include "decimals.h"
#include "tick.h"           /* 19.05.92 */
#define _DATE_
#endif

/* 14.09.99 ... */
#ifdef OS9000
#include <sys/ctypes>
#include "decimals.h"
#include "tick.h"
#define _DATE_
#endif
/* ... 14.09.99 */

#ifndef _DATE_
ERROR: UNDEF SYSTEM
#endif
  static L_SWORD DAY_MON[2][1+MAXMON] =
   {
    {0,31,28,31,30,31,30,31,31,30,31,30,31}
   ,{0,31,29,31,30,31,30,31,31,30,31,30,31}
   };


void DLLAPI DATEDAYNUMBER(L_LONG NN, L_SWORD *DAY, L_SWORD *MON, L_SWORD *YEAR)
/****************************************/   /* 16.12.92 AVO */
{ register L_SWORD M, IS, DM;                    /* 02.05.03 ... */
  register L_LONG Y,N;                         /* 18.02.92 M */
  L_LONG S = 0;				     /* 06.05.98 */
  register L_LONG w;                           /* ... 02.05.03 */

  N = NN;
  *YEAR = 0; *MON = 0; *DAY = 0;
  if (N-- > 0)
    {
     w = N / DAY4CENT;                                  /* 02.05.03 ... */
     Y = 1 + w * 400;
     N -= w * DAY4CENT;                                 /* ... 02.05.03 */
     /* 06.05.98 */
     if (N == DAY4CENT-1)
     {
       Y++;
       N--;
       S++;
     }
     /* 06.05.98 */
     w = N / DAY1CENT;                                  /* 02.05.03 ... */
     Y += w * 100;
     N -= w * DAY1CENT;
     w = N / DAY4YEAR;
     Y += w * 4;
     N -= w * DAY4YEAR;
     w = N / DAY1YEAR;
     Y += w;                                            /* ... 02.05.03 */
     N += S;						/* 06.05.98 */
     /* added by TJ Feb 22, 1996 */
     if (N == 1460) 
     {
        Y--;
        N = 365;
     }
     else
     /* end of addition */
        N -= w * DAY1YEAR;                              /* 02.05.03 */
     N++;
     IS = BIGYEAR((L_SWORD)Y);                 /* 18.02.92 M */
     for (M = 1; M <= MAXMON; M++)
       {
	DM = DAY_MON[IS][M];
	if (N <= DM)
	  {
	   *YEAR = (L_SWORD)Y; *MON = M; *DAY = (L_SWORD)(N);   /* 16.12.92 AVO */
	   break;
	  }
       N -= DM;
       }
    }

} /* end DATEDAYNUMBER */

/* 17.02.06 ... */
void DLLAPI EDATEDAYNUMBER(L_DECIMAL D, L_LONG NN, L_SWORD *DAY, L_SWORD *MON, L_SWORD *YEAR)
{
  if (D[15] && NN != 0)
    NN++;
  DATEDAYNUMBER(NN,DAY,MON,YEAR);
  if (D[15] && NN != 0)
  {
    (*DAY) = 0;
    (*MON)--;
    (*YEAR)--;
  }
}
/* ... 17.02.06 */
