/****************************************************************************
 *                        RELEX, Inc. DBMS Linter                           *
 *  This is unpublished proprietary source code of RELEX, Inc.              *
 *  The copyright notice does not evidence any actual or intended           *
 *  publication of such source code.                                        *
 *                                                                          *
 *                 Copyright (c) 1990-2012 RELEX, Inc.                      *
 *                                                                          *
 *                   This software was developed by                         *
 *                                                                          *
 *                            RELEX, Inc.                                   *
 *                         Voronezh, Russia                                 *
 *                                                                          *
 *                        All rights reserved.                              *
 ****************************************************************************
 AUTHOR:
 ----------------------------------------------------------------------------
 PURPOSE: DATE components names
 ----------------------------------------------------------------------------
 14.10.91 
 22.12.92 -- AVO
 07.04.97 -- Pasechnik
 20.07.97 -- Ermakov (Copyright) 
 12.08.97 -- Kent (DLLAPI)
 28.08.97 -- Ermakov (DAY_MON comment)
 04.11.97 -- Ermakov && Max ( Corrected week and month display )
 14.09.99 -- Ermakov (For OS9000 - russian names moved to tname.h)
 05.10.99 -- Ermakov (For QNX)
 18.12.00 -- VxWorks
 20.04.01 -- KOV (formats are added + functions NAMMON,MONNAM,NAMDAY,DAYNAM are changed)
 25.04.01 -- KOV added 4 functions
 14.12.07 -- KOV (Changes for TT#16356: date can't be greater than 31.12.9999)
 19.07.12 -- Galizin (OpenVMS)
*/

#ifdef __MSDOS__
#include <ctype.h>
#include "decimals.h"
#include "tick.h"           /* 19.05.92 */
#define _DATE_
#endif

#ifdef INTER_OS2
#include <ctype.h>
#include "tick.h"
#define _DATE_
#endif

#ifdef __INTER_DLL__
#ifndef INTER_MSWINDOWS
#define INTER_MSWINDOWS
#endif
#endif
#ifdef INTER_MSWINDOWS
#include <ctype.h>
#include "tick.h"
#define _DATE_
#endif

#if defined(UNIX) || defined(QNX) || defined(VXWORKS) || defined(VMS)  /* 19.07.12 05.10.99 */ /* 18.12.00 */
#include <ctype.h>
#include "decimals.h"
#include "tick.h"           /* 19.05.92 */
#define _DATE_
#endif

/* 14.09.99 ... */
#ifdef OS9000
#include <sys/ctypes>
#include "decimals.h"
#include "tick.h"
#define _DATE_
#endif
/* ... 14.09.99 */

#ifndef _DATE_
ERROR: UNDEF SYSTEM
#endif

#include <string.h>

L_DECIMAL L_MAX_DATE = {0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,
                      0x4C, 0x59, 0x25, 0x37, 0x1F, 0x00, 0x00, 0x00}; /* 14.12.07 */

void DLLAPI TICKTODATE(const L_DECIMAL D, L_LONG *L1, L_LONG *L2);
/*                                                          28.08.97
  static L_SWORD DAY_MON[2][1+MAXMON] =
   {
    {0,31,28,31,30,31,30,31,31,30,31,30,31}
   ,{0,31,29,31,30,31,30,31,31,30,31,30,31}
   };
*/

#ifdef OS9000
#include "tname.h"
#else
#include "tnameeng.h"
#endif

void DLLAPI NAMMON(L_SWORD MON, L_CHAR *NAM, L_SWORD koder)               /* AVO 26.12.92 */
/******************************************/
{
  strncpy(NAM,NAMMON1[koder][MON],3);                            /* 20.04.01 */
}

/* 25.04.01 ... */
void DLLAPI NAMMONex(L_SWORD MON, L_CHAR *NAM, L_SWORD koder, L_SWORD Count) 
{
  strncpy(NAM,NAMMON1[koder][MON],Count);
}
/* ... 25.04.01*/

L_SWORD DLLAPI MONNAM(L_CHAR *NAM, L_SWORD koder)                         /* AVO 26.12.92 */
/***********************/
{ L_SWORD i,f=1;                    /* 07.04.97 */
  L_CHAR *S;
  S=NAM;
/*  ToLowS(S,20);*/
  for(i=0;(f!=0) && (i<=12);)
    {f=strncmp(NAMMON1[koder][i],S,3);                          /* 20.04.01 */
     if (f!=0) i++;};
  if (i<=12) return i;
  else return 0;
}

/* 25.04.01 ... */
L_SWORD DLLAPI MONNAMex(L_CHAR *NAM, L_SWORD koder, L_SWORD Count)
{ L_SWORD i,f=1;
  L_CHAR *S;
  S=NAM;
  for(i=0;(f!=0) && (i<=12);)
    {
     f=strncmp(NAMMON1[koder][i],S,Count);
     if (f!=0) i++;};
  if (i<=12) return i;
  else return 0;
}
/* ... 25.04.01*/

void DLLAPI NAMDAY(L_SWORD DAYWEEK,L_CHAR *NAM,L_SWORD koder)
/*********************************/
{
  strncpy(NAM,NAMDAY1[koder][DAYWEEK],3);                   /* 20.04.01 */
}

/* 25.04.01 ... */
void DLLAPI NAMDAYex(L_SWORD DAYWEEK,L_CHAR *NAM,L_SWORD koder, L_SWORD Count)
{
  strncpy(NAM,NAMDAY1[koder][DAYWEEK],Count);
}
/* ... 25.04.01*/

L_SWORD DLLAPI DAYNAM(L_CHAR *NAM)
/***********************/
{ L_SWORD i,f=1;                    /* 07.04.97 */
  L_CHAR *S;
  S=NAM;
/*  ToLowS(S,20);*/
  for(i=0;(f!=0) && (i<=7);)
    { f=strncmp(NAMDAY1[0][i],S,3);                         /* 20.04.01 */
     if (f!=0) i++;};
  if (i<=7) return i;
  else return 0;
}

/* 25.04.01 ... */
L_SWORD DLLAPI DAYNAMex(L_CHAR *NAM, L_SWORD Count)                   /* 20.04.01 */
{ L_SWORD i,f=1;
  L_CHAR *S;
  S=NAM;
  for(i=0;(f!=0) && (i<=7);)
    {
     f=strncmp(NAMDAY1[0][i],S,Count);                    /* 20.04.01 */
     if (f!=0) i++;};
  if (i<=7) return i;
  else return 0;
}
/* ... 25.04.01*/
